/* 
 * Program:             $RCSfile: chkAttrId.c,v $  $Revision: 31.7 $
 * 
 * Purpose:
 * 
 * Author:              S.Yamamoto  1999/12/07
 * 
 * (C) Copyright:       S.Yamamoto  1999
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: chkAttrId.c,v 31.7 2003/07/08 05:46:47 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>

typedef struct {
    SpdAttrId       attrId;
    char            *className;
    char            *attrName;
} AttrIdEntry;

static AttrIdEntry attrIds[] = {
    /* Dirty trick. */

#include "attrIds.c"
};

int main(int argc, char *argv[])
{
    
    int             ch, i;
    SpdBoolean      flag_v = OFF;

    while ((ch = getopt(argc, argv, "d")) != -1) {
        switch (ch) {
          case 'd':             /* Debug. */
            flag_v = ON;
            break;
          default:
            spdErrorExit("'%c': Invalid option.\n", ch);
            break;
        }
    }

    for (i = 0; attrIds[i].attrId != SPD_NON_AID; i++) {
        if (flag_v) {
            spdMessage("spdGetAttrIdByName3(%d, \"%s\", \"%s\"): %d.\n",
                       SPD_NON_CID, 
                       attrIds[i].className, attrIds[i].attrName,
                       attrIds[i].attrId);
        }
        if (spdGetAttrIdByName3(SPD_NON_CID, attrIds[i].className,
                                attrIds[i].attrName) != attrIds[i].attrId) {
            spdErrorExit("spdGetAttrIdByName3(%d, \"%s\", \"%s\") %d != %d.\n",
                         SPD_NON_CID, 
                         attrIds[i].className, attrIds[i].attrName,
                         spdGetAttrIdByName3(SPD_NON_CID, attrIds[i].className,
                                             attrIds[i].attrName),
                         attrIds[i].attrId);
        }
    }

    return (EXIT_SUCCESS);
}
