/* 
 * Program:             $RCSfile: chkGetTyp.c,v $  $Revision: 40.3 $
 * 
 * Purpose:
 * 
 * Author:              S.Yamamoto  2001/10/05
 * 
 * (C) Copyright:       S.Yamamoto  2001
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: chkGetTyp.c,v 40.3 2001/12/24 16:17:24 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>

int spdGetTyp(SpdClassId classId);

int main(int argc, char *argv[])
{
    SpdId       i;

    for (i = SPD_FIRST_CID_I_MODEL; i <= SPD_LAST_RID_P_MODEL; i++) {
        /* printf("class_table[%d].typ = %d.\n", i, class_table[i].typ); */
        if (class_table[i].typ != spdGetTyp(i)) 
            spdErrorExit("\"%s\": %d, %d: Invalid typ.\n", 
                         spdGetClassNameById(i), 
                         class_table[i].typ, spdGetTyp(i));
    }

    return (EXIT_SUCCESS);
}
