/*
 * Created on 2003/06/10
 * SpdElementHandler.java - Copyright (c) 2003 H.Yoshida
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS IS FREEWARE. NO WARRANTY.
 */
package JXModel3.xsdml;

/**
 * XSDMLElementHandler Interface - like a STL's foreach().
 * @author H.Yoshida
 */
public interface SpdElementHandler {
	/**
	 * The invoked method by XMLElementList
	 * @param e
	 */
	public abstract void action(SpdElement e);

}
