/* 
 * Program:             $RCSfile: DBRel.java,v $  $Revision: 40.6 $
 * 
 * Purpose:             
 *
 * Author:              K.Hoshino  2001/10/02
 *                      S.Yamamoto  2001/10/02
 *
 * (C) Copyright:       K.Hoshino and S.Yamamoto  2001 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: DBRel.java,v 40.6 2003/02/15 11:56:36 yamamoto Exp yamamoto $
 */

package Japid.Freja.DBAccess;

import java.io.*;
import java.util.*;
import Japid.Freja.*;

/*
 * classrelscheme formatۤʤΤݤʤȤ 
 * Freja¦ɬפȤȤsort, nameΤߤʤΤǡ
 * Ʊ饹ǰȤǽǤ롥礹٤?
 * K.Hoshino 2001/10/14.
 */

public class DBRel {
    String          relName;
    /** ǡDBRelAttr */
    Vector       attr;

    public DBRel() {
    }

    public DBRel(String relName, Vector attr) {
        this.relName = relName;
        this.attr = attr;
    }

    public int getAttrNum() {
        return attr.size();
    }

    public DBRelAttr getAttrAt(int i) {
        return (DBRelAttr) attr.elementAt(i);
    }

    public String getAttrNameAt(int i) {
        return getAttrAt(i).name;
    }

    public boolean attrIsIntAt(int i) {
        return getAttrAt(i).sort.isInt();
    }

    public boolean attrIsStringAt(int i) {
        return getAttrAt(i).sort.isString();
    }

    public int getAttrIndexByName(String name) {
        for (int i = 0; i < attr.size(); i++) {
            if (getAttrNameAt(i).equals(name))
                return i;
        }

        FrjWorld.error("No Attr \"" + name + "\" in DBRel \"" + relName + "\"");
        return -1;
    }
}
