/* 
 * Program:             $RCSfile: SortByID.java,v $  $Revision: 41.4 $
 * 
 * Purpose:             
 *
 * Author:              Y.Hachisu  1998/06/18
 *                      S.Yamamoto  1998/06/18
 *
 * (C) Copyright:       Y.Hachisu and S.Yamamoto  1998 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: SortByID.java,v 41.4 2003/02/12 03:39:41 yamamoto Exp yamamoto $
 */

package Japid.Freja;

import java.util.Vector;
import java.util.Enumeration;

/**
  * Classes SortByXXX is to sort FrjObject by order of XXX.
  */

public class SortByID extends VectorSorter {
    public SortByID() {
        super();
    }

    public SortByID(Vector v) {
        super(v);
    }

    public SortByID(Enumeration e) {
        super(e);
    }

    public int compare(Object a, Object b) {
        FrjObject objA = (FrjObject) a;
        FrjObject objB = (FrjObject) b;
                
        if (objA.getID() > objB.getID()) {
            return 1;
        } else if (objA.getID() < objB.getID()) {
            return -1;
        } else {
            return 0;
        }
    }
}
