/* 
 * Program:             $RCSfile: SortStrings.java,v $  $Revision: 41.4 $
 * 
 * Purpose:             
 *
 * Author:              Y.Hachisu  1998/06/18
 *                      S.Yamamoto  1998/06/18
 *
 * (C) Copyright:       Y.Hachisu and S.Yamamoto  1998 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: SortStrings.java,v 41.4 2003/02/12 03:39:42 yamamoto Exp yamamoto $
 */

package Japid.Freja;

import java.util.Vector;
import java.util.Enumeration;

/**
 * Classes SortStrings is to sort String by lexicographical order.
 * NOTE: This class differs from class SortByStr
 *       which sorts FrjObject by str attribute
 */

public class SortStrings extends VectorSorter {
    public SortStrings(Vector v) {
        super(v);
    }

    public SortStrings(Enumeration e) {
        super(e);
    }

    public SortStrings() {
        super();
    }

    public int compare(Object a, Object b) {
        String strA = (String) a;
        String strB = (String) b;

        if (strA == null && strB == null) {
            return 0;
        }
        if (strA == null && strB != null) {
            return 1;
        } else if (strA != null && strB == null) {
            return -1;
        }
        return (strA.compareTo(strB));
    }
}
