/* 
 * Program:             $RCSfile: IsValidClass.java,v $  $Revision: 40.5 $
 * 
 * Purpose:             
 *
 * Author:              S.Yamamoto  2002/12/02
 *
 * (C) Copyright:       S.Yamamoto  2002 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: IsValidClass.java,v 40.5 2003/07/08 05:47:51 yamamoto Exp yamamoto $
 */

/* 
 * Return value:
 * 1: If specified class exist in the class path.
 * 0: Otherwise.
 * -1: Error.
 */

package Japid.Tools.IsValidClass;

import java.util.Properties;

class IsValidClass {
    public static void main(String args[]) {
        if (args.length == 0) {
            System.out.println("-1");
            System.exit(-1);
        }

        Class       c = null;
        String      classname = args[0];
        try {
            // Get java.lang.Class from class name.
            c = Class.forName(classname);
            System.out.println("1");
            System.exit(1);
        } catch (ClassNotFoundException e) {
            // Class is not found.
            System.out.println("0");
            System.exit(0);
        }
    }
}
