/* 
 * Program:             $RCSfile: MessageDialog.java,v $  $Revision: 40.4 $
 * 
 * Purpose:             
 *
 * Author:              H.Kuwabara  2003/06/02
 *                      S.Yamamoto  2003/06/02
 *
 * (C) Copyright:       H.Kuwabara and S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: MessageDialog.java,v 40.4 2003/07/08 05:47:57 yamamoto Exp yamamoto $
 */

package Japid.Tools.Syab3;

import java.awt.Component;
import javax.swing.JOptionPane;

public class MessageDialog {
    private static Component parent = null;

    public static final int ERROR_MESSAGE = JOptionPane.ERROR_MESSAGE;
    public static final int INFORMATION_MESSAGE = JOptionPane.INFORMATION_MESSAGE;
    public static final int WARNING_MESSAGE = JOptionPane.WARNING_MESSAGE;
    public static final int QUESTION_MESSAGE = JOptionPane.QUESTION_MESSAGE;
    public static final int PLAIN_MESSAGE = JOptionPane.PLAIN_MESSAGE;

    public static void setParentComponent(Component parent) {
        MessageDialog.parent = parent;
    }

    /**
     *  Brings up a dialog that display a message.
     *  @param message the object to display
     *  @param title the title string for the dialog
     *  @param messageType the type of message to be displayed
     */
    public static void showMessageDialog(Object message, 
                                         String title, 
                                         int messageType) {
        JOptionPane.showMessageDialog(parent, message, title, messageType);
    }
}
