/* 
 * Program:             $RCSfile: Exit.java,v $  $Revision: 40.3 $
 * 
 * Purpose:             
 *
 * Author:              H.Kuwabara  2003/06/02
 *                      S.Yamamoto  2003/06/02
 *
 * (C) Copyright:       H.Kuwabara and S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: Exit.java,v 40.3 2003/07/08 05:47:59 yamamoto Exp yamamoto $
 */

package Japid.Tools.Syab3.action;

import java.awt.event.ActionEvent;
import javax.swing.AbstractAction;

import Japid.Tools.Syab3.Main;
import Japid.Tools.Syab3.Resource;

public class Exit extends AbstractAction {
    private Main main;

    private Exit() {
    }

    public Exit(Main main) {
        super(Resource.getInstance().getString("menu.file.exit"));
        this.main = main;
    }

    public void actionPerformed(ActionEvent e) {
        main.terminate();
    }
}
