/* 
 * Program:             $RCSfile: OffsetSorterSelect.java,v $  $Revision: 40.3 $
 * 
 * Purpose:             
 *
 * Author:              H.Kuwabara  2003/06/02
 *                      S.Yamamoto  2003/06/02
 *
 * (C) Copyright:       H.Kuwabara and S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: OffsetSorterSelect.java,v 40.3 2003/07/08 05:48:00 yamamoto Exp yamamoto $
 */

package Japid.Tools.Syab3.action;

import java.awt.event.ActionEvent;
import javax.swing.AbstractAction;

import Japid.Tools.Syab3.ViewModelMediator;

public class OffsetSorterSelect extends AbstractAction {
    private ViewModelMediator mediator;

    private OffsetSorterSelect() {
    }

    public OffsetSorterSelect(ViewModelMediator mediator) {
        this.mediator = mediator;
    }

    public void actionPerformed(ActionEvent e) {
        mediator.selectOffsetSorter();
    }
}
