/* 
 * Program:             $RCSfile: ClassMoreInfo.java,v $  $Revision: 40.4 $
 * 
 * Purpose:             
 *
 * Author:              K.Hoshino  2000/07/08
 *                      S.Yamamoto  2000/07/08
 *
 * (C) Copyright:       K.Hoshino and S.Yamamoto  2000 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: ClassMoreInfo.java,v 40.4 2003/02/15 11:56:46 yamamoto Exp yamamoto $
 */

package Japid.Tools.jspie;

import java.io.*;
import java.util.*;
import Japid.Freja.*;

/**
 * 饹ɲþJapid¦Doclet¦Ϥͤ
 */

public class ClassMoreInfo extends DefRefInfo {
    public Vector literals;

    public Vector field_moreinfos;
    public Vector method_moreinfos;

    ClassMoreInfo(FrjObject frj_obj) {
        super(frj_obj);

        literals = new Vector();
        field_moreinfos = new Vector();
        method_moreinfos = new Vector();
    }

    public void setliteral(String ref_str) {
        literals.add(ref_str);
    }

    public Vector getliteral() {
        return literals;
    }
    
    public void setFieldMoreInfo(FieldMoreInfo field_mi) {
        field_moreinfos.add(field_mi);
    }
    
    public void setMethodMoreInfo(MethodMoreInfo method_mi) {
        method_moreinfos.add(method_mi);
    }

    public FieldMoreInfo getFieldMoreInfo(String fieldname) {
        FieldMoreInfo fmi = null;

        boolean notfound = true;
        for (int i = 0; notfound && i < field_moreinfos.size(); i++) {
            fmi = (FieldMoreInfo) field_moreinfos.elementAt(i);
            String common_name = fmi.getCommonName();
            if (common_name.equals(fieldname)) {
                notfound = false;
            }
        }

        if (notfound) {
            fmi = null;
        }

        return fmi;
    }

    public MethodMoreInfo getMethodMoreInfo(String methodname) {
        MethodMoreInfo mmi = null;

        boolean notfound = true;
        for (int i = 0; notfound && i < method_moreinfos.size(); i++) {
            mmi = (MethodMoreInfo) method_moreinfos.elementAt(i);
            String common_name = mmi.getCommonName();
            if (common_name.equals(methodname)) {
                notfound = false;
            }
        }

        if (notfound) {
            mmi = null;
        }

        return mmi;
    }
}
