/* 
 * Program:             $RCSfile: DefRefInfo.java,v $  $Revision: 40.4 $
 * 
 * Purpose:             
 *
 * Author:              K.Hoshino  2000/07/08
 *                      S.Yamamoto  2000/07/08
 *
 * (C) Copyright:       K.Hoshino and S.Yamamoto  2000 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: DefRefInfo.java,v 40.4 2003/02/15 11:56:46 yamamoto Exp yamamoto $
 */

package Japid.Tools.jspie;

import java.io.*;
import java.util.*;
import Japid.Freja.*;

/**
 * ȴطJapid¦Doclet¦Ϥͤ
 */
public class DefRefInfo {
    public String def;
    public Vector ref;

    public FrjObject frj_obj = null;
    public String common_name = null;

    public DefRefInfo(FrjObject frj_obj) {
        setFrjObj(frj_obj);
        ref = new Vector();
    }

    public void setCommonName(String common_name) {
        this.common_name = common_name;
    }

    public void setFrjObj(FrjObject frj_obj) {
        this.frj_obj = frj_obj;
    }

    public void setDef(String def) {
        this.def = def;
    }

    public void setRef(String ref_str) {
        ref.add(ref_str);
    }

    public String getDef() {
        return def;
    }

    public Vector getRef() {
        return ref;
    }

    public String getCommonName() {
        return common_name;
    }

    public FrjObject getFrjObj() {
        return frj_obj;
    }
}

