/* 
 * Program:             $RCSfile: Jspie.java,v $  $Revision: 40.5 $
 * 
 * Purpose:             
 *
 * Author:              K.Hoshino  2000/07/08
 *                      S.Yamamoto  2000/07/08
 *
 * (C) Copyright:       K.Hoshino and S.Yamamoto  2000 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: Jspie.java,v 40.5 2003/02/15 11:56:47 yamamoto Exp yamamoto $
 */

package Japid.Tools.jspie;

import java.io.*;
import Japid.Freja.*;

public class Jspie {
    SourceFileMaker source_file_maker = null;

    public Jspie() {
    }

    public void start(String[][] options, String[] args) {
        try {
            //printAllargs(args);

            JspieConfiguration jc = new JspieConfiguration();
            jc.setOptions(options);

            (new CrejaLoader()).loadCreja(args);

            source_file_maker = new SourceFileMaker();
            source_file_maker.analyseSourceFiles(jc);

        } catch(Exception e) {
            System.out.println("Exception: " + e);
        }
    }

    private void printAllargs(String args[]) {
        for (int i = 0; i < args.length ; i++) {
            System.out.println(args[i]);
        }
    }

    public void writeSourceFiles() {
        try {
            source_file_maker.writeSourceFiles();
        } catch(IOException e) {
            System.out.println("IOException: " + e);
        }
    }
}

