/* 
 * Program:             $RCSfile: JspieUtil.java,v $  $Revision: 40.5 $
 * 
 * Purpose:             
 *
 * Author:              K.Hoshino  2000/07/08
 *                      S.Yamamoto  2000/07/08
 *
 * (C) Copyright:       K.Hoshino and S.Yamamoto  2000 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: JspieUtil.java,v 40.5 2003/02/15 11:56:47 yamamoto Exp yamamoto $
 */

package Japid.Tools.jspie;

import java.io.*;
import Japid.Freja.*;

public class JspieUtil {
    /*
     * !! ϤExceptionȤ٤Ǥ͡
     */

    public static void error(String str) {
        System.out.println("Error: jspie: " + str);
    }

    public static void error(String className, String str) {
        System.out.println("Error: jspie: " + className + ": " + str);
    }

    public static void errorExit(String str) {
        error(str);
        System.exit(1);
    }

    public static void errorExit(String className, String str) {
        error(className, str);
        System.exit(1);
    }

    public static void warning(String str) {
        System.out.println("Warning: jspie: " + str);
    }

    public static void warning(String className, String str) {
        System.out.println("Warning: jspie: " + className + ": " + str);
    }

    public static void warningExit(String str) {
        warning(str);
        System.exit(1);
    }

    public static void warningExit(String className, String str) {
        warning(className, str);
        System.exit(1);
    }

    public static void message(String str) {
        System.out.println("Message: jspie: " + str);
    }

    public static void message(String className, String str) {
        System.out.println("Message: jspie: " + className + ": " + str);
    }
}
