/* 
 * Program:             $RCSfile: MoreInfoManager.java,v $  $Revision: 40.4 $
 * 
 * Purpose:             
 *
 * Author:              K.Hoshino  2000/07/08
 *                      S.Yamamoto  2000/07/08
 *
 * (C) Copyright:       K.Hoshino and S.Yamamoto  2000 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: MoreInfoManager.java,v 40.4 2003/02/15 11:56:48 yamamoto Exp yamamoto $
 */

package Japid.Tools.jspie;

import java.io.*;
import java.util.*;
import Japid.Freja.*;

/**
 * javadoc륯饹/󥿥եեɲþ
 * Japid¦Doclet¦Ϥͤ
 * !! DocletԹ塤static᥽åɤФˤʤäƤ뤬
 */

public final class MoreInfoManager {

    static Vector class_moreinfos = new Vector();

    MoreInfoManager() {
        /*class_moreinfos = new Vector();*/
    }

    public static void setClassMoreInfo(ClassMoreInfo class_mi) {
        class_moreinfos.add(class_mi);
    }

    public static ClassMoreInfo getClassMoreInfo(String classname) {
        ClassMoreInfo cmi = null;

        boolean notfound = true;
        for (int i = 0; notfound && i < class_moreinfos.size(); i++) {
            cmi = (ClassMoreInfo) class_moreinfos.elementAt(i);
            String common_name = cmi.getCommonName();
            if(common_name.equals(classname)) notfound = false;
        }

        if (notfound) {
            cmi = null;
        }

        return cmi;
    }
}
