/* 
 * Program:             $RCSfile: SourceChange.java,v $  $Revision: 40.5 $
 * 
 * Purpose:             
 *
 * Author:              K.Hoshino  2000/07/08
 *                      S.Yamamoto  2000/07/08
 *
 * (C) Copyright:       K.Hoshino and S.Yamamoto  2000 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: SourceChange.java,v 40.5 2003/07/08 05:47:52 yamamoto Exp yamamoto $
 */

package Japid.Tools.jspie;

import java.io.*;
import java.util.*;
import Japid.Freja.*;

/**
 * եHTMLȤѹ
 */

class SourceChange implements Comparable {
    FrjObject   before;
    String      after;

    SourceChange(FrjObject before, String after) {
        this.before = before;
        this.after = after;
    }

    public int compareTo(Object o) {
        int return_int;

        SourceChange sc = (SourceChange)o;
        int myoffset = before.getStrOffset();
        int offset = sc.before.getStrOffset();
        
        if (myoffset > offset) {
            return_int = 1;
        } else if (myoffset == offset) {
            return_int = 0;
        } else {
            return_int = -1;
        }

        return return_int;
    }
}

