/* 
 * Program:		$RCSfile: scroll.js,v $  $Revision: 51.2 $
 * 
 * Purpose:		
 *
 * Author:		Y.Sawada  2003/10/01
 *			S.Yamamoto  2003/10/01
 *
 * (C) Copyright:	Y.Sawada and S.Yamamoto	 2003
 *			This file is a product of the project Sapid.
 */

/*
 * $Id: scroll.js,v 51.2 2003/10/22 06:34:07 yamamoto Exp yamamoto $
 */

function getScroll(){
    var x, y ;

    if( document.all !== void 0 ){
        x = document.body.scrollLeft ;
        y = document.body.scrollTop ;
    }else if( document.layers !== void 0 ){
        x = window.pageXOffset ;
        y = window.pageYOffset ;
    }else{
        x = window.scrollX ;
        y = window.scrollY ;
    }
    return { x : x, y : y };
}

var SCROLL ;
var divCountScroller = 30 ; // Number of scroll steps.

function scroller( x, y, count ){
    
    if( count === void 0 ){
        
        count = 0 ;
        SCROLL = getScroll();
        
    }
    
    if( count++ < divCountScroller ){
        
        var c = count/divCountScroller ;
        
        var nx = SCROLL.x+( x-SCROLL.x )*( c+1/Math.PI*Math.sin( Math.PI*c ) );
        var ny = SCROLL.y+( y-SCROLL.y )*( c+1/Math.PI*Math.sin( Math.PI*c ) );
        
        window.scrollTo( nx, ny );
        
        setTimeout( "scroller("+x+","+y+","+count+");", 10 );
	// 2nd argument (10) means refresh interaval.
    }
}
