<%--
# Program:		$RCSfile: editForm.jsp,v $  $Revision: 51.6 $
# 
# Purpose:		
# 
# Author:		Y.Sawada  2003/10/01
#			S.Yamamoto  2003/10/01
# 
# (C) Copyright:	Y.Sawada and S.Yamamoto  2003
#			This file is a product of the project Sapid.
--%>

<%--
    $Id: editForm.jsp,v 51.6 2003/11/25 12:35:23 yamamoto Exp yamamoto $
--%>  

<%@ page contentType="text/html; charset=Shift_JIS" %>
<%@ page import="jspie3.*" %>
<%@ page import="java.io.*,java.util.*" %>
<%@ page import="org.xml.sax.*,org.w3c.dom.*,javax.xml.parsers.*" %>
<%@ page import="javax.xml.transform.*,javax.xml.transform.stream.*,javax.xml.transform.dom.*" %>
<%@ include file="util.jsp" %>
<%
    String project = new String("0"); // kimeuti
    String fileName = request.getParameter("fileName");
    String linkId = request.getParameter("linkId");
    String linkIds = request.getParameter("linkIds");
    if(fileName == null || linkId == null){
        response.sendRedirect("../html/error.html");
    }
    Hashtable memoData = new Hashtable();

    String linkPath = application.getRealPath("/project/" + project + "/memo-link.xml");
    Document linkDoc = getDocument(linkPath);
    Node linkNode =  getMemoNode(linkDoc.getDocumentElement(),linkId);
    Element pos = (Element)(linkNode.getChildNodes().item(1));
    Element memo = (Element)(linkNode.getChildNodes().item(3));
    String objId = pos.getAttribute("id");
    String x = pos.getAttribute("x");
    String y = pos.getAttribute("y");
    String memoId = memo.getAttribute("id");

    String memoPath = application.getRealPath("/project/" + project + "/memo.xml");
    Document memoDoc = getDocument(memoPath);
    Node memoNode =  getMemoNode(memoDoc.getDocumentElement(),memoId);
    memoData  = getNodeContents(memoNode);
    String body = (String)memoData.get("body");
    body = body.replaceAll("<br />","");
    String document = (String)memoData.get("document");
    if(document != null && document.equals("none")){
        document = "";
    }
%>
<?xml version="1.0" encoding="Shift_JIS"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ja" lang="ja">
<head>
    <title>editForm</title>
    <meta http-equiv="Content-Type" content="text/html; charset=Shift_JIS">
    <script type="text/javascript" src="../js/findObj.js"></script>
    <script type="text/javascript" src="../js/formCheck.js"></script>
    <link rel="stylesheet" type="text/css" href="../JSPIE3.css" />
</head>
<body>
<form name="form" action="edit.jsp" method="post" onsubmit="return formCheck()">
<input type="hidden" name="file" value="<%=fileName%>" />
<input type="hidden" name="linkId" value="<%=linkId%>" />
<input type="hidden" name="linkIds" value="<%=linkIds%>" />
<input type="hidden" name="memoId" value="<%=memoId%>" />
<table>
	<tr>
		<td>^Cg</td>
		<td><input type="text" name="title" size="26" maxlength="120" value="<%=memoData.get("title")%>" /></td>
	</tr>
	<tr>
		<td>Ώ</td>
		<td>
			<input type="text" size="18" name="objId" id="area1" readonly="readonly" value="<%=objId%>" /><br />
			<input type="text" size="18" name="objSort" id="area0" readonly="readonly" />
		</td>
	</tr>
	<tr>
		<td>ʒu</td>
		<td>
			<input type="text" size="7" name="x" id="area2" readonly="readonly" value="<%=x%>" />
			<input type="text" size="7" name="y" id="area3" readonly="readonly" value="<%=y%>" />
		</td>
	</tr>
	<tr>
		<td>敪</td>
		<td>
		<%=IndexData.createSelect("sort",Integer.parseInt((String)memoData.get("sort")))%>
		</td>
	</tr>
	<tr>
		<td>dvx</td>
		<td>
		<%=IndexData.createSelect("importance",Integer.parseInt((String)memoData.get("importance")))%>
		</td>
	</tr>
	<tr>
		<td>tⳏ</td>
		<td>
		<%=IndexData.createSelect("state",Integer.parseInt((String)memoData.get("state")))%>
		</td>
	</tr>
	<tr>
		<td>ێ</td>
		<td>
		<%=IndexData.createSelect("limit",Integer.parseInt((String)memoData.get("limit")))%>
		</td>
	</tr>
	<tr>
		<td></td>
		<td>
		<%=IndexData.createSelect("permit",Integer.parseInt((String)memoData.get("permit")))%>
		</td>
	</tr>
	<tr>
		<td>J</td>
		<td>
		<%=IndexData.createSelect("publicity",Integer.parseInt((String)memoData.get("publicity")))%>
		</td>
	</tr>
	<tr>
		<td>֘ADOC</td>
		<td><input type="text" name="document" size="26" maxlength="120" value="<%=document%>" /></td>
	</tr>
	<tr>
		<td>֘At</td>
		<td>
<%
    String relations = (String)memoData.get("relation");
    if(relations != null && !relations.equals("none")){
        String[] relation = relations.split(",");
        for(int i = 0; i < relation.length; i++){
        String poss2 = WriteMemoTree.getLinkPos(relation[i],linkDoc);
            if(poss2 != null && poss2.equals(fileName)) { // this file
                if(relation[i].equals(linkId)) { //  this memo
		    out.println(relation[i]);
                }
                else { // other memo
                    out.println("<a class=\"u\" href=\"javascript:window.top.f21.mref('" 
                                  + relation[i] +"')\">" + relation[i] + "</a>");
                }
            }
            else { // other file
                out.println("<a class=\"u\" href=\"fileset.jsp?file="
                              + poss2 + "&amp;id=" + relation[i] + "\">"
                              + relation[i] + "(" + poss2 + ")</a>");
            }
	    out.println(" <a class=\"u\" href=\"deleteMemoRelation.jsp?memoId=" + memoId
			+ "&amp;delete=" + relation[i] + "&amp;fileName="
			+ fileName + "&amp;linkIds=" + linkId + "\">delete</a><br />");
        }
    }
%>
		</td>
	</tr>
	<tr><td colspan="2">
		<textarea rows="5" cols="25" name="body"><%=body%></textarea>
	</td></tr>
	<tr>
		<td colspan="2">
			<input type="submit" value="ҏW" name="method" />
			<input type="reset" value="Zbg" onclick="window.location.reload()" />
			<input type="button" value="LZ" onclick="window.location.replace('memolist.jsp?file=<%=fileName%>')" />
		</td>
	</tr>
	<tr>
		<td colspan="2">
			<input type="submit" value="폜" name="method" />
		</td>
	</tr>
</table>
</form>
<p>ΏۂIłȂꍇA<br />xZbgĂD</p>
</body>
</html>
