<%--
# Program:		$RCSfile: memoSearch.jsp,v $  $Revision: 50.1 $
# 
# Purpose:		
# 
# Author:		Y.Sawada  2003/10/01
#			S.Yamamoto  2003/10/01
# 
# (C) Copyright:	Y.Sawada and S.Yamamoto  2003
#			This file is a product of the project Sapid.
--%>

<%--
    $Id: memoSearch.jsp,v 50.1 2003/11/19 01:34:41 yamamoto Exp yamamoto $
--%>  

<%@ page contentType="text/html; charset=Shift_JIS" import="jspie3.*,java.io.*,java.util.HashSet" %>
<%!
    public String strEncode(String strVal) throws UnsupportedEncodingException{
        if(strVal == null)
            return (null);
        else
            return (new String(strVal.getBytes("ISO-8859-1"),"JISAutoDetect"));
    }
%>
<%
    String project = new String("0"); // kimeuti
    String fileName = request.getParameter("file");
    String queryString = strEncode(request.getParameter("queryString"));
    if(fileName == null || queryString == null){
        response.sendRedirect("../html/error.html");
    }

    int scope = Integer.parseInt(request.getParameter("scope"));
    boolean isAnd = new Boolean(request.getParameter("isAnd")).booleanValue();
    boolean checkBody = new Boolean(request.getParameter("checkBody")).booleanValue();
    boolean checkTitle = new Boolean(request.getParameter("checkTitle")).booleanValue();
    boolean checkAuther = new Boolean(request.getParameter("checkAuther")).booleanValue();

	SearchQuery sq = new SearchQuery();
	sq.setProject(project);
	sq.setPackageName("none");
	sq.setFileName(fileName);
	sq.setQueryString(queryString);
	sq.setAnd(isAnd);
	sq.setCheckBody(checkBody);
	sq.setCheckTitle(checkTitle);
	sq.setCheckAuther(checkAuther);
	sq.setScope(scope);
/*
    String packageName = fileName.replaceFirst("/.*$","");
    if(packageName.equals(fileName)){
        packageName = "none";
    }
*/
%>
<?xml version="1.0" encoding="Shift_JIS"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ja" lang="ja">
<head>
    <title>memoSearch</title>
    <meta http-equiv="Content-Type" content="text/html; charset=Shift_JIS">
    <link rel="stylesheet" type="text/css" href="../JSPIE3.css" />
</head>
<body>
<p>
<%
    String xmlPath = application.getRealPath("/project/" + project);
	SearchMemo sm = new SearchMemo(xmlPath,sq);
	HashSet matchMemo = sm.getResult();
	if(matchMemo !=null && !matchMemo.isEmpty()){
	    SearchMemoResult smr = new SearchMemoResult(xmlPath,sm.getResult());
	    if(scope == 0){ // project
		smr.memoTreeVisit();
	    }
	    else if(scope == 1){ // package
		// mada
	    }
	    else if(scope == 2){ // file
		smr.memoTreeVisit(sq.getFileName());
	    }
	    out.print(smr.getResult());
	}
	else{
	    out.println("not found <br />");
	}
%>
</p>
</body>
</html>
