<%--
# Program:              $RCSfile: result.jsp,v $  $Revision: 51.5 $
# 
# Purpose:              
# 
# Author:               Y.Hotta  2003/10/01
#                       S.Yamamoto  2003/10/01
# 
# (C) Copyright:        Y.Hotta and S.Yamamoto  2003
#                       This file is a product of the project Sapid.
--%>

<%--
    $Id: result.jsp,v 51.5 2003/11/20 16:25:41 yamamoto Exp yamamoto $
--%>

<?xml version="1.0" encoding="Shift_JIS"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ja" lang="ja">
<head>
<title>result</title>
    <meta http-equiv="Content-Type" content="text/html; charset=Shift_JIS" />
    <link href="../Jx2Html.css" type="text/css" rel="stylesheet" />
    <script src="../js/ref.js" type="text/javascript"></script>
</head>
<%@ page contentType="text/html; charset=Shift_JIS"
         import = "jspie3.DirWalkIterator"
         import = "java.io.*"
         import = "java.net.*"
         import = "java.util.*"
         import = "java.util.regex.*"
         import = "org.w3c.dom.*"
         import = "javax.xml.parsers.*"
         import = "org.xml.sax.*"
         import = "org.xml.sax.helpers.*"
%>
<%!
final String PROJECTID = "0";
final int COMMENT_LENGTH = 50;
final int KEYWORD_SIZE = 20;
String keyword;
String kind;
String match;
String ignore;
String outfile;
String position;
StringBuffer sb;
StringBuffer sb2;
StringBuffer sb3;
StringBuffer sb4;
StringBuffer sb5;

String Id = "";
String multi;
boolean flag_file;
boolean flag_kind;

private class SaxHandler extends DefaultHandler {
    boolean flag_literal = false;
    boolean flag_comment = false;
    boolean flag_ident = false;
    boolean flag_kind = false;
    boolean flag_expr_a = false;
    boolean flag_expr_v = false;
    boolean flag_type = false;
    String line;
    String s;
    String temps;
    String sb2cut;

    int linenum = 1;
    public void startElement(String namespaceURI,
                             String localName,
                             String qName,
                             Attributes attrs){
        if (qName.equals("literal") && kind.equals("literal")) {
            flag_literal = true;
        } else if (qName.equals("nl")) {
            linenum =  Integer.parseInt(attrs.getValue("line")) + 1;
        } else if (qName.equals("comment")) {
            flag_comment = true;
        } else if (qName.equals("Type")) {
            flag_type = true;
        } else if(qName.equals("ident")) {
            if(Id.equals(attrs.getValue("defid"))) {
                flag_ident = true;
            }
        } else if (qName.equals(kind)) {
            flag_kind = true;
        } else if (qName.equals("Expr")) {
            if (attrs.getValue("sort").equals("Assign")) {
                flag_expr_a = true;
            } else if (attrs.getValue("sort").equals("VarRef")) {
                if (flag_expr_a) {
                    flag_expr_v = true;
                } else {
                    flag_expr_v = false;
                }
            }
        }
    }
    public void endElement(String namespaceURI,
                             String localName,
                             String qName) {
        if (qName.equals("literal") && kind.equals("literal")){
            String string = sb2.toString();
            String line = "line" + (linenum);
            String s = branchSerch(keyword,line,string,outfile,match,ignore,'o');
            if(s != null){
                sb.append(s);
                sb.append("</li>\n");
            }
            flag_literal = false;
            sb2.delete(0, sb2.length());
        } else if(qName.equals("comment") && keyword.equals("") && kind.equals("comment")){
            line = "line" + (linenum);
            sb2cut = sb2.toString().substring(0, (sb2.toString().length() < COMMENT_LENGTH ?
                                                  sb2.toString().length() : COMMENT_LENGTH));
            s = branchSerch(keyword,line,sb2cut,outfile,match,ignore,'o');
            if(s != null){
                sb.append(s);
                sb.append("</li>\n");
            }
            sb2.delete(0, sb2.length());
            flag_comment = false;
        } else if(qName.equals("comment")) {
            line = "line" + (linenum);
            Pattern pattern = Pattern.compile("\n");
            String[] s1 = pattern.split(sb2.toString());
            for (int i = 0; i < s1.length; i++) {
                if(i >= 1){
                    linenum++;
                }
                Pattern pattern2 = Pattern.compile(" ");
                String[] s2 = pattern2.split(s1[i]);
                for (int j = 0; j < s2.length; j++) {
                    s2[j] = s2[j].replaceAll(",", "");
                    s2[j] = s2[j].replaceAll(";", "");
                    s2[j] = s2[j].replaceAll(":", "");
                    s2[j] = s2[j].replaceAll("\t", "");
                    s2[j] = s2[j].replaceAll("/\\*", "");
                    s2[j] = s2[j].replaceAll("\\*/", "");
                    s2[j] = s2[j].replaceAll("\\*", "");
                    s2[j] = s2[j].replaceAll("\\.$", "");
                    s2[j] = s2[j].replaceAll("^//$", "");
                    if (!s2[j].equals(" ") && !s2[j].equals("")) {
                        s2[j] = s2[j].trim();
                        String line2 = "line" + (linenum);
                        s = branchSerch(keyword, line2, s2[j], outfile, match, ignore, 'o');
                        if (s != null) {
                            sb2cut = sb2.toString().substring(0, (sb2.toString().length() < COMMENT_LENGTH ?
                                                                  sb2.toString().length() : COMMENT_LENGTH));
                            s = branchSerch("", line, sb2cut, outfile, match, ignore,'o');
                            if (temps == null) {
                                temps = s;
                                sb.append(s);
                                sb.append("</li>\n");
                            }
                            if (!temps.equals(s)) {
                                sb.append(s);
                                sb.append("</li>\n");
                            }
                        }
                    }
                }
            }
            sb2.delete(0,sb2.length());
            flag_comment = false;
        } else if (qName.equals("kind")) {
            flag_kind = false;
        } else if (qName.equals("Type")) {
            flag_type = false;
        } else if (qName.equals("kw")) {
            flag_type = false;
        } else if (qName.equals("Expr")) {
            flag_expr_a = false;
            flag_expr_v = false;
        } else if (qName.equals("ident")) {
            if (flag_ident) {
                String string = sb2.toString();
                String line = "line" + (linenum);
                String s = null;
                if (flag_expr_v || flag_expr_a) {
                    if (position.equals("left") || position.equals("both")) {
                        s = branchSerch(keyword, line, string, outfile, match, ignore, 'a');
                    }
                } else {
                    if (position.equals("right") || position.equals("both")) {
                        s = branchSerch(keyword, line, string, outfile, match, ignore, 'r');
                    }
                }
                if (flag_kind) {
                    s = null;
                }
                if (s != null) {
                    sb.append(s);
                    sb.append("</li>\n");
                }
                sb2.delete(0,sb2.length());
            }
            flag_ident = false;
            if (flag_type) {
                flag_type = false;
            } else {
                flag_kind = false;
            }
            flag_expr_a = false;
            flag_expr_v = false;
        }
    }
    public void startDocument() {
        sb.delete(0,sb.length());
    }
    public void endDocument() {
        linenum = 1;
        Id = "";
    }
    public void characters(char[] ch,
                           int start,
                           int length) {
        String str = new String(ch, start, length);
        str = str.trim();
        str = str.replaceAll("&", "&amp;");
        str = str.replaceAll("<", "&lt;");
        str = str.replaceAll(">", "&gt;");
        if (flag_comment) {
            if (kind.equals("comment")) {
                if (!str.equals("")) {
                    sb2.append(str);
                }
            }
        } else if (flag_literal) {
            if (kind.equals("literal")) {
                if (!str.equals("")) {
                    sb2.append(str);
                }
            }   
        } else if (flag_ident) {
            if (!str.equals("")) {
                sb2.append(str);
            }
        }
    }
}
boolean checkMatch(String p, String s, String ignore) {
    Pattern pattern = null;

    if (ignore.equals("no")) {
        pattern = Pattern.compile(p, Pattern.CASE_INSENSITIVE);
    } else {
        pattern = Pattern.compile(p);
    }
    Matcher matcher = pattern.matcher(s);
    return matcher.matches();
}
String outA(String o, String i, String n) {
    return "<li><a href=\"fileset.jsp?file=" + o + "&amp;id=" + i +"\" target=\"f21\" class=\"" + kind + "\">" + n + "</a></li>\n";
}

String outA(String o, String i, String n, String p) {
    String s = "";
    if (p.equals("other") || p.equals("Declaration")) { 
        s += "<li>";
        s += "<a href=\"fileset.jsp?file=" + o + "&amp;id=" + i + "\"";
        s += "target=\"f21\" class=\"" + kind + "\">" + n + "</a>";
    } else if (p.equals("Assignment")) {
        s += "<li>";
        s += "  - <a href=\"fileset.jsp?file=" + o + "&amp;id=" + i + "\"";
        s += "target=\"f21\" class=\""+kind+"\">" + i + "</a> (Left Value)";
    } else if (p.equals("Reference") && (kind.equals("Field") || kind.equals("Param") || kind.equals("Local"))) {
        s += "<li>";
        s += "  - <a href=\"fileset.jsp?file=" + o + "&amp;id=" + i + "\"";
        s += "target=\"f21\" class=\"" + kind + "\">" + i + "</a> (Right Value)";
    } else if (p.equals("Reference")) {
        s += "<li>";
        s += "  - <a href=\"fileset.jsp?file=" + o + "&amp;id=" + i + "\"";
        s += "target=\"f21\" class=\""+kind+"\">" + i + "</a> (" + p + ")";
    }
    return s;
}

String branchSerch(String keyword, String classId, String className,
                   String outfile, String match, String ignore, char posi) {
    String posiName = "";
    switch(posi) {
        case 'o' :
            posiName = "other";
            break;
        case 'r' :
            posiName = "Reference";
            break;
        case 'd' :
            posiName = "Declaration";
            break;
        case 'a' :
            posiName = "Assignment";
            break;
    }
    if (match.equals("regex")) {
        if(this.checkMatch(keyword, className, ignore) || keyword.equals("")) {
            return this.outA(outfile, classId, className, posiName);
        } else {
            return null;
        }
    } else if (match.equals("strict")) {
        if (ignore.equals("yes")) {
            if (keyword.equals(className) || keyword.equals("")) {
                return this.outA(outfile, classId, className, posiName);
            } else {
                return null;
            }
        } else {
            if (keyword.equalsIgnoreCase(className) || keyword.equals("")) {
                return this.outA(outfile, classId, className, posiName);
            } else {
                return null;
            }
        }
    } else if(match.equals("back")) {
        if (keyword.equals("") || this.checkMatch(".*" + keyword + "$", className, ignore)) {
            return this.outA(outfile, classId, className, posiName);
        } else {
            return null;
        }
    } else if (match.equals("front")) {
        if (this.checkMatch("^" + keyword + ".*", className, ignore) || keyword.equals("")){ 
            return this.outA(outfile, classId, className, posiName);
        } else {
            return null;
        }
    } else if (match.equals("contain") && multi.equals("and")) {
        Pattern ptn = Pattern.compile(" ");
        String[] kw = ptn.split(keyword);
        int i = 0;
        for(int j = 0; j < kw.length; j++){
            if (ignore.equals("yes")) {
                if (className.indexOf(kw[j]) > -1 || keyword.equals("")) {
                    i++;
                }
            } else {
                if (className.toLowerCase().indexOf(kw[j].toLowerCase()) > -1
                   || keyword.equals("")) {
                    i++;
                }
            }
        }
        if (i == kw.length) {
            return this.outA(outfile, classId, className, posiName);
        } else {
            return null;
        }
    } else if (match.equals("contain")) {
        if (ignore.equals("yes")) {
            if (className.indexOf(keyword) > -1 || keyword.equals("")) {
                return this.outA(outfile, classId, className, posiName);
            } else {
                return null;
            }
        } else {
            if (className.toLowerCase().indexOf(keyword.toLowerCase()) > -1
            || keyword.equals("")) {
                return this.outA(outfile, classId, className, posiName);
            } else {
                return null;
            }
        }
    } else {
        return null;
    }
}
%>
<body>
<div></div>
<%
sb = new StringBuffer();
sb2 = new StringBuffer();
sb3 = new StringBuffer();
sb4 = new StringBuffer();
sb5 = new StringBuffer();
String xmlpath = "project/" + PROJECTID + "/SDB/J-MODEL";
String htmlpath = "project/" + PROJECTID + "/html";
File fl = new File(application.getRealPath(xmlpath));
String[] kinds = request.getParameterValues("kind");
String inkeyword = request.getParameter("keyword");
match = request.getParameter("match");
ignore = request.getParameter("ignore");

String[] positions = request.getParameterValues("position");
if (positions.length == 2) {
    position = positions[1];
} else {
    position = "both";
}

multi = request.getParameter("multi");
ArrayList fileList = new ArrayList();

if (request.getParameterValues("file") != null) {
    String[] files = request.getParameterValues("file");
    for (int a = 0; a < files.length; a++) {
        fileList.add(new File(application.getRealPath(files[a])));
    }
} else {
    DirWalkIterator dw = new DirWalkIterator(fl.toString(), ".*\\.java\\.xml$", true);
    File tmpFile;
    while (dw.hasNext()) {
        fileList.add((File)dw.next());
    }
}
outfile = "";


//DOM

Document doc = null; 
DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
DocumentBuilder db = dbf.newDocumentBuilder();

//SAX

SAXParserFactory spf = SAXParserFactory.newInstance();
SAXParser sp = spf.newSAXParser();
SaxHandler sh = new SaxHandler();

String[] kw = new String[KEYWORD_SIZE];

if (match.equals("contain") && multi.equals("and")) {
    kw[0] = inkeyword;
} else {
    Pattern ptn = Pattern.compile(" ");
    kw = ptn.split(inkeyword);
}

for (int m = 0; m < kinds.length; m++) {
kind = kinds[m];
    for (int l = 0; l < kw.length; l++) {
        keyword = kw[l];
        if (keyword != null){
            if (inkeyword.equals("")) {
                out.print("S");
            } else {
                out.print(keyword + "");
            }
            out.print(kind+"<br />\n");
            flag_file = false;
            sb5.append("<ol>");
            for (int k = 0; k < fileList.size(); k++) {
                if (fileList.get(k) != null) {
                    File searchfile = (File)fileList.get(k);
                    String st;
                    if (File.separator.equals("\\")) {
                        st = searchfile.toString().replaceAll("\\" + File.separator, "/");
                    } else {
                        st = searchfile.toString();
                    }
                    String xmlname = searchfile.getName().substring(0,searchfile.getName().length() - 9);
                    String[] s1 = st.split(xmlpath, 2);
                    String[] s2 = s1[1].split("/");
                    String ppath = "";
                    for (int o = 1; o < s2.length; o++) {
                        if (s2.length > 3 && o < s2.length - 2) {
                            if ( o == 1) {
                                ppath = s2[o];
                            } else {
                                ppath += "/" + s2[o];
                            }
                        }
                    }
                    if (!ppath.equals("")) {
                        ppath += "/";
                    }
                    outfile = ppath + xmlname;
                    doc = db.parse(searchfile);
                    flag_file = false;
                    sb3.append("<li><a href=\"fileset.jsp?file=" + outfile +"\" target=\"f21\" class=\"file\">");
                    sb3.append(searchfile.getName().substring(0,searchfile.getName().length()-4));
                    sb3.append("</a><ol>\n");
                    if (kind.equals("literal")) {
                        sp.parse(searchfile, sh);
                        sb3.append(sb.toString());
                        if (!sb.toString().equals("")) {
                            flag_file = true;
                            flag_kind = true;
                        }
                    } else if (kind.equals("comment")) {
                        sp.parse(searchfile, sh);
                        sb3.append(sb.toString());
                        if (!sb.toString().equals("")) {
                            flag_file = true;
                            flag_kind = true;
                        }
                    } else {
                        NodeList classList = doc.getElementsByTagName(kind);
                        if (classList.getLength() > 0) {
                            for (int i = 0; i < classList.getLength(); i++) {
                                Node classNode = classList.item(i);
                                NamedNodeMap attrlist = classNode.getAttributes();
                                Node attr = attrlist.getNamedItem("id");
                                String classId = attr.getNodeValue();
                                NodeList childClassList = classNode.getChildNodes();
                                for(int j = 0; j < childClassList.getLength(); j++){
                                    Node childClassNode = childClassList.item(j);
                                    if (childClassNode.getNodeName().equals("ident")) {
                                        attrlist = childClassNode.getAttributes();
                                        attr = attrlist.getNamedItem("defid");
                                        String defId = attr.getNodeValue();
                                        if (classId.equals(defId)) {
                                            String className = childClassNode.getFirstChild().getNodeValue();
                                            String s = branchSerch(keyword, classId, className, outfile, match, ignore, 'd');
                                            if (s != null) {
                                                sb3.append(s);
                                                sb4.append("<ol>\n");
                                                Id = classId;
                                                sp.parse(searchfile, sh);
                                                sb4.append(sb.toString());
                                                sb4.append("</ol>\n");
                                                if(!sb.toString().equals("")){
                                                    sb3.append(sb4.toString());
                                                }
                                                sb4.delete(0,sb4.length());
                                                sb3.append("</li>\n");
                                                flag_file = true;
                                                flag_kind = true;
                                            }
                                        }
                                    }
                                } 
                            }
                        }
                    }
                    sb3.append("</ol>\n</li>\n");
                    if (flag_file) {
                        sb5.append(sb3);
                        flag_file = false;
                    }
                    sb3.delete(0,sb3.length());
                }
            }
            sb5.append("</ol>\n");
            if (flag_kind) {
                out.print(sb5);
                flag_kind = false;
            }
            sb5.delete(0,sb5.length());
        }
    }
}
%>
</body>
</html>
