/* 
 * Program:             $RCSfile: SearchMemoResult.java,v $  $Revision: 50.1 $
 * 
 * Purpose:             
 *
 * Author:              Y.Sawada  2003/10/01
 *                      S.Yamamoto  2003/10/01
 *
 * (C) Copyright:       Y.Sawada and S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: SearchMemoResult.java,v 50.1 2003/11/18 23:24:15 yamamoto Exp yamamoto $
 */

package jspie3;

import org.w3c.dom.*;
import java.util.*;

public class SearchMemoResult extends WriteMemoTree{
    HashSet matchMemo;

    // test code
    public static void main(String[] args){
	HashSet result = new HashSet();
	result.add("m2");
	SearchMemoResult smr = new SearchMemoResult(".",result);
	smr.memoTreeVisit();
	System.out.print(smr.getResult());
    }
    // test code end

    public SearchMemoResult(String path,HashSet result){
	super(path);
	matchMemo = result;
    }

    protected void  visit(Node node,String linkIds){
	String linkId = ((Element)node).getAttribute("id");
	NodeList nl2 = node.getChildNodes();
	Element pos = (Element)nl2.item(1);
	Element memo = (Element)nl2.item(3);
	String posId = pos.getAttribute("id");
	String memoId = memo.getAttribute("id");
	if(matchMemo.contains(memoId)){
	    String fileName = pos.getFirstChild().getNodeValue();
	    Node memoNode = getMemoNode(memoId);
	    Hashtable c = getMemoContents(memoNode);
	    result.append("<a target=\"f21\" href=\"fileset.jsp?file=" + rootFileName + "&amp;id=" + linkIds +"\"></a>");
	    result.append(c.get("auther") + " " + c.get("title") + " ");
	    result.append(memoId + ":"  + linkIds +  " (" + rootFileName + ") " + c.get("create"));
	    result.append("<br />\n");
	}
    }

    protected void visitAfter(Node node, String linkIds){
    }
}
