/* 
 * Program:             $RCSfile: SearchQuery.java,v $  $Revision: 50.1 $
 * 
 * Purpose:             
 *
 * Author:              Y.Sawada  2003/10/01
 *                      S.Yamamoto  2003/10/01
 *
 * (C) Copyright:       Y.Sawada and S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: SearchQuery.java,v 50.1 2003/11/18 23:22:13 yamamoto Exp yamamoto $
 */

package jspie3;

public class SearchQuery {
    private String project;
    private String packageName;
    private String fileName;
    private String queryString;
    private String[] queryStrings;
    private boolean isAnd;
    private boolean checkBody;
    private boolean checkTitle;
    private boolean checkAuther;
    private int scope;

    public SearchQuery(){
	project = new String();
	packageName = new String();
	fileName = new String();
	queryString = new String();
	isAnd = false;
	checkTitle = false;
	checkAuther = false;
	scope = 0;
    }

    /**
     * @return
     */
    public boolean isCheckAuther() {
	return checkAuther;
    }

    /**
     * @return
     */
    public boolean isCheckBody() {
	return checkBody;
    }

    /**
     * @return
     */
    public boolean isCheckTitle() {
	return checkTitle;
    }

    /**
     * @return
     */
    public String getFileName() {
	return fileName;
    }

    /**
     * @return
     */
    public boolean isAnd() {
	return isAnd;
    }

    /**
     * @return
     */
    public String getPackageName() {
	return packageName;
    }

    /**
     * @return
     */
    public String getProject() {
	return project;
    }

    /**
     * @return
     */
    public String getQueryString() {
	return queryString;
    }

    /**
     * @return
     */
    public String[] getQueryStrings() {
	return queryStrings;
    }

    /**
     * @return
     */
    public int getScope() {
	return scope;
    }

    /**
     * @param b
     */
    public void setCheckAuther(boolean b) {
	checkAuther = b;
    }

    /**
     * @param b
     */
    public void setCheckBody(boolean b) {
	checkBody = b;
    }

    /**
     * @param b
     */
    public void setCheckTitle(boolean b) {
	checkTitle = b;
    }

    /**
     * @param string
     */
    public void setFileName(String string) {
	fileName = string;
    }

    /**
     * @param b
     */
    public void setAnd(boolean b) {
	isAnd = b;
    }

    /**
     * @param string
     */
    public void setPackageName(String string) {
	packageName = string;
    }

    /**
     * @param string
     */
    public void setProject(String string) {
	project = string;
    }

    /**
     * @param string
     */
    public void setQueryString(String string) {
	queryString = string;
	queryStrings = queryString.split(" |");
    }

    /**
     * @param i
     */
    public void setScope(int i) {
	scope = i;
    }

}
