/* 
 * Program:             $RCSfile: WriteMemoHeader.java,v $  $Revision: 50.4 $
 * 
 * Purpose:             
 *
 * Author:              Y.Sawada  2003/10/01
 *                      S.Yamamoto  2003/10/01
 *
 * (C) Copyright:       Y.Sawada and S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: WriteMemoHeader.java,v 50.4 2003/11/22 05:34:27 yamamoto Exp yamamoto $
 */

package jspie3;

import java.io.*;
import java.util.*;
import javax.xml.parsers.*;
import org.w3c.dom.*;

public class WriteMemoHeader extends MemoTreeVisitor{
    private StringBuffer func1;
    private StringBuffer func2;
    private StringBuffer func3;
    private StringBuffer func4;

    public WriteMemoHeader(String path){
	super(path);
	func1 = new StringBuffer();
	func2= new StringBuffer();
	func3 = new StringBuffer();
	func4 = new StringBuffer();
    }
    
    public void visit(Node node, String linkIds){
	if(depth == 0){
	    String linkId = ((Element)node).getAttribute("id");
	    NodeList nl2 = node.getChildNodes();
	    Element pos = (Element)nl2.item(1);
	    String posId = pos.getAttribute("id");
	    String x = pos.getAttribute("x");
	    String y = pos.getAttribute("y");
	    func1.append("  deploy2('" + linkId + "','" + posId + "'," + x + "," + y + ");\n");
	    func2.append("  displayNone('" + linkId +"');\n");
	    func3.append("  displayBlock('" + linkId +"');\n");
	    func4.append("  dragLay['" + linkId +"'] = new dragLay('" + linkId + "');\n");
	}
    }

    public String getResult(){
	result.append("<!--\n");
	result.append("function deploy(){\n");
	result.append(func1);
	result.append("}\n");
	result.append("function memoInvisible(){\n");
	result.append(func2);
	result.append("}\n");
	result.append("function memoVisible(){\n");
	result.append(func3);
	result.append("}\n");
	result.append("function drag(){\n");
	result.append(func4);
	result.append("}\n");
	result.append("-->\n");
	return result.toString();
    }
}
