/* 
 * Program:             $RCSfile: FCD-view.h,v $  $Revision: 40.3 $
 * 
 * Purpose:             Class definition of CommentView.
 *
 * Author:              N.Atsumi  2001/11/29
 *                      S.Yamamoto  2001/10/27 
 *
 * (C) Copyright:       N.Atsumi and S.Yamamoto  2001 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: FCD-view.h,v 40.3 2003/02/20 15:12:55 yamamoto Exp yamamoto $
 */ 

#ifndef _SPD_FCD_VIEW_H
#define _SPD_FCD_VIEW_H

/* Class id. */

#define SPD_CID_FCDG                (SPD_FIRST_CID_FCD_VIEW + 0)

#if (SPD_CID_FCDG != SPD_LAST_CID_FCD_VIEW)
    "Invalid configuration."
#endif

#define SPD_CID_NUM_FCD_VIEW \
        (SPD_LAST_CID_FCD_VIEW - SPD_FIRST_CID_FCD_VIEW + 1)

/* Relation id. */

#define SPD_RID_FUNC_FCDG           (SPD_FIRST_RID_FCD_VIEW + 0)
#define SPD_RID_LIBDATA_DEPEND      (SPD_FIRST_RID_FCD_VIEW + 1)
#define SPD_RID_LIBCTRL_DEPEND      (SPD_FIRST_RID_FCD_VIEW + 2)
#define SPD_RID_FCDG_EXPR           (SPD_FIRST_RID_FCD_VIEW + 3)
#define SPD_RID_FCDG_LIB            (SPD_FIRST_RID_FCD_VIEW + 4)
#define SPD_RID_DEF_VAR             (SPD_FIRST_RID_FCD_VIEW + 5)
#define SPD_RID_COND_OP             (SPD_FIRST_RID_FCD_VIEW + 6)
#define SPD_RID_COND_VAL            (SPD_FIRST_RID_FCD_VIEW + 7)

#if (SPD_RID_COND_VAL != SPD_LAST_RID_FCD_VIEW)
    "Invalid configuration."
#endif

#define SPD_RID_NUM_FCD_VIEW \
        (SPD_LAST_RID_FCD_VIEW - SPD_FIRST_RID_FCD_VIEW + 1)

/* Number of all classes and relations. */

#define SPD_CRID_NUM_FCD_VIEW \
        (SPD_CID_NUM_FCD_VIEW + SPD_RID_NUM_FCD_VIEW)

/******************************************************************************/

/* Attribute values. */

#define FCDG_LIBDEF     1
#define FCDG_LIBREF     2
#define FCDG_LIBDEFREF  3
#define FCDG_CONDITION  4

/******************************************************************************/

#define SPD_FCD_VIEW_VERSION      1

extern SpdDBModel FCD_view;

#endif /* _SPD_FCD_VIEW_H */
