/* 
 * Program:             $RCSfile: ImodelAR.h,v $  $Revision: 30.7 $
 * 
 * Purpose:             
 * 
 * Author:              T.Hidaka  1998/05/21
 *                      S.Yamamoto  1998/05/23
 * 
 * (C) Copyright:       T.Hidaka and S.Yamamoto  1998 - 2001
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: ImodelAR.h,v 30.7 2003/07/06 10:09:07 yamamoto Exp yamamoto $
 */ 

#if !defined(_SPD_IMODEL_AR_H)
#define _SPD_IMODEL_AR_H

#if defined(SAPID_AR5)

/* 
 * SpdSet spdGetFileDeclSet(SpdRelId relationId);
 */
SpdRel spdGetFileDeclOfFile(SpdRelId relationId, SpdObjId fileId);
int spdGetAbsoluteOffset(SpdRelId relationId, SpdObjId fileId);
int spdGetRelativeOffset(SpdRelId relationId);
SpdSet2 spdConvRelSetToOccSet(SpdSet2 rels, SpdObjId parentId);
SpdSet2 spdConvOccSetToRelSet(SpdSet2 occs);
SpdSet2 spdGetOffsetOfObjSet(SpdObjId objectId, SpdObjId fileId);
SpdSet2 spdGetIncludedOccSet(SpdObjId objectId,
                            SpdConstString objectType,
                            SpdObjId fileId);
SpdConstString spdGetObjText(SpdObjId objectId);
int spdGetLengthOfObj(SpdObjId objectId);

#endif /* defined(SAPID_AR5) */

#endif /* !defined(_SPD_IMODEL_AR_H) */
