/* 
 * Program:             $RCSfile: StmtModelAR.h,v $  $Revision: 30.3 $
 * 
 * Purpose:             StmtModel access routines.
 *
 * Author:              T.Suzuki  1998/10/22
 *                      S.Yamamoto  1998/10/22
 *
 * (C) Copyright:       T.Suzuki and S.Yamamoto  1998
 *                      This file is a product of the project Sapid.
 */

#ifndef _STMTMODEL_AR_H
#define _STMTMODEL_AR_H

#include "StmtModel.h"

extern SpdObjId spdGetStmtOfExpr(SpdObjId expr);
extern SpdSet2  spdGetExprOfStmt(SpdObjId stmt);
extern SpdRel   sdaGetParentCtrlRel(SpdObjId stmt);
extern SpdObjId sdaGetParentCtrlStmt(SpdObjId stmt);
extern SpdRel   spdGetAStmtExprRel(SpdObjId stmt);

extern SpdSet2  sdaGetChildCtrlStmt(SpdObjId stmt);

extern SpdQueue*spdGetSortedStmtRelId(SpdObjId blk);
extern SpdQueue*spdGetSortedStmts(SpdObjId blk);

#endif /* _STMTMODEL_AR_H */
