/*  
 * Program:             $RCSfile: IDFactory.java,v $  $Revision: 51.1 $
 * 
 * Purpose:             Create id.
 * 
 * Author:              S.Takeshi  2003/08/03
 *                      S.Yamamoto  2003/08/03
 * 
 * (C) Copyright:       S.Takeshi and S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: IDFactory.java,v 51.1 2003/09/09 07:30:55 yamamoto Exp yamamoto $
 */

package wapid.jsxmodel;

public class IDFactory {

    private final int INIT_ID = 0;
    protected int ID;

    public IDFactory(){
        this.ID = INIT_ID;
    }

    public int createID(){
        return ID++;
    }

}
