/*  
 * Program:             $RCSfile: JSXTFormalParameter.java,v $  $Revision: 50.6 $
 * 
 * Purpose:             Parameter (NonTerminalNode).
 *                      child: Stmt, FuncDecl
 * 
 * Author:              S.Takeshi  2003/08/03
 *                      S.Yamamoto  2003/08/03
 * 
 * (C) Copyright:       S.Takeshi and S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: JSXTFormalParameter.java,v 50.6 2003/08/12 06:36:43 yamamoto Exp yamamoto $
 */

package wapid.jsxmodel;

import wapid.parser.js.*;

public class JSXTFormalParameter extends JSXTMetaNode {
    public int node_type = PARAM;
    public String node_name = "Param";

    public JSXTFormalParameter(int depth, Token firstToken, Token lastToken) {
        super(depth, firstToken, lastToken);
        setNodeName(node_name);
    }
}
