/*  
 * Program:             $RCSfile: JSXTIdentifier.java,v $  $Revision: 50.6 $
 * 
 * Purpose:             identifier (TerminalNode).
 * 
 * Author:              S.Takeshi  2003/08/03
 *                      S.Yamamoto  2003/08/03
 * 
 * (C) Copyright:       S.Takeshi and S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: JSXTIdentifier.java,v 50.6 2003/08/12 06:36:46 yamamoto Exp yamamoto $
 */

package wapid.jsxmodel;

import wapid.parser.js.*;

public class JSXTIdentifier extends JSXTMetaNode {
    public int node_type = IDENT;
    public String node_name = "ident";
    private String identifierName = null;

    public JSXTIdentifier(int depth, Token firstToken, Token lastToken) {
        super(depth, firstToken, lastToken);
        setNodeName(node_name);
        super.isTerminalNode = true;
        this.identifierName = firstToken.image;
    }
    
    public void setName(String literalName) {
        this.identifierName = literalName.intern();
    }

    public String toString() {
        return checkStr(identifierName);
    }
}
