/*  
 * Program:             $RCSfile: JSXTOperator.java,v $  $Revision: 50.6 $
 * 
 * Purpose:             operator (TerminalNode).
 * 
 * Author:              S.Takeshi  2003/08/03
 *                      S.Yamamoto  2003/08/03
 * 
 * (C) Copyright:       S.Takeshi and S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: JSXTOperator.java,v 50.6 2003/08/12 06:20:35 yamamoto Exp yamamoto $
 */

package wapid.jsxmodel;

import wapid.parser.js.*;

public class JSXTOperator extends JSXTMetaNode {

    public int node_type = OP;
    public String node_name = "op";

    protected String operatorCode = null;

    public JSXTOperator(int depth, Token firstToken, Token lastToken) {
        super(depth, firstToken, lastToken);
        setNodeName(node_name);
        super.isTerminalNode = true;
        this.operatorCode = firstToken.image;
    }
}
