/*  
 * Program:             $RCSfile: SymbolTableElement.java,v $  $Revision: 50.2 $
 * 
 * Purpose:             
 * 
 * Author:              S.Takeshi  2003/09/06
 *                      S.Yamamoto  2003/09/06
 * 
 * (C) Copyright:       S.Takeshi and S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: SymbolTableElement.java,v 50.2 2003/09/07 07:28:57 yamamoto Exp yamamoto $
 */

/**
 * SymboleTableElement
 * 
 * @author
 */

package wapid.jsxmodel.xref;

import java.util.*;

public class SymbolTableElement implements SymbolTableConstants {

	String symName;
	String symPos;
	int symID;
	int symType;

	// this symbol is used at ...
	Vector usedList;

	/**
	 * Constructor
	 * @param symName
	 * @param symPos
	 * @param id
	 * @param sort
	 */
	public SymbolTableElement(String symName,String symPos,int id,int sort) {
		this.symName = symName;
		this.symPos = symPos;
		this.symID = id;
		this.symType = sort;
		this.usedList = new Vector();
	}
	
	/**
	 * Get column counter.
	 * @return
	 */
	public int getColumnNum() {
		String[] posa = symPos.split(" ");
		int c = Integer.parseInt(posa[1]);
		return c;
	}

	/**
	 * Get line counter.
	 * @return
	 */
	public int getLineNum() {
		String[] posa = symPos.split(" ");
		int l = Integer.parseInt(posa[0]);
		return l;
	}

}
