/*  
 * Program:             $RCSfile: SymbolTableReference.java,v $  $Revision: 50.2 $
 * 
 * Purpose:             SymboleTableElement.
 * 
 * Author:              S.Takeshi  2003/09/06
 *                      S.Yamamoto  2003/09/06
 * 
 * (C) Copyright:       S.Takeshi and S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: SymbolTableReference.java,v 50.2 2003/09/07 07:28:58 yamamoto Exp yamamoto $
 */

/**
 * SymboleTableElement
 * 
 * @author
 */

package wapid.jsxmodel.xref;

public class SymbolTableReference implements SymbolTableConstants {

	String identName;
	String identPos;
	int identID;
	int defID;

	int identSort;// funcall, grobalvar, localvar

	/**
	 * 
	 * 
	 * @param Name
	 * @param Pos
	 * @param id
	 * @param defID
	 */
	public SymbolTableReference(String Name,String Pos,int id,int defID) {
		this.identName = Name;
		this.identPos = Pos;
		this.identID = id;
		this.defID = defID;
	}
	
	/**
	 * Get column counter.
	 * @return
	 */
	public int getColumnNum() {
		String[] posa = identPos.split(" ");
		int c = Integer.parseInt(posa[1]);
		return c;
	}

	/**
	 * Get line counter.
	 * @return
	 */
	public int getLineNum() {
		String[] posa = identPos.split(" ");
		int l = Integer.parseInt(posa[0]);
		return l;
	}

}
