package wapid.wxmodel.abstractwxmodelar;

import java.io.*;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.Writer;
import java.net.MalformedURLException;
import java.net.URL;
import javax.xml.parsers.*;
import org.w3c.dom.*;
import org.xml.sax.*;

/**
 * <b>AWxNl</b> is generated from WXModel.rxm by Relaxer.
 * This class is derived from:
 * 
 * <!-- for programmer
 * <elementRule role="nl" type="string"/>
 * 
 * <tag name="nl">
 *   <attribute name="id" required="true" type="ID"/>
 *   <attribute name="line" type="NMTOKEN"/>
 *   <attribute name="offset" type="NMTOKEN"/>
 *   <attribute name="coffset" type="NMTOKEN"/>
 * </tag>
 * -->
 * <!-- for javadoc -->
 * <pre> &lt;elementRule role="nl" type="string"/&gt;
 * &lt;tag name="nl"&gt;
 *   &lt;attribute name="id" required="true" type="ID"/&gt;
 *   &lt;attribute name="line" type="NMTOKEN"/&gt;
 *   &lt;attribute name="offset" type="NMTOKEN"/&gt;
 *   &lt;attribute name="coffset" type="NMTOKEN"/&gt;
 * &lt;/tag&gt;
 * </pre>
 *
 * @version WXModel.rxm 1.0 (Tue Oct 14 15:24:08 JST 2003)
 * @author  Relaxer 1.0rc2 (http://www.relaxer.org)
 */
public class AWxNl implements java.io.Serializable, Cloneable, IRVisitable, IRNode, IAWxFileChoice, IAWxXMLDeclChoice, IAWxAttributeChoice, IAWxStringChoice, IAWxDoctypeDeclChoice, IAWxExternalIDChoice, IAWxStyleSheetChoice, IAWxElementChoice, IAWxSTagChoice, IAWxETagChoice, IAWxEmptyChoice {
    private String content_;
    private String id_;
    private String line_;
    private String offset_;
    private String coffset_;
    private IRNode parentRNode_;

    /**
     * Creates a <code>AWxNl</code>.
     *
     */
    public AWxNl() {
        id_ = "";
    }

    /**
     * Creates a <code>AWxNl</code>.
     *
     * @param source
     */
    public AWxNl(AWxNl source) {
        setup(source);
    }

    /**
     * Creates a <code>AWxNl</code> by the Stack <code>stack</code>
     * that contains Elements.
     * This constructor is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     */
    public AWxNl(RStack stack) {
        setup(stack);
    }

    /**
     * Creates a <code>AWxNl</code> by the Document <code>doc</code>.
     *
     * @param doc
     */
    public AWxNl(Document doc) {
        setup(doc.getDocumentElement());
    }

    /**
     * Creates a <code>AWxNl</code> by the Element <code>element</code>.
     *
     * @param element
     */
    public AWxNl(Element element) {
        setup(element);
    }

    /**
     * Creates a <code>AWxNl</code> by the File <code>file</code>.
     *
     * @param file
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public AWxNl(File file) throws IOException, SAXException, ParserConfigurationException {
        setup(file);
    }

    /**
     * Creates a <code>AWxNl</code>
     * by the String representation of URI <code>uri</code>.
     *
     * @param uri
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public AWxNl(String uri) throws IOException, SAXException, ParserConfigurationException {
        setup(uri);
    }

    /**
     * Creates a <code>AWxNl</code> by the URL <code>url</code>.
     *
     * @param url
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public AWxNl(URL url) throws IOException, SAXException, ParserConfigurationException {
        setup(url);
    }

    /**
     * Creates a <code>AWxNl</code> by the InputStream <code>in</code>.
     *
     * @param in
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public AWxNl(InputStream in) throws IOException, SAXException, ParserConfigurationException {
        setup(in);
    }

    /**
     * Creates a <code>AWxNl</code> by the InputSource <code>is</code>.
     *
     * @param is
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public AWxNl(InputSource is) throws IOException, SAXException, ParserConfigurationException {
        setup(is);
    }

    /**
     * Creates a <code>AWxNl</code> by the Reader <code>reader</code>.
     *
     * @param reader
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public AWxNl(Reader reader) throws IOException, SAXException, ParserConfigurationException {
        setup(reader);
    }

    /**
     * Initializes the <code>AWxNl</code> by the AWxNl <code>source</code>.
     *
     * @param source
     */
    public void setup(AWxNl source) {
        int size;
        setContent(source.getContent());
        setId(source.getId());
        setLine(source.getLine());
        setOffset(source.getOffset());
        setCoffset(source.getCoffset());
    }

    /**
     * Initializes the <code>AWxNl</code> by the Document <code>doc</code>.
     *
     * @param doc
     */
    public void setup(Document doc) {
        setup(doc.getDocumentElement());
    }

    /**
     * Initializes the <code>AWxNl</code> by the Element <code>element</code>.
     *
     * @param element
     */
    public void setup(Element element) {
        init(element);
    }

    /**
     * Initializes the <code>AWxNl</code> by the Stack <code>stack</code>
     * that contains Elements.
     * This constructor is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     */
    public void setup(RStack stack) {
        init(stack.popElement());
    }

    /**
     * @param element
     */
    private void init(Element element) {
        IWXModelFactory factory = WXModelFactory.getFactory();
        RStack stack = new RStack(element);
        content_ = URelaxer.getElementPropertyAsString(element);
        id_ = URelaxer.getAttributePropertyAsString(element, "id");
        line_ = URelaxer.getAttributePropertyAsString(element, "line");
        offset_ = URelaxer.getAttributePropertyAsString(element, "offset");
        coffset_ = URelaxer.getAttributePropertyAsString(element, "coffset");
    }

    /**
     * @return Object
     */
    public Object clone() {
        IWXModelFactory factory = WXModelFactory.getFactory();
        return (factory.createAWxNl(this));
    }

    /**
     * Creates a DOM representation of the object.
     * Result is appended to the Node <code>parent</code>.
     *
     * @param parent
     */
    public void makeElement(Node parent) {
        Document doc;
        if (parent instanceof Document) {
            doc = (Document)parent;
        } else {
            doc = parent.getOwnerDocument();
        }
        Element element = doc.createElement("nl");
        URelaxer.setElementPropertyByString(element, this.content_);
        int size;
        if (this.id_ != null) {
            URelaxer.setAttributePropertyByString(element, "id", this.id_);
        }
        if (this.line_ != null) {
            URelaxer.setAttributePropertyByString(element, "line", this.line_);
        }
        if (this.offset_ != null) {
            URelaxer.setAttributePropertyByString(element, "offset", this.offset_);
        }
        if (this.coffset_ != null) {
            URelaxer.setAttributePropertyByString(element, "coffset", this.coffset_);
        }
        parent.appendChild(element);
    }

    /**
     * Initializes the <code>AWxNl</code> by the File <code>file</code>.
     *
     * @param file
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(File file) throws IOException, SAXException, ParserConfigurationException {
        setup(file.toURL());
    }

    /**
     * Initializes the <code>AWxNl</code>
     * by the String representation of URI <code>uri</code>.
     *
     * @param uri
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(String uri) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(uri, UJAXP.FLAG_NONE));
    }

    /**
     * Initializes the <code>AWxNl</code> by the URL <code>url</code>.
     *
     * @param url
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(URL url) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(url, UJAXP.FLAG_NONE));
    }

    /**
     * Initializes the <code>AWxNl</code> by the InputStream <code>in</code>.
     *
     * @param in
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(InputStream in) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(in, UJAXP.FLAG_NONE));
    }

    /**
     * Initializes the <code>AWxNl</code> by the InputSource <code>is</code>.
     *
     * @param is
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(InputSource is) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(is, UJAXP.FLAG_NONE));
    }

    /**
     * Initializes the <code>AWxNl</code> by the Reader <code>reader</code>.
     *
     * @param reader
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(Reader reader) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(reader, UJAXP.FLAG_NONE));
    }

    /**
     * Creates a DOM document representation of the object.
     *
     * @exception ParserConfigurationException
     * @return Document
     */
    public Document makeDocument() throws ParserConfigurationException {
        Document doc = UJAXP.makeDocument();
        makeElement(doc);
        return (doc);
    }

    /**
     * Gets the String property <b>content</b>.
     *
     * @return String
     */
    public final String getContent() {
        return (content_);
    }

    /**
     * Sets the String property <b>content</b>.
     *
     * @param p_content
     */
    public final void setContent(String p_content) {
        this.content_ = p_content;
    }

    /**
     * Gets the String property <b>id</b>.
     *
     * @return String
     */
    public final String getId() {
        return (id_);
    }

    /**
     * Sets the String property <b>id</b>.
     *
     * @param p_id
     */
    public final void setId(String p_id) {
        this.id_ = p_id;
    }

    /**
     * Gets the String property <b>line</b>.
     *
     * @return String
     */
    public final String getLine() {
        return (line_);
    }

    /**
     * Sets the String property <b>line</b>.
     *
     * @param p_line
     */
    public final void setLine(String p_line) {
        this.line_ = p_line;
    }

    /**
     * Gets the String property <b>offset</b>.
     *
     * @return String
     */
    public final String getOffset() {
        return (offset_);
    }

    /**
     * Sets the String property <b>offset</b>.
     *
     * @param p_offset
     */
    public final void setOffset(String p_offset) {
        this.offset_ = p_offset;
    }

    /**
     * Gets the String property <b>coffset</b>.
     *
     * @return String
     */
    public final String getCoffset() {
        return (coffset_);
    }

    /**
     * Sets the String property <b>coffset</b>.
     *
     * @param p_coffset
     */
    public final void setCoffset(String p_coffset) {
        this.coffset_ = p_coffset;
    }

    /**
     * Makes a XML text representation.
     *
     * @return String
     */
    public String makeTextDocument() {
        StringBuffer buffer = new StringBuffer();
        makeTextElement(buffer);
        return (new String(buffer));
    }

    /**
     * Makes a XML text representation.
     *
     * @param buffer
     */
    public void makeTextElement(StringBuffer buffer) {
        int size;
        buffer.append("<nl");
        if (id_ != null) {
            buffer.append(" id=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(getId())));
            buffer.append("\"");
        }
        if (line_ != null) {
            buffer.append(" line=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(getLine())));
            buffer.append("\"");
        }
        if (offset_ != null) {
            buffer.append(" offset=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(getOffset())));
            buffer.append("\"");
        }
        if (coffset_ != null) {
            buffer.append(" coffset=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(getCoffset())));
            buffer.append("\"");
        }
        buffer.append(">");
        buffer.append(URelaxer.escapeCharData(URelaxer.getString(getContent())));
        buffer.append("</nl>");
    }

    /**
     * Makes a XML text representation.
     *
     * @param buffer
     * @exception IOException
     */
    public void makeTextElement(Writer buffer) throws IOException {
        int size;
        buffer.write("<nl");
        if (id_ != null) {
            buffer.write(" id=\"");
            buffer.write(URelaxer.escapeAttrQuot(URelaxer.getString(getId())));
            buffer.write("\"");
        }
        if (line_ != null) {
            buffer.write(" line=\"");
            buffer.write(URelaxer.escapeAttrQuot(URelaxer.getString(getLine())));
            buffer.write("\"");
        }
        if (offset_ != null) {
            buffer.write(" offset=\"");
            buffer.write(URelaxer.escapeAttrQuot(URelaxer.getString(getOffset())));
            buffer.write("\"");
        }
        if (coffset_ != null) {
            buffer.write(" coffset=\"");
            buffer.write(URelaxer.escapeAttrQuot(URelaxer.getString(getCoffset())));
            buffer.write("\"");
        }
        buffer.write(">");
        buffer.write(URelaxer.escapeCharData(URelaxer.getString(getContent())));
        buffer.write("</nl>");
    }

    /**
     * Makes a XML text representation.
     *
     * @param buffer
     */
    public void makeTextElement(PrintWriter buffer) {
        int size;
        buffer.print("<nl");
        if (id_ != null) {
            buffer.print(" id=\"");
            buffer.print(URelaxer.escapeAttrQuot(URelaxer.getString(getId())));
            buffer.print("\"");
        }
        if (line_ != null) {
            buffer.print(" line=\"");
            buffer.print(URelaxer.escapeAttrQuot(URelaxer.getString(getLine())));
            buffer.print("\"");
        }
        if (offset_ != null) {
            buffer.print(" offset=\"");
            buffer.print(URelaxer.escapeAttrQuot(URelaxer.getString(getOffset())));
            buffer.print("\"");
        }
        if (coffset_ != null) {
            buffer.print(" coffset=\"");
            buffer.print(URelaxer.escapeAttrQuot(URelaxer.getString(getCoffset())));
            buffer.print("\"");
        }
        buffer.print(">");
        buffer.print(URelaxer.escapeCharData(URelaxer.getString(getContent())));
        buffer.print("</nl>");
    }

    /**
     * Makes a XML text representation.
     *
     * @param buffer
     */
    public void makeTextAttribute(StringBuffer buffer) {
    }

    /**
     * Makes a XML text representation.
     *
     * @param buffer
     * @exception IOException
     */
    public void makeTextAttribute(Writer buffer) throws IOException {
    }

    /**
     * Makes a XML text representation.
     *
     * @param buffer
     */
    public void makeTextAttribute(PrintWriter buffer) {
    }

    /**
     * Gets the property value as String.
     *
     * @return String
     */
    public String getContentAsString() {
        return (URelaxer.getString(getContent()));
    }

    /**
     * Gets the property value as String.
     *
     * @return String
     */
    public String getIdAsString() {
        return (URelaxer.getString(getId()));
    }

    /**
     * Gets the property value as String.
     *
     * @return String
     */
    public String getLineAsString() {
        return (URelaxer.getString(getLine()));
    }

    /**
     * Gets the property value as String.
     *
     * @return String
     */
    public String getOffsetAsString() {
        return (URelaxer.getString(getOffset()));
    }

    /**
     * Gets the property value as String.
     *
     * @return String
     */
    public String getCoffsetAsString() {
        return (URelaxer.getString(getCoffset()));
    }

    /**
     * Sets the property value by String.
     *
     * @param string
     */
    public void setContentByString(String string) {
        setContent(string);
    }

    /**
     * Sets the property value by String.
     *
     * @param string
     */
    public void setIdByString(String string) {
        setId(string);
    }

    /**
     * Sets the property value by String.
     *
     * @param string
     */
    public void setLineByString(String string) {
        setLine(string);
    }

    /**
     * Sets the property value by String.
     *
     * @param string
     */
    public void setOffsetByString(String string) {
        setOffset(string);
    }

    /**
     * Sets the property value by String.
     *
     * @param string
     */
    public void setCoffsetByString(String string) {
        setCoffset(string);
    }

    /**
     * Returns a String representation of this object.
     * While this method informs as XML format representaion, 
     *  it's purpose is just information, not making 
     * a rigid XML documentation.
     *
     * @return String
     */
    public String toString() {
        try {
            return (makeTextDocument());
        } catch (Exception e) {
            return (super.toString());
        }
    }

    /**
     * Accepts the Visitor for enter behavior.
     *
     * @param visitor
     * @return boolean
     */
    public boolean enter(IRVisitor visitor) {
        return (visitor.enter(this));
    }

    /**
     * Accepts the Visitor for leave behavior.
     *
     * @param visitor
     */
    public void leave(IRVisitor visitor) {
        visitor.leave(this);
    }

    /**
     * Gets the IRNode property <b>parentRNode</b>.
     *
     * @return IRNode
     */
    public final IRNode rGetParentRNode() {
        return (parentRNode_);
    }

    /**
     * Sets the IRNode property <b>parentRNode</b>.
     *
     * @param p_parentRNode
     */
    public final void rSetParentRNode(IRNode p_parentRNode) {
        this.parentRNode_ = p_parentRNode;
    }

    /**
     * Gets child RNodes.
     *
     * @return IRNode[]
     */
    public IRNode[] rGetRNodes() {
        java.util.List classNodes = new java.util.ArrayList();
        IRNode[] nodes = new IRNode[classNodes.size()];
        return ((IRNode[])classNodes.toArray(nodes));
    }

    /**
     * Tests if a Element <code>element</code> is valid
     * for the <code>AWxNl</code>.
     *
     * @param element
     * @return boolean
     */
    public static boolean isMatch(Element element) {
        if (!URelaxer.isTargetElement(element, "nl")) {
            return (false);
        }
        RStack target = new RStack(element);
        boolean $match$ = false;
        Element child;
        if (!target.isEmptyElement()) {
            return (false);
        }
        return (true);
    }

    /**
     * Tests if elements contained in a Stack <code>stack</code>
     * is valid for the <code>AWxNl</code>.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     * @return boolean
     */
    public static boolean isMatch(RStack stack) {
        Element element = stack.peekElement();
        if (element == null) {
            return (false);
        }
        return (isMatch(element));
    }

    /**
     * Tests if elements contained in a Stack <code>stack</code>
     * is valid for the <code>AWxNl</code>.
     * This method consumes the stack contents during matching operation.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     * @return boolean
     */
    public static boolean isMatchHungry(RStack stack) {
        Element element = stack.peekElement();
        if (element == null) {
            return (false);
        }
        if (isMatch(element)) {
            stack.popElement();
            return (true);
        } else {
            return (false);
        }
    }
}
