
package wapid.wxmodel.wxmodelar;

import wapid.wxmodel.abstractwxmodelar.*;

import java.util.*;

public class WxExternalID extends AWxExternalID implements IXObject
{

    /** ƥ֥Ȥݻ */
    private IXObject parentObject = null;

    /** ־ݻ륯饹 */
    private XObjectPosition pos = null;

    /** WxSystemݻ */
    private Vector vec_WxSystem = null;
    /** WxStringݻ */
    private Vector vec_WxString = null;
    /** WxPublicݻ */
    private Vector vec_WxPublic = null;
    /** WxSpݻ */
    private Vector vec_WxSp = null;
    /** WxNlݻ */
    private Vector vec_WxNl = null;
    /** WxCommentݻ */
    private Vector vec_WxComment = null;
    /** WxScriptletݻ */
    private Vector vec_WxScriptlet = null;
    

    
    /** ҥΡɤ˿ƥΡɤ򥻥åȤ */
    public void setParentObject(IXObject parentObject){
       this.parentObject = parentObject;
       IAWxExternalIDChoice[] contents = getContent();
       for(int i=0;i<contents.length;i++){
           ((IXObject)contents[i]).setParentObject(this);
       }
    }
    
    

    /** ƥΡɤ֤ */
    public IXObject getParentObject(){
       return parentObject;
    }


    
    
    /** WxSystem Υƥ졼 */
    public Iterator  getWxSystemIterator(){
        if(vec_WxSystem==null){
            divideXObject();
        }
        return vec_WxSystem.iterator();
    }
    /** WxSystem[] ֥Ȥ  */
    public WxSystem[] getWxSystems(){
        WxSystem[] ret_obj;
        if(vec_WxSystem==null){
            divideXObject();
        }
        ret_obj = new WxSystem[vec_WxSystem.size()];
        for(int i=0;i<vec_WxSystem.size();i++){
            ret_obj[i] = (WxSystem)vec_WxSystem.elementAt(i);
        }
        return ret_obj;
    }
    
    /** WxString Υƥ졼 */
    public Iterator  getWxStringIterator(){
        if(vec_WxString==null){
            divideXObject();
        }
        return vec_WxString.iterator();
    }
    /** WxString[] ֥Ȥ  */
    public WxString[] getWxStrings(){
        WxString[] ret_obj;
        if(vec_WxString==null){
            divideXObject();
        }
        ret_obj = new WxString[vec_WxString.size()];
        for(int i=0;i<vec_WxString.size();i++){
            ret_obj[i] = (WxString)vec_WxString.elementAt(i);
        }
        return ret_obj;
    }
    
    /** WxPublic Υƥ졼 */
    public Iterator  getWxPublicIterator(){
        if(vec_WxPublic==null){
            divideXObject();
        }
        return vec_WxPublic.iterator();
    }
    /** WxPublic[] ֥Ȥ  */
    public WxPublic[] getWxPublics(){
        WxPublic[] ret_obj;
        if(vec_WxPublic==null){
            divideXObject();
        }
        ret_obj = new WxPublic[vec_WxPublic.size()];
        for(int i=0;i<vec_WxPublic.size();i++){
            ret_obj[i] = (WxPublic)vec_WxPublic.elementAt(i);
        }
        return ret_obj;
    }
    
    /** WxSp Υƥ졼 */
    public Iterator  getWxSpIterator(){
        if(vec_WxSp==null){
            divideXObject();
        }
        return vec_WxSp.iterator();
    }
    /** WxSp[] ֥Ȥ  */
    public WxSp[] getWxSps(){
        WxSp[] ret_obj;
        if(vec_WxSp==null){
            divideXObject();
        }
        ret_obj = new WxSp[vec_WxSp.size()];
        for(int i=0;i<vec_WxSp.size();i++){
            ret_obj[i] = (WxSp)vec_WxSp.elementAt(i);
        }
        return ret_obj;
    }
    
    /** WxNl Υƥ졼 */
    public Iterator  getWxNlIterator(){
        if(vec_WxNl==null){
            divideXObject();
        }
        return vec_WxNl.iterator();
    }
    /** WxNl[] ֥Ȥ  */
    public WxNl[] getWxNls(){
        WxNl[] ret_obj;
        if(vec_WxNl==null){
            divideXObject();
        }
        ret_obj = new WxNl[vec_WxNl.size()];
        for(int i=0;i<vec_WxNl.size();i++){
            ret_obj[i] = (WxNl)vec_WxNl.elementAt(i);
        }
        return ret_obj;
    }
    
    /** WxComment Υƥ졼 */
    public Iterator  getWxCommentIterator(){
        if(vec_WxComment==null){
            divideXObject();
        }
        return vec_WxComment.iterator();
    }
    /** WxComment[] ֥Ȥ  */
    public WxComment[] getWxComments(){
        WxComment[] ret_obj;
        if(vec_WxComment==null){
            divideXObject();
        }
        ret_obj = new WxComment[vec_WxComment.size()];
        for(int i=0;i<vec_WxComment.size();i++){
            ret_obj[i] = (WxComment)vec_WxComment.elementAt(i);
        }
        return ret_obj;
    }
    
    /** WxScriptlet Υƥ졼 */
    public Iterator  getWxScriptletIterator(){
        if(vec_WxScriptlet==null){
            divideXObject();
        }
        return vec_WxScriptlet.iterator();
    }
    /** WxScriptlet[] ֥Ȥ  */
    public WxScriptlet[] getWxScriptlets(){
        WxScriptlet[] ret_obj;
        if(vec_WxScriptlet==null){
            divideXObject();
        }
        ret_obj = new WxScriptlet[vec_WxScriptlet.size()];
        for(int i=0;i<vec_WxScriptlet.size();i++){
            ret_obj[i] = (WxScriptlet)vec_WxScriptlet.elementAt(i);
        }
        return ret_obj;
    }
    
    

    
    /** XObject ʬ */
    private void divideXObject(){
       vec_WxSystem = new Vector();
       vec_WxString = new Vector();
       vec_WxPublic = new Vector();
       vec_WxSp = new Vector();
       vec_WxNl = new Vector();
       vec_WxComment = new Vector();
       vec_WxScriptlet = new Vector();
       

       IAWxExternalIDChoice[] contents = getContent();
       for(int i=0;i<contents.length;i++){
          
          if(contents[i] instanceof WxSystem){
              vec_WxSystem.addElement((WxSystem)contents[i]);
          }
          
          if(contents[i] instanceof WxString){
              vec_WxString.addElement((WxString)contents[i]);
          }
          
          if(contents[i] instanceof WxPublic){
              vec_WxPublic.addElement((WxPublic)contents[i]);
          }
          
          if(contents[i] instanceof WxSp){
              vec_WxSp.addElement((WxSp)contents[i]);
          }
          
          if(contents[i] instanceof WxNl){
              vec_WxNl.addElement((WxNl)contents[i]);
          }
          
          if(contents[i] instanceof WxComment){
              vec_WxComment.addElement((WxComment)contents[i]);
          }
          
          if(contents[i] instanceof WxScriptlet){
              vec_WxScriptlet.addElement((WxScriptlet)contents[i]);
          }
          
       }
    }
    

    
    /** ɤ */
    public String toSourceCode(){
       StringBuffer buffer = new StringBuffer();
       IAWxExternalIDChoice[] contents = getContent();
       for(int i=0;i<contents.length;i++){
           buffer.append(((IXObject)contents[i]).toSourceCode());
       }
       return buffer.toString();
    }
    
    

    /** ֥Ȥ̾ */
    public String getObjectName(){
       String fullObjName = getClass().getName();
       return fullObjName.substring(fullObjName.lastIndexOf(".")+1).substring(2);
    }
    /** XObject̾ */
    public String getXObjectName(){
       String fullObjName = getClass().getName();
       return fullObjName.substring(fullObjName.lastIndexOf(".")+1);
    }

    
    /**
     * ־򥻥å 
     * @return int ֥ȤĹ      
     */
    public int setPosition(XObjectPositionFactory factory){
       int len = 0;
       IAWxExternalIDChoice[] contents = getContent();
       pos = factory.createPosition();
       for(int i=0;i<contents.length;i++){
            len += ((IXObject)contents[i]).setPosition(factory);         
       }
       factory.setEndPosition(pos);
       pos.setLength(len);
       return len;
    }
    
    

    /** եåȤ֤ */
    public int getCOffset(){
        return pos.getOffset();
    }

    /** Ĺ֤ */
    public int getCLength(){
        return pos.getLength();
    }    

    /** ϤιԤ֤ */
    public int getStartLine(){
        return pos.getStartLine();
    }

    /** Ϥ֤ */
    public int getStartColumn(){
        return pos.getStartColumn();
    }

    /** ιԤ֤ */
    public int getEndLine(){
        return pos.getEndLine();
    }

    /** ֤ */
    public int getEndColumn(){
        return pos.getEndColumn();
    }

}
