
package wapid.wxmodel.wxmodelar;

import wapid.wxmodel.abstractwxmodelar.*;

import java.util.*;

public class WxStyleSheet extends AWxStyleSheet implements IXObject
{

    /** ƥ֥Ȥݻ */
    private IXObject parentObject = null;

    /** ־ݻ륯饹 */
    private XObjectPosition pos = null;

    /** WxTagoݻ */
    private Vector vec_WxTago = null;
    /** WxAttributeݻ */
    private Vector vec_WxAttribute = null;
    /** WxTagcݻ */
    private Vector vec_WxTagc = null;
    /** WxSpݻ */
    private Vector vec_WxSp = null;
    /** WxNlݻ */
    private Vector vec_WxNl = null;
    /** WxCommentݻ */
    private Vector vec_WxComment = null;
    /** WxScriptletݻ */
    private Vector vec_WxScriptlet = null;
    

    
    /** ҥΡɤ˿ƥΡɤ򥻥åȤ */
    public void setParentObject(IXObject parentObject){
       this.parentObject = parentObject;
       IAWxStyleSheetChoice[] contents = getContent();
       for(int i=0;i<contents.length;i++){
           ((IXObject)contents[i]).setParentObject(this);
       }
    }
    
    

    /** ƥΡɤ֤ */
    public IXObject getParentObject(){
       return parentObject;
    }


    
    
    /** WxTago Υƥ졼 */
    public Iterator  getWxTagoIterator(){
        if(vec_WxTago==null){
            divideXObject();
        }
        return vec_WxTago.iterator();
    }
    /** WxTago[] ֥Ȥ  */
    public WxTago[] getWxTagos(){
        WxTago[] ret_obj;
        if(vec_WxTago==null){
            divideXObject();
        }
        ret_obj = new WxTago[vec_WxTago.size()];
        for(int i=0;i<vec_WxTago.size();i++){
            ret_obj[i] = (WxTago)vec_WxTago.elementAt(i);
        }
        return ret_obj;
    }
    
    /** WxAttribute Υƥ졼 */
    public Iterator  getWxAttributeIterator(){
        if(vec_WxAttribute==null){
            divideXObject();
        }
        return vec_WxAttribute.iterator();
    }
    /** WxAttribute[] ֥Ȥ  */
    public WxAttribute[] getWxAttributes(){
        WxAttribute[] ret_obj;
        if(vec_WxAttribute==null){
            divideXObject();
        }
        ret_obj = new WxAttribute[vec_WxAttribute.size()];
        for(int i=0;i<vec_WxAttribute.size();i++){
            ret_obj[i] = (WxAttribute)vec_WxAttribute.elementAt(i);
        }
        return ret_obj;
    }
    
    /** WxTagc Υƥ졼 */
    public Iterator  getWxTagcIterator(){
        if(vec_WxTagc==null){
            divideXObject();
        }
        return vec_WxTagc.iterator();
    }
    /** WxTagc[] ֥Ȥ  */
    public WxTagc[] getWxTagcs(){
        WxTagc[] ret_obj;
        if(vec_WxTagc==null){
            divideXObject();
        }
        ret_obj = new WxTagc[vec_WxTagc.size()];
        for(int i=0;i<vec_WxTagc.size();i++){
            ret_obj[i] = (WxTagc)vec_WxTagc.elementAt(i);
        }
        return ret_obj;
    }
    
    /** WxSp Υƥ졼 */
    public Iterator  getWxSpIterator(){
        if(vec_WxSp==null){
            divideXObject();
        }
        return vec_WxSp.iterator();
    }
    /** WxSp[] ֥Ȥ  */
    public WxSp[] getWxSps(){
        WxSp[] ret_obj;
        if(vec_WxSp==null){
            divideXObject();
        }
        ret_obj = new WxSp[vec_WxSp.size()];
        for(int i=0;i<vec_WxSp.size();i++){
            ret_obj[i] = (WxSp)vec_WxSp.elementAt(i);
        }
        return ret_obj;
    }
    
    /** WxNl Υƥ졼 */
    public Iterator  getWxNlIterator(){
        if(vec_WxNl==null){
            divideXObject();
        }
        return vec_WxNl.iterator();
    }
    /** WxNl[] ֥Ȥ  */
    public WxNl[] getWxNls(){
        WxNl[] ret_obj;
        if(vec_WxNl==null){
            divideXObject();
        }
        ret_obj = new WxNl[vec_WxNl.size()];
        for(int i=0;i<vec_WxNl.size();i++){
            ret_obj[i] = (WxNl)vec_WxNl.elementAt(i);
        }
        return ret_obj;
    }
    
    /** WxComment Υƥ졼 */
    public Iterator  getWxCommentIterator(){
        if(vec_WxComment==null){
            divideXObject();
        }
        return vec_WxComment.iterator();
    }
    /** WxComment[] ֥Ȥ  */
    public WxComment[] getWxComments(){
        WxComment[] ret_obj;
        if(vec_WxComment==null){
            divideXObject();
        }
        ret_obj = new WxComment[vec_WxComment.size()];
        for(int i=0;i<vec_WxComment.size();i++){
            ret_obj[i] = (WxComment)vec_WxComment.elementAt(i);
        }
        return ret_obj;
    }
    
    /** WxScriptlet Υƥ졼 */
    public Iterator  getWxScriptletIterator(){
        if(vec_WxScriptlet==null){
            divideXObject();
        }
        return vec_WxScriptlet.iterator();
    }
    /** WxScriptlet[] ֥Ȥ  */
    public WxScriptlet[] getWxScriptlets(){
        WxScriptlet[] ret_obj;
        if(vec_WxScriptlet==null){
            divideXObject();
        }
        ret_obj = new WxScriptlet[vec_WxScriptlet.size()];
        for(int i=0;i<vec_WxScriptlet.size();i++){
            ret_obj[i] = (WxScriptlet)vec_WxScriptlet.elementAt(i);
        }
        return ret_obj;
    }
    
    

    
    /** XObject ʬ */
    private void divideXObject(){
       vec_WxTago = new Vector();
       vec_WxAttribute = new Vector();
       vec_WxTagc = new Vector();
       vec_WxSp = new Vector();
       vec_WxNl = new Vector();
       vec_WxComment = new Vector();
       vec_WxScriptlet = new Vector();
       

       IAWxStyleSheetChoice[] contents = getContent();
       for(int i=0;i<contents.length;i++){
          
          if(contents[i] instanceof WxTago){
              vec_WxTago.addElement((WxTago)contents[i]);
          }
          
          if(contents[i] instanceof WxAttribute){
              vec_WxAttribute.addElement((WxAttribute)contents[i]);
          }
          
          if(contents[i] instanceof WxTagc){
              vec_WxTagc.addElement((WxTagc)contents[i]);
          }
          
          if(contents[i] instanceof WxSp){
              vec_WxSp.addElement((WxSp)contents[i]);
          }
          
          if(contents[i] instanceof WxNl){
              vec_WxNl.addElement((WxNl)contents[i]);
          }
          
          if(contents[i] instanceof WxComment){
              vec_WxComment.addElement((WxComment)contents[i]);
          }
          
          if(contents[i] instanceof WxScriptlet){
              vec_WxScriptlet.addElement((WxScriptlet)contents[i]);
          }
          
       }
    }
    

    
    /** ɤ */
    public String toSourceCode(){
       StringBuffer buffer = new StringBuffer();
       IAWxStyleSheetChoice[] contents = getContent();
       for(int i=0;i<contents.length;i++){
           buffer.append(((IXObject)contents[i]).toSourceCode());
       }
       return buffer.toString();
    }
    
    

    /** ֥Ȥ̾ */
    public String getObjectName(){
       String fullObjName = getClass().getName();
       return fullObjName.substring(fullObjName.lastIndexOf(".")+1).substring(2);
    }
    /** XObject̾ */
    public String getXObjectName(){
       String fullObjName = getClass().getName();
       return fullObjName.substring(fullObjName.lastIndexOf(".")+1);
    }

    
    /**
     * ־򥻥å 
     * @return int ֥ȤĹ      
     */
    public int setPosition(XObjectPositionFactory factory){
       int len = 0;
       IAWxStyleSheetChoice[] contents = getContent();
       pos = factory.createPosition();
       for(int i=0;i<contents.length;i++){
            len += ((IXObject)contents[i]).setPosition(factory);         
       }
       factory.setEndPosition(pos);
       pos.setLength(len);
       return len;
    }
    
    

    /** եåȤ֤ */
    public int getCOffset(){
        return pos.getOffset();
    }

    /** Ĺ֤ */
    public int getCLength(){
        return pos.getLength();
    }    

    /** ϤιԤ֤ */
    public int getStartLine(){
        return pos.getStartLine();
    }

    /** Ϥ֤ */
    public int getStartColumn(){
        return pos.getStartColumn();
    }

    /** ιԤ֤ */
    public int getEndLine(){
        return pos.getEndLine();
    }

    /** ֤ */
    public int getEndColumn(){
        return pos.getEndColumn();
    }

}
