package wapid.xhtml;

import java.util.*;

public class WpdFile extends WpdObject {
    ArrayList nodelist;
    String name;
    public WpdFile() {
        nodelist = new ArrayList();
    }
    public WpdFile(int a,int b, int c) {
        super(a,b,c);
        nodelist=new ArrayList();
    }


    void setName(String name) {
        this.name = name;
    }
    public String getName() {
        return name;
    }

    void addNode(WpdNode wn) {
        nodelist.add(wn);
    }

    public Iterator getNodes() {
        return nodelist.iterator();
    }

    public Iterator getNodesWithoutComment() {
        LinkedList nodelistwithoutcomm=new LinkedList(nodelist);
        boolean flag = true;
        while (flag) {
            for (int i = 0;i < nodelistwithoutcomm.size();i++) {
                WpdNode wn1 = (WpdNode)nodelistwithoutcomm.get(i);
                if (wn1.getClassName().equals("Comment") ||
                   wn1.getClassName().equals("Text")){
                    for (int j = 0;j < nodelistwithoutcomm.size();j++) {
                        WpdNode wn2 = (WpdNode)nodelistwithoutcomm.get(j);
                        if (wn2.getOffset() + wn2.getLength() == wn1.getOffset() &&
                           wn2.getClassName().equals("Text")) {
                            if (wn1.getClassName().equals("Text")) {
                                wn2.addText(wn1.getText());
                                wn2.setLength(wn2.getLength() + wn1.getLength());
                                nodelistwithoutcomm.remove(i);
                                nodelistwithoutcomm.set(j,wn2);
                                flag = true;break;
                            } else if (wn1.getClassName().equals("Comment")) {
                                wn2.setLength(wn2.getLength() + wn1.getLength());
                                nodelistwithoutcomm.remove(i);
                                nodelistwithoutcomm.set(j,wn2);
                                flag = true;break;
                            }
                        }
                    }                   
                }
            }
            flag = false;
        }
        return nodelistwithoutcomm.iterator();
    }

    public Iterator getNodesOffsetOrderWithoutComment() {
        LinkedList nodelistwithoutcomm=new LinkedList(nodelist);
        boolean flag = true;
        while (flag) {
            for (int i = 0;i < nodelistwithoutcomm.size();i++) {
                WpdNode wn1 = (WpdNode)nodelistwithoutcomm.get(i);
                if (wn1.getClassName().equals("Comment") ||
                   wn1.getClassName().equals("Text")) {
                    for (int j = 0;j < nodelistwithoutcomm.size();j++) {
                        WpdNode wn2 = (WpdNode)nodelistwithoutcomm.get(j);
                        if (wn2.getOffset() + wn2.getLength() == wn1.getOffset() &&
                           wn2.getClassName().equals("Text")) {
                            if (wn1.getClassName().equals("Text")) {
                                wn2.addText(wn1.getText());
                                wn2.setLength(wn2.getLength() + wn1.getLength());
                                nodelistwithoutcomm.remove(i);
                                nodelistwithoutcomm.set(j,wn2);
                                flag = true;break;
                            } else if (wn1.getClassName().equals("Comment")) {
                                wn2.setLength(wn2.getLength() + wn1.getLength());
                                nodelistwithoutcomm.remove(i);
                                nodelistwithoutcomm.set(j,wn2);
                                flag = true;break;
                            }
                        }
                    }                   
                }
            }
            flag = false;
        }
        ArrayList l = new ArrayList(nodelistwithoutcomm);
        Collections.sort(l);
        return l.iterator();
    }


    public Iterator getNodesOffsetOrder() {
        ArrayList list = new ArrayList(nodelist);
        Collections.sort(list);
        /*      WpdNode[] wn=(WpdNode[])nodelist.toArray(new WpdNode[0]);
        Arrays.sort(wn);
        ArrayList list=new ArrayList();
        for(int i=0;i<wn.length;i++){
            list.add(wn[i]);
            }*/
        return list.iterator();
    }
}
