/* 
 * Program:             $RCSfile: j2jx.h,v $  $Revision: 40.10 $
 * 
 * Purpose:             
 *
 * Author:              S.Yamamoto  2003/02/07
 *
 * (C) Copyright:       S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

/* Range class. */
typedef struct _Range {
    int     sp, ep;
} Range, *RangeP;

void initExtractFile(void);
void cleanUpExtractFile(void);

void setSavedJpdFile(SymData *file);

void extractFile(SymData *file);
void extractClass(SymData *jclass);
void extractInterface(SymData *interface);
void extractRoutine(SymData *routine);
void extractVariable(SymData *var);
void extractType(SymData *type);
void extractSBlock(SymData *sblock);
void extractStatement(SymData *stmt);
void extractExpression(SymData *exp);
void extractLiteral(SymData *lit);
void extractQName(SymData *qname);
void extractLabel(SymData *label);
void extractComment(SymData *com);
