/* 
 * Program:             $RCSfile: mkCommentView.h,v $  $Revision: 40.5 $
 * 
 * Purpose:             
 * 
 * Author:              K.Hoshino  2001/10/27
 *                      S.Yamamoto  2001/10/27 
 * 
 * (C) Copyright:       K.Hoshino and S.Yamamoto  2001
 *                      This file is a product of the project Sapid.
 */

/* ƥեϽʤ */
#define MKCOMMENTVIEW_AVOID_SYSTEM_FILE

/* 󥯥롼ɤ줿եϽʤ */
#define MKCOMMENTVIEW_AVOID_INCLUDED_FILE

/* ǥХ֤ */
/* #define MKCOMMENTVIEW_DEBUG */

extern SpdSet2 pcommentOccs; /* CommentView Ǥʪΰ襳Ǥν */

extern SpdSet2 elementOccs; /* Ȥդ¾ǤΥ饹ν */
extern SpdSet2 declarationOccs;
extern SpdSet2 labelOccs;
extern SpdSet2 expressionOccs;
extern SpdSet2 pblockOccs;
extern SpdSet2 blockOccs;

/* 󥯥롼ɤ줿եνΤΤ */
extern SpdSet2 includedDeclarationOccs; /* ifileǤǡ󥯥롼ɤ줿 */
                                       /* ե¸ߤΤ */
extern SpdIdSet includedPfileIds;      /* 󥯥롼ɤƤե */
                                       /* (ΥȷϥỌ̇̄ΰΥƥ) */
extern SpdBoolean pfileIsIncludedFile; /* ߽Υե뤬pfileǤ뤫ɤ */


extern SpdObjId pfileId; /* ߽ pfile */
extern SpdObjId ifileId; /* ߽ ifile */

extern SpdString sourceString;  /* ߽ pfile ʸ */

/*
 * ֥Ȥνиɽ
 *
 * SpdOccȤϰ㤤ΥեǤνиɽ
 */
typedef struct {
    SpdObjId objectId;
    SpdRelId relationId; /* objectoffsetrelationId */

    SpdRegion region;

    /* Ƭΰ */
    int offsetFromLineHead;
    /* ܤ鲿ܤޤǤ */
    int lineNumBegin;
    int lineNumEnd;

    SpdString str;

    /* rcommentΤߤ˻ѡǤ˴Ϣդ줿 */
    SpdBoolean related; 
} CommentViewOcc;

/* mkCommentView.c */

void parse_option(int argc, char *argv[]);
void spdFreeCommentViewOcc(SpdElemValue elem);

/* getElements.c */

void printSpdConvRegionItoCFailerInfo(SpdObjId objectId, SpdRegion regionI,
                                      SpdRegion regionC);

SpdString getSourceString(void);

CommentViewOcc *setCommentViewOcc(SpdObjId objectId, SpdRegion region,
                                  SpdRelId relationId, SpdSet2 occs);
void getPblocks(void);
void getElements(void);

void removeMacroCallExpression(void);
void mkElementOccs(void);

/* mkRelation.c */

void analyse(void);

/* getElementsSubByTraverse.c */

void traverseForCommentViewGetElem(SpdObjId ifileId, SpdObjId declarationId,
                                   int declOffset);

/* mkCommentViewTest.c */

void printCommentViewOccInfo(CommentViewOcc *occ);
void printCommentViewOccsInfo(SpdSet2 ss);
void printOccInfo(SpdOcc *occ);
void printObjInfo(SpdObjId elementId);

void printLcommentInfoInPfile(SpdObjId pfileId);
void printAllLcommentInfo(void);
void printALcommentInfo(SpdObjId lcommentId);

void printElementsInfo(SpdBoolean p, SpdBoolean d, SpdBoolean l, SpdBoolean e,
                       SpdBoolean b);
void printRegionInfo(SpdRegion region);
