/* 
 * Program:             $RCSfile: debug.c,v $  $Revision: 30.6 $
 * 
 * Purpose:
 * 
 * Author:              T.Hidaka  1998/12/01
 *                      S.Yamamoto  1999/01/23
 * 
 * (C) Copyright:       T.Hidaka and S.Yamamoto  1998 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: debug.c,v 30.6 2003/07/20 11:46:09 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "mkPmodel.h"

/* ǥХåѴؿ */

void printCursor(const char *s1, const FileBuffer *fb, MyCursor csr)
{
    if (verbose) {
        spdMessage("%s current %s(%d):%d next (%d):%d\n", s1, 
                   fb->filename, csr.current.lineno, csr.current.offset,
                   csr.next.lineno, csr.next.offset);
    }
}

void printLine(const char *s1, const FileBuffer *fb, const MyCursor *csr)
{
    int len;

    if (1 < verbose) {
        len = csr->next.offset - csr->current.offset -1;
        if (len < 0) {
            len = 20;
        }
        spdMessage("%s\t%s(%d)+%d %.*s\n", s1, fb->filename, 
                   csr->current.lineno,
                   len, len, fb->buf + csr->current.offset);
    }
}
