/* 
 * Program:             $RCSfile: label_spec.c,v $  $Revision: 30.2 $
 * 
 * Purpose:             ٥˴ؤǡ١롼
 * 
 * Author:              K.Mabuchi  1991/09/30
 *                      S.Yamamoto  1992/04/01
 * Modified:            H.Ariga  1993/07/01
 * 
 * (C) Copyright:       K.Mabuchi, H.Ariga and S.Yamamoto  1991 - 1998
 *                      This file is a product of the project Sapid.
 */

/*
 * ٥˴ؤǡ١롼
 */

#ifndef lint
static char rcsid[] =
    "$Id: label_spec.c,v 30.2 1999/04/01 16:14:48 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "main.h"
#include "prototype.h"

extern SpdString sdb_null_value;

LO_ListP label_table;

/* ٥륪֥Ȥɲ */
LOP insert_label(int sort,int length)
{
    static int  lo_num = 0;
    LOP         new;

    new = (LOP)spdCalloc(sizeof(struct LabelObject),1);

    new->id = INC_ID(lo_num);
    new->sort = sort;
    new->length = length;
    new->name = sdb_null_value;
    new->next = lo_list;
    new->prev = NULL;
    if (lo_list != NULL) {
        lo_list->prev = new;
    }
    lo_list = new;
    
    return new;
}

/* ٥ꥹȤɲ */
LO_ListP insert_label_list(LO_ListP list, LOP ptr_lo,WP ptr)
{
    LO_ListP new;
    extern FOP current_file;

    new = (LO_ListP)spdCalloc(sizeof(struct LabelObjectList),1);
    new->label_s = ptr_lo;
    new->source = app_source_LC(NULL,(ptr?ptr->head_point:0),current_file);
    
    new->next = list;
    new->prev = NULL;
    if (list != NULL) list->prev = new;

    return new;
}


