/*
 * Program:             $RCSfile: link4b_ident.c,v $  $Revision: 30.8 $
 *
 * Purpose:
 *
 * Author:              S.Kawai  1995/10/01
 *                      S.Yamamoto  1996/06/02
 * Modified:            R.Miura  1998/07/05
 *
 * (C) Copyright:       S.Kawai, R.Miura and S.Yamamoto  1995 - 2001
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: link4b_ident.c,v 30.8 2003/06/28 15:32:18 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "ISDB.h"

#ifdef SDBLINK4B
#include "sdblink4b.h"
#elif SPD_MERGE_SDB
#include "sdblink4c.h"
#endif

/* identifier̾󤻤뤿Υϥåơ֥롥 */
static GlobalTable  global_map[HASH_SIZE];

/* 
 * identifierѤΥϥå(ѿglobal_map[HASH_SIZE])뤿δؿ
 */

/* 
 * identifierϥåơ֥ɲä롥
 */

void push_global_table(SpdId id, char *name)
{
    GlobalTable     new;

    new = spdMalloc(sizeof(struct _global_table));
    new->id = id;

    /* !! add_new_object()ơʣ̤줿ΰȤ褦ˤ */
    new->name = spdStrdup(name);

    new->next = global_map[(unsigned int)(*name)];
    global_map[(unsigned int)(*name)] = new;
}

/* 
 * ϥåθԤϿѤǤФidʳSPD_NON_ID֤
 */

SpdId get_equal_global(char *name)
{
    GlobalTable     ptr;

    for (ptr = global_map[(unsigned int)(*name)];
         ptr != NULL; ptr = ptr->next) {
        if (SPD_STREQ(name, ptr->name)) {
            return (ptr->id);
        }
    }
    return (SPD_NON_ID);
}

/* 
 * ϥå롥
 */

void free_global_table(void)
{
    int         i;
    GlobalTable ptr, ptr_next;

    for (i = 0; i < HASH_SIZE; i++) {
        for (ptr = global_map[i]; ptr != NULL; ptr = ptr_next) {
            ptr_next = ptr->next;
            spdFree(ptr->name);
            spdFree(ptr);
        }
    }
}
