/* 
 * Program:             $RCSfile: sdblink5.h,v $  $Revision: 40.2 $
 * 
 * Purpose:             
 * 
 * Author:              N.Fukuyasu  2003/04/01
 *                      S.Yamamoto  2003/04/01        
 * 
 * (C) Copyright:       N.Fukuyasu and S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

#ifndef _SDBLINK5_H
#define _SDBLINK5_H

/* ext_db_obj.c */

/*
 * ExtDBObj:
 *   ץƥޥѤ˴ϢɲäSpdDBObj
 *   childϿƻҴطλҡrelϤ¾δϢ
 */

typedef struct _ext_db_obj {
  SpdDBObj *obj;
  SpdDBRel **child;
  int child_num;
  int child_size;
  SpdDBRel **rel;
  int rel_num;
  int rel_size;
} ExtDBObj;

void add_child_relation(ExtDBObj *parent, SpdDBRel *child_rel);
void add_ext_relation(ExtDBObj *obj, SpdDBRel *rel);
void free_ext_db_obj(ExtDBObj ext_obj);

/* optimize.c */

void set_optimize_level(int level);
int get_optimize_level(void);

void ISDB_optimize(void);

void initialize_search_functions_ISDB(void);

/* link_ISDB.c */

void count_ISDB_objs(int file_num, SpdObjId file_id[]);
void load_ISDB(SpdObjId file_id);

SpdObjId make_a_program_object(SpdConstString prog_name);
void read_file_objects_Imodel(void);
void make_prog_file(SpdObjId prog_id, SpdObjId file_id);
void write_Imodel(void);

#endif /* _SDBLINK5_H */
