/* 
 * Program:             $RCSfile: sdbmerge.h,v $  $Revision: 40.2 $
 * 
 * Purpose:             
 * 
 * Author:              N.Fukuyasu  2003/04/01
 *                      S.Yamamoto  2003/04/01        
 * 
 * (C) Copyright:       N.Fukuyasu and S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

#ifndef _SDB_MERGE_H
#define _SDB_MERGE_H

/* relation_table.c */

typedef struct _relation_table_element {
  SpdObjId pobj_id;
  SpdObjId cobj_id;
} RelTableElement;

typedef struct _relation_table {
  RelTableElement *element;
  int size;
  int num;
} RelTable;

#define RELATION_TABLE_EMPTY   { NULL, 0, 0 }

RelTable add_relation_element(RelTable table, SpdObjId pobj, SpdObjId cobj);
RelTable release_relation_table(RelTable table);
int get_relation_table_num(RelTable table);
SpdObjId get_relation_table_pobj_id(RelTable table, int i);
SpdObjId get_relation_table_cobj_id(RelTable table, int i);

#endif /* _SDB_MERGE_H */
