/* 
 * Program:             $RCSfile: spdDebug.c,v $  $Revision: 30.1 $
 * 
 * Purpose:
 * 
 * Author:              N.Fukuyasu, S.Kawai and Y.Momiyama  1995/12/07
 * Modified:            S.Yamamoto  1995/12/08
 * 
 * (C) Copyright:       N.Fukuyasu, S.Kawai, Y.Momiyama
 *                      and S.Yamamoto  1995
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: spdDebug.c,v 30.1 1998/09/24 11:26:47 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>

#define INDENT_S    "|  "

static int indent = 0;

void func_in(char *class_name, char *res)
{
    int i;

    for (i = 0; i < indent; i++) {
        printf("%s", INDENT_S);
    }

    printf("|%s: %p %s\n", class_name, res, res);

    indent++;
}

void func_out(char *class_name, char *res)
{
    int i;

    indent--;

    for (i = 0; i < indent; i++) {
        printf("%s", INDENT_S);
    }

    printf("|%s: %p %s\n", class_name, res, res);
}
