/* 
 * Program:             $RCSfile: spdSetSub.h,v $  $Revision: 30.4 $
 * 
 * Purpose:             For internal use of "spdSet.c".
 * 
 * Author:              M.Hakamata  1997/06/27
 *                      S.Yamamoto  1997/02/09
 *
 * (C) Copyright:       M.Hakamata and S.Yamamoto  1997 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef _SPDSET_SUB_H
#define  _SPDSET_SUB_H

#ifdef _SPDSET_H

#define IS_DEFAULT_ELEM(s)  ((s)->elemSiz == DEFAULT_INT_SET)
#define IS_SMALL_ELEM(s)    ((s)->elemSiz <= sizeof(Contents))
#define IS_LARGE_ELEM(s)    (!IS_DEFAULT_ELEM((s)) && !IS_SMALL_ELEM((s)))

#define GET_CONTENTS(s, c) \
    ((IS_DEFAULT_ELEM((s)) || IS_LARGE_ELEM((s))) ? (c) : &(c))

#define MARK                1       /* 黻ѤΥޥ */
#define UNMARK              0       /* 黻ѤΥޥ */ 
#define FREED               (-1)    /* ؿ_freeElemPtr()Ѥ롥 */
#define DEFAULT_BUCKET_NUM  (11U)   /* ΥХåȤο */
#define ELEM_AVERAGE        (4U)    /* ĤΥХåʿǸĿ */

/* Hash function. */
/* unsigned int _setHash(SpdSet1 set, unsigned int key); */

#define _setHash(x, y)  ((unsigned int)(y) % (x)->bktNum)

/* keyбElemPtr򸡺롥 */
ElemPtr* _spdSearchElem1(SpdSet1 set, int key);

#endif /* _SPDSET_H */

#endif /* _SPDSET_SUB_H */
