/* 
 * Program:             $RCSfile: linklist.h,v $  $Revision: 30.6 $
 * 
 * Purpose:             
 * 
 * Author:              N.Koyama  2000/03/16
 *                      S.Yamamoto  2000/03/16
 * 
 * (C) Copyright:       N.Koyama and S.Yamamoto  2000 - 2001
 *                      This file is a product of the project Sapid.
 */

/* 
 * "$Id: linklist.h,v 30.6 2003/06/04 17:00:59 yamamoto Exp yamamoto $";
 */

#ifndef _LINKLIST_H
#define _LINKLIST_H

typedef struct _Node {
    void            *data;
    struct _Node    *next;
} *Node;

typedef Node Linklist;

Linklist initLinklist(void);
void insertLinklistFirst(Linklist lst, void *data);
void *removeLinklistFirst(Linklist lst);
void freeLinklist(Linklist lst);
Node getFirstNode(Linklist lst);
Node getNextNode(Node node);
/* inline void *getNodeData(Node node); */
void *getNodeData(Node node);
int isEmptyLinklist(Linklist lst);

#endif /* not _LINKLIST_H */
