/* 
 * Program:             $RCSfile: funcinfo.h,v $  $Revision: 40.6 $
 * 
 * Purpose:             
 * 
 * Author:              N.Koyama  2000/03/16
 *                      S.Yamamoto  2000/03/16
 * 
 * (C) Copyright:       N.Koyama and S.Yamamoto  2000 - 2001
 *                      This file is a product of the project Sapid.
 */

/* 
 * "$Id: funcinfo.h,v 40.6 2002/01/15 06:09:20 yamamoto Exp yamamoto $";
 */

#ifndef _FUNCDEF_H
#define _FUNCDEF_H

/* Message functions. */
void putMessage(char **message, char *format, ...);
void clearMessage(FuncInfo *fi);
void fprintfMessage(FILE *fp, char **message);

/* Funcinfo functions. */
FuncInfo getFuncInfo(SpdObjId declId);
void freeFuncInfo(FuncInfo fi);
void printFuncInfo(FuncInfo fi);

/* FuncSet functions. */
FuncSet getFuncSet(SpdObjId declId);
void freeFuncSet(FuncSet fset);

/* Sapid functions. */
SpdString getName(SpdObjId id);
char *getArgTypename(SpdObjId decl_id);
char *getFuncTypename(SpdObjId func_id);

#ifdef SPD_CHK_DOC2
SpdObjId getpfileId(SpdObjId declId);
#endif

/* utilties. */
SpdString trim(SpdString a);

#endif /* not _FUNCDEF_H */
