/************************************************ 
 * BDD Manipulator - header file (Version 6.03) * 
 * Copyright (C) 1992 Kyoto University          *
 * Author : Shin-ichi MINATO    (1992/4/24)     *
 ************************************************/

/* 
 * Modified by S.Yamamoto 2000/03/18.
 * 
 * $Id: sbdd.h,v 30.2 2000/03/19 08:57:12 yamamoto Exp yamamoto $
 */

#ifndef sbdd_h
#define sbdd_h

typedef	int bddp;

#define	TRUE	1
#define	FALSE	0
#define	ERR	-1
#define WORD	32
#define NIL	(~(1<<(WORD-1)))
#define BDDNIL	NIL

extern	int	bddinit();
extern	bddp	bddfalse();
extern	bddp	bddtrue();
extern	bddp	bddprime();
extern	bddp	bddcopy();
extern	bddp	bddnot();
extern	bddp	bddshift();
extern	bddp	bddshift2();
extern	bddp	bddand();
extern	bddp	bddor();
extern	bddp	bddxor();
extern	bddp	bddnand();
extern	bddp	bddnor();
extern	bddp	bddxnor();
extern	bddp	bddrstr();
extern	bddp	bddrstr0();
extern	bddp	bddrstr1();
extern	bddp	bddcofact();
extern	int	bddlevel();
extern	int	bddimply();
extern	int	bddfree();
extern	void	bddgc();
extern	void	defval();
extern	int	bddval();
extern	int	bddused();
extern	int	bddsize();
extern	void	emode();

#endif
