/* 
 * Program:             $RCSfile: SpdUtil.c,v $  $Revision: 31.3 $
 * 
 * Purpose:
 * 
 * Author:              H.Ohhashi  1999/04/10
 *                      S.Yamamoto  1999/04/10
 * 
 * (C) Copyright:       H.Ohhashi and S.Yamamoto  1999
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: SpdUtil.c,v 31.3 1999/10/22 10:40:11 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include <tcl.h>
#include "tclAR.h"
#include "tclARSub.h"

int tcl_spdSetSDBdir(ClientData clientData, Tcl_Interp *interp,
                     int argc, char *argv[])
{
    /* : 1ġ */
    if (argc != 2) {
        interp->result = "wrong # args";
        return TCL_ERROR;
    }

    spdSetSDBdir(argv[1]);

    return TCL_OK;
}

int tcl_spdGetSDBdir(ClientData clientData, Tcl_Interp *interp,
                     int argc, char *argv[])
{
    /* : ʤ */
    if (argc != 1) {
        interp->result = "wrong # args";
        return TCL_ERROR;
    }

    Tcl_SetResultString(spdGetSDBdir());

    return TCL_OK;
}
