/* 
 * Program:             $RCSfile: spdstr.c,v $  $Revision: 30.4 $
 * 
 * Purpose:             Ϣθ˴ؤؿ
 *
 * Author:              T.Hidaka  1997/06/27
 * Modified:            S.Yamamoto  1997/09/05
 *
 * (C) Copyright:       T.Hidaka and S.Yamamoto  1997 - 2000
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: spdstr.c,v 30.4 2000/03/19 09:19:29 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include <Sapid/SpdStr.h>
#include <tcl.h>
#include "tclAR.h"
#include "tclARSub.h"

int tcl_spdStr(ClientData clientData, Tcl_Interp *interp,
               int argc, char *argv[])
{
    SpdObjId id;
    
    /*  : oid */
    if (argc != 2) {
        interp->result = "wrong # args";
        return TCL_ERROR;
    }

    if (tclAR_GetInt(interp, argv[1], &id) != TCL_OK) {
        return TCL_ERROR;
    }

    Tcl_SetResult(interp, spdStr(id), (Tcl_FreeProc*)spdStrFree);

    return TCL_OK;
}
