/* 
 * Program:             $RCSfile: test-sip2-2.c,v $  $Revision: 30.4 $
 * 
 * Purpose:
 * 
 * Author:              S.Yamamoto  2000/12/03
 * 
 * (C) Copyright:       S.Yamamoto  2000
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: test-sip2-2.c,v 30.4 2002/08/02 06:39:32 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>

#if !defined(EXIT_SUCCESS)
#define EXIT_SUCCESS    0
#endif

#define NUM_OF_A        5   /* Should be greater than 3. */

/* Test2. */
static void test_addr(void);
static void test_break_and_continue(void);

static int test2(void);

int main(int argc, char *argv[])
{
    int     i;
    int     retVal;

    /* Test2 (test of "break" and "continue"). */
    printf("### Test2. ###\n");
    retVal = test2();
    /* printf("test2(): %d.\n", retVal); */

    return (EXIT_SUCCESS);
}

/******************************************************************************/

static int test2(void)
{
    test_break_and_continue();

    /* test_addr(); */
    printf("### Test2 (test_addr()) skipped. ###\n");
}

static void test_addr(void)
{
    int b, *p, *q;

    b = 2;
    p = &b;
    q = (p + 1) -1;
    printf("p: %p\n", p);
    printf("*p: %d\n", *p);
    printf("q: %p\n", q);
    printf("*q: %d\n", *q);
}

static void test_break_and_continue(void)
{
    int     i;

    i = NUM_OF_A;
    while (0 < i) {
        printf("WHILE: %d.\n", i);
        if (i == 3) {
            i -= 2;
            continue;
        } else if (i == 1) {
            break;
        }
        i--;
    }
}
