/* 
 * Program:             $RCSfile: test-sip2-5.c,v $  $Revision: 30.5 $
 * 
 * Purpose:
 * 
 * Author:              S.Yamamoto  2000/12/03
 * 
 * (C) Copyright:       S.Yamamoto  2000
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: test-sip2-5.c,v 30.5 2002/08/02 06:42:04 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>

#if !defined(EXIT_SUCCESS)
#define EXIT_SUCCESS    0
#endif

#define NUM_OF_A        5   /* Should be greater than 3. */

static int test5(void);

int main(int argc, char *argv[])
{
    int     i;
    int     retVal;
    
    /* Test5 (test of simple control flow). */
    printf("### Test5. ###\n");
    retVal = test5();
    /* printf("test5(): %d.\n", retVal); */

    return (EXIT_SUCCESS);
}

/******************************************************************************/

static int test5(void)
{
    int     i;

    /* Test of "if" statement. */
    i = 0;
    if (-1 < i) {
        printf("IF: TRUE: %d.\n", i);
    }
    if (0 < 1) {
        printf("IF: TRUE: %d.\n", i);
    } else {
        printf("IF: FALSE: %d.\n", i);
    }
    if (0 == 1) {
        printf("IF: TRUE: %d.\n", i);
    } else {
        printf("IF: FALSE: %d.\n", i);
    }
    if (1 + 2 == 3)
        /* Empty. */;
    if (998 != 999) {
        /* Empty. */;
    } else {
        /* Empty. */;
    }

    /* Test of "SWTICH" statement. */
    i = 1;
    switch (i) {
      case 0:
        printf("SWITCH: 0: %d.\n", i);
        break;
      case 1:
        printf("SWITCH: 1: %d.\n", i);
        break;
      case 2:
        printf("SWITCH: 2: %d.\n", i);
        break;
      default:
        printf("SWITCH: DEFAULT: %d.\n", i);
        break;
    }
    i = 3;
    switch (i) {
      case 0:
        printf("SWITCH: 0: %d.\n", i);
        break;
      case 1:
        printf("SWITCH: 1: %d.\n", i);
        break;
      case 2:
        printf("SWITCH: 2: %d.\n", i);
        break;
      default:
        printf("SWITCH: DEFAULT: %d.\n", i);
        break;
    }
        
    /* Test of "while" statement. */
    /* !! Add test of "break" and "continue". */
    i = NUM_OF_A;
    while (0 < i) {
        printf("WHILE: %d.\n", i);
        i--;
    }
    while (1 == 2) {
        /* Empty. */;
    }

    /* Test of "do" statement (buggy). */
    /* !! Add test of "break" and "continue". */
    i = NUM_OF_A;
    do {
        printf("DO: %d.\n", i);
        i--;
    } while (0 < i);

    /* Test of "for" statement (buggy). */
    /* !! Add test of "break" and "continue". */
    for (i = 0; i < NUM_OF_A; i++) {
        printf("FOR: %d.\n", i);
    }
    for (i = 0; i < NUM_OF_A; i++) {
        /* Empty. */;
    }

    /* Test of "goto" statement (buggy). */
    goto label1;
    printf("GOTO: %d.\n", i);
    return (EXIT_SUCCESS + 999);
    
  label1:

    return (EXIT_SUCCESS);
}
