/* 
 * Program:             $RCSfile: XSLTTester.java,v $  $Revision: 40.2 $
 * 
 * Purpose:             XSLT tester.
 *
 * Author:              Y.Sawada  2002/12/02
 *                      S.Yamamoto  2002/12/02
 *
 * (C) Copyright:       Y.Sawada and S.Yamamoto  2002
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: XSLTTester.java,v 40.2 2002/12/02 12:48:59 yamamoto Exp yamamoto $
 */

import javax.xml.transform.*;
import javax.xml.transform.stream.*;

public class XSLTTester {
    public static void main(String[] args) {
        try {
            TransformerFactory trfactory = TransformerFactory.newInstance();
            Transformer t = trfactory.newTransformer(new StreamSource(args[0]));
            
            if (3 < args.length) {
                for (int i = 3; i < args.length; i++) {
                    String[]    param;

                    param = args[i].split("=");
                    // System.out.println(param[0] + "=" + param[1]);
                    t.setParameter(param[0], param[1]);
                }
            }
            t.transform(new StreamSource(args[1]),
                        new StreamResult(args[2]));
        } catch(Exception e) {
            e.printStackTrace();
        }
    }
}
