/* 
 * Program:             $RCSfile: ZipEntryList.java,v $  $Revision: 40.3 $
 * 
 * Purpose:             ZIP$B%U%!%$%k$NFbMF$rNs5s$9$k!%(B
 *
 * Author:              H.Kuwabara  2001/07/18
 *                      S.Yamamoto  2001/07/18
 *
 * (C) Copyright:       H.Kuwabara and S.Yamamoto  2001 - 2002
 *                      This file is a product of the project Sapid.
 */

import java.io.File;
import java.text.DateFormat;
import java.util.Date;
import java.util.Enumeration;
import java.util.zip.*;

/**
 *  ZIP$B%U%!%$%k$NFbMF$rNs5s$9$k!%99?7F|!&%5%$%:!&%U%!%$%kL>$rI=<($9$k!%(B
 *  
 *  @author H.Kuwabara and S.Yamamoto.
 */

public class ZipEntryList
{
    public static void main(String[] args)
    {
	try{
	    // ZIP $B%U%!%$%k$r3+$/(B
	    ZipFile file = new ZipFile(new File(args[0]));

	    // $B$9$Y$F$N%(%s%H%j$KBP$7$FA`:n(B
	    for(Enumeration e = file.entries(); e.hasMoreElements(); ){
		// $B%(%s%H%j$r0l$D<hF@(B
		ZipEntry entry = (ZipEntry)e.nextElement();
		// $B99?7F|I=<((B
		System.out.print(DateFormat.getInstance().format(new Date(entry.getTime())) + "  ");
		// $B%5%$%:I=<((B
		System.out.print(entry.getSize() + "  ");
		// $B%U%!%$%kL>I=<((B
		System.out.println(entry.getName());
	    }

	    file.close();
	}
	catch(Exception e){
	    e.printStackTrace();
	}
    }
}
