/* 
 * Program:             $RCSfile: ZipPack.java,v $  $Revision: 40.5 $
 * 
 * Purpose:             ZIP$B%U%!%$%k$r:n$k!%(B
 *
 * Author:              H.Kuwabara  2001/07/18
 *                      S.Yamamoto  2001/07/18
 *
 * (C) Copyright:       H.Kuwabara and S.Yamamoto  2001 - 2002
 *                      This file is a product of the project Sapid.
 */

import java.io.*;
import java.util.zip.*;

/**
 *  ZIP$B%U%!%$%k$r:n$k!%(B
 *  
 *  @author H.Kuwabara and S.Yamamoto.
 */

public class ZipPack
{
    private static final int BUF_SIZE = 1024;

    public static void main(String[] args)
    {
	try{
	    // $B=PNO@h(B($BBh0l0z?t$,:n$k(B ZIP $B%U%!%$%k$NL>A0(B)
	    ZipOutputStream zos = new ZipOutputStream(new FileOutputStream(args[0]));

	    // $BBhFs0z?t0J2<$N%U%!%$%k$r(B ZIP $B%U%!%$%k$KDI2C(B
	    for(int i = 1; i < args.length; i++){
		// $BF~NO85(B
		BufferedInputStream bis =new BufferedInputStream(new FileInputStream(args[i]));
		// $B%(%s%H%j$r:n@.(B
		ZipEntry entry = new ZipEntry(args[i]);
		entry.setTime(new File(args[i]).lastModified());
		// $B?7$7$$%(%s%H%j$N=q$-9~$_$r3+;O(B
		zos.putNextEntry(entry);

		System.err.println("adding: " + args[i]);

		// $B=PNO(B
		byte[] b = new byte[BUF_SIZE];
		int size;
		while((size = bis.read(b, 0, b.length)) != -1){
		    zos.write(b, 0, size);
		}

		// $B%(%s%H%j$N=q$-9~$_=*N;(B
		zos.closeEntry();
		bis.close();
	    }

	    zos.close();
	}
	catch(Exception e){
	    e.printStackTrace();
	}
    }
}

class ZipPackDummy
{
    private static final int DUMMY = 1024;

    public static int dummyFunc(int x)
    {
        return (x + 1);
    }
}
