/* 
 * Program:             $RCSfile: ZipEntryList.java,v $  $Revision: 40.3 $
 * 
 * Purpose:             ZIPt@C̓e񋓂D
 *
 * Author:              H.Kuwabara  2001/07/18
 *                      S.Yamamoto  2001/07/18
 *
 * (C) Copyright:       H.Kuwabara and S.Yamamoto  2001 - 2002
 *                      This file is a product of the project Sapid.
 */

import java.io.File;
import java.text.DateFormat;
import java.util.Date;
import java.util.Enumeration;
import java.util.zip.*;

/**
 *  ZIPt@C̓e񋓂DXVETCYEt@C\D
 *  
 *  @author H.Kuwabara and S.Yamamoto.
 */

public class ZipEntryList
{
    public static void main(String[] args)
    {
	try{
	    // ZIP t@CJ
	    ZipFile file = new ZipFile(new File(args[0]));

	    // ׂẴGgɑ΂đ
	    for(Enumeration e = file.entries(); e.hasMoreElements(); ){
		// Gg擾
		ZipEntry entry = (ZipEntry)e.nextElement();
		// XV\
		System.out.print(DateFormat.getInstance().format(new Date(entry.getTime())) + "  ");
		// TCY\
		System.out.print(entry.getSize() + "  ");
		// t@C\
		System.out.println(entry.getName());
	    }

	    file.close();
	}
	catch(Exception e){
	    e.printStackTrace();
	}
    }
}
