/* 
 * Program:             $RCSfile: ZipPack.java,v $  $Revision: 40.5 $
 * 
 * Purpose:             ZIPt@CD
 *
 * Author:              H.Kuwabara  2001/07/18
 *                      S.Yamamoto  2001/07/18
 *
 * (C) Copyright:       H.Kuwabara and S.Yamamoto  2001 - 2002
 *                      This file is a product of the project Sapid.
 */

import java.io.*;
import java.util.zip.*;

/**
 *  ZIPt@CD
 *  
 *  @author H.Kuwabara and S.Yamamoto.
 */

public class ZipPack
{
    private static final int BUF_SIZE = 1024;

    public static void main(String[] args)
    {
	try{
	    // o͐( ZIP t@C̖O)
	    ZipOutputStream zos = new ZipOutputStream(new FileOutputStream(args[0]));

	    // ȉ̃t@C ZIP t@Cɒǉ
	    for(int i = 1; i < args.length; i++){
		// ͌
		BufferedInputStream bis =new BufferedInputStream(new FileInputStream(args[i]));
		// Gg쐬
		ZipEntry entry = new ZipEntry(args[i]);
		entry.setTime(new File(args[i]).lastModified());
		// VGg݂̏Jn
		zos.putNextEntry(entry);

		System.err.println("adding: " + args[i]);

		// o
		byte[] b = new byte[BUF_SIZE];
		int size;
		while((size = bis.read(b, 0, b.length)) != -1){
		    zos.write(b, 0, size);
		}

		// Gg̏ݏI
		zos.closeEntry();
		bis.close();
	    }

	    zos.close();
	}
	catch(Exception e){
	    e.printStackTrace();
	}
    }
}

class ZipPackDummy
{
    private static final int DUMMY = 1024;

    public static int dummyFunc(int x)
    {
        return (x + 1);
    }
}
