/* 
 * Program:             $RCSfile: DeclTest.c,v $  $Revision: 40.5 $
 * 
 * Purpose:             
 * 
 * Author:              N.Kaneko  2002/11/24
 *                      S.Yamamoto  2002/11/24
 * 
 * (C) Copyright:       N.Kaneko and S.Yamamoto  2002
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: DeclTest.c,v 40.5 2003/05/29 04:20:13 yamamoto Exp yamamoto $";
#endif

/*
ŪAPIƥȥץ
ƥˡ
˹ϢΥƥ
SDBǤ¹֥Ȥ
֥Ȥĥ֥Ȥ롥
typeϢΥƥ
SDBtypeΥ֥ȤϢĳƥ饹Υ֥Ȥ
֥ȤƤtype餬Ĵ٤
#˥奢ŪˤϹϢƱ
expressionϢΥƥ
typeƱ
*/

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "DeclTest.h"

int main(int argc, char *argv[])
{
    SpdConstString  program_name;                  /* This program name. */
    SpdDBId         dbId;
    SpdModelId      ImodelId;

    /* Test result: 0 means that no error occurs. */
    int             Test_Com = 0;
    int             Test_type = 0;
    int             Test_expr = 0;
    
    program_name = spdBasename(argv[0]);
    spdInitialize(program_name);

    ImodelId = spdUseModel(&I_model);
    dbId = spdOpenSDB();
    spdReadDB(ImodelId, dbId);
    
    /* طϢΥƥȤԤ */
    spdMessage("Testing constructional APIs...");
    Test_Com = testConstitute(Test_Com);
    if (Test_Com == 0) {
        fprintf(stderr, ": OK.\n");
    }else{
        fprintf(stderr, ": NG.\n");
    }
    
    /* typeϢΥƥȤԤ */
    spdMessage("Testing type-relation APIs...");
    Test_type = testTypeRel(Test_type);
    if (Test_type == 0) {
        fprintf(stderr, ": OK.\n");
    }else{
        fprintf(stderr, ": NG.\n");
    }
    
    /* expression˴ؤ뻲ȴϢΥƥȤԤ */
    spdMessage("Testing expression-relation APIs...");
    Test_expr = testExprRel(Test_expr);
    if (Test_expr == 0) {
        fprintf(stderr, ": OK.\n");
    }else{
        fprintf(stderr, ": NG.\n");
    }
    
    spdCloseSDB(dbId);

    return ((Test_Com == 0 && Test_type == 0 && Test_expr == 0) ?
            EXIT_SUCCESS : EXIT_FAILURE);
}
