/* 
 * Program:             $RCSfile: ExprCheck.c,v $  $Revision: 40.4 $
 * 
 * Purpose:             expressionϢƥѴؿ
 * 
 * Author:              N.Kaneko  2002/11/24
 *                      S.Yamamoto  2002/11/24
 * 
 * (C) Copyright:       N.Kaneko and S.Yamamoto  2002 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: ExprCheck.c,v 40.4 2003/05/24 13:47:51 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "DeclTest.h"

int testExprRel(int Test)
{
    /*
    饹expressionȤδϢΥƥȤԤ
    ƥȤˤȤơ饹expressionȴϢĥ饹Υ֥Ȥ
    ֥ȤƤӥ饹expression롥
    ΤȤ줿expressionexpressionƱǤ뤫Ĵ٤롥
    */
    
    SpdObjIdArray ExprIdArray;
    int i;
    
    ExprIdArray = spdGetObjIdArray("expression", NULL, NULL);
    
    /*
    expr->expr->expr
    */
    if(Test == 0){
        for(i = 0; i < ExprIdArray.size; i++){
            Test = checkExpr(ExprIdArray.id[i], "expression", Test);
            if(Test != 0){
                break;
            }
        }
    }
    /*
    expr->identifier->expr
    */
    if(Test == 0){
        for(i = 0; i < ExprIdArray.size; i++){
            Test = checkExpr(ExprIdArray.id[i], "identifier", Test);
            if(Test != 0){
                break;
            }
        }
    }
    /*
    expr->optionaldecl->expr
    */
    if(Test == 0){
        for(i = 0; i < ExprIdArray.size; i++){
            Test = checkExpr(ExprIdArray.id[i], "optionaldecl", Test);
            if(Test != 0){
                break;
            }
        }
    }
    /*
    expr->type->expr
    */
    if(Test == 0){
        for(i = 0; i < ExprIdArray.size; i++){
            Test = checkExpr(ExprIdArray.id[i], "type", Test);
            if(Test != 0){
                break;
            }
        }
    }
    /*
    expr->const->expr
    */
    if(Test == 0){
        for(i = 0; i < ExprIdArray.size; i++){
            Test = checkExpr(ExprIdArray.id[i], "constant", Test);
            if(Test != 0){
                break;
            }
        }
    }
    
    spdFreeObjIdArray(ExprIdArray);
    return Test;
}

int checkExpr(SpdObjId check_id, SpdString check_class, int TestFlag)
{
    SpdTargetObjSet other_objs, expr_objs;
    int i, j;
    TestFlag = 0;/*ƥѤΥե饰 0:ƥȰ۾ʤ, 1:ƥȰ۾濫*/
    
    /* printf("check_id:%d\n", check_id); */
    /*expr->check_class->expr*/
    other_objs = spdGetFromExprObjs(check_id, check_class);
    /*printf("other_objs_num:%d\n", other_objs.TargetObjNum);
    for (i = 0; i < other_objs.TargetObjNum; i++) {
        printf("other_objs:%d\n", other_objs.TargetObjIds[i]);
        }*/
    for (i = 0; i < other_objs.TargetObjNum; i++) {
        if (TestFlag == 0) {
            expr_objs = spdGetToExprObjs(other_objs.TargetObjIds[i], "expression");
            /* printf("expr_num:%d\n", expr_objs.TargetObjNum); */
            TestFlag = 1;
            for(j = 0; j < expr_objs.TargetObjNum; j++){
                if(expr_objs.TargetObjIds[j] == check_id){
                    TestFlag = 0;
                }
            }
            if(TestFlag == 1){
                spdWarning("expr->%s->expr not matched.\n", check_class);
                break;
            }
        }
        spdFreeSpdTargetObjSet(expr_objs);
    }
    spdFreeSpdTargetObjSet(other_objs);
    
    
    return TestFlag;
}
