#! PerlCmd
# 
# Program:              $RCSfile: search.pl,v $  $Revision: 30.11 $
# 
# Purpose:              
# 
# Author:               T.Yamamoto  1998/02/15
#                       S.Yamamoto  1998/03/14
# 
# Copyright:            T.Yamamoto and S.Yamamoto  1998 - 2000
#                       This file is a product of the project Sapid.
#

# 
# $Id: search.pl,v 30.11 2003/10/20 08:52:03 yamamoto Exp yamamoto $
# 

### оݥե򥻥åȡ

sub set_search_target {
    ## 
    @flist = ();

    if ($form{'sw_file'} eq "on") {
	push(@flist,"list-file.html");
    }
    if ($form{'sw_func'} eq "on") {
	push(@flist,"list-func.html");
    }
    if ($form{'sw_var'} eq "on") {
	push(@flist,"list-var.html");
    }
    if ($form{'sw_l_var'} eq "on") {
	push(@flist,"list-l-var.html");
    }
    if ($form{'sw_arg'} eq "on") {
	push(@flist,"list-arg.html");
    }
    if ($form{'sw_type'} eq "on") {
	push(@flist,"list-type.html");
    }
    if ($form{'sw_member'} eq "on") {
	push(@flist,"list-member.html");
    }
    if ($form{'sw_enum'} eq "on") {
	push(@flist,"list-enum.html");
    }
    if ($form{'sw_macro'} eq "on") {
	push(@flist,"list-macro.html");
    }
    if ($form{'sw_const'} eq "on") {
	push(@flist,"list-const.html");
    }
    if ($form{'sw_tag'} eq "on") {
	push(@flist,"list-tag.html");
    }
    if ($form{'sw_doc'} eq "on") {
	push(@flist,"list-doc.html");
    }
}

### ͤ͡°ʸCGIˤѿ̾ȤϢ롥

sub create_occ_attr_table {
    $occ_attr_tbl{"Right value"} = "sw_right";
    $occ_attr_tbl{"Left value"} = "sw_left";
    $occ_attr_tbl{"Left &amp; right value"} = "sw_left_right";
    $occ_attr_tbl{"Reference"} = "sw_ref";
}

### ̻ҤνиѤν(ѿȥѿΤ)

sub make_occurence_format {
    # ̾դ
    local($file, $a_attr, $color, $location, $occ_attr);
    ($file, $a_attr, $color, $location, $occ_attr) = @_;

    local($ret);
    ### $occ_attr ˤ " (L or R)" ȤʸäƤΤ
    ### '(' ')' ʸФ
    $occ_attr =~ s/ \(//;
    $occ_attr =~ s/\)//;

    if ($occ_attr eq "" || $form{$occ_attr_tbl{$occ_attr}} eq "on") {
	$ret = " - $file: <a href=\"$a_attr\" target=\"righttop\"";
	if ($use_css == 1) {
	    $ret = "$ret class=\"$color\">$location</a>";
	} else {
	    $ret = "$ret ><font color=\"$color\">$location</font></a>";
	}
	if ($occ_attr ne "") {
	    $ret = "$ret ($occ_attr)";
	}
	$ret = "$ret <br />\n";
    } else {
	$ret = "";
    }
}

### ̻Ҥνи򸡺(ѿɽѿѿΤ)

sub search_occurence {
    # ̾դ
    local($category, $ident, $a_attr, $color);
    ($category, $ident, $a_attr, $color) = @_;

    # ɽѿ
    local($spec_file, $object_id, $is_found, $elem);
    local(@ret);

    # ѿɽѿѿΤ߽Ԥ
    # ơ֥ե, Id
    if ($category eq "Function") {
        $occ_target = "<b>Called<\/b>";
    } else {
        $occ_target = "<b>Used<\/b>";
    }
    $href_attr = $a_attr;
    ($spec_file, $object_id) = split(/\#s/, $href_attr);
	
    open(SPEC,"<$spec_file") || die "ERROR !!! : $spec_file is unseen entity.";
    START: while (<SPEC>) {
	if (/^occ_elem=([^\n]*)/) {
	    $occ_elem = $1;
	}
	# 뼱̻Ҥõ

	if (/<!-- $object_id -->/) {
	    # ɤ߹ߤʤ
	    while (<SPEC>) {
	        if (/$occ_target/) {
		    while (<SPEC>) {
		        if (/$occ_elem/) {
			    $elem = &make_occurence_format($1, $2, $3, $4, $5);
			    # (ꥹ)ɲ
			    if ($elem ne "") {
			        push(@ret, $elem);
			    }
			} elsif (/<\/td>/) {
			    # λ
			    last START;
		        }
		    }
		}
	    }
	}
    }
    close(SPEC);
    @ret;
}

################################################################################

### ڤʬ

@pairs = split(/&/, $ENV{'QUERY_STRING'});
foreach $pair (@pairs) {
    ($name, $value) = split(/=/, $pair);
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $form{$name} = $value;
}

&set_search_target();
&create_occ_attr_table();

$expr = $form{'expr'};

### HTMLΥإå

print "Content-type: text/html\n\n";

### ƥץ졼ȥեɤ߹ࡥ

$template_file = 'search.header';
open(TEMPLATE, "<$template_file") || die "ERROR !!! : $template_file is unseen entity.";
while (<TEMPLATE>) {
    print $_;
}
close(TEMPLATE);

### եɤ߹ߡ

$num = 0;
foreach $f (@flist) {
    $head = "";
    @ilist = ();
    @tlist = ();
    @hlist = ();
    @clist = (); # Υ֥ȤΥ󥯿Ƥ
    @onclist = ();

    # ɤ߹ߤƱ˥ꥹȤ
    open(IN,"<$f") || die "ERROR !!! : $f is unseen entity.";
    while (<IN>) {
	if (/<center><b>([^<]*)<\/b><\/center>/) {
	    $head = $1;
	} elsif (/^&nbsp; - &nbsp;/) {
	    next;
	} elsif (/search_elem=([^\n]*)/) {
	    $search_target = $1;
	} elsif (/use_css=([^\n]*)/) {
	    if ($1 eq "yes") {
	        $use_css = 1;
	    } else {
	        $use_css = 0;
	    }
	} elsif (/$search_target/) {
	    $href = $1;
	    $target = $2;
	    $linkcolor = $3;
	    $item = $4;
	    if ($item =~ /$expr/) {
		push(@ilist, $item);
		push(@tlist, $target);
		push(@hlist, $href);
                push(@clist, $linkcolor);
		$num++;
	    }
	}
    }
    close(IN);

    # ꥹȤϤ
    if (!($#ilist < 0)) {
	print "<br />\n";	
	print "<center><b>$head</b></center>\n";
	while (!($#ilist < 0)) {
	    $item = shift(@ilist);
	    $target = shift(@tlist);
	    $href = shift(@hlist);
	    $linkcolor = shift(@clist);

	    # ̻Ҥ¸
	    $ident = $item;
	    # HTMLѤν
	    if ($use_css == 1) {
	        $item =~ s/($expr)/<font color="#690000">$1<\/font>/;
	    } else {
	        $item =~ s/($expr)/<span class=\"Search\">$1<\/span>/;
	    }

	    if ($use_css == 1) {
	        print "<a href=\"$href\" targe=\"$target\" ";
		print "class=\"$linkcolor\">$item</a><br />\n";
	    } else {
	        print "<a href=\"$href\" target=\"$target\">";
		print "<font color=\"$linkcolor\">$item</font></a><br />\n";
	    }
	    # и򸡺
	    @occ_list = &search_occurence($head, $ident, $href, $linkcolor);
	    $occ_num = @occ_list;
	    # иǤʤϽϤʤ
	    if ($occ_num != 0) {
	        foreach (@occ_list) {
		    print;
		}
	    }
	}
	print "\n";	
    }
}

# äν

if ($num == 0) {
    print "<center><b>Nothing</b></center>\n";
}

### HTMLΥեå

print "</body>\n";
print "</html>\n";
