/* 
 * Program:             $RCSfile: style.h,v $  $Revision: 30.36 $
 * 
 * Purpose:             
 *
 * Author:              H.Ohhashi  1997/07/01
 *                      S.Yamamoto 1997/10/17
 *
 * (C) Copyright:       H.Ohhashi and S.Yamamoto  1997 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef _SPD_SPIE_STYLE_H
#define _SPD_SPIE_STYLE_H

/* 
 * HTML elements.
 */
 
#define HTML_LINK_ELEMENT \
        "<link rel=\"stylesheet\" href=\"SPIE.css\" type=\"text/css\" />"

#define HTML_META_ELEMENT \
        "<meta name=\"robots\" content=\"noindex,nofollow\" />"

/******************************************************************************/

/* ե졼 */
#define FRAME_LEFT_FILE     "index.html"
#define FRAME_RIGHT_FILE    "frame-r.html"

/* Top page. */
#define INDEX_FILE          "spie-index.html"

/* ե */
#define LIST_FILE_FILE      "list-file.html"

/* ؿ */
#define LIST_FUNC_FILE      "list-func.html"

/* ѿ */
#define LIST_VAR_FILE       "list-var.html"

/* ɽѿ */
#define LIST_L_VAR_FILE     "list-l-var.html"

/*  */
#define LIST_ARG_FILE       "list-arg.html"

/* ޥ */
#define LIST_MACRO_FILE     "list-macro.html"

/* ѿ */
#define LIST_MEMBER_FILE    "list-member.html"

/* Ұ */
#define LIST_ENUM_FILE      "list-enum.html"

/*  */
#define LIST_TYPE_FILE      "list-type.html"

/*  */
#define LIST_CONST_FILE     "list-const.html"

/*  */
#define LIST_TAG_FILE       "list-tag.html"

/* ɥȰ */
#define LIST_DOC_FILE       "list-doc.html"

/* Extention of HTML file. */  
#define HTML_SUFFIX         ".html"

/* Extention of spdSed file. */  
#define SPDSED_SUFFIX       ".spdSed"

/* ؿͽ */
#define SPEC_FUNC_FILE      "spec-func.html"

/* ѿͽ */
#define SPEC_VAR_FILE       "spec-var.html"

/* ɽѿͽ */
#define SPEC_L_VAR_FILE     "spec-l-var.html"

/* ͽ */
#define SPEC_ARG_FILE       "spec-arg.html"

/* ޥͽ */
#define SPEC_MACRO_FILE     "spec-macro.html"

/* ѿͽ */
#define SPEC_MEMBER_FILE    "spec-member.html"

/* һͽ */
#define SPEC_ENUM_FILE      "spec-enum.html"

/* ͽ */
#define SPEC_TYPE_FILE      "spec-type.html"

/* ͽ */
#define SPEC_CONST_FILE     "spec-const.html"

/* ͽ */
#define SPEC_TAG_FILE       "spec-tag.html"

/* Tipsѷե */
#define TIPS_TYPEDEF_FILE   "tips-type.html"

/* CGI  */
#define SEARCH_CGI          "search.cgi"

/* HTMLΥإå */
#define SEARCH_HEADER       "search.header"

/******************************************************************************/

/* CGIλϤޤ򼨤ޥ */
#define CGI_BEGIN           "SPIE-CGI-BEGIN"

/* CGIν򼨤ޥ */
#define CGI_END             "SPIE-CGI-END"

/* CGIե */
#define MEMO_CGI_FILE       "memo.cgi"

/* Υǡե */
#define MEMO_DAT_FILE       "memo.dat"

/* Υꥹȥե */
#define LIST_MEMO_FILE      "list-memo.html"

/* νϥե */
#define SPEC_MEMO_FILE      "spec-memo.html"

/* ⥿ȥ */
#define MEMO_TITLE          "Memo"

/* ե */
#define LOGO_FILE           "logo.html"

/******************************************************************************/

/* ʬγ() */
#define COLS_PERCENT                "30%"

/* ʬγ() */
#define LEFT_ROWS_PERCENT           "50%"
#define MEMO_ROWS_PERCENT           "80%"
#define JAVASCRIPT_ROWS_PERCENT     "5%"

/* ե륿ȥ */
#define FILE_TITLE          "File"

/* ؿȥ */
#define FUNC_TITLE          "Function"

/* ѿȥ */
#define G_VAR_TITLE         "Global variable"

/* ޥȥ */
#define MACRO_TITLE         "Macro"

/* ѿȥ */ 
#define MEMBER_TITLE        "Member"

/* ҥȥ */ 
#define ENUM_TITLE          "Enum"

/* ȥ */
#define TYPEDEF_TITLE       "Typedef"

/* ȥ */
#define CONST_TITLE         "Constant"

/* ȥ */
#define TAG_TITLE           "Tag"

/* ̻Ҥ̾ȥ */
#define NAME_TITLE          "Name"

/* ԥȥ */      
#define AUTHOR_TITLE        "Author"

/* ǯȥ */
#define MODIFIED_DAY_TITLE  "Modified date"

/* ȥ */
#define ARGUMENT_TITLE      "Argument"

/* ɽѿȥ */
#define L_VAR_TITLE         "Local variable"

/* ƤӽФؿȥ */
#define CALL_TITLE          "Call"

/* ƤӽФؿȥ */   
#define CALLED_TITLE        "Called"

/* ޥܥǥȥ */
#define BODY_TITLE          "Body"
      
/* ȥ */
#define TYPE_TITLE          "Type"

/* Ѿ꥿ȥ */
#define USED_TITLE          "Used"

/* ɥȥȥ */
#define DOCUMENT_TITLE      "Document"

/* ȥȥ */
#define COMMENT_TITLE       "Comment"

/* 򻲾Ȥ륢󥫡 */
#define TO_SOURCE           "Source"

/* ͽ򻲾Ȥ륢󥫡 */       
#define TO_SPEC             "Spec"

/* 򻲾Ȥ륢󥫡 */  
#define TO_DECL             "Declaration"

/* ȥ */
#define SEARCH              "Search"

/* Υե졼٥ */
#define LEFTBOTTOM          "leftbottom"

/* Υե졼٥ */
#define RIGHTTOP            "righttop"

/* Left and right value title. */
#define LR_STR_LEFT         "Left value"
#define LR_STR_RIGHT        "Right value"
#define LR_STR_LEFT_RIGHT   "Left &amp; right value"
#define LR_STR_REFERENCE    "Reference"

/* ڡκǸղäԤο */
#define TRAILING_LINE_NUM   100

#define TOOL_ROWS_PERCENT   "15%"
#define INDEX_TITLE         "Index"
#define FUNC_INDEX_TITLE    "Function Index"
#define G_VAR_INDEX_TITLE   "Global Variable Index"
#define L_VAR_INDEX_TITLE   "Local Variable Index"
#define ARG_INDEX_TITLE     "Argument Index"
#define MEMBER_INDEX_TITLE  "Member Index"
#define TYPEDEF_INDEX_TITLE "Typedef Index"
#define MACRO_INDEX_TITLE   "Macro Index"
#define CONST_INDEX_TITLE   "Constant Index"
#define FILE_INDEX_TITLE    "File Index"
#define ENUM_INDEX_TITLE    "Enum Index"
#define TAG_INDEX_TITLE     "Tag Index"
#define DOC_INDEX_TITLE     "Doc Index"

#define FUNC_TABLE_TITLE    "Function Table"
#define G_VAR_TABLE_TITLE   "Global Variable Table"
#define L_VAR_TABLE_TITLE   "Local Variable Table"
#define ARG_TABLE_TITLE     "Argument Table"
#define MACRO_TABLE_TITLE   "Macro Table"
#define CONST_TABLE_TITLE   "Constant Table"
#define MEMBER_TABLE_TITLE  "Member Table"
#define TYPE_TABLE_TITLE    "Typedef Table"
#define ENUM_TABLE_TITLE    "Enum Table"
#define TAG_TABLE_TITLE     "Tag Table"

/* Ѥο (110ϰϤǻꤹ뤳) */
#define MAX_CHECKER_NUM     5
/* ġΰο (10ĻѤʤƤ⵭ҤƤ) */
#define CHECKER_COLOR_1     "#EE82EE"
#define CHECKER_COLOR_2     "#00FFFF"
#define CHECKER_COLOR_3     "#FFD700"
#define CHECKER_COLOR_4     "#00FF00"
#define CHECKER_COLOR_5     "#C0C0C0"
#define CHECKER_COLOR_6     "#EE82EE"
#define CHECKER_COLOR_7     "#00FFFF"
#define CHECKER_COLOR_8     "#FFD700"
#define CHECKER_COLOR_9     "#00FF00"
#define CHECKER_COLOR_10    "#C0C0C0"

extern ColorStyle color_style[MAX_STYLE_NUM];

#endif /* not _SPD_SPIE_STYLE_H */
