#! SapidBinDir/tkAR4sh
# 
# Program:              $RCSfile: var.tcl,v $  $Revision: 30.5 $
# 
# Purpose:
#
# Author:               K.Yasuhara  1998/07/01
#                       S.Yamamoto  1999/10/28
#
# (C) Copyright:        K.Yasuhara and S.Yamamoto  1998 - 1999
#                       This file is a product of the project Sapid.
# 

# 
# "$Id: var.tcl,v 30.5 1999/12/27 09:18:23 yamamoto Exp yamamoto $";
# 

################################################################################
# ѿȽ⥸塼
#     argv[0] : ǡǥ쥯ȥ   (default:DATA/)
#           argv[1] : Treeǡե̾ (default:DATA/tree.dat)
#           argv[2] : Ĵ٤ѿܥֹ
#           argv[3] : Ĵ٤ѿΤؿܥֹ
#           argv[4] : SDB ǥ쥯ȥ
#     ϡܥֹ.CTRL
#           ܥֹ.CTRL.tag
#           ܥֹ.DATA
#           ܥֹ.DATA.tag
#           ܥֹ.IN-OUT
#           ܥֹ.IN-OUT.tag
#           ܥֹ.ENUM
#           ܥֹ.ENUM.tag
# ա°ʤϥեϺ
################################################################################

# TclAR «
source "$env(SAPID_TCLAR_LIBDIR)/tclAR.tcl"
spdSetSDBdir [lindex $argv 4]
set target [smuGetAProgramName]
spdTarget P-model $target

# ɤ߹
set DATADIR  [lindex $argv 0]
set TREEDAT  [lindex $argv 1]
set VAR      [lindex $argv 2]
set FUNC     [lindex $argv 3]

################################################################################
# ĥ꡼ɤ߹
set id [ open $TREEDAT r ]
seek $id 0 start
set count 0 ; # ĥ꡼ǿ
while { [eof $id]==0 } {
    gets $id line
    scan $line "%d %s %d %d" code name SpId mode
    set attr($count) "$count $code $name $SpId $mode"
    if {$code == 0} { break }
    incr count
}
close $id

################################################################################
# ѿȽ ᥤ⥸塼
#     Ĵ٤֥åID
# ޥ
#   BLOCK_IF:2  BLOCK_SWITCH:4  BLOCK_WHILE:16  BLOCK_DO:32
#   BLOCK_FOR:8
proc check_blanch { blk_id } {
    switch [spdGetAttrVal $blk_id sort] {
	2 {
	    set exp_id [spdGetRelObj $blk_id blk_expr parent_block_id]
	    if {[check_expr $exp_id] != 0} {
		WRITE IF $exp_id CTRL
	    }
	}
	4 {
	    set exp_id [spdGetRelObj $blk_id blk_expr parent_block_id]
	    if {[check_expr $exp_id] != 0} {
		WRITE SWITCH $exp_id CTRL
	    }
	}
	16 {
	    set exp_id [spdGetRelObj $blk_id blk_expr parent_block_id]
	    if {[check_expr $exp_id] != 0} {
		WRITE WHILE $exp_id CTRL
	    }
	}
	32 {
	    set exp_id [spdGetRelObj $blk_id blk_expr parent_block_id]
	    if {[check_expr $exp_id] != 0} {
		WRITE DO $exp_id CTRL
	    }
	}
	8 {
	    # for3Ǥ
	    # forοǤĴ٤
	    set exp_buf [spdGetRelObj $blk_id blk_expr parent_block_id]
            if {[check_expr [lindex $exp_buf 1]] != 0} {
		WRITE FOR [lindex $exp_buf 1] CTRL
	    }
	}
	default {
	    return
	}
    }

    # ƵŪ֥åĴ٤
#    set blk2_id  [spdGetRelObj $blk_id blk_blk parent_block_id]
    set blk2_buf [spdGetRelObj $blk_id blk_blk parent_block_id]
    foreach blk2 $blk2_buf {
	check_blanch $blk2
    }
}

################################################################################
# ǡѿȽ ᥤ⥸塼
#     Ĵ٤֥åID
# ޥ
#   BLOCK_BASIC:1
proc check_data { blk_id } {
    if {[spdGetAttrVal $blk_id sort] == 1} {
	set exp_buf [spdGetRelObj $blk_id blk_expr parent_block_id]
	foreach ex $exp_buf {
	    switch [check_expr $ex] {
		1 -
		3 { WRITE DATA $ex DATA }
	    }
	}
    }

    # ƵŪ֥åĴ٤
    set blk_buf [spdGetRelObj $blk_id blk_blk parent_block_id]
    foreach blk $blk_buf {
	check_data $blk
    }
}

################################################################################
# ѿȽ ᥤ⥸塼
proc check_io {} {
    global VAR_ident

    set exp_buf [spdGetRelObj $VAR_ident ident_ref identifier_id]
    foreach exp $exp_buf {
	switch [check_expr_io $exp 0] {
	    4  { WRITE OUT $exp IN-OUT }
	    12 { WRITE IN/OUT $exp IN-OUT }
	    #8  { WRITE IN $exp IN-OUT }
	    default { }
	}
    }
}
# ݥ󥿤λȤĴ٤ (ݥ󥿤Ǥֳ¦Ǹ)
# ޥ
#   EXPR_PL_VALUE:4  EXPR_PR_VALUE:8  EXPR_PLR_VALUE:12
proc check_expr_io {exp_id in} {
    set rtn $in
    switch [spdGetAttrVal $exp_id lrtype] {
        4  { set rtn 4 }
	12 { set rtn 12 }
	8  { set rtn 8 }
	default { }
    }

    # Ƥ򤿤ɤꡢƵŪĴ٤
    set exp_buf [spdGetRelObj $exp_id expr_expr inner_expression_id]
    foreach exp $exp_buf {
	switch [check_expr_io $exp $rtn] {
	    4  { set rtn 4 }
	    12 { set rtn 12 }
	    8  { set rtn 8 }
	    default { }
	}
    }
    return $rtn
}

################################################################################
# ѿȽ⥸塼
# ޥ
#   BLOCK_BASIC:1
proc check_enum {blk_id} {
    if {[spdGetAttrVal $blk_id sort] == 1} {
	set exp_buf [spdGetRelObj $blk_id blk_expr parent_block_id]
	foreach exp $exp_buf {
	    switch [check_expr $exp] {
		2 {
	            if {[check_right_macro $exp] == "TRUE"} {
			WRITE ENUM $exp ENUM
		    }
		}
		default { }
	    }
	}
    }
    # ƵŪĴ٤
    set blk_buf [spdGetRelObj $blk_id blk_blk parent_block_id]
    foreach blk $blk_buf {
	check_enum $blk
    }
}
# դޥΤߤɤ
# ޥ
#     SAPID_AR4_BLOCK_MACROCALL:2
proc check_right_macro {exp_id} {
    # դidȤ
    set exp_buf [spdGetRelObj $exp_id expr_expr outer_expression_id]
    lsort -integer $exp_buf
    set tmp_id  [lindex $exp_buf 1]
    # դñexpressionɤ
    if {[spdGetRelObj $tmp_id expr_expr outer_expression_id] == ""} {
	set exp_occ [lindex [spdGetOffsetOfObj $tmp_id] 0]
	set i_reg [spdConvOccToRegion $exp_occ]
	set p_reg [spdConvRegionItoC $i_reg]
	if {[Region2Text $i_reg] != [Region2Text $p_reg]} {
	    return TRUE
	}
    }
}
# regionʸؤѴ
proc Region2Text { reg } {
    set id [open [spdGetName [lindex $reg 0]] r]
    seek $id 0 start
    set contents [read $id]
    close $id
    return [string range $contents [lindex $reg 1] [expr [lindex $reg 1] + [lindex $reg 2] - 1]]
}

################################################################################
# expressionidentи뤫ɤ
# и():  и():  и(ξ):  ʤ:
# ޥ
#   EXPR_R_VALUE :2  EXPR_PR_VALUE :8
#   EXPR_L_VALUE :1  EXPR_PL_VALUE :4
#   EXPR_LR_VALUE:3  EXPR_PLR_VALUE:12
proc check_expr {expr_id} {
    global VAR_ident
    set L 0
    set R 0
    set tmp_id [spdGetRelObj $expr_id ident_ref expression_id]
    if {$tmp_id == $VAR_ident} { 
	# ȯν
	switch [spdGetAttrVal $expr_id lrtype] {
	    2 -
	    8       { set R 1 }
	    1 -
	    4       { set L 1 }
	    3 -
	    12      { return 3 }
	    default { }
	}
    }
    # ƵŪ˥å
    set exp_buf [spdGetRelObj $expr_id expr_expr outer_expression_id]
    foreach exp $exp_buf {
	switch [check_expr $exp] {
	    1 { set R 1 }
	    2 { set L 1 }
	    3 { return 3 }
	}
    }
    if     {($R == 1) && ($L == 0)} { return 1 }\
    elseif {($R == 0) && ($L == 1)} { return 2 }\
    elseif {($R == 1) && ($L == 1)} { return 3 }\
    else                            { return 0 }
}
################################################################################
# ե񤭹ߴؿ
#     name    񤭹ʸ
#           expr_id 󥯤ĥexpression
#           sort    °(CTRL DATA IN-OUT ENUM)
# աǺեѿʬΥɥѤǤ
set LET 0
set TAGNUM 0
set Cflag  0 ;# CTRL°Ļˤʤ
set Dflag  0 ;# DATA°Ļˤʤ
set IOflag 0 ;# IO°Ļˤʤ
set Eflag  0 ;# ENUM°Ļˤʤ
proc WRITE {name expr_id sort} {
    global id id2
    global Cflag Dflag IOflag Eflag
    global LET TAGNUM VAR
    set WIN .var.f.txt ;# ݥåץåץɥΥƥȥѥ

    switch $sort {
	CTRL   { set Cflag  1 }
	DATA   { set Dflag  1 }
	IN-OUT { set IOflag 1 }
	ENUM   { set Eflag  1 }
    }

    incr LET [expr [string length $name] + 1] ;# "+1"ϥ
    set old $LET
    set offset [id2offset $expr_id]
    incr LET [expr [string length $offset] + 1]
    incr TAGNUM

    puts $id  "$name:$offset"
    puts $id2 "$WIN tag add JUMP$TAGNUM \"1.0 + $old chars\" \"1.0 + $LET chars\" ;\
	       $WIN tag configure JUMP$TAGNUM -foreground red ;\
	       $WIN tag bind JUMP$TAGNUM <Button-1> {;\
	         set MODE 0;\
	         ViewBotton $VAR;\
		 Select .f1.tree.$VAR;\
		 .text.out yview \"1.0 + $offset chars\" };"
}
################################################################################
# ID饪եåȤѴ
proc id2offset {id} {
    set offset [spdGetOffsetOfObj $id]
    set offset [spdConvOccToRegion [lindex $offset 0]]
    set offset [spdConvRegionItoC $offset]
    set offset [spdConvRegionSpdToTcl $offset]
    return [lindex $offset 1]
}

# ե֤̾
#     ܥֹ
proc FileName { num } {
    global count attr
    for {set i $num} {$i > 0} {incr i -1} {
	if {[lindex $attr($i) 1] == 2} {
	    if {[lindex $attr($i) 4] == 0} {
		return [lindex $attr($i) 2]
	    }
	}
    }
}

################################################################################
# 
################################################################################

# ѿident_id
set VAR_ident [spdGetRelObj [lindex $attr($VAR) 3] decl_ident declarator_id]
if {[spdGetAttrVal $VAR_ident sort] == "ID_TAG"} {
    exit
}

# ؿΥ֥å
set decr_id [lindex $attr($FUNC) 3]
set opt_id  [spdGetRelObj $decr_id decl_opt declarator_id]
set body_id [spdGetRelObj $opt_id func_body function_id]
set blk_buf [spdGetRelObj $body_id blk_blk parent_block_id]

################################################################################
# ؿΤ٤ƤΥ֥åˤĤ"ѿ"Ĵ
set LET 0
set id [open $DATADIR$VAR.CTRL w]
set id2 [open $DATADIR$VAR.CTRL.tag w]
foreach blk $blk_buf {
    check_blanch $blk
}
close $id
close $id2
if {$Cflag == 0} {
    exec rm $DATADIR$VAR.CTRL
    exec rm $DATADIR$VAR.CTRL.tag
}

################################################################################
# ؿΤ٤ƤΥ֥åˤĤ"ǡѿ"Ĵ
set LET 0
set id [open $DATADIR$VAR.DATA w]
set id2 [open $DATADIR$VAR.DATA.tag w]
foreach blk $blk_buf {
    check_data $blk
}
close $id
close $id2
if {$Dflag == 0} {
    exec rm $DATADIR$VAR.DATA
    exec rm $DATADIR$VAR.DATA.tag
}

################################################################################
# "ѿ"Ĵ
if {([lindex $attr($VAR) 1]==4) && ([lindex $attr($VAR) 4]==1)} {
    # ݥѿǤʤнλ
    set type_id [spdGetRelObj $VAR_ident ident_type identifier_id]
    if {[spdGetAttrVal $type_id sort] == 2} {
	set LET 0
	set id [open $DATADIR$VAR.IN-OUT w]
	set id2 [open $DATADIR$VAR.IN-OUT.tag w]
	check_io
	close $id
	close $id2
	if {$IOflag == 0} {
	    exec rm $DATADIR$VAR.IN-OUT
	    exec rm $DATADIR$VAR.IN-OUT.tag
	}
    }
}

################################################################################
# ؿΤ٤ƤΥ֥åˤĤ"ѿ"Ĵ
set LET 0
set id [open $DATADIR$VAR.ENUM w]
set id2 [open $DATADIR$VAR.ENUM.tag w]
foreach blk $blk_buf {
    check_enum $blk
}
close $id
close $id2
if {$Eflag == 0} {
    exec rm $DATADIR$VAR.ENUM
    exec rm $DATADIR$VAR.ENUM.tag
}

exit
################################################################################
# End
################################################################################
