#! SapidBinDir/tkAR4sh
# 
# Program:              $RCSfile: vcr.tcl,v $  $Revision: 30.9 $
# 
# Purpose:
#
# Author:               K.Yasuhara  1998/07/01
#                       S.Yamamoto  1999/10/28
#
# (C) Copyright:        K.Yasuhara and S.Yamamoto  1998 - 1999
#                       This file is a product of the project Sapid.
# 

# 
# "$Id: vcr.tcl,v 30.9 2000/01/14 14:49:35 yamamoto Exp yamamoto $";
# 

################################################################################
# ӥ奢륯ե ᥤ⥸塼
#     ե롧tree.dat                : ĥ꡼ǡե
#                   name.dat                : ̾ѹǡ
#                   [ե̾].tag        : ѥǡ
#                   [ե̾].tag2       : ɲåǡ
#                   [ܥֹ].spec       : ͽ
#                   [ܥֹ].spec.tag   : ͽѥǡ
#                   [ܥֹ].spec.tag2  : ͽɲåǡ
#                   [ܥֹ].CTRL       : ѿ ȥꥹ
#                   [ܥֹ].CTRL.tag   : ѿ ȥꥹȥǡ
#                   [ܥֹ].DATA       : ǡѿ ȥꥹ
#                   [ܥֹ].DATA.tag   : ǡѿ ȥꥹȥǡ
#                   [ܥֹ].IN-OUT     : ѿ ȥꥹ
#                   [ܥֹ].IN-OUT.tag : ѿ ȥꥹȥǡ
#                   [ܥֹ].ENUM       : ѿ ȥꥹ
#                   [ܥֹ].ENUM.tag   : ѿ ȥꥹȥǡ
#    ̾衧TO[ܥֹ]   :  
#                  TAG[ܥֹ]  :  
#                ȡ[FileNum]CM[]:  
#                ޡSRC[TagNum]      :  ɲåޡ
#                ȡ[TagNum]         :  ɲå
#                ̵TT[ܥֹ]   : 
#                ͭT[ܥֹ]    : 
#                ޡSPC[TagNum]      :  ɲåޡ
#                ȡ[TagNum]         :  ɲå
################################################################################

# Ķ
set VCRTREEDIR VcrBinDir		; # "vcr-tree"Υǥ쥯ȥꡥ
set INSTDIR VcrBinDir			; # "*.tcl"Υǥ쥯ȥꡥ

set DATADIR DATA/                        ; # ǡǼѥǥ쥯ȥ
set TREEDAT [format %stree.dat $DATADIR] ; # treeǡΥե̾
set NAMEDAT [format %sname.dat $DATADIR] ; # nameǡΥե̾
option add *background #d9d9d9           ; # طʿ

# ν
set SDBDIR "./SDB"
for {set i 0} {$i < $argc} {incr i} {
    switch -- [lindex $argv $i] {
        -D {
            incr i
            set SDBDIR [lindex $argv $i]
            if { $SDBDIR == "" } {
                puts "sat4: Option Error."
                puts "Usage: vcr \[-D SDBdir\]"
                exit;
            }
        }
    }
}

# TclAR «
source "$env(SAPID_TCLAR_LIBDIR)/tkAR4.tcl"
spdSetSDBdir $SDBDIR
set target [smuGetAProgramName]
spdTarget P-model $target

###############################################################################
# ˥塼Сκ
###############################################################################
# ᥤ
proc MakeMenu {} {
    global DATADIR OpenFileName select
    # ˥塼
    menubutton .menu.file -text "File" -menu .menu.file.m
    menubutton .menu.tool -text "Tool" -menu .menu.tool.m
    pack .menu.file .menu.tool -side left

    ## ե
    menu .menu.file.m -tearoff no
    .menu.file.m add command -label "Save As" -command SaveFile
    .menu.file.m add separator
    .menu.file.m add command -label "Exit"    -command exit
    ## ġ
    menu .menu.tool.m -tearoff no
    .menu.tool.m add command  -label "Find"  -command Find
    .menu.tool.m add cascade  -label "Name"  -menu .menu.tool.m.name
    .menu.tool.m add separator
    .menu.tool.m add cascade  -label "Clear" -menu .menu.tool.m.init

    ### ̾ѹ
    menu .menu.tool.m.name -tearoff no
    .menu.tool.m.name add command -label "ReName" -command Rename
    .menu.tool.m.name add separator
    .menu.tool.m.name add command -label "Default" -command DefaultName
    .menu.tool.m.name add command -label "Default All" -command DefaultNameAll
    ### 
    menu .menu.tool.m.init -tearoff no
    .menu.tool.m.init add command -label "Current" \
	    -command { if {$MODE == 0} {
	                   eval exec rm -f \
				   [format %s%s.tag2 $DATADIR $OpenFileName]
		           Source [ButtonName $select]
                       } else {
			   eval exec rm -f \
				   [format %s%s.spec.tag2 $DATADIR [ButtonName $select]]
		           Spec [ButtonName $select]
		       }
		     }
    .menu.tool.m.init add command -label "Mode All" \
	    -command { if {$MODE == 0} {
	                   eval exec rm -f [glob -nocomplain $DATADIR*.c.tag2]
	                   Source [ButtonName $select]
                       } else {
			   eval exec rm -f [glob -nocomplain $DATADIR*.spec.tag2]
			   Spec [ButtonName $select]
		       }
                     }
    .menu.tool.m.init add command -label "All" \
	    -command { eval exec rm -f [glob -nocomplain $DATADIR*.tag2]
                       if {$MODE == 0} { 
	                   Source [ButtonName $select]
		       } else {
			   Spec [ButtonName $select]
		       }
                     }
}
# ե¸
proc SaveFile {} {
    set ftypes {
	{"C File"         {.c}}
	{"Text File"    {.txt}}
	{"All files"         *}
    }
    set fname [tk_getSaveFile -filetypes $ftypes \
	    -parent . -initialfile Untitled -defaultextension .txt ]
    if {$fname == ""} {
	return
    } else {
	set contents [ .text.out get 1.0 end ]
	set fileid [ open $fname "w" ]
	puts -nonewline $fileid $contents
	close $fileid
    }
}
# ʸ󸡺
proc Find {} {
    if {[winfo exists .find] != 0} { destroy .find }
    .text.out tag delete FIND
    set x [expr [winfo pointerx .] - 10]
    set y [expr [winfo pointery .] - 50]
    toplevel .find
    wm title .find "Search"
    wm geometry .find +$x+$y

    label .find.mes -text "Input word."
    entry .find.text -background white -textvariable FindText
    set comm " MakeFIND \$FindText
	       .text.out tag configure FIND -background black -foreground white
	       bind .text.out <Button-1> { .text.out tag delete FIND }
	       destroy .find "
    button .find.ok -text "OK" -command $comm
    pack .find.mes .find.text -side top -fill both -expand yes
    pack .find.ok
    focus .find.text
}
# ɽˤʸ󸡺
proc MakeFIND {pattern} {
    if {$pattern == ""} { return }
    scan [.text.out index end] %d numLines
    for {set i 0} {$i < $numLines} {incr i} {
	.text.out mark set last $i.0
	while {[regexp -indices $pattern \
		[.text.out get last "last lineend"] indices]} {
	    .text.out mark set first "last + [lindex $indices 0] chars"
	    .text.out mark set last  "last + 1chars + [lindex $indices 1] chars"
	    .text.out tag add FIND first last
	}
    }
}
###############################################################################
# ĥ꡼κ
# ܥ̾"+,-"  $w(tree).scr$NUM
#           "name" $w(tree).$NUM
###############################################################################
# ĥ꡼ ᥤ
proc MakeTree {} {
    global attr COUNT w select

    $w(tree) configure -state normal
    $w(tree) delete 1.0 end

    for {set i 0} {$i < $COUNT} {incr i} {
	if {[lindex $attr($i) 0] == 1} { ; # Programܥ
	    set O_Prog 0
	    MakeTreeProg
	    if {[lindex $attr($i) 4] == 1} { set O_Prog 1 }
            set O_File 0 ; set O_Func 0
	} elseif {[lindex $attr($i) 0] == 2} { ; # Fileܥ
            set O_File 0
	    if {$O_Prog == 1} {
		MakeTreeFile $i
	    } else { continue }
	    if {[lindex $attr($i) 4] == 1} { set O_File 1 }
	    set O_Func 0
	} elseif {[lindex $attr($i) 0] == 3} { ; # Funcܥ
            set O_Func 0
	    if {($O_Prog == 1) && ($O_File == 1)} {
		MakeTreeFunc $i
	    } else { continue }
	    if {[lindex $attr($i) 4] == 1} { set O_Func 1 }
	} else { ; # LocalVariableܥ
	    if {($O_Prog == 1) && ($O_File == 1) && ($O_Func == 1)} {
		MakeTreeLv $i
	    }
	}
    }
    $select configure -background lightgreen -activebackground green
    $w(tree) configure -state disabled
}
# Programܥκ
proc MakeTreeProg {} {
    global attr w select

    # Ҥɤɽɽܥ
    button $w(tree).scr0 -anchor n\
	    -padx 0 -pady 0 -borderwidth 0\
 	    -command { if { [lindex $attr(0) 4] == 0 } {
	                   set attr(0) [lreplace $attr(0) 4 4 1]
	                   MakeTree
                       } else {
			   set attr(0) [lreplace $attr(0) 4 4 0]
			   Select $w(tree).0
			   MakeTree
                       }
                     }
    $w(tree) window create insert -window $w(tree).scr0
    if {[lindex $attr(0) 4] == 0} {
	$w(tree).scr0 configure -text "+"
    } else {
	$w(tree).scr0 configure -text "-"
    }
    # ץܥ
    button $w(tree).0 -text "[lindex $attr(0) 2]" -anchor w\
	    -borderwidth 0 -highlightthickness 0 -padx 0 -pady 0\
	    -command { Select $w(tree).0 }
    $w(tree) window create insert -window $w(tree).0

    $w(tree) insert insert "\n"
}
# Fileܥκ
#    ܥֹ
proc MakeTreeFile { num } {
    global attr w

    # Ҥɤɽɽܥ
    button $w(tree).scr$num -anchor n \
	    -padx 0 -pady 0 -borderwidth 0
    $w(tree) window create insert -window $w(tree).scr$num
    # ҶäƤ뤫
    if {[lindex $attr([expr $num + 1]) 0] > 2} {
	set comm \
	    "-command { if {[lindex $attr($num) 4] == 0} {
	                   set attr($num) {[lreplace $attr($num) 4 4 1]}
	                   MakeTree
                       } else {
			   set attr($num) {[lreplace $attr($num) 4 4 0]}
			   # ҤɤĤ鼫ʬ򤹤
			   if {\[ChildSelected $num\] == 1} {
			       Select $w(tree).$num
			   }
			   MakeTree
                       }
                     } "
	eval $w(tree).scr$num configure $comm
	if {[lindex $attr($num) 4] == 0} {
	    $w(tree).scr$num configure -text "  +"
	} else {
	    $w(tree).scr$num configure -text "  -"
	}
    } else {
	$w(tree).scr$num configure -text "  -"
    }
    # ץܥ
    button $w(tree).$num -text "[lindex $attr($num) 2]" -anchor w \
	    -borderwidth 0 -highlightthickness 0 -padx 0 -pady 0
    set comm \
	    "-command { Select $w(tree).$num
                        .text.out yview 1.0 } "
    $w(tree) window create insert -window $w(tree).$num
    eval $w(tree).$num configure $comm

    $w(tree) insert insert "\n"
}
# Funcܥκ
#    ܥֹ
proc MakeTreeFunc { num } {
    global attr w
    global MODE

    # Ҥɤɽɽܥ
    button $w(tree).scr$num -anchor n\
	    -padx 0 -pady 0 -borderwidth 0
    $w(tree) window create insert -window $w(tree).scr$num
    if {[lindex $attr([expr $num + 1]) 0] > 3} {
	set comm\
	    "-command { if {[lindex $attr($num) 4] == 0} {
	                   set attr($num) {[lreplace $attr($num) 4 4 1]}
	                   MakeTree
                       } else {
			   set attr($num) {[lreplace $attr($num) 4 4 0]}
			   if {\[ChildSelected $num\] == 1} {
			       Select $w(tree).$num
			   }
			   MakeTree
                       }
                     }"
	if {[lindex $attr($num) 4] == 0} {
	    $w(tree).scr$num configure -text "    +"
	} else {
	    $w(tree).scr$num configure -text "    -"
	}
	eval $w(tree).scr$num configure $comm
    } else {
	$w(tree).scr$num configure -text "    -"
    }
    # ץܥ
    button $w(tree).$num -text "[lindex $attr($num) 2]" -anchor w\
	    -borderwidth 0 -highlightthickness 0 -padx 0 -pady 0
    set comm\
	    "-command {Select $w(tree).$num
                       if {\$MODE == 0} {
			   .text.out yview TO$num.first
		       }  }"
    $w(tree) window create insert -window $w(tree).$num
    eval $w(tree).$num configure $comm

    $w(tree) insert insert "\n"
}
# Lvܥκ
#    ܥֹ
proc MakeTreeLv { num } {
    global attr w
    global MODE

    button $w(tree).scr$num -text "      -" -anchor n\
	    -padx 0 -pady 0 -borderwidth 0
    $w(tree) window create insert -window $w(tree).scr$num

    # ץܥ
    button $w(tree).$num -text "[lindex $attr($num) 2]" -anchor w\
	    -borderwidth 0 -highlightthickness 0 -padx 0 -pady 0
    set comm\
	    "-command {Select $w(tree).$num
                       if {\$MODE ==0} {
			   .text.out yview TO$num.first
		       } }"
    $w(tree) window create insert -window $w(tree).$num
    eval $w(tree).$num configure $comm

    $w(tree) insert insert "\n"
}
###############################################################################
# ĥ꡼˴ؤؿ
###############################################################################
# ɽʪ
#     򤷤ܥΥѥ
proc Select { path } {
    global MODE
    global STACKCUR STACKTOP STACK

    incr STACKCUR
    set STACKTOP $STACKCUR
    set STACK($STACKCUR) "set MODE $MODE;\
                          ViewBotton [ButtonName $path];\
			  SelectMain $path"
##
#    puts push($STACKCUR)->$STACK($STACKCUR) ; # ǥХå
##
    SelectMain $path
}
proc SelectMain { newpath } {
    global select w attr
    global MODE OLDMODE
    global STACKCUR STACKTOP STACK

    # ĥ꡼ο񴹤
    $w(tree) configure -state normal
    $select configure -background #d9d9d9 -activebackground #ececec
    $newpath configure -background lightgreen -activebackground green
    $w(tree) configure -state disabled

    # ɽ񴹤
    set old [ButtonName $select]
    set new [ButtonName $newpath]
    if {$MODE == 0} {
	# ⡼ɥ󥸡ۤʤե뤬򤵤줿
	if {$MODE != $OLDMODE} {
	    Source $new
	    if {[lindex $attr($new) 0] > 2} {
		.text.out yview TO$new.first
	    } else {
		.text.out yview 1.0
	    }
	} elseif {[FileName $old] != [FileName $new]} {
	    Source $new
	}
	.text.out tag configure TAG$old -background #d9d9d9
	.text.out tag configure TO$old -background #d9d9d9
	.text.out tag configure TAG$new -background green
	.text.out tag configure TO$new -background yellow
    } else {
	# ⡼ɥ󥸡ۤʤܥ򤵤줿
	if {$MODE != $OLDMODE} {
	    .text.out tag configure TAG$old -background #d9d9d9
	    .text.out tag configure TO$old -background #d9d9d9
	    Spec $new
	} elseif {$old != $new} {
	    Spec $new
	}
    }

    set select $newpath
    set OLDMODE $MODE
}
# Ҥ򤵤Ƥ1֤
#     new:򤷤ܥֹ
# ĥ꡼ĤҤɤ⤬򤵤ƤȽ
proc ChildSelected { new } {
    global attr select
    set old [ButtonName $select]

    # ʬˤϻҤɤϤʤ
    if { $old <= $new } {
	return 0
    }
    set flag [lindex $attr($new) 0]
    for {set i [expr $new + 1]} {$i <= $old} {incr i} {
	if {[lindex $attr($i) 0] <= $flag} { return 0 }
    }
    return 1
}
# ܥζɽ
#     ܥֹ
# ꤵ줿ܥֹΥܥŪɽ
proc ViewBotton { num } {
    global attr
    set sort [lindex $attr($num) 0]
    # ʬγؤõ
    for {set i $sort} {$i > 1} {incr i -1} {
	# ľγؤ򳫤
	for {set j $num} {$j >= 0} {incr j -1} {
	    if {$i == [expr [lindex $attr($j) 0] + 1]} {
		set attr($j) [lreplace $attr($j) 4 4 1]
		break
	    }
	}
    }
    MakeTree
}
# ܥֹ֤
#     ܥΥѥ̾
proc ButtonName { path } {
    global w
    set len [expr [string length $w(tree)] + 1]
    return [string range $path $len end]
}
# ե֤̾
#     ܥֹ
proc FileName { num } {
    global attr
    for {set i $num} {$i > 0} {incr i -1} {
	if {[lindex $attr($i) 0] == 2} {
	    return [lindex $attr($i) 5]
	}
    }
}
proc FileId { num } {
    global attr
    for {set i $num} {$i > 0} {incr i -1} {
	if {[lindex $attr($i) 0] == 2} {
	    return [lindex $attr($i) 3]
	}
    }
    return 0
}
###############################################################################
# ɽ
###############################################################################
# ͽɽ
#     򤵤줿ܥֹ
proc Spec { num } {
    global DATADIR TREEDAT NAMEDAT
    global OpenFileName attr
    global INSTDIR

    # λͽե뤬ʤʤ
    if {[file exists [format %s%s.spec $DATADIR $num]] == 0} {
	CheckVER $num
	exec [format %sspec $INSTDIR] $DATADIR $TREEDAT $num $SDBDIR
    }
    # ͽɽ
    set OpenFileName [FileName $num]
    set fileid [ open [format %s%s.spec $DATADIR $num] "r" ]
    set contents [ read $fileid ]
    close $fileid
    .text.out configure -state normal
    .text.out delete 1.0 end
    .text.out insert 1.0 $contents
    .text.out configure -state disabled
    ReadTag [format %s%s.spec.tag $DATADIR $num]
    if {[file exists $NAMEDAT] != 0} {
	ReadTag $NAMEDAT
    }
    if {[file exists [format %s%s.spec.tag2 $DATADIR $num]] != 0} {
	ReadTag [format %s%s.spec.tag2 $DATADIR $num]
    }
    focus .text.out
}

# եɽ
#     򤵤줿ܥֹ
proc Source { num } {
    global DATADIR NAMEDAT
    global OpenFileName attr

    # ץΥܥλ
    if {[lindex $attr($num) 0] == 1} {
	.text.out configure -state normal
	.text.out delete 1.0 end
	.text.out configure -state disabled
	if {[file exists $NAMEDAT] != 0} {
	    ReadTag $NAMEDAT
	}
	return
    }

    set OpenFileName [FileName $num]
    set OpenFileId   [FileId $num]

    spdDeleteSource .text.out
    spdLoadSource   .text.out $OpenFileId
    # ǽ1ԤϺ
    .text.out configure -state normal
    .text.out delete 1.0 2.0
    .text.out configure -state disabled

    ReadTag [format %s%s.tag $DATADIR $OpenFileName]
    if {[file exists $NAMEDAT] != 0} {
	ReadTag $NAMEDAT
    }
    if {[file exists [format %s%s.tag2 $DATADIR $OpenFileName]] != 0} {
	ReadTag [format %s%s.tag2 $DATADIR $OpenFileName]
    }
    focus .text.out
}

# ɤ߹
#     ե̾
proc ReadTag { tagfile } {
    global DATADIR
    global OpenFileName TagNum

    set TagNum 0
    set id [ open $tagfile r ]
    seek $id 0 start
    while { [eof $id]==0 } {
	gets $id line
	incr TagNum
    }
    close $id
    source $tagfile
}
###############################################################################
# ѿʬΥ
###############################################################################
# ѿʬΥɥɽ
#    num  :ܥֹ
#          sort :(CTRL DATA IN-OUT ENUM)
proc VarWin {num sort} {
    global attr
    global DATADIR

    # ɥ
    set x [expr [winfo pointerx .] - 10]
    set y [expr [winfo pointery .] - 50]
    if { [winfo exists .var] == 0} {
	toplevel .var
	wm geometry .var +$x+$y
	frame .var.f
	pack .var.f -side top -fill both -expand yes
	text .var.f.txt -wrap none -width 15 -height 10 -relief sunken -state disabled\
		-yscrollcommand ".var.f.scr set"
	scrollbar .var.f.scr -command ".var.f.txt yview"
	pack .var.f.scr -side right -fill y
	pack .var.f.txt -fill both -expand yes
	button .var.but -text Close -command { destroy .var }
	pack .var.but -side top -expand no
    }
    wm title .var "[lindex $attr($num) 2]:$sort"

    # ѿʬΥɽ
    set fileid [open $DATADIR$num.$sort "r"]
    set contents [ read $fileid ]
    close $fileid
    .var.f.txt configure -state normal
    .var.f.txt delete 1.0 end
    .var.f.txt insert 1.0 $contents
    .var.f.txt configure -state disabled
    ReadTag $DATADIR$num.$sort.tag
    focus .var.f.txt
}
# ѿʬΥե
#     var.tcl ƤӽФδؿ
#     δؿϡvar.tcl ΰ
#    num  :ܥֹ
proc CheckVER { num } {
    global attr COUNT
    global DATADIR TREEDAT INSTDIR
    if {[lindex $attr($num) 0] == 4} {
	# ѿ or ѿ
	for {set j [expr $num - 1]} {$j > 0} {incr j -1} {
	    if {[lindex $attr($j) 0] == 3} {
		exec [format %svar $INSTDIR] $DATADIR $TREEDAT $num $j $SDBDIR
		break
	    }
	}
    } elseif {[lindex $attr($num) 0] == 3} {
	if {[lindex $attr($num) 1] == 0} {
	    # ѿ
	    for {set j [expr $num - 1]} {$j > 0} {incr j -1} {
		if {([lindex $attr($j) 0] == 3) && ([lindex $attr($j) 1] != 0)} {
		    exec [format %svar $INSTDIR] $DATADIR $TREEDAT $j $num $SDBDIR
		} else {
		    break
		}
	    }
	}
    }
}
###############################################################################
# ü쵡ǽ
###############################################################################
# ̾ѹ
proc Rename {} {
    global attr select

    set NUM [ButtonName $select]

    if {[winfo exists .name] != 0} { destroy .name }
    set x [expr [winfo pointerx .] - 10]
    set y [expr [winfo pointery .] - 50]
    toplevel .name
    wm title .name "Rename:[lindex $attr($NUM) 2]"
    wm geometry .name +$x+$y

    label .name.mes -text "Input new name."
    entry .name.text -background white -textvariable NewName
    set comm " if {\$NewName != \"\"} {
	           AddNameFile $NUM \$NewName
	           WriteName $NUM \$NewName
               }
	       destroy .name "
    button .name.ok -text "OK" -command $comm
    pack .name.mes .name.text -side top -fill both -expand yes
    pack .name.ok
    focus .name.text
    # ̾ͤϸߤ̾ (ǥեȤ̾ˤ뤳Ȥǽ)
    .name.text delete 0 end
    .name.text insert 0 [lindex $attr($NUM) 2]
}
# ̾ѹǡ񤭤
#     num  : ѹ̾ĥܥֹ
#           name : ѹ̾
proc AddNameFile { num name } {
    global NAMEDAT
    set id [open $NAMEDAT a+]
    puts $id "WriteName $num $name"
    close $id
}
# ̾ѹ󥻥
proc DefaultName {} {
    global select attr
    set NUM [ButtonName $select]
    if {[lindex $attr($NUM) 0] < 3} {return}
    RemoveNameFile $NUM
}
# $NAMEDAT ̾ѹ
#     num : ܥֹ
proc RemoveNameFile {num} {
    global NAMEDAT attr
    if {[file exists $NAMEDAT] == 0} {return}
    set count 0
    set id [open $NAMEDAT r]
    seek $id 0 start
    while {[eof $id]==0} {
	gets $id line
	if {$line == ""} { break }
	scan $line "%s %d %s" comm NUM name
	if {$NUM != $num} {
	    incr count
	    set left($count) $line
	}
    }
    set id [open $NAMEDAT w]
    for {set i 1} {$i <= $count} {incr i} {
	puts $id $left($i)
    }
    WriteName $num [lindex $attr($num) 5]
    # Ȥʤʤ
    if {$count==0} {
	exec rm $NAMEDAT
    }
}
# ̾ѹ
#   եɽ֤Ʊˤ
proc DefaultNameAll {} {
    global attr select COUNT MODE NAMEDAT
    if {[file exists $NAMEDAT] == 0} {return}
    set NUM [ButtonName $select]
    exec rm $NAMEDAT
    for {set i 0} {$i <= $COUNT} {incr i} {
	set attr($i) [lreplace $attr($i) 2 2 [lindex $attr($i) 5]]
    }
    MakeTree
    if {$MODE==0} {
	Source $NUM
    } else {
	Spec $NUM
    }
}
# ѿΥܥֹ椫ƱפѿΥꥹȤ֤
#     num : Ĵ٤ѿΥܥֹ
# Ȥʤѿ static ǤäƤϤʤʤ
proc SameGv {num} {
    global attr COUNT
    set LIST {}
    set NAME [lindex $attr($num) 2]
    set ID   [lindex $attr($num) 3]
    for {set i 0} {$i < $COUNT} {incr i} {
	if {[lindex $attr($i) 0] != 3} {continue}
	if {[lindex $attr($i) 3] == $ID} {
	    lappend LIST $i
	    continue
	}
	if {[lindex $attr($i) 2] == $NAME} {
	    if {([lindex $attr($num) 1]==1)||([lindex $attr($num) 1]==2)} {
		lappend LIST $i
		continue
	    }
	}
    }
    return $LIST
}
# ̾񤭴
#     num  : ѹܥֹ
#           name : ѹ̾
# WriteName1,WriteName2ƤӽФ
proc WriteName {num name} {
    global MODE
    if {$MODE == 0} {
	WriteName2 $num $name
    } else {
	WriteName1 $num $name
    }
}
# ͽɽˤ̾ѹ
#     num  : ѹܥֹ
#           name : ѹ̾
proc WriteName1 {num name} {
    global attr w
    # ѿ(staticϽ)̤νԤʤ
    if {([lindex $attr($num) 0]==3) &&\
	    (([lindex $attr($num) 1]==1) || ([lindex $attr($num) 1]==2))} {
	set nums [SameGv $num]
	foreach i $nums {
 	    if {[winfo exists $w(tree).$i] == 1} {
		$w(tree).$i configure -text "$name"
	    }
	    WriteNameMain T$i $name
	    WriteNameMain TT$i $name
	    set attr($i) [lreplace $attr($i) 2 2 $name]
	}
    } else {
	if {[winfo exists $w(tree).$num] == 1} {
	    $w(tree).$num configure -text "$name"
	}
	WriteNameMain T$num $name
	WriteNameMain TT$num $name
	set attr($num) [lreplace $attr($num) 2 2 $name]
    }
}
# ɽˤ̾ѹ
#     num  : ѹܥֹ
#           name : ѹ̾
proc WriteName2 {num name} {
    global attr w
    global OpenFileName

    if {[lindex $attr($num) 0]==3} {
        if {[lindex $attr($num) 1]==0} {
	    # ؿ
	    if {[winfo exists $w(tree).$num] == 1} {
		$w(tree).$num configure -text "$name"
	    }
	    WriteNameMain TAG$num $name
	    WriteNameMain TO$num $name
	    set attr($num) [lreplace $attr($num) 2 2 $name]
	} elseif {[lindex $attr($num) 1]==3} {
	    # staticѿ ʥѿƱ
	    if {$OpenFileName != [FileName $num]} {return}
	    if {[winfo exists $w(tree).$num] == 1} {
		$w(tree).$num configure -text "$name"
	    }
	    WriteNameMain TAG$num $name
	    WriteNameMain TO$num $name
	    set attr($num) [lreplace $attr($num) 2 2 $name]
	} else {
	    # ѿ
	    set nums [SameGv $num]
	    foreach i $nums {
		if {[winfo exists $w(tree).$i] == 1} {
		    $w(tree).$i configure -text "$name"
		}
		WriteNameMain TAG$i $name
		WriteNameMain TO$i $name
		set attr($i) [lreplace $attr($i) 2 2 $name]
	    }
	}
    } elseif {[lindex $attr($num) 0]==4} {
	if {$OpenFileName != [FileName $num]} {return}
	if {[winfo exists $w(tree).$num] == 1} {
	    $w(tree).$num configure -text "$name"
	}
	WriteNameMain TAG$num $name
	WriteNameMain TO$num $name
	set attr($num) [lreplace $attr($num) 2 2 $name]
    } else {
	if {[winfo exists $w(tree).$num] == 1} {
	    $w(tree).$num configure -text "$name"
	}
	set attr($num) [lreplace $attr($num) 2 2 $name]
    }
}
# ºݤ˽񤭴ʬ
#     tagname : ̾
#           name    : ѹ̾
proc WriteNameMain {tagname name} {
    global MODE
    set tag [.text.out tag ranges $tagname]
    set num [llength $tag]

    .text.out configure -state normal
    for {set i 0} {$i < $num} {incr i 2} {
	set tag [.text.out tag ranges $tagname]
	set pos  [lindex $tag $i]
	set pos2 [lindex $tag [expr $i+1]]
	.text.out delete $pos $pos2
	.text.out insert $pos $name $tagname
    }
    .text.out configure -state disabled
}


###############################################################################
# ޡ
#     ޡο
proc Paint { m } {
    global DATADIR MODE
    global OpenFileName TagNum

    if {$MODE == 0} { set PRE SRC } else { set PRE SPC }

    incr TagNum
    set flag [ catch [ .text.out tag add $PRE$TagNum sel.first sel.last ] ]
    if { $flag != 0 } { incr TagNum -1; return }
    set comm ".text.out tag bind $PRE$TagNum <Key-c> { ;\
             .text.out tag delete $PRE$TagNum ;\
	     AddDataFile 1 \".text.out tag delete $PRE$TagNum\" }"
    eval $comm
    eval .text.out tag configure $PRE$TagNum -background $m
    # եǤФ
    AddDataFile 0 ".text.out tag add $PRE$TagNum [.text.out tag ranges $PRE$TagNum] ; "
    AddDataFile 0 ".text.out tag configure $PRE$TagNum -background $m ; "
    AddDataFile 1 $comm
}
set COLOR "#000000"   ;# tk_chooseColor
proc MakeColor1 {} {
    global COLOR
    set COLOR [tk_chooseColor -parent . -initialcolor $COLOR -title "Make Color"]
    Paint $COLOR
}
proc MakeColor {} {
    global color
    set x [expr [winfo pointerx .] - 10]
    set y [expr [winfo pointery .] - 50]
    toplevel .color
    wm title .color "Make Color"
    wm geometry .color +$x+$y

    set names {red green blue}
    for {set i 0} {$i < 3} {incr i} {
	set name  [lindex $names $i]
	set     w($i) .color.$i
	frame  $w($i)
	pack   $w($i) -side top -fill both -expand yes
	label  $w($i).l -width 10 -text "$name:[lindex $color $i]"
	scale  $w($i).s -from 0 -to 255 -orient horizontal -showvalue no\
		 -command "ChangeColor $name $i"
	pack   $w($i).l $w($i).s -side left -fill both -expand yes
	$w($i).s set [lindex $color $i]
    }
    button .color.made -text OK -relief raised\
	    -command "Paint \[BakColor\];destroy .color"
    pack .color.made -fill both -expand yes
}
proc ChangeColor {name pos value} {
    global color
    set color [lreplace $color $pos $pos $value]
    set bak [BakColor]
    set txt [TxtColor]
    .color.made configure -bg $bak -fg $txt -activebackground $bak -activeforeground $txt
    .color.$pos.l configure -text "$name:[lindex $color $pos]"
}
proc BakColor {} {
    global color
    return [format #%2.2x%2.2x%2.2x [lindex $color 0] [lindex $color 1] [lindex $color 2]]
}
proc TxtColor {} {
    global color
    return [format #%2.2x%2.2x%2.2x [expr 255-[lindex $color 0]]\
	                            [expr 255-[lindex $color 1]]\
	                            [expr 255-[lindex $color 2]]]
}


###############################################################################
# 
#     Pos:Ȥ
proc MakeComment { Pos } {
    global TagNum OpenFileName

    if {$OpenFileName == ""} {return}
    set x [expr [winfo pointerx .] - 10]
    set y [expr [winfo pointery .] - 50]
    toplevel .comment
    wm title .comment "Comment"
    wm geometry .comment +$x+$y
    label .comment.mes -text "Input comment (Don't use '\"'&'\\')"
    text .comment.text -width 40 -height 5 -background white
    button .comment.ok -text "OK" -command {
	# ߥν
	while {1} {
	    set contents [.comment.text get 1.0 "end -1c"]
	    set DQ [string first \" $contents]
	    if {$DQ == -1} { break }
	    .comment.text delete "1.0 + $DQ chars" 1.0+[expr $DQ + 1]chars
	}
	# ɽե񤭤
	if {$contents != ""} {
	    incr TagNum
	    .text.out configure -state normal
	    .text.out insert $Pos $contents $TagNum
	    .text.out tag configure $TagNum -foreground purple
	    .text.out tag bind $TagNum <Key-c> {
		.text.out configure -state normal
		.text.out delete $TagNum.first $TagNum.last
		.text.out configure -state disabled
	    }
	    .text.out configure -state disabled
	    set Comment ".text.out configure -state normal ;\
		.text.out insert $Pos \"$contents\" $TagNum ;\
		.text.out tag configure $TagNum -foreground purple;\
		.text.out configure -state disabled;\
		.text.out tag bind $TagNum <Key-c> {;\
		    .text.out configure -state normal;\
		    .text.out delete $TagNum.first $TagNum.last;\
		    .text.out configure -state disabled;\
		    AddDataFile 1 \";\
	                .text.out configure -state normal;\
	                .text.out delete $TagNum.first $TagNum.last;\
	                .text.out configure -state disabled \" }"
	    AddDataFile 1 $Comment
	}
	destroy .comment }
    button .comment.cancel -text "Cancel" -command {
	destroy .comment }
    pack .comment.mes .comment.text  -side top -fill both -expand yes
    pack .comment.ok .comment.cancel -side left
    focus .comment.text
}


###############################################################################
# ݥåץåץ˥塼
#     ü쵡ǽƤӽФΥ˥塼
proc MakePopup {} {
    menu .popup -tearoff no
    .popup add command -label "Comment" -command { set Pos [.text.out index current]
	                                           MakeComment $Pos }
    .popup add separator
    .popup add cascade -label "Paint" -menu .popup.color
    menu .popup.color -tearoff no
    .popup.color add command -label "Yellow"   -command { Paint yellow }
    .popup.color add command -label "Orange"   -command { Paint orange }
    .popup.color add command -label "Green"    -command { Paint green }
    .popup.color add command -label "Red"      -command { Paint red }
    .popup.color add command -label "White"    -command { Paint white }
    .popup.color add separator
    .popup.color add command -label "Other..." -command { MakeColor }

}

# ɽФХ
#     Υݥåץåץ˥塼Ƥ֤ΥХ
proc Binding {} {
    bind .text.out <Button-3> {
	set x [ expr [ winfo rootx %W ] + %x ]
	set y [ expr [ winfo rooty %W ] + %y ]
	tk_popup .popup $x $y
    }
}

# ǡ񤭤
#     ret :Ԥ뤫ɤ (0:Ԥʤ1:)
#           line:ºݤ˽񤭽Фʸ
# ü쵡ǽե˽񤭹ؿ
proc AddDataFile { ret line } {
    global DATADIR OpenFileName
    global select
    global MODE

    if {$MODE == 0} {
	set id [open [format %s%s.tag2 $DATADIR $OpenFileName] a+]
    } else {
	set id [open [format %s%s.spec.tag2 $DATADIR [ButtonName $select]] a+]
    }

    if {$ret == 0} {
	    puts -nonewline $id $line
    } else {
	puts $id $line
    }
    close $id
}


###############################################################################
# 
set STACKCUR 0      ; # 򥹥å 
set STACKTOP 0      ; # 򥹥å ȥå
global STACK        ; # 򥹥å
set STACK(0) "set MODE 0;SelectMain .f1.tree.0"

proc Back {} {
    global STACKCUR
    global STACK
    global MODE

    if {$STACKCUR != 0} {
	incr STACKCUR -1
##
#	puts popB($STACKCUR)->$STACK($STACKCUR) ; # ƥ
##
	eval $STACK($STACKCUR)
    }
}

proc Next {} {
    global STACKCUR STACKTOP
    global STACK
    global MODE

    if {$STACKCUR < $STACKTOP} {
	incr STACKCUR
##
#        puts popN($STACKCUR)->$STACK($STACKCUR) ; # ƥ
##
	eval $STACK($STACKCUR)
    }
}



###############################################################################
##########################       ᥤ¹        ##########################
###############################################################################

wm title . "VCR"
wm geometry . 90x35+120+0

# ǡǼѥǥ쥯ȥ꤬ʤʤ
if {[file exists $DATADIR] == 0} {
    exec mkdir $DATADIR
}

###############################################################################
# Treeǡκ
set FIRST 0 ; # ưΤ1Ȥʤ
if {[file exists $TREEDAT] == 0} {
    exec [format %svcr-tree $VCRTREEDIR] $TREEDAT $SDBDIR
    set FIRST 1
}

###############################################################################
# Treeǡɤ߹
global attr    ; # °{ sort sub_sort ReName Id Open:1\Close:0 Name}
global COUNT   ; # Treeǿ

set id [ open $TREEDAT "r" ]
seek $id 0 start
set COUNT 0
while { [eof $id]==0 } {
    gets $id line
    scan $line "%d %s %d %d" code name SpId mode
    set attr($COUNT) "$code $mode $name $SpId 0 $name"
    if {$code == 0} { break }
##
    puts "$COUNT\t$attr($COUNT)"
##
    # ΥեΥե뤬ʤʤ
    if {$code == 2} {
	if {[file exists [format %s%s.tag $DATADIR $name]] == 0} {
	    exec [format %stag $INSTDIR] $DATADIR $TREEDAT $COUNT $SDBDIR
	}
    }
    incr COUNT
}
close $id

###############################################################################
# ˥塼Сκ
frame .menu -borderwidth 2 -relief raised
pack .menu -side top -fill x
MakeMenu

###############################################################################
# ĥ꡼κ
set w(tree) .f1.tree   ; # ĥ꡼ɽ륦ɥ̾ (.f1.tree)
set select  $w(tree).0 ; # 򤵤Ƥܥpath

# ĥ꡼ɽ١
frame .f1
pack .f1 -side left -fill both
# ĥ꡼ɽС
text $w(tree) -wrap none -width 20 -relief flat -state disabled\
	-yscrollcommand ".f1.ybar set" -xscrollcommand ".f1.xbar set"
scrollbar .f1.xbar -command ".f1.tree xview" -orient horizontal
scrollbar .f1.ybar -command ".f1.tree yview"
pack .f1.ybar -side right -fill y
pack .f1.xbar -side bottom -fill x
pack $w(tree) -fill both -expand yes

MakeTree

###############################################################################
# ɽ
set OpenFileName "" ; # Ƥե̾
set TagNum 0        ; # ο
set MODE 0          ; # ɽ⡼  0:ե / 1:ͽ
set OLDMODE 0

# ɽ١
frame .text
pack .text -side left -fill both -expand yes

# ɽ⡼
frame .text.mode
pack .text.mode -side top -fill both
button .text.mode.back -text Back -command Back
button .text.mode.next -text Next -command Next
button .text.mode.mode -text Mode -command {
    if {$MODE == 0} { 
	set MODE 1;Select $select 
    } else {
	set MODE 0;Select $select
    }
}
button .text.mode.rename -text "ReName" -command Rename
button .text.mode.find   -text " Find " -command Find
button .text.mode.save   -text "SaveAs" -command SaveFile
button .text.mode.exit   -text " Exit " -command exit
label  .text.mode.lab  -textvariable OpenFileName -bg white -width 10
pack .text.mode.back .text.mode.next -side left
pack .text.mode.mode .text.mode.rename -side left
pack .text.mode.find .text.mode.save .text.mode.lab -side left
pack .text.mode.exit -side right

# ɽ
text .text.out -yscrollcommand ".text.ybar set"\
	-xscrollcommand ".text.xbar set"\
	-wrap none -setgrid 1 -state disabled
scrollbar .text.ybar -command ".text.out yview"
scrollbar .text.xbar -command ".text.out xview" -orient horizon
pack .text.ybar -side right -fill y
pack .text.xbar -side bottom -fill x
pack .text.out -fill both -expand yes

###############################################################################
# ü쵡ǽ
set color { 0 0 0 }
MakePopup
Binding

# ĥ꡼Τ Name.datɤ߹
if {[file exists $NAMEDAT] != 0} {
    ReadTag $NAMEDAT
}

# ʤʤܸΥȤäư򤹤롣
#     Υ򤹤٤ɤǤʤФʤʤΤ
#for {set i 0} {$i < $COUNT} {incr i} {
#    if {[lindex $attr($i) 0] == 2} {
#	ReadTag [format %s%s.tag $DATADIR [lindex $attr($i) 2]]
#    }
#}

.text.out configure -state normal
.text.out delete 1.0 end
.text.out configure -state disabled

###############################################################################
# End
###############################################################################
