/* 
 * Program:         $RCSfile: etc.c,v $  $Revision: 30.5 $
 * 
 * Purpose:         Ѵؿ
 *
 * Author:          K.Yasuhara  2000/07/01
 *                  S.Yamamoto  2000/07/01
 *
 * (C) Copyright:   K.Yasuhara and S.Yamamoto  2000 - 2003
 *                  This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: etc.c,v 30.5 2003/06/15 04:47:59 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <math.h>
#include <Sapid/Sapid.h>
#include "my.h"

/* ɸ֤εΥ֤ */

GLdouble PosDiff (POS from, POS to)
{
    return pow(pow(from.x-to.x,2)+pow(from.y-to.y,2)+pow(from.z-to.z,2), 0.5);
}

/* XYʿ̤ˤɸ֤εΥ֤ */

GLdouble PosDiff_XY (POS from, POS to)
{
    return pow(pow(from.x-to.x,2)+pow(from.y-to.y,2), 0.5);
}

/* ٥ȥ­ */

POS PosPlus (POS pos1, POS pos2)
{
    return SetPos(pos1.x+pos2.x, pos1.y+pos2.y, pos1.z+pos2.z);
}

/* ٥ȥΰ */

POS PosMinus (POS pos1, POS pos2)
{
    return SetPos(pos1.x-pos2.x, pos1.y-pos2.y, pos1.z-pos2.z);
}

/* ٥ȥΤ */

POS PosMult (POS pos, double c)
{
    return SetPos(pos.x*c, pos.y*c, pos.z*c);
}

/* ե֤ͤ */

GLdouble MakeAlpha (FUNC func)
{
    GLdouble diff = PosDiff(func.pos,eye);
    if (diff >= 10.0f) {
        return 1.0f;
    } else if (diff <= near) {
        return 0.0f;
    } else {
        return 0.07f * diff + 0.3;
    }
}

/* ObjectID  ֹ */

int IdToFuncNum (int id)
{
    int i;
    for(i=0; i<func_num; i++) {
        if(func[i].id == id) return i;
    }
    return -1;

}

int IdToGvNum (int id)
{
    int i;
    for(i=0; i<gv_num; i++) {
        if(gv[i].id == id) return i;
    }
    return -1;
}

/****************************************************************************
  ¤Τؤ
  ****************************************************************************/
/* ɸ¤κ */

POS SetPos (GLdouble x, GLdouble y, GLdouble z)
{
    POS ret;
    ret.x = x;
    ret.y = y;
    ret.z = z;
    return ret;
}
