/* 
 * Program:         $RCSfile: event.c,v $  $Revision: 30.9 $
 * 
 * Purpose:         ٥Ƚץࡥ
 *
 * Author:          K.Yasuhara  2000/07/01
 *                  S.Yamamoto  2000/07/01
 *
 * (C) Copyright:   K.Yasuhara and S.Yamamoto  2000 - 2003
 *                  This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: event.c,v 30.9 2003/06/22 07:28:45 yamamoto Exp yamamoto $";
#endif

#include <ctype.h>   /* toupper */
#include <math.h>    /* sin,cos */
#include <stdio.h>
#include <Sapid/Sapid.h>
#include "my.h"

/* ץȥ(ΥեǤΤ) */
/* ޥ */
int  Pick(int x, int y);                /* ʪΤΤȽ */
int  Hits(int hits, GLuint buf[]);      /* äʪΤ */
/* ɽʪ */
void ChangeDrawFunc_uAll_sub(int num);
void ChangeDrawFunc_dAll_sub(int num);
int  ChangeDrawFunc_Path(int from, int to, int *check);
/* եΰư */
void FileMoveRight(void);                   /* ؿޤȤƱž */
void FileMoveLeft(void);                    /* ؿޤȤƺž */

/* ˥᡼ */
void MoveFunc(struct Togl *togl,int id, int dx, int dy);  /* ؿκɸѤ */
void MoveFunc2(struct Togl *togl, int id, POS p);
int DstMove1(struct Togl *togl, double x, double y, double z);

/* ʸ word ʸˤ Uword ˳Ǽ */
void ToUpper(char *word, char *Uword);

/****************************************************************************
  ޥϢ
  ****************************************************************************/
/* ޥ٥ : ܥ<1> */

int Mouse1_on(struct Togl *togl, int argc, char *argv[])
{
    int   x   = atoi(argv[2]);              /* ޥ xɸ */
    int   y   = atoi(argv[3]);              /* ޥ yɸ */
    mouse_on_x = x;  mouse_on_y = y;
    mouse_catch_id = Pick(x,y);
    if (mouse_catch_id != -1) {
        mouse_catch = CATCH;                /* ʪΤä */
    } else {
        mouse_catch = NO_CATCH;             /* ʪΤäƤʤ */
    }
    return TCL_OK;
}

int Mouse1_motion(struct Togl *togl, int argc, char *argv[])
{
    int x,y, dx,dy;
    int num;
    double d;

    /* ޥθߺɸ */
    x   = atoi(argv[2]);
    y   = atoi(argv[3]);
    /* ޥΰư */
    dx = x - mouse_on_x;
    dy = y - mouse_on_y;
    /* 򤷤ʤȰư̤Ѥ */
    mouse_on_x = x;
    mouse_on_y = y;

    /* ֥ȤϤǤ饪֥Ȥư */
    if(mouse_catch == CATCH) {
        num = IdToFuncNum(mouse_catch_id);
        if(num!=-1){                        /* ưǤΤϴؿΤ */
            MoveFunc(togl, num, dx, -dy);
        } else {
            return TCL_OK;                  /* ѿưʤ */
        }
    } else {
        d = PosDiff_XY(eye,dst);
        /* ΰư */
        eye.x = d * cos(-2.0*PI*dx/win_w + sita) + dst.x;
        eye.y = d * sin(-2.0*PI*dx/win_w + sita) + dst.y;
        eye.z = eye.z + (double)dy/win_h*10;
    }
    Togl_PostRedisplay(togl);
    return TCL_OK;
}

int Mouse1_double(struct Togl *togl, int argc, char *argv[])
{
  /* int   x   = atoi(argv[2]); */         /* ޥ xɸ */
  /* int   y   = atoi(argv[3]); */         /* ޥ yɸ */
  int num;                                 /* ʪΤֹ */

    /* ֥ȤϤǤʤʤ鲿⤷ʤ */
    if (mouse_catch != CATCH) return TCL_OK;

    num = IdToFuncNum(mouse_catch_id);
    /*  */
    if(num != -1){
        /* ؿ򤵤줿 */
        if(select_gv != -1){
            /* ľѿ */
            select_gv = -1;
        } else {
            /*  */
            if(select_func == num) {
                ChangeDrawFunc();           /* ɤδؿ */
                Togl_PostRedisplay(togl);
                return TCL_OK;
            }
            /* ľؿ */
            MoveFunc2(togl, select_func, func_old_pos);
        }
        select_func = num;
        ChangeDrawFunc();                   /* ɤδؿ */
        ChangeDrawGv();                     /* ɤѿ */
        func_old_pos = func[select_func].pos;
        MoveFunc2(togl, select_func, SetPos(0,0,func[select_func].pos.z));
    }else{
        /* ѿ򤵤줿 */
        if(select_func != -1){
            /* ľؿ */
            MoveFunc2(togl, select_func, func_old_pos);
            select_func = -1;
        } else {
            /* ľѿ */
        }
        drawgv = NEAR;
        select_gv = IdToGvNum(mouse_catch_id);
        ChangeDrawGv();                     /* ɤѿ */
        ChangeDrawFunc();                   /* ɤδؿ */
    }
    ChangeDrawName();                       /* ɤ̾ */
    ChangeDrawFile();                       /* ɤΥե̾ */

    Togl_PostRedisplay(togl);
    return TCL_OK;
}

/* ޥ٥ : ܥ<2> */

int Mouse2_on(struct Togl *togl, int argc, char *argv[])
{
    mouse_on_x = atoi(argv[2]);
    mouse_on_y = atoi(argv[3]);
    return TCL_OK;
}

int Mouse2_motion(struct Togl *togl, int argc, char *argv[])
{
    int x,y, dx,dy;
    double d;

    x   = atoi(argv[2]);                    /* ޥ xɸ */
    y   = atoi(argv[3]);                    /* ޥ yɸ */
    dx = x - mouse_on_x;                    /* ޥ x ư */
    dy = y - mouse_on_y;                    /* ޥ y ư */
    mouse_on_y = y;                         /* 򤷤ʤȰư̤Ѥ */
    d = PosDiff_XY(eye,dst);
    /* ϴβžƱ */
    eye.x = d * cos(-2.0*PI*dx/win_w + sita) + dst.x;
    eye.y = d * sin(-2.0*PI*dx/win_w + sita) + dst.y;
    /*  */
    d = dst.z - eye.z;
    eye.z = eye.z + (double)dy/win_h*10;
    dst.z = eye.z + d;
    Togl_PostRedisplay(togl);
    return TCL_OK;
}

/* ޥ٥ : ܥ<4> */

int Mouse4_on(struct Togl *togl, int argc, char *argv[])
{
    /* ΥƹԤ */
    eye.x = dst.x +1.1*(eye.x-dst.x);
    eye.y = dst.y +1.1*(eye.y-dst.y);
    eye.z = dst.z +1.1*(eye.z-dst.z);
    Togl_PostRedisplay(togl);
    return TCL_OK;
}

/* ޥ٥ : ܥ<5> */

int Mouse5_on(struct Togl *togl, int argc, char *argv[])
{
    /* դƹԤ */
    double d = PosDiff(eye,dst);
    if(d < 1.0) return TCL_OK;              /* ʾդʤ */
    eye.x = dst.x +0.9*(eye.x-dst.x);
    eye.y = dst.y +0.9*(eye.y-dst.y);
    eye.z = dst.z +0.9*(eye.z-dst.z);
    Togl_PostRedisplay(togl);
    return TCL_OK;
}

/* åʪΤȤ館Ƥ뤫Ƚ    */
/*    : x,y å줿ޥκɸ */
/*    : å줿ʪΤ ID        */

int Pick(int x, int y)
{
    GLint   viewport[4];
    int     hits;
    GLuint  *buf = spdMalloc(5 * func_num * sizeof(GLuint));

    /* SELECT ⡼ɤΤ */
    glGetIntegerv(GL_VIEWPORT, viewport);
    glSelectBuffer(5*func_num, buf);
    (void) glRenderMode(GL_SELECT);
    glInitNames();
    glPushName(-1);
    /*  */
    glMatrixMode(GL_PROJECTION);
    glPushMatrix();
    glLoadIdentity();
    gluPickMatrix(x, viewport[3]-y, 1.0, 1.0, viewport);
    gluPerspective(zoom, aspect, near, far);
    gluLookAt(eye.x, eye.y, eye.z, dst.x, dst.y, dst.z, top.x, top.y, top.z);
    /* ʪΤγ */
    glMatrixMode(GL_MODELVIEW);
    /* 򤵤Τ񤯤 */
    DrawFunc();                             /* ؿ */
    if(drawgv) DrawGv();                    /* ѿ */
    /* Ȥ᤹ */
    glMatrixMode(GL_PROJECTION);
    glPopMatrix();
    glMatrixMode(GL_MODELVIEW);

    hits = glRenderMode(GL_RENDER);
    return Hits(hits, buf);
}

/* å줿ʪ ID ֤                   */
/*    : hits  å줿ʪΤο          */
/*          buf[] 쥯Хåե            */

int Hits(int hits, GLuint buf[])
{
    int i;
    GLint names;
    GLuint *ptr;
    GLuint minz, z;
    GLuint match = -1;  /* warningɻѽ */

    if(hits < 0) {
        printf("WARNING: select buffer overflow.\n");
        return -1;
    } else if(hits == 0) {
        return -1;
    }
    minz = 0xffffffff;
    ptr = (GLuint *) buf;
    for(i=0; i<hits; i++) {
        names = *ptr;
        ptr++;
        z = *ptr;
        ptr++; ptr++;
        if(z <= minz) {
            minz = z;
            match = *ptr;
        }
        ptr += names;
    }
    return match;
}

/****************************************************************************
  TCL ̤񤭴
  ****************************************************************************/
/* TCL ؿԤ(Mouse1_doubleΥѥ) */

int SelectFunc_tcl(struct Togl *togl, int argc, char *argv[])
{
    int num = atoi(argv[2]);                /* 򤹤ؿֹ */

    if(select_gv != -1){
        /* ľѿ */
        select_gv = -1;
    } else {
        /* ľؿ */
        if(select_func == num) {
            ChangeDrawFunc();               /* ɤδؿ */
            Togl_PostRedisplay(togl);
            return TCL_OK;
        }
        MoveFunc2(togl, select_func, func_old_pos);
    }
    select_func = num;
    ChangeDrawFunc();                       /* ɤδؿ */
    ChangeDrawGv();                         /* ɤѿ */
    func_old_pos = func[select_func].pos;
    MoveFunc2(togl, select_func, SetPos(0,0,func[select_func].pos.z));
    ChangeDrawName();                       /* ɤ̾ */
    ChangeDrawFile();                       /* ɤΥե̾ */

    Togl_PostRedisplay(togl);
    return TCL_OK;
}

/****************************************************************************
  ɽʪ (ѥ)
  ****************************************************************************/
/* ꤵ줿ؿΥѥˤؿ */

int ChangeDrawFunc_From(struct Togl *togl, int argc, char *argv[])
{
    int i, *check;
    int num = atoi(argv[2]);
    /* ĶĴ */
    if (num == -1) return TCL_OK;
    if (select_func == -1) return TCL_OK;
    /*  */
    check = spdMalloc(func_num * sizeof(int));
    for(i=0; i<func_num; i++){
        func[i].view = FALSE;
        check[i] = FALSE;
    }
    /* Ĵ */
    if(ChangeDrawFunc_Path(num, select_func, check))
        func[select_func].view = TRUE;
    func[num].view = TRUE;

    spdFree(check);
    ChangeDrawFile();
    Togl_PostRedisplay(togl);
    return TCL_OK;
}

/* ꤵ줿ؿؤΥѥˤؿ */

int ChangeDrawFunc_To(struct Togl *togl, int argc, char *argv[])
{
    int i, *check;
    int num = atoi(argv[2]);
    /* ĶĴ */
    if (num == -1) return TCL_OK;
    if (select_func == -1) return TCL_OK;
    /*  */
    check = spdMalloc(func_num * sizeof(int));
    for(i=0; i<func_num; i++){
        func[i].view = FALSE;
        check[i] = FALSE;
    }
    /* Ĵ */
    if(ChangeDrawFunc_Path(select_func, num, check))
        func[num].view = TRUE;
    func[select_func].view = TRUE;

    spdFree(check);
    ChangeDrawFile();
    Togl_PostRedisplay(togl);
    return TCL_OK;
}

int ChangeDrawFunc_Path(int from, int to, int *check)
{
    int i;
    /* Ĵ٤Τϰ٤ */
    if (check[from]==TRUE) return func[from].view;
    check[from]=TRUE;

    for(i=0; i<edge_num; i++) {
        if(edge[i].from == from) {
            if(edge[i].to == to) {
                func[from].view = TRUE;
            }
            if(ChangeDrawFunc_Path(edge[i].to, to, check) == TRUE) {
                func[from].view = TRUE;
            }
        }
    }

    if(func[from].view == TRUE) return TRUE;
    return FALSE;
}

/* ̤Ƥδؿ */

int ChangeDrawFunc_uAll(struct Togl *togl, int argc, char *argv[])
{
    int i;
    /* ؿΤ߼¹ */
    if(select_func == -1) return TCL_OK;
    /*  */
    for(i=0; i<func_num; i++){
        func[i].view = FALSE;
    }
    /* ƵŪĴ */
    ChangeDrawFunc_uAll_sub(select_func);

    ChangeDrawFile();
    Togl_PostRedisplay(togl);
    return TCL_OK;
}

void ChangeDrawFunc_uAll_sub(int num)
{
    int i;
    if(func[num].view) return;
    func[num].view = TRUE;
    func[num].label = TRUE;
    for(i=0; i<edge_num; i++){
        if(edge[i].to == num){
            ChangeDrawFunc_uAll_sub(edge[i].from);
        }
    }
}

/* ̤Ƥδؿ */

int ChangeDrawFunc_dAll(struct Togl *togl, int argc, char *argv[])
{
    int i;
    /* ؿΤ߼¹ */
    if(select_func == -1) return TCL_OK;
    /*  */
    for(i=0; i<func_num; i++){
        func[i].view = FALSE;
    }
    /* ƵŪĴ */
    ChangeDrawFunc_dAll_sub(select_func);

    ChangeDrawFile();
    Togl_PostRedisplay(togl);
    return TCL_OK;
}

void ChangeDrawFunc_dAll_sub(int num)
{
    int i;
    if(func[num].view) return;
    func[num].view = TRUE;
    func[num].label = TRUE;
    for(i=0; i<edge_num; i++){
        if(edge[i].from == num){
            ChangeDrawFunc_dAll_sub(edge[i].to);
        }
    }
}

/* ȤƤʤؿ */

int ChangeDrawFunc_NOTUSE(struct Togl *togl, int argc, char *argv[])
{
    int i;
    /* ؿΤ߼¹ */
    if(select_func == -1) return TCL_OK;
    /*  */
    for(i=0; i<func_num; i++){
        func[i].view = FALSE;
    }
    ChangeDrawFunc_dAll_sub(func_main);
    /* ֵž */
    for(i=0; i<func_num; i++){
        if(func[i].view){
            func[i].view = FALSE;
        } else {
            func[i].view = TRUE;
            func[i].label = TRUE;
        }
    }
    ChangeDrawGv();
    ChangeDrawFile();
    Togl_PostRedisplay(togl);
    return TCL_OK;
}

/* ֽ */

int ChangeDrawFunc_Reset(struct Togl *togl, int argc, char *argv[])
{
    if(select_func != -1){
        func[select_func].pos = func_old_pos;
    }
    dst = SetPos(0,0,0);
    select_func = func_main;
    func_old_pos = func[func_main].pos;
    func[func_main].pos = SetPos(0,0,0);
    func[func_main].view = TRUE;
    select_gv   = -1;

    ChangeDrawFunc();
    ChangeDrawGv();
    ChangeDrawFile();
    Togl_PostRedisplay(togl);
    return TCL_OK;
}

/****************************************************************************
  եΰư
  ****************************************************************************/
/* 岼ư */

int MoveFile(struct Togl *togl, int argc, char *argv[])
{
    int i, f_id;
    double dz = atof(argv[2]);

    if(select_func != -1)
        f_id = func[select_func].file_id;
    else
        f_id = gv[select_gv].file_id;
    /* ؿΰư */
    for(i=0; i<f_info[f_id].f_num; i++)
        func[f_info[f_id].f[i]].pos.z += dz;
    /* ѿΰư */
    for(i=0; i<f_info[f_id].g_num; i++)
        gv[f_info[f_id].g[i]].pos.z += dz;
    /* ե󹹿 */
    f_info[f_id].z += dz;

    Togl_PostRedisplay(togl);
    return TCL_OK;
}

/* ž */

int MoveFileLeft(struct Togl *togl, int argc, char *argv[])
{
    int    f_id,tmp,i;
    double z,l,ds;
    /* ѿϼ¹Ԥʤ */
    if(select_func == -1) return TCL_OK;
    /* ưեֹ */
    f_id = func[select_func].file_id;
    z = f_info[f_id].z;
    for(i=0; i<f_info[f_id].f_num; i++){
        tmp = f_info[f_id].f[i];
        l   = func[tmp].l;
        ds  = func[tmp].ds;
        func[tmp].pos = SetPos(l*cos(ds-0.1), l*sin(ds-0.1), z);
        func[tmp].ds  = ds - 0.1;
    }

    Togl_PostRedisplay(togl);
    return TCL_OK;
}

/* ž */

int MoveFileRight(struct Togl *togl, int argc, char *argv[])
{
    int    f_id,tmp,i;
    double z,l,ds;
    /* ѿϼ¹Ԥʤ */
    if(select_func == -1) return TCL_OK;
    /* ưեֹ */
    f_id = func[select_func].file_id;
    z = f_info[f_id].z;
    for(i=0; i<f_info[f_id].f_num; i++){
        tmp = f_info[f_id].f[i];
        l   = func[tmp].l;
        ds  = func[tmp].ds;
        func[tmp].pos = SetPos(l*cos(ds+0.1), l*sin(ds+0.1), z);
        func[tmp].ds  = ds + 0.1;
    }

    Togl_PostRedisplay(togl);
    return TCL_OK;
}

/****************************************************************************
  ư
  ****************************************************************************/
/* ؿɽɸư(˥᡼) */
/*   id ưʪΤֹ (func[id]) */
/*         dx ޥXư         */
/*         dy ޥYư         */

void MoveFunc(struct Togl *togl, int id, int dx, int dy)
{
    int i, f_id;
    POS to;
    double new_r;
    GLdouble tmp1[16], tmp2[16];
    GLint tmp3[4];
    GLdouble ox[1],oy[1],oz[1];

    /* ɸѴ */
    glGetDoublev(GL_MODELVIEW_MATRIX,tmp1);
    glGetDoublev(GL_PROJECTION_MATRIX,tmp2);
    glGetIntegerv(GL_VIEWPORT,tmp3);
    /* ɥɸѴ */
    gluProject(func[id].pos.x, func[id].pos.y, func[id].pos.z, 
               tmp1,tmp2,tmp3, ox,oy,oz);
    /* ư */
    ox[0] = ox[0] + dx;
    oy[0] = oy[0] + dy;
    /* ֥Ⱥɸ᤹ */
    gluUnProject(ox[0],oy[0],oz[0], tmp1,tmp2,tmp3, ox,oy,oz);

    /* ưեֹ */
    f_id = func[id].file_id;

    /* ZɸѤʤ褦˰ư */
    to = SetPos(ox[0]-eye.x, oy[0]-eye.y, oz[0]-eye.z);
    to = PosMult(to, (eye.z-func[id].pos.z)/fabs(to.z));
    to = PosPlus(eye, to);
    ox[0] = to.x;  oy[0] = to.y;  oz[0] = to.z;

    /* ؿ󹹿 */
    if(ox[0]<0){
        func[id].ds = atan(oy[0]/ox[0]) + PI;
    }else{
        func[id].ds = atan(oy[0]/ox[0]);
    }
    if(id != select_func){
        /* ʪʳϵΥѤʤ */
        ox[0] = func[id].l * cos(func[id].ds);
        oy[0] = func[id].l * sin(func[id].ds);
    }else{
        func[id].l  = pow(pow(ox[0],2)+pow(oy[0],2), 0.5);
    }

    /* ˥᡼ */
    ox[0] = (ox[0] - func[id].pos.x)/SPEED;
    oy[0] = (oy[0] - func[id].pos.y)/SPEED;
    for(i=0 ; i<SPEED; i++) {
        func[id].pos.x += ox[0];
        func[id].pos.y += oy[0];
        /* Ⱦ¤ι (եפΤߤ˴ط) */
        /*   <<>> ٹʤ     */
        new_r = pow(pow(func[id].pos.x,2)+pow(func[id].pos.y,2), 0.5);
        if(new_r > f_info[f_id].r) f_info[f_id].r = new_r;

        display_cb(togl);
    }
}

/* ؿɽɸư(˥᡼) */
/*   id ưʪΤֹ (func[id]) */
/*         x  ưXɸ               */
/*         y  ưYɸ               */
/*         z  ưZɸ               */

void MoveFunc2(struct Togl *togl, int id, POS p)
{
    int i;
    double dx,dy,dz;
    dx = (p.x - func[id].pos.x)/SPEED;
    dy = (p.y - func[id].pos.y)/SPEED;
    dz = (p.z - func[id].pos.z)/SPEED;
    for(i=0; i<SPEED; i++) {
        func[id].pos.x += dx;
        func[id].pos.y += dy;
        func[id].pos.z += dz;
        display_cb(togl);
    }
}

/* TOP ⡼ɻΰư */

int MoveTOP(struct Togl *togl, int argc, char *argv[])
{
    switch(atoi(argv[2])) {
      case 0:                               /*  */
        eye = PosPlus(eye,top);
        dst = PosPlus(dst,top);
        break;
      case 1:                               /*  */
        eye = PosPlus(SetPos(-top.y, top.x, 0),eye);
        dst = PosPlus(SetPos(-top.y, top.x, 0),dst);
        break;
      case 2:                               /*  */
        eye = PosPlus(SetPos(top.y, -top.x, 0),eye);
        dst = PosPlus(SetPos(top.y, -top.x, 0),dst);
        break;
      case 3:                               /*  */
        eye = PosMinus(eye,top);
        dst = PosMinus(dst,top);
        break;
    }
    Togl_PostRedisplay(togl);
    return TCL_OK;
}

/* /ư */

int SetObjPos(struct Togl *togl, int argc, char *argv[])
{
    int obj = atoi(argv[2]);
    int r   = atoi(argv[3]);
    int z   = atoi(argv[4]);
    double d;

    switch(obj) {
      case 1:                               /* Dst */
        d = PosDiff_XY(eye,dst);
        dst.x = -d * cos(2.0*PI*r/100 + sita) + eye.x;
        dst.y = -d * sin(2.0*PI*r/100 + sita) + eye.y;
        dst.z = (double)z/5;
        Togl_PostRedisplay(togl);
        break;
      case -1:                              /* TOP Mode */
        eye.z = (double)z/5 + 11;
        top = SetPos(cos(2.0*PI*r/100 + sita + PI),
                     sin(2.0*PI*r/100 + sita + PI),
                     0);
        Togl_PostRedisplay(togl);
        break;
    }

    return TCL_OK;
}

/* ΰư (˥᡼) */

int DstMove(struct Togl *togl, int argc, char *argv[])
{
    return DstMove1(togl,atof(argv[2]),atof(argv[3]),atof(argv[4]));
}

int DstMove1(struct Togl *togl, double x, double y, double z)
{
    int i;

    x = (x - dst.x)/SPEED;
    y = (y - dst.y)/SPEED;
    z = (z - dst.z)/SPEED;
    for(i=0 ; i<SPEED; i++) {
        dst.x += x;
        dst.y += y;
        dst.z += z;
        display_cb(togl);
    }
    if(viewmode == TOP){
        eye.x = 0.0f;
        eye.y = 0.0f;
    }
    return TCL_OK;
}

/* ӥ塼⡼ (˥᡼) */

int ChangeViewMode(struct Togl *togl, int argc, char *argv[])
{
    double d,dxy,w,x,y,z;
    if(viewmode == NORMAL){
        /* NORMAL -> TOP */
        while(1) {
            d   = PosDiff(eye,dst);
            dxy = PosDiff_XY(eye,dst);
            w   = dxy*COS5 - (eye.z-dst.z)*SIN5;
            x   = dst.x + w*(eye.x-dst.x)/dxy;
            y   = dst.y + w*(eye.y-dst.y)/dxy;
            z   = dst.z + (eye.z-dst.z)*COS5 + dxy*SIN5;
            if(z-eye.z < 0){
                top.z = 0;
                /* ΰ֤Ĵ */
                eye.x = dst.x;
                eye.y = dst.y;
                break;
            }
            top.x = x-eye.x;  top.y = y-eye.y;  top.z = z-eye.z;
            eye.x = x;  eye.y = y;  eye.z = z;
            display_cb(togl);
            Togl_PostRedisplay(togl);
        }
        viewmode = TOP;
    }else if(viewmode == TOP){
        /* TOP -> NORMAL */
        viewmode = NORMAL;
        eye.x -= top.x/100; eye.y -= top.y/100; /* Ĵ & 0 */
        while(1) {
            d   = PosDiff(eye,dst);
            dxy = PosDiff_XY(eye,dst);
            w   = dxy*COS5 + (eye.z-dst.z)*SIN5;
            x   = dst.x + w*(eye.x-dst.x)/dxy;
            y   = dst.y + w*(eye.y-dst.y)/dxy;
            z   = dst.z + (eye.z-dst.z)*COS5 - dxy*SIN5;
            if(z-dst.z < 1.5){
                top.x = 0;  top.y = 0;  top.z = 1;
                display_cb(togl);
                break;
            }
            top.x = eye.x-x;  top.y = eye.y-y;  top.z = eye.z-z;
            eye.x = x;  eye.y = y;  eye.z = z;
            display_cb(togl);
        }
    }
    return TCL_OK;
}

/****************************************************************************
  Tcl/Tk Ѵؿ (̤񤭴ʤ)
  ****************************************************************************/

/* 饤ɥСΥ١٤¸ */

int SetSita(ClientData clientData, Tcl_Interp *interp,
            int argc, char *argv[])
{
    sita = asin((eye.y-dst.y)/PosDiff_XY(eye,dst));
    if(eye.x-dst.x < 0){
        sita = sita + (PI/2-sita)*2;
    }
    return TCL_OK;
}

/* ưоݤθߤι⤵롥ؿSetObjPos()Ϣưѹ뤳ȡ */

int GetZ(ClientData clientData, Tcl_Interp *interp,
         int argc, char *argv[])
{
    int  obj = atoi(argv[1]);
    switch(obj) {
      case 1:
        sprintf(interp->result, "%f", dst.z*5);
        break;
      case -1:
        sprintf(interp->result, "%f", (PosDiff(eye,dst)-11)*5);
        break;
    }
    return TCL_OK;
}

/* Tcl 饯å줿֥ȤĴ٤ */

int GetClickedObjId(ClientData clientData, Tcl_Interp *interp,
                    int argc, char *argv[])
{
    int x = atoi(argv[1]);                  /* å줿xɸ */
    int y = atoi(argv[2]);                  /* å줿yɸ */
    
    /* å֤ˤʪΤĴ٤ */
    sprintf(interp->result, "%d", Pick(x,y));
    
    return TCL_OK;
}

/* IDؤƤ뤫 TCL Τ餻 */

int GetIdSort_tcl(ClientData clientData, Tcl_Interp *interp,
                  int argc, char *argv[])
{
    int i;
    int num = atoi(argv[1]);                /* ֥ID */
    
    if(num == -1) {
        sprintf(interp->result, "NONE");
        return TCL_OK;
    }
    
    for(i=0; i<func_num; i++) {
        if(func[i].id == num) {
            if(select_func == i)
                sprintf(interp->result, "S_FUNC");
            else
                sprintf(interp->result, "FUNC");
            return TCL_OK;
        }
    }
    for(i=0; i<gv_num; i++) {
        if(gv[i].id == num) {
            if(select_gv == i)
                sprintf(interp->result, "S_GV");
            else
                sprintf(interp->result, "GV");
            return TCL_OK;
        }
    }
    return TCL_OK;
}

/* ʸޤؿõ */

int FindFunc_tcl(ClientData clientData, Tcl_Interp *interp,
                 int argc, char *argv[])
{ 
    int i;
    char *Uname;                            /* ʸδؿ̾Ǽ */
    char *word = argv[1];                   /* ʸ */
    ToUpper(word,word);                     /* ʸʸˤ */
    
    for(i=0; i<func_num; i++) {
        Uname = spdMalloc(strlen(func[i].name)+1);
        ToUpper(func[i].name,Uname);
        if(strstr(Uname, word) != NULL) {
            Tcl_AppendElement(interp, func[i].name);
        }
        spdFree(Uname);
    }
    return TCL_OK;
}

void ToUpper(char *word, char *Uword)
{
    int i;
    for(i=0; i<strlen(word)+1; i++){
        Uword[i]=toupper(word[i]);
    }
    return;
}

/* ؿֹõ */

int GetFuncNum_tcl(ClientData clientData, Tcl_Interp *interp,
                   int argc, char *argv[])
{ 
    int i;

    for(i=0; i<func_num; i++) {
        if(SPD_STREQ(argv[1], func[i].name)) {
            sprintf(interp->result, "%d",i);
            break;
        }
    }
    return TCL_OK;
}

/* ե̾Ĵ٤ */

int GetFileName_tcl(ClientData clientData, Tcl_Interp *interp,
                    int argc, char *argv[])
{ 
    int num = atoi(argv[1]);                /* ؿֹ */
    sprintf(interp->result, "%s", f_info[func[num].file_id].name);
    return TCL_OK;
}

/* ObjectID  ֹ */

int IdToFuncNum_tcl(ClientData clientData, Tcl_Interp *interp,
                    int argc, char *argv[])
{ 
    int id = atoi(argv[1]);
    int i;
    for(i=0; i<func_num; i++) {
        if(func[i].id == id) {
            sprintf(interp->result, "%d",i);
            break;
        }
    }
    return TCL_OK;
}
