#! /usr/bin/wish
# 
# Program:              $RCSfile: face.tcl,v $  $Revision: 30.3 $
# 
# Purpose:		OpenGLбTcl/Tk⥸塼롥
#
# Author:               K.Yasuhara  2000/07/01
#                       S.Yamamoto  2000/07/01
#
# (C) Copyright:        K.Yasuhara and S.Yamamoto  2000 - 2003
#                       This file is a product of the project Sapid.
# 

# 
# "$Id: face.tcl,v 30.3 2003/06/15 04:48:00 yamamoto Exp yamamoto $";
# 

# ɥ
proc MakeView {} {
    wm title . "VCR OpenGL"

    frame .f
    pack  .f -fill both -expand t

      # ¦ʬ
      frame .f.b
      pack  .f.b -fill both -side right

        # ĥ饤
        scale .f.b.s \
		-from 50 -to -50 -orient vertical \
		-showvalue f -width 10 \
		-variable Y_SCALE \
		-command {.f.a.gl SetObjPos $MOVEOBJ $X_SCALE $Y_SCALE}
        pack  .f.b.s -fill y -side left

        # ѽ
	frame .f.b.f4 -bd 3 -relief groove
	pack .f.b.f4 -side top
	  label .f.b.f4.l -text "Move File"
	  pack .f.b.f4.l -side top
	  button .f.b.f4.b1 -text "" \
		  -command { if {$MOVEOBJ == -1} {
	                       .f.a.gl MoveTOP 0
	                     } else {
	                       .f.a.gl MoveFile 0.1
			     }
			 }
	  pack .f.b.f4.b1 -side top
	  frame .f.b.f4.f
	  pack .f.b.f4.f -side top
	    button .f.b.f4.f.b1 -text "" \
		  -command { if {$MOVEOBJ == -1} {
	                       .f.a.gl MoveTOP 1
	                     } else {
			       .f.a.gl MoveFileLeft
			     }
			 }
	    button .f.b.f4.f.b2 -text "" \
		  -command { if {$MOVEOBJ == -1} {
	                       .f.a.gl MoveTOP 2
	                     } else {
			       .f.a.gl MoveFileRight
			     }
			 }
	    pack .f.b.f4.f.b1 .f.b.f4.f.b2 -side left
	  button .f.b.f4.b2 -text "" \
		  -command { if {$MOVEOBJ == -1} {
	                       .f.a.gl MoveTOP 3
	                     } else {
			       .f.a.gl MoveFile -0.1
			     }
			 }
	  pack .f.b.f4.b2 -side top

        # View Mode ؤ
	button .f.b.b2 -text "TOP" \
		-command { if {$MOVEOBJ == -1} {
	                       .f.a.gl ChangeViewMode
	                       set MOVEOBJ 1
	                       SetSita
			       set X_SCALE 0
			       set Y_SCALE [GetZ $MOVEOBJ]
			       .f.b.b2 configure -text "TOP"
			       .f.b.f4.l configure -text "Move File"
			   } else {
			       SetSita
			       .f.a.gl ChangeViewMode
			       set MOVEOBJ -1
			       set X_SCALE 0
			       set Y_SCALE [GetZ $MOVEOBJ]
			       .f.b.b2 configure -text "NORMAL"
			       .f.b.f4.l configure -text "Move Eye"
			   }
		       }
        pack   .f.b.b2 -fill x -side top

        # ѿɽ
	button .f.b.b1 -text "Gv" \
		-command {.f.a.gl ChangeViewGv}
        pack   .f.b.b1 -fill x -side top

        # ̤Ѵؿɽ
	button .f.b.b5 -text "NotUse Func" \
		-command {.f.a.gl ChangeDrawFunc_NOTUSE}
        pack   .f.b.b5 -fill x -side top

        # 
	button .f.b.b4 -text "Search" \
		-command { Find	}
        pack   .f.b.b4 -fill x -side top

        # 
	button .f.b.b3 -text "Reset" \
		-command { if {$MOVEOBJ != -1} {
	                     SetSita
		             set X_SCALE 0
		             set Y_SCALE [GetZ $MOVEOBJ]
	                     .f.a.gl ChangeDrawFunc_Reset
	                   }
		       }
        pack   .f.b.b3 -fill x -side top

        # λܥ
        button .f.b.b9 -text EXIT -command exit
        pack   .f.b.b9 -fill x -side bottom


      # ¦ʬ
      frame .f.a 
      pack  .f.a -fill both -expand t -side left

        # 饤
        scale .f.a.s -from 50 -to -50 -orient horizontal \
	               -showvalue f -width 10\
		       -variable X_SCALE \
                       -command {.f.a.gl SetObjPos $MOVEOBJ $X_SCALE $Y_SCALE}
        pack  .f.a.s -fill x -side bottom

        # OpenGL ʬ
        togl  .f.a.gl -width 500 -height 500 \
		      -rgba true -alpha true -double true -depth true
        pack  .f.a.gl  -fill both -expand t -side top

}

# ɥ˥塼κ
proc MakeMenu {} {
    . configure -menu .menu
    menu .menu

    # File
    .menu add cascade -label "File" -menu .menu.file
      menu .menu.file -tearoff no
      .menu.file add command -label "Exit" -command exit

    # View
    .menu add cascade -label "View" -menu .menu.view
      menu .menu.view -tearoff no

      # View -> Mode  (⡼ѹ)
      .menu.view add cascade -label "Mode" -menu .menu.view.mode
	menu .menu.view.mode -tearoff no
	.menu.view.mode add radiobutton -label "DETAIL" \
		-variable MODE -value 0 \
		-command {.f.a.gl ChangeMode 0}
	.menu.view.mode add radiobutton -label "NORMAL" \
		-variable MODE -value 1 \
		-command {.f.a.gl ChangeMode 1}
	.menu.view.mode add radiobutton -label "TINY" \
		-variable MODE -value 2 \
		-command {.f.a.gl ChangeMode 2}

      # View -> Object  (襪֥ѹ)
      .menu.view add cascade -label "Object" -menu .menu.view.obj
	menu .menu.view.obj -tearoff no
	.menu.view.obj add radiobutton -label "ALL" \
		-variable OBJ -value 0 \
		-command {.f.a.gl ChangeViewObj 0}
	.menu.view.obj add radiobutton -label "NEAR" \
		-variable OBJ -value 1 \
		-command {.f.a.gl ChangeViewObj 1}
	.menu.view.obj add radiobutton -label "SAMEFILE" \
		-variable OBJ -value 2 \
		-command {.f.a.gl ChangeViewObj 2}

      # View -> Name  (̾ɽѹ)
      .menu.view add cascade -label "Name" -menu .menu.view.name
	menu .menu.view.name -tearoff no
	.menu.view.name add radiobutton -label "ALL" \
		-variable NAME -value 0 \
		-command {.f.a.gl ChangeViewName 0}
	.menu.view.name add radiobutton -label "NEAR" \
		-variable NAME -value 1 \
		-command {.f.a.gl ChangeViewName 1}
	.menu.view.name add radiobutton -label "SAMEFILE" \
		-variable NAME -value 2 \
		-command {.f.a.gl ChangeViewName 2}

    # Option
    .menu add cascade -label "Option" -menu .menu.option
      menu .menu.option -tearoff no

      # Option -> Scale  (֥ȥѹ)
      .menu.option add cascade -label "Scale" -menu .menu.option.scale
	menu .menu.option.scale -tearoff no
	.menu.option.scale add radiobutton -label " 40%" \
		-variable SCALE -value 0.4 \
		-command {.f.a.gl ChangeScale 0.4}
	.menu.option.scale add radiobutton -label " 60%" \
		-variable SCALE -value 0.6 \
		-command {.f.a.gl ChangeScale 0.6}
	.menu.option.scale add radiobutton -label " 80%" \
		-variable SCALE -value 0.8 \
		-command {.f.a.gl ChangeScale 0.8}
	.menu.option.scale add radiobutton -label "100%" \
		-variable SCALE -value 1.0 \
		-command {.f.a.gl ChangeScale 1.0}
	.menu.option.scale add radiobutton -label "120%" \
		-variable SCALE -value 1.2 \
		-command {.f.a.gl ChangeScale 1.2}
	.menu.option.scale add radiobutton -label "140%" \
		-variable SCALE -value 1.4 \
		-command {.f.a.gl ChangeScale 1.4}
	.menu.option.scale add radiobutton -label "160%" \
		-variable SCALE -value 1.6 \
		-command {.f.a.gl ChangeScale 1.6}

      # Option -> Font  (եѹ)
      .menu.option add cascade -label "Font" -menu .menu.option.font
        menu .menu.option.font -tearoff no
        .menu.option.font add radiobutton -label "LARGE" \
		-variable FONT -value 0 \
		-command {.f.a.gl ChangeFont 0}
        .menu.option.font add radiobutton -label "MIDIUM"	\
		-variable FONT -value 1 \
		-command {.f.a.gl ChangeFont 1}
        .menu.option.font add radiobutton -label "SMALL" \
		-variable FONT -value 2 \
		-command {.f.a.gl ChangeFont 2}


}

# ؿ򱦥åȤɽ˥塼
proc MakePopup {} {
    # ؿ򱦥åȤΥ˥塼
    menu .popup1 -tearoff no
    .popup1 add command -label "Path From" -command \
	    { .f.a.gl ChangeDrawFunc_From [IdToFuncNum_tcl $CLICKED_ID] }
    .popup1 add command -label "Path To" -command \
	    { .f.a.gl ChangeDrawFunc_To [IdToFuncNum_tcl $CLICKED_ID] }

    # 򤵤줿ؿ򱦥åȤΥ˥塼
    menu .popup2 -tearoff no
    .popup2 add command -label "Upper Func" \
	    -command { .f.a.gl ChangeDrawFunc_uAll }
    .popup2 add command -label "Down Func" \
	    -command { .f.a.gl ChangeDrawFunc_dAll }
}

proc MakeBind {} {
    # ޥܥ󣱤ư
    #     ֥Ȥΰư/ ⤷ ΰư
    bind .f.a.gl <ButtonPress-1> {
	.f.a.gl Mouse1_on %x %y
    }
    bind .f.a.gl <ButtonRelease-1> {
    }
    bind .f.a.gl <B1-Motion> {
	.f.a.gl Mouse1_motion %x %y
	SetSita
    }
    bind .f.a.gl <Double-Button-1> {
	.f.a.gl Mouse1_double %x %y
    }

    # ޥܥ󣲤ư
    #     ȻƱư
    bind .f.a.gl <ButtonPress-2> {
	.f.a.gl Mouse2_on %x %y
    }
    bind .f.a.gl <B2-Motion> {
	.f.a.gl Mouse2_motion %x %y
    }
    bind .f.a.gl <ButtonRelease-2> {
	SetSita
    }

    # ޥܥ󣳤ư
    #     ֥ȤΥ֥˥塼ɽ
    bind .f.a.gl <ButtonPress-3> {
	set x [ expr [ winfo rootx %W ] + %x ]
	set y [ expr [ winfo rooty %W ] + %y ]
	set CLICKED_ID [GetClickedObjId %x %y]
	switch [GetIdSort_tcl $CLICKED_ID] {
	    FUNC   { tk_popup .popup1 $x $y }
	    S_FUNC { tk_popup .popup2 $x $y }
	    GV -
	    S_GV -
	    NONE {}
	}
    }

    # ޥܥ/ư (ۥ)
    #     ȤεΥѤ
    bind .f.a.gl <ButtonPress-4> {
	.f.a.gl Mouse4_on
    }
    bind .f.a.gl <ButtonPress-5> { 
	.f.a.gl Mouse5_on
   }
}

# ؿ
proc Find {} {
    # Ťɥ˴
    if {[winfo exists .find] != 0} { destroy .find }
    # ɥκ
    set x [expr [winfo pointerx .] - 10]
    set y [expr [winfo pointery .] - 50]
    toplevel .find
    wm title .find "Search Func"
    wm geometry .find +$x+$y

    # åȤ
    frame .find.l
    frame .find.r -relief groove -borderwidth 4
    pack .find.l -side left -fill both -expand yes 
    pack .find.r -side left -fill both

    # Ⱦʬ
    label .find.l.lab -text "Input word."
    entry .find.l.text -bg white -textvariable FindText
    button .find.l.b -text "Search" -command {
	# ꥹȤɽƤ
	if {$SORT == 1} {
	    # ե٥åȽˤ
	    set result [lsort [FindFunc_tcl $FindText]]
	} else {
	    # եˤ
	    set result ""
	    set old_fi_name ""
	    foreach fu_name [FindFunc_tcl $FindText] {
		set new_fi_name [GetFileName_tcl [GetFuncNum_tcl $fu_name]]
		if {$old_fi_name != $new_fi_name} {
		    set old_fi_name $new_fi_name
		    lappend result "-=- $new_fi_name -=-" $fu_name
		} else {
		    lappend result $fu_name
		}
	    }
	}
	.find.l.f.list delete 0 end
	foreach funcinfo $result {
	    .find.l.f.list insert end $funcinfo
	}
    }
    frame .find.l.f
      listbox .find.l.f.list -yscrollcommand ".find.l.f.s set"
      scrollbar .find.l.f.s -command ".find.l.f.list yview"
    frame .find.l.sort -relief groove -borderwidth 5
      label .find.l.sort.l -text "Sort by"
      radiobutton .find.l.sort.a -text "a-Z" \
	      -variable SORT -value 1
      radiobutton .find.l.sort.f -text "file" \
	      -variable SORT -value 2

    pack .find.l.lab -side top
    pack .find.l.text -side top -fill x
    pack .find.l.b -side top
    pack .find.l.f -side top -fill both -expand yes
      pack .find.l.f.s -side right -fill y
      pack .find.l.f.list -side right -fill both -expand yes
    pack .find.l.sort -side top -fill x
      pack .find.l.sort.l .find.l.sort.a .find.l.sort.f -side left


    # Ⱦʬ
    radiobutton .find.r.r1 -text "From" -anchor w \
	    -variable SEL -value 1
    label .find.r.m1 -text "" -bg white
    radiobutton .find.r.r2 -text "To" -anchor w \
	    -variable SEL -value 2
    label .find.r.m2 -text "" -bg white
    button .find.r.cls -text "Clear" -command {
	.find.r.m2 configure -text ""
    }
    button .find.r.ok -text "OK" -command {
	set FROM [GetFuncNum_tcl [.find.r.m1 cget -text]]
	set TO   [GetFuncNum_tcl [.find.r.m2 cget -text]]
	if {$FROM == ""} {
	    Error "Invalid From value !!"
	} elseif {$TO == ""} {
	    .f.a.gl SelectFunc_tcl $FROM
	} else {
	    .f.a.gl SelectFunc_tcl $FROM
	    .f.a.gl ChangeDrawFunc_To $TO
	}
    }
    button .find.r.no -text "Cancel" -command "destroy .find"

    pack .find.r.r1 .find.r.m1 .find.r.r2 .find.r.m2 .find.r.cls -fill x -side top
    pack .find.r.no .find.r.ok -side bottom -fill x


    # å򤹤 (ButtonPressǤϥ)
    bind .find.l.f.list <ButtonRelease-1> {
	.find.r.m$SEL configure \
		-text [.find.l.f.list get [.find.l.f.list curselection]]
    }

    focus .find.l.text
}

# ԥ顼ɽؿ
proc Error {mes} {
    toplevel .err
    set x [expr [winfo pointerx .] - 10]
    set y [expr [winfo pointery .] - 50]
    wm title .err "Error"
    wm geometry .err +$x+$y
    label .err.mes -text $mes
    button .err.ok -text "OK" -command {destroy .err}
    pack .err.mes .err.ok
}

# OpenGL ɽΤߤΥƥ
proc MakeViewTest {} {
    wm title . "Test View"
    # OpenGL ʬ
    frame .f
    pack  .f -fill both -expand t

      # ¦ʬ
      frame .f.b
      pack  .f.b -fill both -side right
        # ĥ饤
        scale .f.b.s \
		-from 50 -to -50 -orient vertical \
		-showvalue f -width 10 \
		-variable Y_SCALE \
		-command {.f.a.gl SetObjPos $MOVEOBJ $X_SCALE $Y_SCALE}
        pack  .f.b.s -fill y -side left
      # ¦ʬ
      frame .f.a 
      pack  .f.a -fill both -expand t -side left
        # 饤
        scale .f.a.s -from 50 -to -50 -orient horizontal \
	               -showvalue f -width 10\
		       -variable X_SCALE \
                       -command {.f.a.gl SetObjPos $MOVEOBJ $X_SCALE $Y_SCALE}
        pack  .f.a.s -fill x -side bottom
        # OpenGL ʬ
        togl  .f.a.gl -width 500 -height 500 \
		      -rgba true -alpha true -double true -depth true
        pack  .f.a.gl  -fill both -expand t -side top
}

######################################################################
###                                                            ###
######################################################################

# ˥塼ν
set MODE 1
set OBJ  1
set NAME 1
set FONT 1
set SCALE 1.0

# ᥤ󥦥ɥ GUI 
set MOVEOBJ 1
set X_SCALE 0
set Y_SCALE 0

#  GUI 
set SEL  1
set SORT 1

# ¹
MakeViewTest
#MakeView
MakeMenu

MakePopup
MakeBind
