#! PerlCmd
# 
# Program:              $RCSfile: _config.pl,v $  $Revision: 41.2 $
# 
# Purpose:              
# 
# Author:               N.Atsumi  2001/07/22
#                       S.Yamamoto  2001/07/22
# 
# Copyright:            N.Atsumi and S.Yamamoto  2001 - 2002
#                       This file is a product of the project Sapid.
#

# 
# $Id: _config.pl,v 41.2 2002/11/11 08:00:12 yamamoto Exp yamamoto $
# 

package config;

# configure file ɤ߹
sub read_config() {
  open(CONFIG, "<.fcdg");
  $conf_line = <CONFIG>;
  while ($conf_line ne "") {
    chomp $conf_line;
    $conf_line =~ s/\s//g; 
    if ($conf_line =~ /:/) {
      &set_color;
    }
    $conf_line = <CONFIG>;
  }
  close(CONFIG);
  return %color;
}

# 
sub set_color() {
  @conf_target = split(/:/, $conf_line);
  if ($conf_line =~ /bg_color/) {
    shift(conf_target);
    $color{bg_color} = shift(conf_target);
    return;
  }
  if ($conf_line =~ /alink_color/) {
    shift(conf_target);
    $color{alink_color} = shift(conf_target);
    return;
  }
  if ($conf_line =~ /vlink_color/) {
    shift(conf_target);
    $color{vlink_color} = shift(conf_target);
    return;
  }
  if ($conf_line =~ /link_color/) {
    shift(conf_target);
    $color{link_color} = shift(conf_target);
    return;
  }
  if ($conf_line =~ /text_color/) {
    shift(conf_target);
    $color{text_color} = shift(conf_target);
    return;
  }
  if ($conf_line =~ /func_color/) {
    shift(conf_target);
    $color{func_color} = shift(conf_target);
    return;
  }
}

1;
