#! PerlCmd
# 
# Program:              $RCSfile: left_top.pl,v $  $Revision: 41.3 $
# 
# Purpose:              
# 
# Author:               N.Atsumi  2001/07/22
#                       S.Yamamoto  2001/07/22
# 
# Copyright:            N.Atsumi and S.Yamamoto  2001 - 2002
#                       This file is a product of the project Sapid.
#

# 
# $Id: left_top.pl,v 41.3 2003/08/22 10:41:57 yamamoto Exp yamamoto $
# 

require 'config.pl';

%color = &config'read_config;
print "Content-type: text/html\n\n";
print qq(
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title>FCDG </title>
</head>
<body bgcolor="$color{bg_color}" text="$color{text_color}" link="$color{link_color}" alink="$color{alink_color}" vlink="$color{vlink_color}">
<h1>Library Function List</h1>
);
$func_idx = 0;
&get_list;
&print_list;
print qq(
</body>
</html>
);

sub get_list() {
  open(FCDG_INDEX, "<FCDG");
  $line = <FCDG_INDEX>;
  while ($line = <FCDG_INDEX>) {
    chomp($line);
    if (($line !~ /^FILE:/) && ($line !~ /^NAME:/) && ($line !~ /^SPEC:/) &&
       ($line !~ /^PROG:/)) {
      chomp($line);
      &get_func;
    }
  }
  close(FCDG_INDEX);
}

sub get_func() {
  @fcdg = split(/\t/, $line);
  foreach $node (@fcdg) {
    if (($node !~ /\[/) && (($node =~ /:/) || ($node =~ /;/))) {
      $node =~ s/.*://;
      $node =~ s/.*;//;
      if (grep(/^$node$/,@func)) {
	$func_num{$node}++;
      } elsif (($node ne "") && ($node ne "(null)")) {
	$func[$func_idx] = $node;
	$func_idx++;
	$func_num{$node} = 1;
      }
    }
  }
}

sub print_list() {
#  foreach $func_name (@func) {
  foreach $func_name (sort(@func)) {
    print qq(
<a href=search.cgi?lib=$func_name TARGET=left_bottom>
	     $func_name ($func_num{$func_name})<br></a>
	    );
  }
}
