#! PerlCmd
# 
# Program:              $RCSfile: search.pl,v $  $Revision: 41.4 $
# 
# Purpose:              
# 
# Author:               N.Atsumi  2001/07/22
#                       S.Yamamoto  2001/07/22
# 
# Copyright:            N.Atsumi and S.Yamamoto  2001 - 2002
#                       This file is a product of the project Sapid.
#

# 
# $Id: search.pl,v 41.4 2003/08/22 10:41:56 yamamoto Exp yamamoto $
# 
require 'jcode.pl';
require 'config.pl';

&init_form('euc');
%color=&config'read_config; #'
  &print_main;
sub print_main() {
  print "Content-type: text/html\n\n";
  print qq(
	   <html>
	   <head>
	   <title></title>
	   </head>
	   <body bgcolor="$color{bg_color}" text="$color{text_color}" link="$color{link_color}" alink="$color{alink_color}" vlink="$color{vlink_color}">
	   <h1>FCDG</h1>
	   <form method="get" action="search.cgi">
	   <input type="text" name="lib" vlue="" size="15">
	   <input type="submit" value="Search!">
	   </form>
	  );
  open(FCDG_INDEX, "<FCDG");

  $match_fcdg = 0;
  $num = 0;
  if ($form{'lib'} ne "") {
    while ($line = <FCDG_INDEX>) {
      &get_fcdg();
    }
    if ($num eq "0") {
      &put_no_target();
    }
    foreach $key(sort{$fcdg{$b}<=>$fcdg{$a}}keys(%fcdg)) {
      $wariai = $fcdg{$key}/$num * 100;
      if ($wariai =~ /\./) {
	$length = index($wariai, ".");
      } else {
	$length = length($wariai);
      }
      $wariai = substr($wariai, 0, $length);
      print "[$fcdg{$key}/$num($wariai%)]\n<br>";
      #   print "$key\n";
      &put_template($key);
      &put_ref($key);
      print "\n<hr>\n";
    }
    close(FCDG_INDEX);
  } else {
    print qq(
	     饤֥ؿ̾ϤƤ
	     饤֥ؿȹ礻Υƥץ졼Ȥɽޤ
	    );
  }
  print qq(
	   </body>
	   </html>
	  );
}
# оݤǡ١¸ߤʤ
sub put_no_target() {
  print "$form{'lib'} ϥǡ١¸ߤޤ";
}

sub rm_ret{
  while ($line eq '\n') {
    $line = <FCDG_INDEX>;
  }
}

sub get_fcdg{
  if ($line =~ /PROG:/) {
    $prog =~ s/PROG://;
    return;
  }
  if ($line =~ /FILE:/) {
    $file =~ s/FILE://;
    return;
  }
  if ($line =~ /NAME:/) {
    $name =~ s/NAME://;
    return;
  }
  if ($line =~ /$form{'lib'}/) {
    &check_node($line);
    if ($node_flag eq 1) {
      &check_fcdg($line);
    }
  }
}

sub check_node {
  @elem = split(/\t/, $line);
  foreach $node (@elem) {
    if ($node =~ /$form{'lib'}/) {
      if (($node =~ /$form{'lib'}$/) || ($node =~ /.*:$form{'lib'}$/) ||
	  ($node =~ /.*:.*;$form{'lib'}$/)){
	$node_flag = 1;
	return;
      }
    }
  }
  $node_flag = 0;
}

sub check_fcdg {
  local ($count) = 0;
  if ($fcdg{$line} eq "") {
    $fcdg{$line} = 1;
  } else {
    $fcdg{$line}++;
  }
  $fcdg_ref[$fcdg{$line}]{$line} = "$spec/$file.html#$name";
  $num++;
}

sub put_template {
  local ($template) = @_;
  @part = split /$form{'lib'}/, $template;
  $template =~ s/$form{'lib'}/<FONT COLOR=\"$func_color\">$form{'lib'}<\/FONT>/;
  @elem = split(/\t/, $template);
  $tab_len = 0;
  for ($i = 0; $i < $#elem; $i++) {
    $node = $elem[$i];
    if (($node ne "}") && ($node ne "")) {
      &put_tab($tab_len);
    } else {
      &put_tab($tab_len - 1);
    }
    if ($node eq "{") {
      print "{<br>\n";
      $tab_len++;
    } elsif ($node eq "}") {
      $tab_len--;
      print "}<br>\n";
    } elsif ($node eq "[") {
      print "if (";
      $i++;
      print "var $elem[$i]";
      $i++;
      print "$elem[$i]";
    } elsif ($node eq "]") {
      print ")";
    } elsif ($node =~ /.*;.*:.*/) {
      @ref = split(/;/, $node);
      @def = split(/:/, $ref[$#ref]);
      $def_var = shift(@def);
      $def_value = shift(@def);
      print "$def_var = $def_value(";
      for ($j = 0; $j < $#ref; $j++) {
	print "$ref[$j], ";
      }
      print "...);<br>";
    } elsif ($node =~ /.*;.*\[/) {
      @ref = split(/;/, $node);
      print "if ($ref[0]";
    } elsif ($node =~ /.*;/) {
      @ref = split(/;/,$node);
      print "$ref[$#ref](";
      for ($j = 0; $j < $#ref; $j++) {
	print "$ref[$j], ";
      }
      print "...);<br>";
    } elsif ($node =~ /.*:.*/) {
      @def = split(/:/, $node);
      print "$def[0] = $def[1]();<br>";
    } else {
      if ($node ne "") {
	print "$node";
	if (($node ne "!=") && ($node ne "==") && ($node ne "<=") &&
	    ($node ne ">=") && ($node ne "<") && ($node ne ">") &&
	    ($node !~ /[A-Z0-9]+/) && ($node ne "(null)")) {
	  print "();<br>";
	}
      }
    }
  }
}

sub put_ref {
  local ($ref) = @_;
  for ($i = 1; $i <= $fcdg{$ref}; $i++) {
    print "<a href=\"$fcdg_ref[$i]{$ref}\" target=right>[$i]</a>";
  }
}

sub put_tab {
  local ($tab_num) = @_;
  while ($tab_num ne 0) {
    print "&nbsp;";
    $tab_num--;
  }
}

sub init_form {
  local($query, @assocarray, $assoc, $property, $value, $charcode, $method);
  $charcode = $_[0];
  $method = $ENV{'REQUEST_METHOD'};
  $method =~ tr/A-Z/a-z/;
  if ($method eq 'post') {
    read(STDIN, $query, $ENV{'CONTENT_LENGTH'});
  } else {
    $query = $ENV{'QUERY_STRING'};
  }
  @assocarray = split(/&/, $query);
  foreach $assoc (@assocarray) {
    ($property, $value) = split(/=/, $assoc);
    $value =~ tr/+/ /;
    $value =~ s/%([A-Fa-f0-9][A-Fa-f0-9])/pack("C", hex($1))/eg;
    &jcode'convert(*value, $charcode); #'
      $form{$property} = $value;
   }
}
