#! PerlCmd
# 
# Program:              $RCSfile: mkIdx.pl,v $  $Revision: 30.4 $
# 
# Purpose:
# 
# Author:               T.Suzuki  1997/08/01
#                       S.Yamamoto  1997/08/01
# 
# Copyright:            T.Suzuki and S.Yamamoto  1997 - 2002
#                       This file is a product of the project Sapid.
# 

# 
# $Id: mkIdx.pl,v 30.4 2003/06/08 12:29:48 yamamoto Exp yamamoto $
# 

# global label 󤫤 index
#
# input  ɸ
# output ɸ
# ex.) sort < file.in | uniq | mkIdx.pl > file.out

# ҤȤĤΰȤ
# ʤ -- ٤ƤΤ
#  --
#   `-' 鳫: -ʹߤˤ٥
#   `+' 鳫: +ʹߤˤΤɲ
#   class/cmd/FAQ/func/figure/global/type
#   C   /c   /Q  /F   /f     /g     /t

%LType = (); # Ϥ٥Υ
%TYPES = (
	  'class' => 'C',
	  'cmd',  => 'c',
	  'FAQ',  => 'Q',
	  'func', => 'F',
	  'figure'=> 'f',
	  'global'=> 'g',
	  'type'  => 't');
while(($k,$v)=each(%TYPES)){
    $RevTypes{$v}=$k;
}

sub optAnaly {
    local ($_) = ($_[0]);
    $_ = reverse $_;
    my $flag = '+';

    do {%LType = %TYPES; return;} if ($_ eq '');

    %LType = ();

    my $str = chop;
    if ($str eq '-') {
	%LType = %TYPES;
	$flag = '-';
    } elsif($str ne '+') {
	$_ .= $str;
    }

    while($str = chop){

	do {$flag = $eq; next;} if ($str eq '-' || $str eq '+');
	
	print STDERR "`$str' is not recognize type\n"
	    if ($RevTypes{$str} eq '');

	if ($flag eq '-'){
	    delete $LType{$RevTypes{$str}};
	}else{
	    $LType{$RevTypes{$str}}++;
	}
    }
}    

optAnaly(shift @ARGV);
# print STDERR "labels:",join(" ",keys(%LType)), "\n";

while(<STDIN>){
    my ($type, $texLbl, $fname, $label, $cou, $capt)
	= /{\s*(\S+)\s*}{\s*(\S*)\s*}{\s*(\S*)\s*}{\s*(\S*)\s*}{\s*(\S*)\s*}{\s*(.*)\s*}/;

    next if ($LType{$type} eq '');

    $label = "#$label";
    $label = '' if ($label eq "#LABEL_INDEX");
    
    $texLbl =~ s/^Spd_//;
     
    $buf{$texLbl} .= "$fname$label:";
    $buf{$capt}   .= "$fname$label:" if ($capt ne '' && $capt ne $texLbl);

}

@key = keys(%buf);

@key = sort {$p=$a;$p=~tr/a-z/A-Z/;$q=$b;$q=~tr/a-z/A-Z/; $p cmp $q;} @key;

$idx = 'a';

# ƹܤν
sub outOneIdx {
    my ($idx, $top) = @_;  # 1., 2.Хåեγϥݥ
    my $str = '';
    my $header = 0;
#    print "$top:$key[$top]\n";

    while(1) {
	my ($tk) = $key[$top] =~ /^(.)/;
	$tk =~ tr/a-z/A-Z/;

	last if ($tk gt $idx || $#key < $top);

	my $str = $buf{$key[$top]};
	chop $str;
	
	my @str = split(':', $str);

#	print @str,"\n";

	my $name = $key[$top];
	$name =~ tr/\\//d;
	$name =~ s/^Spd_//;

	if (@str && !$header){
	    print "<HR>\n";
	    print "<H3><a name=\"index_$_\"> $_ </a></H3>\n";
	    $header++;
	}

	foreach (@str) {
	    print "<a href=\"$htRoot$_\">", "$name</a><br>\n";
	}
	$top++;
    }
    
    return $top;
}

print '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"', "\n";
print '    "http://www.w3.org/TR/html4/loose.dtd">', "\n";
print "<HTML>\n";
print "<HEAD>\n";
print "<TITLE>\n";
print "Index\n";
print "</TITLE>\n";
print "</HEAD>\n";

print "<BODY>\n";

print "<h1> Index </h1>\n<hr>";

# 
for ('A'..'Z') {
    print "<A HREF=\"#index_$_\"> $_ </A>\n";
}

$top = 0;
for ('A'..'Z', '_'){
    $top = outOneIdx($_, $top);
    print "\n";
}

print "<HR>\n";
print "</BODY>\n";
print "</HTML>\n";
