#! PerlCmd
# 
# Program:              $RCSfile: ref.pl,v $  $Revision: 30.13 $
# 
# Purpose:
# 
# Author:               T.Suzuki  1997/08/01
#			S.Yamamoto  1998/10/05
# 
# (C) Copyright:        T.Suzuki and S.Yamamoto  1997 - 1998
#                       This file is a product of the project Sapid.
# 

# 
# $Id: ref.pl,v 30.13 2002/11/24 06:14:02 yamamoto Exp yamamoto $
# 

#
# Ȥβ
#

sub trans {
    while(<INPUT>) {
	while (/@@([^\@]+)@@/) {
	    my $label = $1;
	    my $name, $capt;
    
	    if ($label =~ /SEC_INSERT([\d\.]*)/){ # ꥹȤ
		&secinsert($1);
		s/@@[^\@]+@@//;
		next;
	    }
    
	    if ($label =~ /LINKS/) { # ڡΥȥåסܥȥΥ
		&links;
		s/@@[^\@]+@@//;
		next;
	    }
    
	    if ($glbl{$label} ne '') { # global label
		$name = "$htRoot$glbl{$label}[0]";
		$name .= "\#$glbl{$label}[1]"
		    if ($glbl{$label}[1] ne 'LABEL_INDEX');
		
		s/@@([^@]*)@@/$name/;
		
		goto cont;
	    }
    
	    if ($llbl{$label} eq '') {
		if ($extraLink{$label} ne ''){ # Extra Link Label
		    $name = "${htRoot}$extraLink{$label}";
		} else {		       # None Exist Label
		    &pwarn("Label `$label' doesn't exist.");
		    # $name = "\#$label";
		    $name = "${htRoot}UnderConstruction.html";
		}
		$capt = '[ref]';
	    } else {			       # local label
		$name = "$llbl{$label}[0]\#$llbl{$label}[1]";
		$capt = "$llbl{$label}[2]";
	    }
	    
	    s/@@[^\@]+@@/$name/;
	    s/\[ref\]/$capt/;
	  cont:
	}
	print OUTF $_;
	# next:
    }
}

sub secinsert {
    my ($sec) = @_; # Υꥹ
    my $cou = 0;    # ɽΥꥹǤindex
    my $match;      # ֹޥåѤѿ

    # ꥹΡɽϰ֤
    if ($sec eq ''){   # ꥹ
	$match = '\d';
    } else {
	for (@sec) {   # ϰ֤õ
	    last if ($_ eq $sec);
	    $cou++;
	}

	if ($cou > $#sec){
	    perror("Section $sec doesn't exist.");
	    return;
	}
	$match = $sec[$cou];
    }

    # ҥ٥뻻
    my @lvl= ($sec[$cou] =~ /(\.)/g);
    my $lvl = @lvl;
    my $ulc = 1;

    print OUTF "<DL>\n";
#    print STDERR "$cou;$sec[$cou]";
    while($sec[$cou] =~ /^$match/){
	my $label = $secRef{$sec[$cou]};
#	print STDERR $sec[$cou], $secRef{$sec[$cou]};
	my ($name) = "$llbl{$label}[0]\#$llbl{$label}[1]";
	my ($sec_num, $capt) = ("$llbl{$label}[3]" =~ /^([^\s]*)\s(.*)/);
	my ($capt2) = '';
	if ($capt =~ /\@\@\@\@/) { # ʹߤʸ<A>ʤ
	    my @s = split('@@@@', $capt);
	    ($capt, $capt2) = @s;
	}

	my @new_lvl = ($sec[$cou] =~ /(\.)/g);  # ٥
	my $new_lvl = @new_lvl;
	# Ҥΰư٥ʬ/λ
	while($new_lvl != $lvl){
	    $lvl++, $ulc++, print OUTF "<DL>\n"  if ($new_lvl > $lvl);
	    $lvl--, $ulc--, print OUTF "</DL>\n" if ($new_lvl < $lvl);
	}
	$lvl = $new_lvl;

	$capt =~ s/^\s+//;
	$capt =~ s/\s+$//;

	print OUTF " " x ($lvl*4), "<DT> $sec_num <A HREF=\"$name\">",
	                       "$capt</A> $capt2\n";

	if ($shortcutlink) {
	    my $ext_link = &shortcut($capt); # 硼ȥåȥ󥯤
	    print OUTF $ext_link, "\n" if ($ext_link ne '');
	}

	$cou++;
    }
    print OUTF "</DL>\n" x $ulc;
}

sub links   # ΥڡؤΥ
{
    my ($strPrev, $strNext, $strIdx, $strUp, $strTop, $c_index)
	= ('[Prev]', '[Next]', '[Contents]', '[Up]', '[Top]' , '');
   
    $strTop = "<A HREF=\"$fname-$cou.html\"> [Top] </A>";
    $c_index= "<A HREF=\"${htRoot}cross-index.html\">".
	      "<IMG SRC=\"${imgsrc}index-on.gif\" ALT=\"[Index]\" BORDER=0>".
	      "</A>";

    # ǽΥڡ idx, prevoff
    if ($cou > 0){
	$strIdx = "<A HREF=\"$fname-0.html\">".
		  "<IMG SRC=\"${imgsrc}contents-on.gif\"".
		  " ALT=\"[Contents]\" BORDER=0></A>";
	$strPrev ="<A HREF=\"$fname-".($cou-1).".html\">".
		  "<IMG SRC=\"${imgsrc}prev-on.gif\"".
		  " ALT=\"[Prev]\" BORDER=0></A>";
    } else {
	$strIdx = "<IMG SRC=\"${imgsrc}contents-off.gif\"".
		  " ALT=\"[Contents]\" BORDER=0>";
	$strPrev ="<IMG SRC=\"${imgsrc}prev-off.gif\"".
		  " ALT=\"[Prev]\" BORDER=0>";
    }

    # ǸΥڡ nextoff
    if ($cou < $maxPage){
	$strNext ="<A HREF=\"$fname-".($cou+1).".html\">".
		  "<IMG SRC=\"${imgsrc}next-on.gif\"".
		  " ALT=\"[Next]\" BORDER=0></A>";
    } else {
	$strNext ="<IMG SRC=\"${imgsrc}next-off.gif\"".
		  " ALT=\"[Next]\" BORDER=0>";
    }
    
    # ȥåץڡ up  off
    if ($relPath ne './' && $relPath ne ''){
        $strUp =  "<A HREF=\"../index.html\">".
                  "<IMG SRC=\"${imgsrc}up-on.gif\"".
                  " ALT=\"[Up]\" BORDER=0></A>";
    } else {
	$strUp =  "<IMG SRC=\"${imgsrc}up-off.gif\"".
                  " ALT=\"[Up]\" BORDER=0>";
    }

    print OUTF "$strPrev\n$strUp\n$strNext\n$c_index\n$strIdx\n";
}

# top pageindex˳ƥޥ˥奢ؤΥ硼ȥåȥ󥯤
%short_cut = (
        'short_cut_icon' => 'short_cut.gif' # 硼ȥåȤ icon file name
    );

sub shortcut {
    my ($capt) = @_;   # ʸ
    my $str = "";

    ($capt) = ($capt =~ /^\s*(\S+)/);
    
    if ($short_cut{$capt} ne '') {

	# "short_cut_icon.fig"ޤǤϡ"[Short Cut]"ȤƤ
	# Modified by S.Yamamoto 1998/10/05.
	# 	    
	# $str = "<A HREF=\"$short_cut{$capt}\">".
	#	  "<IMG SRC=\"$imgsrc$short_cut{'short_cut_icon'}\" ".
	#	  "ALT=\"[Short Cut]\" BORDER=0></A>";

	$str = " [<A HREF=\"$short_cut{$capt}\">Short Cut</A>]";
    }

    return $str;
}

## Output ###############################

$log2 = 'error.log';
sub openLog {
    $log2 = "${logDir}${filePrefix}error.log";
    open (LOG2, ">>$log2") || perror("File $log2 Can't open.");
}

sub close {
    close LOG2;
};

sub putC {
    print OUTF @_;
}

sub putLog{
    print STDERR @_ if ($VERBOSE_MODE);
    print LOG2   @_;
}

sub perror {
    print STDERR "Error: $fname-$cou.tmp ($.):", @_, "\n";
    print LOG2   "Error: $fname-$cou.tmp ($.):", @_, "\n";
}
sub pwarn {
    print STDERR "Warning: $fname-$cou.tmp ($.):", @_, "\n"
	if ($VERBOSE_MODE);
    print LOG2   "Warning: $fname-$cou.tmp ($.):", @_, "\n";
}

## main #################################


# ref.pl [option] <file name (no saffix)>

$texroot = '';
$texroot = "$ENV{'SAPID_MKHTML_TEX_ROOT'}/"
    if ($ENV{'SAPID_MKHTML_TEX_ROOT'});
$localOutDir  = $ENV{'SAPID_MKHTML_LOCAL_DIR'};
$globalOutDir = $ENV{'SAPID_MKHTML_GLOBAL_DIR'};
$filePrefix   = $ENV{'SAPID_MKHTML_PREFIX'};

$htRoot = $ENV{'SAPID_MKHTML_HTTP_ROOT'};
$htRoot =~ s|/*$|/| if ($htRoot ne '');

$filePrefix = 'spdMkHtml-' if ($filePrefix eq '');

# ץμ

use Getopt::Std;
getopts('L:G:o:R:E:p:i:g:sv');

# ϥե̾

$fname = @ARGV[0];
if ($fname eq ''){ 
    print STDERR "Usage:: $0 <filename>\n";
    exit(1);
}

$fname =~ s/.tex$//;      # ե̾δ, .texĤƤоä
($fnbase) = $fname =~ m|([^/]+)$|; # directoryä
$q_fnbase = quotemeta($fnbase);

($localOutDir)  = $fname =~ m/(.*)$q_fnbase$/o; # get directroy
$localOutDir  .= '/' if ($localOutDir);
$outPutDir = $logDir = $localOutDir;

$globalOutDir = $localOutDir if (!$globalOutDir);

$localOutDir  = "$opt_L/" if ($opt_L);
$globalOutDir = "$opt_G/" if ($opt_G);
$relPath      = "$opt_R/" if ($opt_R);
$logDir       = "$opt_E/" if ($opt_E);
$outPutDir    = "$opt_o/" if ($opt_o);
$fileprefix   = "$opt_p/" if ($opt_p);
$indexlink = 0;
$indexlink    = "$opt_i/" if ($opt_i);
$shortcutlink = "$opt_s";
$VERBOSE_MODE = "$opt_v";

$globalOutDir = "$globalOutDir/" if ($globalOutDir);
$localOutDir  = "$localOutDir/"  if ($localOutDir);
$logDir       = "$logDir/"       if ($logDir);

$globalOutDir =~ s|/*$|/| if ($globalOutDir);
$localOutDir  =~ s|/*$|/| if ($localOutDir);
$logDir       =~ s|/*$|/| if ($logDir);
$relPath      =~ s|/*$|/| if ($relPath);

openLog();

putLog("global label directory :: $globalOutDir\n");
putLog("local  label directory :: $localOutDir\n");

###

$cou = 0;             # ե륫 ( = section)
$imgsrc = "${htRoot}Fig/";

open (LLIN, "$localOutDir$filePrefix$fname.llbl");
open (GLIN, "$globalOutDir"."labels.glbl");
open (EXIN, "$globalOutDir"."extraLink.def");
open (SHIN, "$globalOutDir"."shortcut.def");

# ٥β
while(<LLIN>){
    next if (/^#/);

    my ($sort, $ref, @s)
= /{\s*(\S+)\s*}{\s*(\S*)\s*}{\s*(\S*)\s*}{\s*(\S*)\s*}{\s*(\S*)\s*}{\s*(.*)\s*}/;

    $s[1] =~ s/\\//;
    push @s, $sort;
    $llbl{$ref} = \@s;

    if ($sort eq 'document'){
	push (@sec, $s[2]);
	$secRef{$s[2]}=$ref;
	($maxPage) = $s[2] =~ /(\d+)/;
    }
}

close LLIN;

# Х٥β
while(<GLIN>){
    
    next if (/^\#/);

    my ($sort, $ref, @s)
	= /{\s*(\S+)\s*}{\s*(\S*)\s*}{\s*(\S*)\s*}{\s*(\S*)\s*}{\s*(\S*)\s*}{\s*(.*)\s*}/;

    $s[1] =~ s/\\//;             # link label
#    $s[0] = "$s[0]";      # fileName, 
    push @s, $sort;

    $glbl{$ref} = \@s;

#    push (@sec, $s[2]), $secRef{$s[2]} = $ref if ($sort eq 'document');
}
    
close GLIN;

# extra labels
while(<EXIN>){
    chop;
    next if (/^#/ || /^\s*$/);
    if (/^link\s+(\S+)/i) {
	$outfile = $1;
    } else {
	s/\s+//g;
	$extraLink{$_} = $outfile;
    }
}
close EXIN;

# 硼ȥåȥѤΥե
while(<SHIN>){
    chop;
    next if (/^#/ || /^\s*$/);
    my ($capt, $dir, $file) = split;
    
    if ($dir eq '') {
	$dir = "$capt/$capt-0.html";
    } else {
	if ($file eq '') {
	    $dir .= "/$dir-0.html";
	} else {
	    $dir .= "/$file";
	}
    }

    $short_cut{$capt} = $dir;
}
close SHIN;

while(1)
{
    open (INPUT, "<$localOutDir$filePrefix$fname-$cou.tmp") || last;
    open (OUTF, ">$outPutDir$fname-$cou.html")
	|| perror("File can't open $outPutDir$fname-$cou.html");
    &trans();
    close(INPUT);
    $cou++;
}

# ad hoc ɡ*.gifΥԡ

system("cp -f ${localOutDir}*.gif $outPutDir"), print ss
	if ($outPutDir && `ls ${localOutDir}|grep '.gif\$'`);

$outPutDir = "./" if (!$outPutDir);
system("cd $outPutDir; ln -s $fname-0.html index.html")
	if ($indexlink && !(-e "${outPutDir}index.html"));
