-- sMkSpec.sml: Make Specification (Simple SML Version)
-- Author: Yoshida Atsushi <yoshida@agusa.nuie.nagoya-u.ac.jp>
-- Copyright (C) 1995, Agusa Lab., Information Eng., Nagoya Univ.
-- $Id: sMkSpec.sml,v 1.1.1.1 2001/05/14 06:09:23 yoshida Exp $
-------------------------------------------------------------------
-- $Log: sMkSpec.sml,v $
-- Revision 1.1.1.1  2001/05/14 06:09:23  yoshida
-- Made SML repository of CVS.
--
--
--Revision 1.2  96/02/09  23:46:54  yoshida
--*** empty log message ***
--
-- Revision 1.1  96/02/09  23:45:20  yoshida
-- Initial revision
-------------------------------------------------------------------
class SIMPLE_MKSPEC is
   -- ñʴؿͽϤ
   -- 
   -- ̾ꤵ줿٤ƤΥ桼ؿˤĤơޤϡ
   -- ꤵʤϥץΤ٤ƤΥ桼ؿˤĤ
   -- ؿ̾ȤηΰƤɽѿΰ
   -- ȤƤѿؿΰϤ

   main(args: ARRAY{STR}) is
      INITIALIZE::all;  -- (ɬ)
      APPEARANCE::c_mode;

      if args.size > 1 then
	 -- ˻ꤵ줿ؿˤĤɽ
	 loop
	    func_name ::= args.elt!(1);     -- ΰ
	    func ::= #FUNCTION(func_name);  -- ؿ̾ؿ
	    if ~void(func) and func.is_user_defined then
	       print_spec(func);
	    end;  -- if
	 end;  -- loop
      else
	 -- ٤ƤΥ桼ؿˤĤɽ
	 loop
	    -- ٤Ƥδؿ(f:FUNCTION)Τ桼
	    -- (f.is_user_defined)ؿνФ
	    func ::= {f: FUNCTION | f.is_user_defined}.elt!;
	    print_spec(func);
	 end;  -- loop
      end;  -- if
   end;  -- main

   print_spec(func: FUNCTION) is
      -- ؿͽϤ롣
      #OUT + "-------------------------------------------\n";
      -- ؿ̾(func.name)ȷ(func.a_type)ɽ
      #OUT + "[Function]\t" + func.name + ": " + func.a_type + "\n";

      #OUT + "[Arguments]\n";		-- ΰ
      loop
	 arg: VAR_IDENT := func.args.elt!;
	 -- (arg)Ȥη(arg.a_type)ɽ
	 #OUT + "\t" + arg + ": " +arg.a_type + "\n";
      end;    -- loop

      #OUT + "[Local Variables]\n";	-- ɽѿΰ
      loop
	 -- ؿ(func.body)(inside)ѿ(var:VAR_DECL)ν
	 -- 顢ѿμ̻(ident)Ф
	 local_var: $IDENT := {var: VAR_DECL inside func.body}.ident.elt!;
	 -- ɽѿ(local_var)Ȥη(local_var.a_type)ɽ
	 #OUT + "\t" + local_var + ": " + local_var.a_type + "\n";
      end;  -- loop

      #OUT + "[Global Variables]\n";	-- ȤƤѿΰ
      loop
	 -- ؿ(func.body)(inside)μ̻һȤɽ魯(IDENT_EXPR)
	 -- ν礫黲ȤƤ뼱̻(ident)νФ
	 -- ޥǻȤƤ뼱̻ҤϽ
	 -- ˡν˴ޤޤ(in)ѿ̻(v:VAR_IDENT)Τ
	 -- ѿǤ(v.is_global)Ф
	 global_var: VAR_IDENT := {v: VAR_IDENT in
		{i: IDENT_EXPR inside func.body | i.not_in_a_macro}.ident
		 | v.is_global}.elt!;
	 -- ѿ(global_var)Ȥη(global_var.a_type)ɽ
	 #OUT + "\t" + global_var + ": " + global_var.a_type + "\n";
      end;  -- loop

      #OUT + "[Function Calls]\n";	-- ȤƤؿΰ
      loop
	 -- ؿ(func.body)(inside)μ̻һȤɽ魯(IDENT_EXPR)
	 -- ν礫黲ȤƤ뼱̻(ident)νФ
	 -- ޥǻȤƤ뼱̻ҤϽ
	 -- ˡν˴ޤޤ(in)ؿ̻(v:FUNC_IDENT)ν
	 -- Ф
	 func_call: FUNC_IDENT := {v: FUNC_IDENT in
           {i: IDENT_EXPR inside func.body | i.not_in_a_macro}.ident}.elt!;
	 -- ؿƽФ(func_call)Ȥη(func_call.a_type)ɽ
	 #OUT + "\t" + func_call + ": " + func_call.a_type + "\n";
      end;  -- loop
      #OUT + "[Macro Calls]\n";		-- ȤƤޥΰ
      loop
	 -- ؿΤɽ(appearance)˴ޤޤƤޥƽФФ
	 m ::= func.appearance.all_macros.elt!;
	 #OUT + "\t" + m + "\n";
      end;  -- loop
      #OUT + "-------------------------------------------\n";
   end;  -- print_spec

end; -- class SIMPLE_MKSPEC
-------------------------------------------------------------------
