/* 
 * Program:             $RCSfile: util.c,v $  $Revision: 30.4 $
 * 
 * Purpose:             
 * 
 * Author:              T.Hidaka  1998/05/21
 *                      S.Yamamoto  1998/05/23
 * 
 * (C) Copyright:       T.Hidaka and S.Yamamoto  1998 - 2001
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: util.c,v 30.4 2001/03/25 12:22:38 yamamoto Exp yamamoto $";
#endif

#include <limits.h>
#include <stdio.h>
#include <Sapid/Sapid.h>

/* SapidDBѤϥåؿ */

int spdDBCalcHash(const char *str)
{
    const char *p;
    int hash = 0;

    if (str == NULL)
        return -1;

    for (p = str; *p; p++) {
        hash <<= 3;
        hash += *p;
        hash &= INT_MAX;
    }

    return hash;
}
