/* 
 * Program:             $RCSfile: getAttrIdByName3Sub.c,v $  $Revision: 30.5 $
 * 
 * Purpose:
 * 
 * Author:              S.Yamamoto  1998/09/02
 * 
 * (C) Copyright:       S.Yamamoto  1998 - 2001
 *                      This file is a product of the project Sapid.
 */

SpdAttrId spdGetAttrIdByName3(SpdClassId classId, SpdConstString className,
                              SpdConstString attrName)
{
    SpdAttrNameId   attrNameId;
    
    if (classId == SPD_NON_CID &&
        (classId = spdGetClassIdByName(className)) < 0) {
        return (-1);
    }
    /* Should do range checking for classId. */

    if ((attrNameId = spdGetAttrNameId(attrName)) == SPD_NON_ANAME_ID) {
        return (SPD_NON_AID);
    }    

    return (attr_id[attrNameId][classId]);
}
