/* 
 * Program:             $RCSfile: getAttrNames.c,v $  $Revision: 30.3 $
 * 
 * Purpose:             Generate class table.
 * 
 * Author:              S.Yamamoto  1995/03/20
 * 
 * (C) Copyright:       S.Yamamoto  1995 - 1998
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: getAttrNames.c,v 30.3 2003/06/28 15:31:43 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>

/* 
 * extern Class_t      class_table[];
 */

int main(int argc, char *argv[])
{
    int     i, j;
    
    for (i = 0; class_table[i].name != NULL; i++) {
        for (j = 0; j < SPD_MAX(SpdObjIValN, SpdRelIValN); j++) {
            if (class_table[i].iattr[j] != NULL) {
                printf("%s\n", class_table[i].iattr[j]);
            }
        }
        for (j = 0; j < SpdObjSValN; j++) {
            if (class_table[i].sattr[j] != NULL) {
                printf("%s\n", class_table[i].sattr[j]);
            }
        }
    }

    puts("p-id");
    puts("c-id");

    return (EXIT_SUCCESS);
}
