/* 
 * Program:             $RCSfile: mkGetAttrNameId.c,v $  $Revision: 30.7 $
 * 
 * Purpose:             Generate class table.
 * 
 * Author:              S.Yamamoto  1995/03/20
 * 
 * (C) Copyright:       S.Yamamoto  1995 - 2001
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: mkGetAttrNameId.c,v 30.7 2002/12/16 12:09:50 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "mkGetAttrNameId.h"

/* #define DEBUG_INPUTS */

int main(int argc, char *argv[])
{
    int         i;
    char        buf[SPD_STRING_LEN + 1];
    StrAndVal   inputs[MAX_INPUTS_NUM];

    i = 0;
    while (fgets(buf, SPD_STRING_LEN + 1, stdin) != NULL) {
        /* Trim the last newline character. */
        buf[strlen(buf) - 1] = '\0';
        inputs[i].str = spdStrdup(buf);
        inputs[i].val = i;

#ifdef DEBUG_INPUTS
        spdMessage("\"%s\", %d.\n", inputs[i].str, i);
#endif      

        i++;
    }
    mkMA("SpdAttrNameId", "spdGetAttrNameId", inputs, i, SPD_NON_ANAME_ID);
    while (0 <= --i) {
        spdFree(inputs[i].str);
    }
    return (EXIT_SUCCESS);
}
