/* 
 * Program:             $RCSfile: DBRelAttr.java,v $  $Revision: 40.4 $
 * 
 * Purpose:             
 *
 * Author:              K.Hoshino  2001/10/02
 *                      S.Yamamoto  2001/10/02
 *
 * (C) Copyright:       K.Hoshino and S.Yamamoto  2001 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: DBRelAttr.java,v 40.4 2003/02/15 11:56:36 yamamoto Exp yamamoto $
 */

package Japid.Freja.DBAccess;

import java.io.*;
import java.util.*;

public class DBRelAttr {
    SdbSort     sort;
    String      name;                       /* name of this attribute */
    SymSort     symSort;                    /* for check */

    public DBRelAttr(SdbSort sort, String name, SymSort symSort) {
        this.sort = sort;
        this.name = name;
        this.symSort = symSort;
    }

    public DBRelAttr(int sort, String name, SymSort symSort) {
        this(new SdbSort(sort), name, symSort);
    }

    public DBRelAttr(SdbSort sort, String name, int symSort) {
        this(sort, name, new SymSort(symSort));
    }

    public DBRelAttr(int sort, String name, int symSort) {
        this(new SdbSort(sort), name, new SymSort(symSort));
    }
}
