/* 
 * Program:             $RCSfile: DBTable.java,v $  $Revision: 40.8 $
 * 
 * Purpose:             FrejaDBTableѤ뤿ɬפʥ饹
 *
 * Author:              K.Hoshino  2001/10/02
 *                      S.Yamamoto  2001/10/02
 *
 * (C) Copyright:       K.Hoshino and S.Yamamoto  2001 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: DBTable.java,v 40.8 2003/02/12 03:39:46 yamamoto Exp yamamoto $
 */

package Japid.Freja.DBAccess;

import java.io.*;
import java.util.*;

/**
 * FrejaDBTableѤ뤿ɬפʥ饹
 *
 * See "<SAPID_TOP>/analyzer/jdbin/JB.h".
 */

public class DBTable extends DBTableBase {

    public DBTable() {
    }

    /**
     * nameɽ륯饹롥
     */
    public DBClass getDBClassByName(String name) {
        DBClass dbClass = null;

        for (int i = 0; i < dbClassTables.size(); i++) {
            dbClass = (DBClass) dbClassTables.elementAt(i);
            if (dbClass.className.equals(name)) return dbClass;
        }
        return null;
    }

    /**
     * nameɽ륯饹J-modelǲܤ
     */
    public int getDBClassIndexByName(String name) {
        DBClass dbClass = null;

        for (int i = 0; i < dbClassTables.size(); i++) {
            dbClass = (DBClass) dbClassTables.elementAt(i);
            if (dbClass.className.equals(name)) return i;
        }
        return JDBConsts.JAPID_NON_ID;
    }

    /**
     * nameɽϢ롥
     */
    public DBRel getDBRelByName(String name) {
        DBRel dbRel = null;

        for (int i = 0; i < dbRelTables.size(); i++) {
            dbRel = (DBRel) dbRelTables.elementAt(i);
            if (dbRel.relName.equals(name)) return dbRel;
        }
        return null;
    }

    /**
     * nameɽϢJ-modelǲܤ
     */
    public int getDBRelIndexByName(String name) {
        DBRel dbRel = null;

        for (int i = 0; i < dbRelTables.size(); i++) {
            dbRel = (DBRel) dbRelTables.elementAt(i);
            if (dbRel.relName.equals(name)) return i;
        }
        return JDBConsts.JAPID_NON_ID;
    }

    /**
     * nameɽ륯饹뤤ϴϢJ-modelǲܤ(饹
     * Ϣֹ̤)
     */
    public int getDBClassRelIndexByName(String name) {
        int index;

        index = getDBClassIndexByName(name);
        if (index == JDBConsts.JAPID_NON_ID) {
            index = getDBRelIndexByName(name);

            if (index != JDBConsts.JAPID_NON_ID) {
                index += getDBClassNum();
            }
        }
        
        return index;
    }

    /**
     * nameɽ륯饹뤤ϴϢμֹ֤
     */
    public int getDBClassRelIDByName(String name) {
        int crIndex = getDBClassRelIndexByName(name);
        
        return SymSort.tableIndex2SymSort(crIndex);
    }

    /**
     * 饹ο֤
     */
    public int getDBClassNum() {
        return dbClassTables.size();
    }

    /**
     * Ϣο֤
     */
    public int getDBRelNum() {
        return dbRelTables.size();
    }

    /**
     * 饹ȴϢ֤
     */
    public int getDBClassRelNum() {
        return dbClassTables.size() + dbRelTables.size();
    }
}
