/* 
 * Program:             $RCSfile: F2SQName.java,v $  $Revision: 41.5 $
 * 
 * Purpose:             
 *
 * Author:              Y.Hachisu  1998/06/18
 *                      S.Yamamoto  1998/06/18
 *
 * (C) Copyright:       Y.Hachisu and S.Yamamoto  1998 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: F2SQName.java,v 41.5 2003/02/15 11:56:40 yamamoto Exp yamamoto $
 */

package Japid.Freja.F2S;

import java.io.*;
import java.util.*;
import Japid.Freja.*;
import Japid.Freja.DBAccess.*;

public class F2SQName extends FrjQName implements F2SObject {
    // Constructors
    public F2SQName(FrejaEntry entry, DBClassObject obj) {
        super(entry, obj);
    }

    public F2SQName() {
        super();
    }

    protected void create(FrejaEntry entry, DBClassObject obj) {
        new F2SQName(entry, obj);
    }

    public String toSource() {
        String source = "";
        sortRelatedObjects(new SortByOffset());

        String dot = "";
        Enumeration e = getChildQNames();
        if (e.hasMoreElements()) {
            while (e.hasMoreElements()) {
                source += dot + ((F2SQName) e.nextElement()).toSource();
                dot = ".";
            }
        }
        else {
            source = this.getStr();
        }
        return source;
    }
}
