/* 
 * Program:             $RCSfile: F2SType.java,v $  $Revision: 41.5 $
 * 
 * Purpose:             
 *
 * Author:              Y.Hachisu  1998/06/18
 *                      S.Yamamoto  1998/06/18
 *
 * (C) Copyright:       Y.Hachisu and S.Yamamoto  1998 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: F2SType.java,v 41.5 2003/02/15 11:56:41 yamamoto Exp yamamoto $
 */

package Japid.Freja.F2S;

import java.io.*;
import java.util.*;
import Japid.Freja.*;
import Japid.Freja.DBAccess.*;

public class F2SType extends FrjType implements F2SObject {
    // Constructors
    public F2SType(FrejaEntry entry, DBClassObject obj) {
        super(entry, obj);
    }

    public F2SType() {
        super();
    }

    protected void create(FrejaEntry entry, DBClassObject obj) {
        new F2SType(entry, obj);
    }

    public String toSource() {
        String source = "";
        if (qname != null) {
            source += ((F2SQName) qname).toSource() + "." ;
        }
        if (childType != null) {
            source += ((F2SType) childType).toSource();
        }
        source += this.getStr();
        return source;
    }
}
