/* 
 * Program:             $RCSfile: NoSuchRelatedObjectException.java,v $  $Revision: 41.4 $
 * 
 * Purpose:             
 *
 * Author:              Y.Hachisu  1998/06/18
 *                      S.Yamamoto  1998/06/18
 *
 * (C) Copyright:       Y.Hachisu and S.Yamamoto  1998 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: NoSuchRelatedObjectException.java,v 41.4 2003/02/15 11:56:32 yamamoto Exp yamamoto $
 */

package Japid.Freja;

/**
 * DBException may be thrown on DBAccess.
 */
public class NoSuchRelatedObjectException extends Exception {
    NoSuchRelatedObjectException() {
        super();
    }

    NoSuchRelatedObjectException(String s) {
        super(s);
    }

    NoSuchRelatedObjectException(FrjRelation rel) {
        super(rel.get1stObject().getClassName() + " doesn't have relation("
              + rel.getRelationName() + ") to "
              + rel.get2ndObject().getClassName() +".");
    }
}
