/* 
 * Program:             $RCSfile: PrintStr.java,v $  $Revision: 41.4 $
 * 
 * Purpose:             
 *
 * Author:              Y.Hachisu  1998/06/18
 *                      S.Yamamoto  1998/06/18
 *
 * (C) Copyright:       Y.Hachisu and S.Yamamoto  1998 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: PrintStr.java,v 41.4 2003/02/15 11:56:32 yamamoto Exp yamamoto $
 */

package Japid.Freja;

public class PrintStr implements TraverseMethod {
    private static int level = -1;

    public void doBeforeTraverse(FrjObject obj) {
        for (int i = 0; i < level; i++) {
            System.out.print(" ");
        }
        System.out.print("[" + obj.getClassName() + "] "
                         + obj.getID() + ", " + obj.getStr());
        if (obj instanceof FrjStatement) {
            System.out.print(": " + ((FrjStatement) obj).getSortString());
        }
        if (obj instanceof FrjExpression) {
            System.out.print(": " + ((FrjExpression) obj).getSortString());
        }
        System.out.println();

        level++;
    }
    public void doMyself(FrjObject obj) {
    }
    public void doAfterTraverse(FrjObject obj) {
        level--;
    }
}
