/* 
 * Program:             $RCSfile: RSortByOffset.java,v $  $Revision: 41.4 $
 * 
 * Purpose:             
 *
 * Author:              Y.Hachisu  1998/06/18
 *                      S.Yamamoto  1998/06/18
 *
 * (C) Copyright:       Y.Hachisu and S.Yamamoto  1998 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: RSortByOffset.java,v 41.4 2003/02/12 03:39:40 yamamoto Exp yamamoto $
 */

package Japid.Freja;

import java.util.Vector;
import java.util.Enumeration;

/**
 * Sort vector by offset reversely.
 */

public class RSortByOffset extends VectorSorter {
    public RSortByOffset(Vector v) {
        super(v);
    }

    public RSortByOffset(Enumeration e) {
        super(e);
    }

    public RSortByOffset() {
        super();
    }

    public int compare(Object a, Object b) {
        FrjObject objA = (FrjObject) a;
        FrjObject objB = (FrjObject) b;
                
        if (objA.getOffset() < objB.getOffset()) {
            return 1;
        } else if (objA.getOffset() > objB.getOffset()) {
            return -1;
        } else {
            return 0;
        }
    }
}
