/* 
 * Program:             $RCSfile: SortByRID.java,v $  $Revision: 41.4 $
 * 
 * Purpose:             
 *
 * Author:              Y.Hachisu  1998/06/18
 *                      S.Yamamoto  1998/06/18
 *
 * (C) Copyright:       Y.Hachisu and S.Yamamoto  1998 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: SortByRID.java,v 41.4 2003/02/12 03:39:42 yamamoto Exp yamamoto $
 */

package Japid.Freja;

import java.util.Vector;
import java.util.Enumeration;

/**
  * Classes SortByXXX is to sort FrjObject by order of XXX.
  */

public class SortByRID extends VectorSorter {
    public SortByRID() {
        super();
    }

    public SortByRID(Vector v) {
        super(v);
    }

    public SortByRID(Enumeration e) {
        super(e);
    }

    public int compare(Object a, Object b) {
        FrjRelation relA = (FrjRelation) a;
        FrjRelation relB = (FrjRelation) b;
                
        if (relA.getID() > relB.getID()) {
            return 1;
        } else if (relA.getID() < relB.getID()) {
            return -1;
        } else {
            return 0;
        }
    }
}
