/* 
 * Program:             $RCSfile: SortByStr.java,v $  $Revision: 41.4 $
 * 
 * Purpose:             
 *
 * Author:              Y.Hachisu  1998/06/18
 *                      S.Yamamoto  1998/06/18
 *
 * (C) Copyright:       Y.Hachisu and S.Yamamoto  1998 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: SortByStr.java,v 41.4 2003/02/12 03:39:42 yamamoto Exp yamamoto $
 */

package Japid.Freja;

import java.util.Vector;
import java.util.Enumeration;

/**
 * Classes SortByXXX is to sort FrjObject by order of XXX.
 */

public class SortByStr extends VectorSorter {
    public SortByStr(Vector v) {
        super(v);
    }

    public SortByStr(Enumeration e) {
        super(e);
    }

    public SortByStr() {
        super();
    }

    public int compare(Object a, Object b) {
        FrjObject objA = (FrjObject) a;
        FrjObject objB = (FrjObject) b;

        if (objA == null && objB == null) {
            return 0;
        }
        if (objA == null && objB != null) {
            return 1;
        } else if (objA != null && objB == null) {
            return -1;
        }
        return (objA.getStr().compareTo(objB.getStr()));
    }
}
