/* 
 * Program:             $RCSfile: TypesNotConvertableException.java,v $  $Revision: 41.4 $
 * 
 * Purpose:             
 *
 * Author:              Y.Hachisu  1998/06/18
 *                      S.Yamamoto  1998/06/18
 *
 * (C) Copyright:       Y.Hachisu and S.Yamamoto  1998 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: TypesNotConvertableException.java,v 41.4 2003/02/15 11:56:34 yamamoto Exp yamamoto $
 */

package Japid.Freja;

/**
 * DBException may be thrown on DBAccess.
 */
public class TypesNotConvertableException extends Exception {
    TypesNotConvertableException() {
        super();
    }

    TypesNotConvertableException(String s) {
        super(s);
    }

    TypesNotConvertableException(FrjType t1, FrjType t2) {
        super(t1.getStr() + "(" + t1.getSortString()
              + ") doesn't convert to/from "
              + t2.getStr() + "(" + t2.getSortString() + ").");
    }
}
