/* 
 * Program:             $RCSfile: PrintUnusedVariables.java,v $  $Revision: 40.4 $
 * 
 * Purpose:             
 *
 * Author:              Y.Hachisu  1998/06/18
 *                      S.Yamamoto  1998/06/18
 *
 * (C) Copyright:       Y.Hachisu and S.Yamamoto  1998 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: PrintUnusedVariables.java,v 40.4 2003/02/15 11:56:44 yamamoto Exp yamamoto $
 */

package Japid.Tools;

import java.util.*;
import Japid.Freja.*;
import Japid.Freja.F2S.*;

public class PrintUnusedVariables {
    public static void main(String args[]) {
        if (args.length == 0) {
            System.err.println("java Japid.Tools.PrintUnusedVariables "
                               + "ClassNames");
            return;
        }
                
        for (int i = 0; i < args.length; i++) {
            // Υ饹SDBɤ߹
            System.err.println("loading " + args[i]);
            new F2SLoader().load(Creja.getFrejaEntry(args[0]));
            System.out.println("Unused variables:");

            for (Enumeration e = FrjExtents.getObjects(FrjVariable
                                                       .getClassNameStatically());
                 e.hasMoreElements();) {
                F2SVariable var = (F2SVariable) e.nextElement();
                Enumeration e2 = var.getReferrers();
                if (!e2.hasMoreElements()) {
                    FrjObject c = var.getAncestorObject("Class");
                    System.out.print(c.getStr() + ":" + var.getLineNo() + ": "
                                     + var.toSource());
                    System.out.println("  [" + var.getSortString() + "]");
                }
            }
            FrjExtents.clear();
            System.gc();
        }
    }
}
