/* 
 * Program:             $RCSfile: ActionManager.java,v $  $Revision: 40.3 $
 * 
 * Purpose:             
 *
 * Author:              H.Kuwabara  2003/06/02
 *                      S.Yamamoto  2003/06/02
 *
 * (C) Copyright:       H.Kuwabara and S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: ActionManager.java,v 40.3 2003/07/08 05:47:56 yamamoto Exp yamamoto $
 */

package Japid.Tools.Syab3;

import java.awt.event.ActionListener;
import java.util.Hashtable;

public class ActionManager {
    private Hashtable hash;

    public ActionManager() {
        hash = new Hashtable();
    }

    /**
     *  Maps the specified key to the specified action.
     *  @param key the hashtable key
     *  @param action the action to which the specified key is mapped
     */
    public void put(String key, ActionListener action) {
        hash.put(key, action);
    }

    /**
     *  Gets the action to which the specified key is mapped.
     *  @param key a key
     *  @return the action; null if the key is not mapped to any value
     */
    public ActionListener get(String key) {
        return (ActionListener)hash.get(key);
    }
}
