/* 
 * Program:             $RCSfile: ObjectAttributesArea.java,v $  $Revision: 40.3 $
 * 
 * Purpose:             
 *
 * Author:              H.Kuwabara  2003/06/02
 *                      S.Yamamoto  2003/06/02
 *
 * (C) Copyright:       H.Kuwabara and S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: ObjectAttributesArea.java,v 40.3 2003/07/08 05:47:57 yamamoto Exp yamamoto $
 */

package Japid.Tools.Syab3;

import java.awt.Font;
import javax.swing.JTextArea;

import Japid.Freja.*;

public class ObjectAttributesArea extends JTextArea {
    public ObjectAttributesArea() {
        setEditable(false);
        setFont(new Font("Monospaced", Font.PLAIN, 14));
    }

    public void setObject(FrjObject object) {
        FrjAttrsAsString[] attrs;
        attrs = object.getAttrsAsString();

        StringBuffer sb = new StringBuffer();
        for (int i = 0; attrs[i] != null; i++) {
            sb.append(attrs[i].name);
            sb.append(": ");
            sb.append(attrs[i].value);
            sb.append("\n");
        }

        clearText();
        setText(sb.toString());
    }

    public void clearText() {
        setText("");
    }
}
