/* 
 * Program:             $RCSfile: Reload.java,v $  $Revision: 40.3 $
 * 
 * Purpose:             
 *
 * Author:              H.Kuwabara  2003/06/02
 *                      S.Yamamoto  2003/06/02
 *
 * (C) Copyright:       H.Kuwabara and S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: Reload.java,v 40.3 2003/07/08 05:48:01 yamamoto Exp yamamoto $
 */

package Japid.Tools.Syab3.action;

import java.awt.event.ActionEvent;
import javax.swing.AbstractAction;

import Japid.Tools.Syab3.DataModel;
import Japid.Tools.Syab3.ViewModelMediator;

public class Reload extends AbstractAction {
    private DataModel model;
    private ViewModelMediator mediator;

    private Reload() {
    }

    public Reload(DataModel model, ViewModelMediator mediator) {
        this.model = model;
        this.mediator = mediator;
    }

    public void actionPerformed(ActionEvent e) {
        model.reload();
        mediator.reload();
    }
}
