<%--
# Program:		$RCSfile: util.jsp,v $  $Revision: 51.5 $
# 
# Purpose:		
# 
# Author:		Y.Sawada  2003/10/01
#			S.Yamamoto  2003/10/01
# 
# (C) Copyright:	Y.Sawada and S.Yamamoto  2003
#			This file is a product of the project Sapid.
--%>

<%--
    $Id: util.jsp,v 51.5 2003/11/19 11:41:43 yamamoto Exp yamamoto $
--%>  

<%--
    Document getDocument(String path)
    Node getMemoNode(Node node,String id)
    Hashtable getNodeContents(Node node)
    int getLength(Node node)
    void serialize(Document objDoc,String path)
    String strEncode(String strVal)
    public String CRLT(String strEsc)
--%>
<%!
    Document getDocument(String path){
        try{
            FileReader fl = new FileReader(path);
            BufferedReader br = new BufferedReader(fl);
            InputSource src = new InputSource(br);
             DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
             DocumentBuilder builder = factory.newDocumentBuilder();
             Document objDoc = builder.parse(src);
            return objDoc;
        }catch(Exception e){
            return null;
        }
    }

    Node getMemoNode(Node node,String id){
        NodeList clnNod = node.getChildNodes();
        int leng = clnNod.getLength();
        for(int i=0;i<leng;i++){
            Node objNod = clnNod.item(i);
            if(!objNod.getNodeName().equals("#text")){
                String mid = ((Element)objNod).getAttribute("id");
                if(mid.equals(id)){
                    return objNod;
                }
            }
        }
        return null;
    }
    
    Hashtable getNodeContents(Node node){
        Hashtable nc = new Hashtable();
        NodeList clnNod = node.getChildNodes();
        int leng = clnNod.getLength();
        nc.put("id",((Element)node).getAttribute("id"));
        for(int i=1;i<leng;i++){
            String nodeName = node.getChildNodes().item(i).getNodeName();
            if(!nodeName.equals("#text")){
                String nodeVal = node.getChildNodes().item(i).getFirstChild().getNodeValue();
                nc.put(nodeName,nodeVal);
            }
        }
        return nc;
    }

    Hashtable getNodeContents(Node node, Hashtable nc){
        NodeList clnNod = node.getChildNodes();
        int leng = clnNod.getLength();
        nc.put("id",((Element)node).getAttribute("id"));
        for(int i=1;i<leng;i++){
            String nodeName = node.getChildNodes().item(i).getNodeName();
            if(!nodeName.equals("#text")){
                String nodeVal = node.getChildNodes().item(i).getFirstChild().getNodeValue();
                nc.put(nodeName,nodeVal);
            }
        }
        return nc;
    }

    int getLength(Node node){
        int j=0;
        NodeList children = node.getChildNodes();
        for(int i=0;i<children.getLength();i++){
            if(!children.item(i).getNodeName().equals("#text")){
                j++;
            }
        }
        return j;
    }

    void serialize(Document objDoc,String path){
        try{
            TransformerFactory transFactory = TransformerFactory.newInstance(); 
            Transformer transformer = transFactory.newTransformer();
            ServletContext context = getServletContext();
            String encoding = context.getInitParameter("encoding");
            transformer.setOutputProperty("encoding",encoding);
            transformer.setOutputProperty("indent","yes");
            // transformer.setOutputProperty(OutputKeys.DOCTYPE_SYSTEM, "memo.dtd");
        
            DOMSource source = new DOMSource(objDoc);
            // String output = application.getRealPath("/src/" + fileName + "Memo.xml");
            StreamResult result = new StreamResult(path);
            transformer.transform(source, result);
            }catch(Exception e){
            }
        }

    public String strEncode(String strVal) throws UnsupportedEncodingException{
        if(strVal == null || strVal.equals("")){
            return ("none");
        }
        else{
            return (new String(strVal.getBytes("ISO-8859-1"),"JISAutoDetect"));
        }
    }

    public String CRLT(String strEsc){
        StringBuffer strResult = new StringBuffer();
        int intEnd = 0;
        int cnt = 0;
        intEnd = strEsc.indexOf(System.getProperty("line.separator"),cnt);
        while(intEnd != -1){
            strResult.append(strEsc.substring(cnt,intEnd));
            strResult.append("<br />");
            cnt = intEnd + 1;
            intEnd = strEsc.indexOf(System.getProperty("line.separator"),cnt);
        }
        strResult.append(strEsc.substring(cnt));
        return strResult.toString();
    }
%>
