/* 
 * Program:             $RCSfile: IndexData.java,v $  $Revision: 50.2 $
 * 
 * Purpose:             
 *
 * Author:              Y.Sawada  2003/10/01
 *                      S.Yamamoto  2003/10/01
 *
 * (C) Copyright:       Y.Sawada and S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: IndexData.java,v 50.2 2003/11/20 16:25:43 yamamoto Exp yamamoto $
 */

package jspie3;

import java.util.Hashtable;

public class IndexData{
    static String[] sort = {"" , "ؼ" , "" , "" , "ո" , ""};
    static String[] importance = {"" , "" , ""};
    static String[] state = {"Ԥ" , "Ѥ" , "ȺѤ" , "ǧѤ"};
    static String[] limit = {"ޤ" , "ޤ"};
    static String[] permit = {"ԤΤ߽" , "ïǤ⽤"};
    static String[] publicity = {"" , "Բ"};
    static Hashtable data;

    static{
	data = new Hashtable();
	data.put("sort",sort);
	data.put("importance",importance);
	data.put("state",state);
	data.put("limit",limit);
	data.put("permit",permit);
	data.put("publicity",publicity);
    }

    static public String getData(String sort,int index){
	String[] value = (String[])data.get(sort);
	if(value != null && value.length > index){
	    return value[index];
	}
	else {
	    return null;
	}
    }

    static public String getData(String sort,String index){
	String[] value = (String[])data.get(sort);
	try {
	    int i = Integer.parseInt(index);
	    if(value != null && value.length > i){
		return value[i];
	    }
	    else {
		return null;
	    }
	}
	catch (NumberFormatException e){
	    return null;
	}
    }

    static public String[] getDataArray(String sort){
	return (String[])data.get(sort);
    }

    static public String createSelect(String sort,int val){
	StringBuffer sb = new StringBuffer();
	String[] sortArray = getDataArray(sort);
	sb.append("\t\t\t<select name=\"" + sort + "\">\n");
	for(int i = 0; i < sortArray.length; i++){
	    if(i == val) {
		sb.append("\t\t\t\t<option value=\"" + i + "\" selected=\"selected\">"
			  + sortArray[i] + "</option>\n");
	    }
	    else { 
		sb.append("\t\t\t\t<option value=\"" + i + "\">" + sortArray[i] + "</option>\n");
	    }
	}
	sb.append("\t\t\t</select>\n");
	return sb.toString();
    }
}
