/* 
 * Program:             $RCSfile: public_func.c,v $  $Revision: 40.3 $
 * 
 * Purpose:             
 * 
 * Author:              K.Hoshino  2001/10/27
 *                      S.Yamamoto  2001/10/27 
 * 
 * (C) Copyright:       K.Hoshino and S.Yamamoto  2001
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: public_func.c,v 40.3 2001/12/18 14:19:00 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include <Sapid/PmodelAR.h>
#include <Sapid/ImodelAR.h>
#include <Sapid/ImodelARcompat.h>
#include "CommentViewAR.h"

/*
 * offsetǼ֤
 * ԤƬȲХܤ(ǽ0 ХܤȤ)
 */

int getOffsetFromLineHead(int offset, SpdString sourceStr)
{
    int offsetFromLineHead = 0;
    int i = offset - 1;

    while (i >= 0 && sourceStr[i] != '\r' && sourceStr[i] != '\n') {
        offsetFromLineHead++;
        i--;
    }

    return offsetFromLineHead;
}

/*
 * offsetǼ֤
 * ܤ(ǽ0 ܤȤ)
 */

int getLineNum(int offset, SpdString sourceStr)
{
    int i, lineNum = 0;
    for (i = 0; i < offset; i++) {
        if (sourceStr[i] == '\r') {
            if (sourceStr[i + 1] == '\n') i++;
            lineNum++;
        } else if (sourceStr[i] == '\n') {
            lineNum++;
        }
    }

    return lineNum;
}

/*
 * եǤʸ
 * (spdGetTextByRegionѤƤΤǡ桼¦ǳɬפ)
 */

SpdString getSourceFileString(SpdObjId fileId, int offset, int length)
{
    SpdRegion region;

    region.fileId = fileId;
    region.offset = offset;
    region.length = length;
  
    return spdGetTextByRegion(region);
}

/*
 * ʸ󤫤ʬʸ
 * (spdGetTextByRegionѤƤΤǡ桼¦ǳɬפ)
 */
SpdString getSubString(SpdString buf, int offset, int length)
{
    char *text;
    int i;

    if (buf == NULL) return NULL;

    /* buf礭ۤʤȽ򤹤٤ġ */

    text = spdMalloc(length + 1);
    for (i = 0; i < length; i++) {
        text[i] = buf[offset + i];
    }
    text[i] = '\0';

    return text;
}
