/*  
 * Program:             $RCSfile: JSXTKeyWord.java,v $  $Revision: 50.6 $
 * 
 * Purpose:             keyword (TerminalNode).
 * 
 * Author:              S.Takeshi  2003/08/03
 *                      S.Yamamoto  2003/08/03
 * 
 * (C) Copyright:       S.Takeshi and S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: JSXTKeyWord.java,v 50.6 2003/08/12 06:36:47 yamamoto Exp yamamoto $
 */

package wapid.jsxmodel;

import wapid.parser.js.*;

public class JSXTKeyWord extends JSXTMetaNode {
    public int node_type = KW;
    public String node_name = "kw";
    private String keywordName = null;

    public JSXTKeyWord(int depth, Token firstToken, Token lastToken) {
        super(depth, firstToken, lastToken);
        setNodeName(node_name);
        super.isTerminalNode = true;
        this.keywordName = firstToken.image;
    }
    
    // JMCL
    public void setName(String literalName) {
        this.keywordName = literalName.intern();
    }

    public String toString() {
        return keywordName.toString();
    }
}
