/*  
 * Program:             $RCSfile: JSXTVariableDeclaration.java,v $  $Revision: 50.6 $
 * 
 * Purpose:             VariableDeclaration (NonTerminalNode).
 *                      child: 
 * 
 * Author:              S.Takeshi  2003/08/03
 *                      S.Yamamoto  2003/08/03
 * 
 * (C) Copyright:       S.Takeshi and S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: JSXTVariableDeclaration.java,v 50.6 2003/08/12 06:36:48 yamamoto Exp yamamoto $
 */

package wapid.jsxmodel;

import wapid.parser.js.*;

public class JSXTVariableDeclaration extends JSXTMetaNode {

    public int node_type = VARDEC;
    public String node_name = "VarDec";

    public JSXTVariableDeclaration(int depth, Token firstToken, Token lastToken) {
        super(depth, firstToken, lastToken);
        setNodeName(node_name);
    }
}
