/*  
 * Program:             $RCSfile: SymbolTableFunction.java,v $  $Revision: 50.2 $
 * 
 * Purpose:             
 * 
 * Author:              S.Takeshi  2003/09/06
 *                      S.Yamamoto  2003/09/06
 * 
 * (C) Copyright:       S.Takeshi and S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: SymbolTableFunction.java,v 50.2 2003/09/07 07:28:58 yamamoto Exp yamamoto $
 */

/**
 * SymboleTableFunction
 * 
 * @author
 */

package wapid.jsxmodel.xref;

import java.util.*;

public class SymbolTableFunction {

	String funName;
	String funPos;
	String funText;
	int funID;
	int funNameIdentID;
	int funSort;

	// for local variables
	Vector STLocalVar;
	
	// for nested function
	// TODO To have nested functionlist

	// for reference
	Vector STRefLocalVar;
	Vector STRefGrobalVar;
	Vector STRefFunCall;

	// used list
	Vector usedList;

	/**
	 * Constructor
	 * @param funName
	 * @param funPos
	 * @param id
	 * @param sort
	 */
	public SymbolTableFunction(String funName, String funText, String funPos,int id,int nameIdentId,int sort) {
		this.funName = funName;
		this.funPos = funPos;
		this.funText = funText;
		this.funID = id;
		this.funNameIdentID = nameIdentId;
		this.funSort = sort;
		this.STLocalVar = new Vector();
		this.STRefFunCall = new Vector();
		this.STRefGrobalVar = new Vector();
		this.STRefLocalVar = new Vector();
		this.usedList = new Vector();
	}
	
	/**
	 * Get column counter.
	 * @return
	 */
	public int getColumnNum() {
		String[] posa = funPos.split(" ");
		int c = Integer.parseInt(posa[1]);
		return c;
	}

	/**
	 * Get line counter.
	 * @return
	 */
	public int getLineNum() {
		String[] posa = funPos.split(" ");
		int l = Integer.parseInt(posa[0]);
		return l;
	}
}
