package wapid.wxmodel.abstractwxmodelar;

/**
 * @version WXModel.rxm 1.0 (Tue Oct 14 15:24:11 JST 2003)
 * @author  Relaxer 1.0rc2 (http://www.relaxer.org)
 */
public interface IRVisitor {
    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(AWxFile visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(AWxFile visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(AWxNl visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(AWxNl visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(AWxXMLDecl visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(AWxXMLDecl visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(AWxAttribute visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(AWxAttribute visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(AWxString visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(AWxString visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(AWxDquote visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(AWxDquote visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(AWxSquote visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(AWxSquote visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(AWxText visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(AWxText visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(AWxSp visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(AWxSp visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(AWxComment visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(AWxComment visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(AWxScriptlet visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(AWxScriptlet visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(AWxName visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(AWxName visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(AWxEq visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(AWxEq visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(AWxTago visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(AWxTago visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(AWxTagc visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(AWxTagc visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(AWxDoctypeDecl visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(AWxDoctypeDecl visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(AWxExternalID visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(AWxExternalID visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(AWxSystem visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(AWxSystem visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(AWxPublic visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(AWxPublic visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(AWxStyleSheet visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(AWxStyleSheet visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(AWxElement visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(AWxElement visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(AWxSTag visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(AWxSTag visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(AWxETag visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(AWxETag visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(AWxEmpty visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(AWxEmpty visitable);
}
