
package wapid.wxmodel.wxmodelar;

import wapid.wxmodel.abstractwxmodelar.*;

import java.util.*;

public class WxElement extends AWxElement implements IXObject
{

    /** ƥ֥Ȥݻ */
    private IXObject parentObject = null;

    /** ־ݻ륯饹 */
    private XObjectPosition pos = null;

    /** WxElementݻ */
    private Vector vec_WxElement = null;
    /** WxSTagݻ */
    private Vector vec_WxSTag = null;
    /** WxETagݻ */
    private Vector vec_WxETag = null;
    /** WxTextݻ */
    private Vector vec_WxText = null;
    /** WxEmptyݻ */
    private Vector vec_WxEmpty = null;
    /** WxSpݻ */
    private Vector vec_WxSp = null;
    /** WxNlݻ */
    private Vector vec_WxNl = null;
    /** WxCommentݻ */
    private Vector vec_WxComment = null;
    /** WxScriptletݻ */
    private Vector vec_WxScriptlet = null;
    

    
    /** ҥΡɤ˿ƥΡɤ򥻥åȤ */
    public void setParentObject(IXObject parentObject){
       this.parentObject = parentObject;
       IAWxElementChoice[] contents = getContent();
       for(int i=0;i<contents.length;i++){
           ((IXObject)contents[i]).setParentObject(this);
       }
    }
    
    

    /** ƥΡɤ֤ */
    public IXObject getParentObject(){
       return parentObject;
    }


    
    
    /** WxElement Υƥ졼 */
    public Iterator  getWxElementIterator(){
        if(vec_WxElement==null){
            divideXObject();
        }
        return vec_WxElement.iterator();
    }
    /** WxElement[] ֥Ȥ  */
    public WxElement[] getWxElements(){
        WxElement[] ret_obj;
        if(vec_WxElement==null){
            divideXObject();
        }
        ret_obj = new WxElement[vec_WxElement.size()];
        for(int i=0;i<vec_WxElement.size();i++){
            ret_obj[i] = (WxElement)vec_WxElement.elementAt(i);
        }
        return ret_obj;
    }
    
    /** WxSTag Υƥ졼 */
    public Iterator  getWxSTagIterator(){
        if(vec_WxSTag==null){
            divideXObject();
        }
        return vec_WxSTag.iterator();
    }
    /** WxSTag[] ֥Ȥ  */
    public WxSTag[] getWxSTags(){
        WxSTag[] ret_obj;
        if(vec_WxSTag==null){
            divideXObject();
        }
        ret_obj = new WxSTag[vec_WxSTag.size()];
        for(int i=0;i<vec_WxSTag.size();i++){
            ret_obj[i] = (WxSTag)vec_WxSTag.elementAt(i);
        }
        return ret_obj;
    }
    
    /** WxETag Υƥ졼 */
    public Iterator  getWxETagIterator(){
        if(vec_WxETag==null){
            divideXObject();
        }
        return vec_WxETag.iterator();
    }
    /** WxETag[] ֥Ȥ  */
    public WxETag[] getWxETags(){
        WxETag[] ret_obj;
        if(vec_WxETag==null){
            divideXObject();
        }
        ret_obj = new WxETag[vec_WxETag.size()];
        for(int i=0;i<vec_WxETag.size();i++){
            ret_obj[i] = (WxETag)vec_WxETag.elementAt(i);
        }
        return ret_obj;
    }
    
    /** WxText Υƥ졼 */
    public Iterator  getWxTextIterator(){
        if(vec_WxText==null){
            divideXObject();
        }
        return vec_WxText.iterator();
    }
    /** WxText[] ֥Ȥ  */
    public WxText[] getWxTexts(){
        WxText[] ret_obj;
        if(vec_WxText==null){
            divideXObject();
        }
        ret_obj = new WxText[vec_WxText.size()];
        for(int i=0;i<vec_WxText.size();i++){
            ret_obj[i] = (WxText)vec_WxText.elementAt(i);
        }
        return ret_obj;
    }
    
    /** WxEmpty Υƥ졼 */
    public Iterator  getWxEmptyIterator(){
        if(vec_WxEmpty==null){
            divideXObject();
        }
        return vec_WxEmpty.iterator();
    }
    /** WxEmpty[] ֥Ȥ  */
    public WxEmpty[] getWxEmptys(){
        WxEmpty[] ret_obj;
        if(vec_WxEmpty==null){
            divideXObject();
        }
        ret_obj = new WxEmpty[vec_WxEmpty.size()];
        for(int i=0;i<vec_WxEmpty.size();i++){
            ret_obj[i] = (WxEmpty)vec_WxEmpty.elementAt(i);
        }
        return ret_obj;
    }
    
    /** WxSp Υƥ졼 */
    public Iterator  getWxSpIterator(){
        if(vec_WxSp==null){
            divideXObject();
        }
        return vec_WxSp.iterator();
    }
    /** WxSp[] ֥Ȥ  */
    public WxSp[] getWxSps(){
        WxSp[] ret_obj;
        if(vec_WxSp==null){
            divideXObject();
        }
        ret_obj = new WxSp[vec_WxSp.size()];
        for(int i=0;i<vec_WxSp.size();i++){
            ret_obj[i] = (WxSp)vec_WxSp.elementAt(i);
        }
        return ret_obj;
    }
    
    /** WxNl Υƥ졼 */
    public Iterator  getWxNlIterator(){
        if(vec_WxNl==null){
            divideXObject();
        }
        return vec_WxNl.iterator();
    }
    /** WxNl[] ֥Ȥ  */
    public WxNl[] getWxNls(){
        WxNl[] ret_obj;
        if(vec_WxNl==null){
            divideXObject();
        }
        ret_obj = new WxNl[vec_WxNl.size()];
        for(int i=0;i<vec_WxNl.size();i++){
            ret_obj[i] = (WxNl)vec_WxNl.elementAt(i);
        }
        return ret_obj;
    }
    
    /** WxComment Υƥ졼 */
    public Iterator  getWxCommentIterator(){
        if(vec_WxComment==null){
            divideXObject();
        }
        return vec_WxComment.iterator();
    }
    /** WxComment[] ֥Ȥ  */
    public WxComment[] getWxComments(){
        WxComment[] ret_obj;
        if(vec_WxComment==null){
            divideXObject();
        }
        ret_obj = new WxComment[vec_WxComment.size()];
        for(int i=0;i<vec_WxComment.size();i++){
            ret_obj[i] = (WxComment)vec_WxComment.elementAt(i);
        }
        return ret_obj;
    }
    
    /** WxScriptlet Υƥ졼 */
    public Iterator  getWxScriptletIterator(){
        if(vec_WxScriptlet==null){
            divideXObject();
        }
        return vec_WxScriptlet.iterator();
    }
    /** WxScriptlet[] ֥Ȥ  */
    public WxScriptlet[] getWxScriptlets(){
        WxScriptlet[] ret_obj;
        if(vec_WxScriptlet==null){
            divideXObject();
        }
        ret_obj = new WxScriptlet[vec_WxScriptlet.size()];
        for(int i=0;i<vec_WxScriptlet.size();i++){
            ret_obj[i] = (WxScriptlet)vec_WxScriptlet.elementAt(i);
        }
        return ret_obj;
    }
    
    

    
    /** XObject ʬ */
    private void divideXObject(){
       vec_WxElement = new Vector();
       vec_WxSTag = new Vector();
       vec_WxETag = new Vector();
       vec_WxText = new Vector();
       vec_WxEmpty = new Vector();
       vec_WxSp = new Vector();
       vec_WxNl = new Vector();
       vec_WxComment = new Vector();
       vec_WxScriptlet = new Vector();
       

       IAWxElementChoice[] contents = getContent();
       for(int i=0;i<contents.length;i++){
          
          if(contents[i] instanceof WxElement){
              vec_WxElement.addElement((WxElement)contents[i]);
          }
          
          if(contents[i] instanceof WxSTag){
              vec_WxSTag.addElement((WxSTag)contents[i]);
          }
          
          if(contents[i] instanceof WxETag){
              vec_WxETag.addElement((WxETag)contents[i]);
          }
          
          if(contents[i] instanceof WxText){
              vec_WxText.addElement((WxText)contents[i]);
          }
          
          if(contents[i] instanceof WxEmpty){
              vec_WxEmpty.addElement((WxEmpty)contents[i]);
          }
          
          if(contents[i] instanceof WxSp){
              vec_WxSp.addElement((WxSp)contents[i]);
          }
          
          if(contents[i] instanceof WxNl){
              vec_WxNl.addElement((WxNl)contents[i]);
          }
          
          if(contents[i] instanceof WxComment){
              vec_WxComment.addElement((WxComment)contents[i]);
          }
          
          if(contents[i] instanceof WxScriptlet){
              vec_WxScriptlet.addElement((WxScriptlet)contents[i]);
          }
          
       }
    }
    

    
    /** ɤ */
    public String toSourceCode(){
       StringBuffer buffer = new StringBuffer();
       IAWxElementChoice[] contents = getContent();
       for(int i=0;i<contents.length;i++){
           buffer.append(((IXObject)contents[i]).toSourceCode());
       }
       return buffer.toString();
    }
    
    

    /** ֥Ȥ̾ */
    public String getObjectName(){
       String fullObjName = getClass().getName();
       return fullObjName.substring(fullObjName.lastIndexOf(".")+1).substring(2);
    }
    /** XObject̾ */
    public String getXObjectName(){
       String fullObjName = getClass().getName();
       return fullObjName.substring(fullObjName.lastIndexOf(".")+1);
    }

    
    /**
     * ־򥻥å 
     * @return int ֥ȤĹ      
     */
    public int setPosition(XObjectPositionFactory factory){
       int len = 0;
       IAWxElementChoice[] contents = getContent();
       pos = factory.createPosition();
       for(int i=0;i<contents.length;i++){
            len += ((IXObject)contents[i]).setPosition(factory);         
       }
       factory.setEndPosition(pos);
       pos.setLength(len);
       return len;
    }
    
    

    /** եåȤ֤ */
    public int getCOffset(){
        return pos.getOffset();
    }

    /** Ĺ֤ */
    public int getCLength(){
        return pos.getLength();
    }    

    /** ϤιԤ֤ */
    public int getStartLine(){
        return pos.getStartLine();
    }

    /** Ϥ֤ */
    public int getStartColumn(){
        return pos.getStartColumn();
    }

    /** ιԤ֤ */
    public int getEndLine(){
        return pos.getEndLine();
    }

    /** ֤ */
    public int getEndColumn(){
        return pos.getEndColumn();
    }

}
