
package wapid.wxmodel.wxmodelar;

import wapid.wxmodel.abstractwxmodelar.*;

import java.util.*;

public class WxFile extends AWxFile implements IXObject
{

    /** ƥ֥Ȥݻ */
    private IXObject parentObject = null;

    /** ־ݻ륯饹 */
    private XObjectPosition pos = null;

    /** WxXMLDeclݻ */
    private Vector vec_WxXMLDecl = null;
    /** WxDoctypeDeclݻ */
    private Vector vec_WxDoctypeDecl = null;
    /** WxStyleSheetݻ */
    private Vector vec_WxStyleSheet = null;
    /** WxElementݻ */
    private Vector vec_WxElement = null;
    /** WxSpݻ */
    private Vector vec_WxSp = null;
    /** WxNlݻ */
    private Vector vec_WxNl = null;
    /** WxCommentݻ */
    private Vector vec_WxComment = null;
    /** WxScriptletݻ */
    private Vector vec_WxScriptlet = null;
    

    
    /** ҥΡɤ˿ƥΡɤ򥻥åȤ */
    public void setParentObject(IXObject parentObject){
       this.parentObject = parentObject;
       IAWxFileChoice[] contents = getContent();
       for(int i=0;i<contents.length;i++){
           ((IXObject)contents[i]).setParentObject(this);
       }
    }
    
    

    /** ƥΡɤ֤ */
    public IXObject getParentObject(){
       return parentObject;
    }


    
    
    /** WxXMLDecl Υƥ졼 */
    public Iterator  getWxXMLDeclIterator(){
        if(vec_WxXMLDecl==null){
            divideXObject();
        }
        return vec_WxXMLDecl.iterator();
    }
    /** WxXMLDecl[] ֥Ȥ  */
    public WxXMLDecl[] getWxXMLDecls(){
        WxXMLDecl[] ret_obj;
        if(vec_WxXMLDecl==null){
            divideXObject();
        }
        ret_obj = new WxXMLDecl[vec_WxXMLDecl.size()];
        for(int i=0;i<vec_WxXMLDecl.size();i++){
            ret_obj[i] = (WxXMLDecl)vec_WxXMLDecl.elementAt(i);
        }
        return ret_obj;
    }
    
    /** WxDoctypeDecl Υƥ졼 */
    public Iterator  getWxDoctypeDeclIterator(){
        if(vec_WxDoctypeDecl==null){
            divideXObject();
        }
        return vec_WxDoctypeDecl.iterator();
    }
    /** WxDoctypeDecl[] ֥Ȥ  */
    public WxDoctypeDecl[] getWxDoctypeDecls(){
        WxDoctypeDecl[] ret_obj;
        if(vec_WxDoctypeDecl==null){
            divideXObject();
        }
        ret_obj = new WxDoctypeDecl[vec_WxDoctypeDecl.size()];
        for(int i=0;i<vec_WxDoctypeDecl.size();i++){
            ret_obj[i] = (WxDoctypeDecl)vec_WxDoctypeDecl.elementAt(i);
        }
        return ret_obj;
    }
    
    /** WxStyleSheet Υƥ졼 */
    public Iterator  getWxStyleSheetIterator(){
        if(vec_WxStyleSheet==null){
            divideXObject();
        }
        return vec_WxStyleSheet.iterator();
    }
    /** WxStyleSheet[] ֥Ȥ  */
    public WxStyleSheet[] getWxStyleSheets(){
        WxStyleSheet[] ret_obj;
        if(vec_WxStyleSheet==null){
            divideXObject();
        }
        ret_obj = new WxStyleSheet[vec_WxStyleSheet.size()];
        for(int i=0;i<vec_WxStyleSheet.size();i++){
            ret_obj[i] = (WxStyleSheet)vec_WxStyleSheet.elementAt(i);
        }
        return ret_obj;
    }
    
    /** WxElement Υƥ졼 */
    public Iterator  getWxElementIterator(){
        if(vec_WxElement==null){
            divideXObject();
        }
        return vec_WxElement.iterator();
    }
    /** WxElement[] ֥Ȥ  */
    public WxElement[] getWxElements(){
        WxElement[] ret_obj;
        if(vec_WxElement==null){
            divideXObject();
        }
        ret_obj = new WxElement[vec_WxElement.size()];
        for(int i=0;i<vec_WxElement.size();i++){
            ret_obj[i] = (WxElement)vec_WxElement.elementAt(i);
        }
        return ret_obj;
    }
    
    /** WxSp Υƥ졼 */
    public Iterator  getWxSpIterator(){
        if(vec_WxSp==null){
            divideXObject();
        }
        return vec_WxSp.iterator();
    }
    /** WxSp[] ֥Ȥ  */
    public WxSp[] getWxSps(){
        WxSp[] ret_obj;
        if(vec_WxSp==null){
            divideXObject();
        }
        ret_obj = new WxSp[vec_WxSp.size()];
        for(int i=0;i<vec_WxSp.size();i++){
            ret_obj[i] = (WxSp)vec_WxSp.elementAt(i);
        }
        return ret_obj;
    }
    
    /** WxNl Υƥ졼 */
    public Iterator  getWxNlIterator(){
        if(vec_WxNl==null){
            divideXObject();
        }
        return vec_WxNl.iterator();
    }
    /** WxNl[] ֥Ȥ  */
    public WxNl[] getWxNls(){
        WxNl[] ret_obj;
        if(vec_WxNl==null){
            divideXObject();
        }
        ret_obj = new WxNl[vec_WxNl.size()];
        for(int i=0;i<vec_WxNl.size();i++){
            ret_obj[i] = (WxNl)vec_WxNl.elementAt(i);
        }
        return ret_obj;
    }
    
    /** WxComment Υƥ졼 */
    public Iterator  getWxCommentIterator(){
        if(vec_WxComment==null){
            divideXObject();
        }
        return vec_WxComment.iterator();
    }
    /** WxComment[] ֥Ȥ  */
    public WxComment[] getWxComments(){
        WxComment[] ret_obj;
        if(vec_WxComment==null){
            divideXObject();
        }
        ret_obj = new WxComment[vec_WxComment.size()];
        for(int i=0;i<vec_WxComment.size();i++){
            ret_obj[i] = (WxComment)vec_WxComment.elementAt(i);
        }
        return ret_obj;
    }
    
    /** WxScriptlet Υƥ졼 */
    public Iterator  getWxScriptletIterator(){
        if(vec_WxScriptlet==null){
            divideXObject();
        }
        return vec_WxScriptlet.iterator();
    }
    /** WxScriptlet[] ֥Ȥ  */
    public WxScriptlet[] getWxScriptlets(){
        WxScriptlet[] ret_obj;
        if(vec_WxScriptlet==null){
            divideXObject();
        }
        ret_obj = new WxScriptlet[vec_WxScriptlet.size()];
        for(int i=0;i<vec_WxScriptlet.size();i++){
            ret_obj[i] = (WxScriptlet)vec_WxScriptlet.elementAt(i);
        }
        return ret_obj;
    }
    
    

    
    /** XObject ʬ */
    private void divideXObject(){
       vec_WxXMLDecl = new Vector();
       vec_WxDoctypeDecl = new Vector();
       vec_WxStyleSheet = new Vector();
       vec_WxElement = new Vector();
       vec_WxSp = new Vector();
       vec_WxNl = new Vector();
       vec_WxComment = new Vector();
       vec_WxScriptlet = new Vector();
       

       IAWxFileChoice[] contents = getContent();
       for(int i=0;i<contents.length;i++){
          
          if(contents[i] instanceof WxXMLDecl){
              vec_WxXMLDecl.addElement((WxXMLDecl)contents[i]);
          }
          
          if(contents[i] instanceof WxDoctypeDecl){
              vec_WxDoctypeDecl.addElement((WxDoctypeDecl)contents[i]);
          }
          
          if(contents[i] instanceof WxStyleSheet){
              vec_WxStyleSheet.addElement((WxStyleSheet)contents[i]);
          }
          
          if(contents[i] instanceof WxElement){
              vec_WxElement.addElement((WxElement)contents[i]);
          }
          
          if(contents[i] instanceof WxSp){
              vec_WxSp.addElement((WxSp)contents[i]);
          }
          
          if(contents[i] instanceof WxNl){
              vec_WxNl.addElement((WxNl)contents[i]);
          }
          
          if(contents[i] instanceof WxComment){
              vec_WxComment.addElement((WxComment)contents[i]);
          }
          
          if(contents[i] instanceof WxScriptlet){
              vec_WxScriptlet.addElement((WxScriptlet)contents[i]);
          }
          
       }
    }
    

    
    /** ɤ */
    public String toSourceCode(){
       StringBuffer buffer = new StringBuffer();
       IAWxFileChoice[] contents = getContent();
       for(int i=0;i<contents.length;i++){
           buffer.append(((IXObject)contents[i]).toSourceCode());
       }
       return buffer.toString();
    }
    
    

    /** ֥Ȥ̾ */
    public String getObjectName(){
       String fullObjName = getClass().getName();
       return fullObjName.substring(fullObjName.lastIndexOf(".")+1).substring(2);
    }
    /** XObject̾ */
    public String getXObjectName(){
       String fullObjName = getClass().getName();
       return fullObjName.substring(fullObjName.lastIndexOf(".")+1);
    }

    
    /**
     * ־򥻥å 
     * @return int ֥ȤĹ      
     */
    public int setPosition(XObjectPositionFactory factory){
       int len = 0;
       IAWxFileChoice[] contents = getContent();
       pos = factory.createPosition();
       for(int i=0;i<contents.length;i++){
            len += ((IXObject)contents[i]).setPosition(factory);         
       }
       factory.setEndPosition(pos);
       pos.setLength(len);
       return len;
    }
    
    

    /** եåȤ֤ */
    public int getCOffset(){
        return pos.getOffset();
    }

    /** Ĺ֤ */
    public int getCLength(){
        return pos.getLength();
    }    

    /** ϤιԤ֤ */
    public int getStartLine(){
        return pos.getStartLine();
    }

    /** Ϥ֤ */
    public int getStartColumn(){
        return pos.getStartColumn();
    }

    /** ιԤ֤ */
    public int getEndLine(){
        return pos.getEndLine();
    }

    /** ֤ */
    public int getEndColumn(){
        return pos.getEndColumn();
    }

}
