
package wapid.wxmodel.wxmodelar;

import wapid.wxmodel.abstractwxmodelar.*;

import java.util.*;

public class WxString extends AWxString implements IXObject
{

    /** ƥ֥Ȥݻ */
    private IXObject parentObject = null;

    /** ־ݻ륯饹 */
    private XObjectPosition pos = null;

    /** WxDquoteݻ */
    private Vector vec_WxDquote = null;
    /** WxSquoteݻ */
    private Vector vec_WxSquote = null;
    /** WxTextݻ */
    private Vector vec_WxText = null;
    /** WxSpݻ */
    private Vector vec_WxSp = null;
    /** WxNlݻ */
    private Vector vec_WxNl = null;
    /** WxCommentݻ */
    private Vector vec_WxComment = null;
    /** WxScriptletݻ */
    private Vector vec_WxScriptlet = null;
    

    
    /** ҥΡɤ˿ƥΡɤ򥻥åȤ */
    public void setParentObject(IXObject parentObject){
       this.parentObject = parentObject;
       IAWxStringChoice[] contents = getContent();
       for(int i=0;i<contents.length;i++){
           ((IXObject)contents[i]).setParentObject(this);
       }
    }
    
    

    /** ƥΡɤ֤ */
    public IXObject getParentObject(){
       return parentObject;
    }


    
    
    /** WxDquote Υƥ졼 */
    public Iterator  getWxDquoteIterator(){
        if(vec_WxDquote==null){
            divideXObject();
        }
        return vec_WxDquote.iterator();
    }
    /** WxDquote[] ֥Ȥ  */
    public WxDquote[] getWxDquotes(){
        WxDquote[] ret_obj;
        if(vec_WxDquote==null){
            divideXObject();
        }
        ret_obj = new WxDquote[vec_WxDquote.size()];
        for(int i=0;i<vec_WxDquote.size();i++){
            ret_obj[i] = (WxDquote)vec_WxDquote.elementAt(i);
        }
        return ret_obj;
    }
    
    /** WxSquote Υƥ졼 */
    public Iterator  getWxSquoteIterator(){
        if(vec_WxSquote==null){
            divideXObject();
        }
        return vec_WxSquote.iterator();
    }
    /** WxSquote[] ֥Ȥ  */
    public WxSquote[] getWxSquotes(){
        WxSquote[] ret_obj;
        if(vec_WxSquote==null){
            divideXObject();
        }
        ret_obj = new WxSquote[vec_WxSquote.size()];
        for(int i=0;i<vec_WxSquote.size();i++){
            ret_obj[i] = (WxSquote)vec_WxSquote.elementAt(i);
        }
        return ret_obj;
    }
    
    /** WxText Υƥ졼 */
    public Iterator  getWxTextIterator(){
        if(vec_WxText==null){
            divideXObject();
        }
        return vec_WxText.iterator();
    }
    /** WxText[] ֥Ȥ  */
    public WxText[] getWxTexts(){
        WxText[] ret_obj;
        if(vec_WxText==null){
            divideXObject();
        }
        ret_obj = new WxText[vec_WxText.size()];
        for(int i=0;i<vec_WxText.size();i++){
            ret_obj[i] = (WxText)vec_WxText.elementAt(i);
        }
        return ret_obj;
    }
    
    /** WxSp Υƥ졼 */
    public Iterator  getWxSpIterator(){
        if(vec_WxSp==null){
            divideXObject();
        }
        return vec_WxSp.iterator();
    }
    /** WxSp[] ֥Ȥ  */
    public WxSp[] getWxSps(){
        WxSp[] ret_obj;
        if(vec_WxSp==null){
            divideXObject();
        }
        ret_obj = new WxSp[vec_WxSp.size()];
        for(int i=0;i<vec_WxSp.size();i++){
            ret_obj[i] = (WxSp)vec_WxSp.elementAt(i);
        }
        return ret_obj;
    }
    
    /** WxNl Υƥ졼 */
    public Iterator  getWxNlIterator(){
        if(vec_WxNl==null){
            divideXObject();
        }
        return vec_WxNl.iterator();
    }
    /** WxNl[] ֥Ȥ  */
    public WxNl[] getWxNls(){
        WxNl[] ret_obj;
        if(vec_WxNl==null){
            divideXObject();
        }
        ret_obj = new WxNl[vec_WxNl.size()];
        for(int i=0;i<vec_WxNl.size();i++){
            ret_obj[i] = (WxNl)vec_WxNl.elementAt(i);
        }
        return ret_obj;
    }
    
    /** WxComment Υƥ졼 */
    public Iterator  getWxCommentIterator(){
        if(vec_WxComment==null){
            divideXObject();
        }
        return vec_WxComment.iterator();
    }
    /** WxComment[] ֥Ȥ  */
    public WxComment[] getWxComments(){
        WxComment[] ret_obj;
        if(vec_WxComment==null){
            divideXObject();
        }
        ret_obj = new WxComment[vec_WxComment.size()];
        for(int i=0;i<vec_WxComment.size();i++){
            ret_obj[i] = (WxComment)vec_WxComment.elementAt(i);
        }
        return ret_obj;
    }
    
    /** WxScriptlet Υƥ졼 */
    public Iterator  getWxScriptletIterator(){
        if(vec_WxScriptlet==null){
            divideXObject();
        }
        return vec_WxScriptlet.iterator();
    }
    /** WxScriptlet[] ֥Ȥ  */
    public WxScriptlet[] getWxScriptlets(){
        WxScriptlet[] ret_obj;
        if(vec_WxScriptlet==null){
            divideXObject();
        }
        ret_obj = new WxScriptlet[vec_WxScriptlet.size()];
        for(int i=0;i<vec_WxScriptlet.size();i++){
            ret_obj[i] = (WxScriptlet)vec_WxScriptlet.elementAt(i);
        }
        return ret_obj;
    }
    
    

    
    /** XObject ʬ */
    private void divideXObject(){
       vec_WxDquote = new Vector();
       vec_WxSquote = new Vector();
       vec_WxText = new Vector();
       vec_WxSp = new Vector();
       vec_WxNl = new Vector();
       vec_WxComment = new Vector();
       vec_WxScriptlet = new Vector();
       

       IAWxStringChoice[] contents = getContent();
       for(int i=0;i<contents.length;i++){
          
          if(contents[i] instanceof WxDquote){
              vec_WxDquote.addElement((WxDquote)contents[i]);
          }
          
          if(contents[i] instanceof WxSquote){
              vec_WxSquote.addElement((WxSquote)contents[i]);
          }
          
          if(contents[i] instanceof WxText){
              vec_WxText.addElement((WxText)contents[i]);
          }
          
          if(contents[i] instanceof WxSp){
              vec_WxSp.addElement((WxSp)contents[i]);
          }
          
          if(contents[i] instanceof WxNl){
              vec_WxNl.addElement((WxNl)contents[i]);
          }
          
          if(contents[i] instanceof WxComment){
              vec_WxComment.addElement((WxComment)contents[i]);
          }
          
          if(contents[i] instanceof WxScriptlet){
              vec_WxScriptlet.addElement((WxScriptlet)contents[i]);
          }
          
       }
    }
    

    
    /** ɤ */
    public String toSourceCode(){
       StringBuffer buffer = new StringBuffer();
       IAWxStringChoice[] contents = getContent();
       for(int i=0;i<contents.length;i++){
           buffer.append(((IXObject)contents[i]).toSourceCode());
       }
       return buffer.toString();
    }
    
    

    /** ֥Ȥ̾ */
    public String getObjectName(){
       String fullObjName = getClass().getName();
       return fullObjName.substring(fullObjName.lastIndexOf(".")+1).substring(2);
    }
    /** XObject̾ */
    public String getXObjectName(){
       String fullObjName = getClass().getName();
       return fullObjName.substring(fullObjName.lastIndexOf(".")+1);
    }

    
    /**
     * ־򥻥å 
     * @return int ֥ȤĹ      
     */
    public int setPosition(XObjectPositionFactory factory){
       int len = 0;
       IAWxStringChoice[] contents = getContent();
       pos = factory.createPosition();
       for(int i=0;i<contents.length;i++){
            len += ((IXObject)contents[i]).setPosition(factory);         
       }
       factory.setEndPosition(pos);
       pos.setLength(len);
       return len;
    }
    
    

    /** եåȤ֤ */
    public int getCOffset(){
        return pos.getOffset();
    }

    /** Ĺ֤ */
    public int getCLength(){
        return pos.getLength();
    }    

    /** ϤιԤ֤ */
    public int getStartLine(){
        return pos.getStartLine();
    }

    /** Ϥ֤ */
    public int getStartColumn(){
        return pos.getStartColumn();
    }

    /** ιԤ֤ */
    public int getEndLine(){
        return pos.getEndLine();
    }

    /** ֤ */
    public int getEndColumn(){
        return pos.getEndColumn();
    }

}
