package wapid.xhtml;

import java.io.*;
import java.util.*;
import wapid.parser.xhtml.*;

public class Access {
    //    void load(){
    ArrayList wextents = new ArrayList();



    public void load(String sdbname) {
        String sdbdir = new String("SDB/W-MODEL/" + sdbname);
        loadFile(sdbdir);
        loadNode(sdbdir);

        loadAttribute(sdbdir);
        loadTag(sdbdir);
        loadFile_Node(sdbdir);
        loadNode_Attri(sdbdir);
        loadPnode_Cnode(sdbdir);
        loadNode_Tag(sdbdir);
    }
    /*    public void loadWithoutComment(String sdbname){
        String sdbdir = new String("SDB/W-MODEL/"+sdbname);
        loadFile(sdbdir);
        ///             loadNode(sdbdir);
                        loadNodeWithoutComment(sdbdir);
        loadAttribute(sdbdir);
        loadTag(sdbdir);
        loadFile_Node(sdbdir);
        loadNode_Attri(sdbdir);
        loadPnode_Cnode(sdbdir);
        loadNode_Tag(sdbdir);
    }
    */
    void loadFile(String sdbdir) {
        String file = new String();
        try {
            BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(sdbdir + "/File")));
            file = br.readLine();
            WpdFile wf = new WpdFile(Integer.parseInt(file.substring(0,SimpleNode.IDLENGTH)),0,0);
            wf.setName(file.substring(SimpleNode.LENGTH));
            wf.setClassName("File");
            //      wextents.put(new String(Integer.toString(wf.getId())),wf);
            wextents.add(wf);
        } catch(Exception e) {System.out.println("*" + e.getMessage());}
    }

    void loadNode(String sdbdir) {
        try {
            String Node;
            BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(sdbdir + "/Node")));
            while ((Node = br.readLine()) != null) {
                WpdNode wn = new WpdElement();;
                    
                switch(Integer.parseInt(Node.substring(SimpleNode.LENGTH,SimpleNode.LENGTH + 1))) {
                case SimpleNode.ELEMENT:
                    wn = new WpdElement(Node);
                    wn.setClassName("Element");break;
                    //              wn.setSort(Wnode.ELEMENT);break;
                case SimpleNode.TEXT:
                    wn = new WpdText(Node);
                    wn.setClassName("Text");
                    //              wn.setSort(Wnode.TEXT);
                    String s = Node.substring(SimpleNode.LENGTH + 1);
                    int length = Integer.parseInt(Node.substring(SimpleNode.IDLENGTH + SimpleNode.COFFSETLENGTH,SimpleNode.IDLENGTH + SimpleNode.COFFSETLENGTH + SimpleNode.CLENGTHLENGTH));
                    while (length > s.length()) {
                        Node = br.readLine();
                        s = s.concat("\n");
                        s = s.concat(Node);
                    }
                    wn.addText(s);break;
                case SimpleNode.SCRIPT:
                    wn = new WpdScript(Node);
                    wn.setClassName("Script");
                    //              wn.setSort(Wnode.SCRIPTLET);
                    s = Node.substring(SimpleNode.LENGTH + 1);
                    length = Integer.parseInt(Node.substring(SimpleNode.IDLENGTH + SimpleNode.COFFSETLENGTH,SimpleNode.IDLENGTH + SimpleNode.COFFSETLENGTH + SimpleNode.CLENGTHLENGTH));
                    while (length > s.length()) {
                        Node = br.readLine();
                        s = s.concat("\n");
                        s = s.concat(Node);
                    }
                    wn.setScript(s);break;
                case SimpleNode.XMLDECL:
                    wn = new WpdXMLDecl(Node);
                    wn.setClassName("Xmldecl");break;
                    //              wn.setSort(Wnode.XMLDECL);break;
                case SimpleNode.DOCTYPEDECL:
                    wn = new WpdDoctypeDecl(Node);
                    wn.setClassName("Doctypedecl");
                    //              wn.setSort(Wnode.DOCTYPEDECL);
                    wn.setDoctypeVal(Node.substring(SimpleNode.LENGTH + 1));break;
                case SimpleNode.COMMENT:
                    wn = new WpdComment(Node);
                    wn.setClassName("Comment");
                    //              wn.setSort(Wnode.DOCTYPEDECL);
                    s = Node.substring(SimpleNode.LENGTH + 1);
                    length = Integer.parseInt(Node.substring(SimpleNode.IDLENGTH + SimpleNode.COFFSETLENGTH,SimpleNode.IDLENGTH + SimpleNode.COFFSETLENGTH + SimpleNode.CLENGTHLENGTH));
                    while (length > s.length()) {
                        Node = br.readLine();
                        s = s.concat("\n");
                        s = s.concat(Node);
                    }
                    wn.setComment(s);break;
                }
                wextents.add(wn);
            }
        } catch(Exception e) {System.out.println("2" + e.getMessage());}
    }

    void loadAttribute(String sdbdir) {

        try { 
            String Attri;
            BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(sdbdir + "/Attribute")));

            while ((Attri = br.readLine()) != null) {
                WpdAttribute wa = new WpdAttribute(Attri);
                wa.setClassName("Attri");

                String s = Attri.substring(SimpleNode.LENGTH);
                int length = Integer.parseInt(Attri.substring(SimpleNode.IDLENGTH + SimpleNode.COFFSETLENGTH,SimpleNode.IDLENGTH + SimpleNode.COFFSETLENGTH + SimpleNode.CLENGTHLENGTH));
                while (length > s.length()) {
                    Attri = br.readLine();
                    s = s.concat("\n");
                    s = s.concat(Attri);
                }
                // wn.addText(s); break;

                wa.setNameAndValue(s);
                wextents.add(wa);
            }
        } catch(Exception e) {System.out.println("1" + e.getMessage());}
    }

    void loadTag(String sdbdir) {

        try { 
            String Tag;
            BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(sdbdir + "/Tag")));
            while ((Tag = br.readLine()) != null) {
                WpdTag wt = new WpdStartTag();
                switch(Integer.parseInt(Tag.substring(SimpleNode.LENGTH,SimpleNode.LENGTH + 1))) {
                case SimpleNode.STARTTAG:
                    wt = new WpdStartTag(Tag);
                    wt.setClassName("Starttag");break;
                    //              wt.setSort(Wpdtag.STARTTAG);break;
                case SimpleNode.ENDTAG:
                    wt = new WpdEndTag(Tag);
                    wt.setClassName("Endtag");break;
                    //              wt.setSort(Wtag.ENDTAG);break;
                case SimpleNode.EMPTYTAG:
                    wt = new WpdEmptyTag(Tag);
                    wt.setClassName("Emptytag");break;
                    //              wt.setSort(Wtag.EMPTYTAG);break;
                }

                wt.setName(Tag.substring(SimpleNode.LENGTH + 1));
                wextents.add(wt);
            }
        } catch(Exception e) {System.out.println("3" + e.getMessage());}
    }

    void loadFile_Node(String sdbdir) {

        try {
            String file_node;
            BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(sdbdir + "/file_node")));

            while ((file_node = br.readLine()) != null) {
                WpdFile wf = new WpdFile();
                WpdNode wn = new WpdNode();
                int tmp1 = 0,tmp2 = 0;
                for(int i = 0;i < wextents.size();i++) {
                    WpdObject wo = (WpdObject)wextents.get(i);
                    if (Integer.parseInt(file_node.substring(0,SimpleNode.IDLENGTH)) == wo.getID()) {
                        wf = (WpdFile)wextents.get(i);tmp1 = i;
                        //                      wextents.removeRange(i,i + 1);
                    } else if (Integer.parseInt(file_node.substring(SimpleNode.LENGTH,SimpleNode.LENGTH + SimpleNode.IDLENGTH)) == wo.getID()) {
                        wn = (WpdNode)wextents.get(i);tmp2 = i;
                        //                      wextents.removeRange(i,i + 1);
                    }
                }


                if (wf.getID() != -1&&wn.getID() != -1) {
                wf.addNode(wn);
                wn.setParentObject(wf);
                wextents.set(tmp1,wf);
                //new String(Integer.toString(wf.getId())),wf);
                wextents.set(tmp2,wn);
                //new String(Integer.toString(wn.getId())),wn);
                }
            }
            
        } catch(Exception e) {System.out.println("5" + e.getMessage());}
    }

    void loadNode_Attri(String sdbdir) {

        try {
            String node_attri;
            BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(sdbdir + "/node_attri")));

            while ((node_attri = br.readLine()) != null) {
                WpdNode wn = new WpdNode();
                WpdAttribute wa = new WpdAttribute();
                int tmp = 0;
                for(int i = 0;i < wextents.size();i++) {
                    WpdObject wo = (WpdObject)wextents.get(i);
                    if (Integer.parseInt(node_attri.substring(0,SimpleNode.IDLENGTH)) == wo.getID()) {
                        wn = (WpdNode)wextents.get(i);tmp = i;
                        //                      wextents.removeRange(i,i + 1);
                    } else if (Integer.parseInt(node_attri.substring(SimpleNode.LENGTH,SimpleNode.LENGTH + SimpleNode.IDLENGTH)) == wo.getID()) {
                        wa = (WpdAttribute)wextents.get(i);
                    } 
                }



                if (wn.getID() != -1&&wa.getID() != -1) {
                wn.addAttribute(wa);

                wextents.set(tmp,wn);//put(new String(Integer.toString(wn.getId())),wn);
                }
            }
        } catch(Exception e) {System.out.println("w" + e.getMessage());}
    }

    void loadPnode_Cnode(String sdbdir) {

        try {
            String pnode_cnode;
            BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(sdbdir + "/pnode_cnode")));
            while ((pnode_cnode = br.readLine()) != null) {
                WpdNode wn1 = new WpdNode();
                WpdNode wn2 = new WpdNode();
                int tmp1 = 0,tmp2 = 0;
                for (int i = 0;i < wextents.size();i++) {
                    WpdObject wo = (WpdObject)wextents.get(i);
                    if (Integer.parseInt(pnode_cnode.substring(0,SimpleNode.IDLENGTH)) == wo.getID()) {
                        wn1 = (WpdNode)wextents.get(i);tmp1 = i;
                        //                      wextents.removeRange(i,i+1);
                    } else if (Integer.parseInt(pnode_cnode.substring(SimpleNode.LENGTH,SimpleNode.LENGTH + SimpleNode.IDLENGTH)) == wo.getID()) {
                        wn2 = (WpdNode)wextents.get(i);tmp2 = i;
                        //                      wextents.removeRange(i,i+1);
                    }
                }



                if (wn1.getID() != -1&&wn2.getID() != -1) {
                wn1.addChildNode(wn2);
                wn2.setParentObject(wn1);
                wextents.set(tmp1,wn1);
                wextents.set(tmp2,wn2);
                }

            }
        } catch(Exception e) {System.out.println("e" + e.getMessage());}
    }

    void loadNode_Tag(String sdbdir) {

        try {
            String node_tag;
            BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(sdbdir + "/node_tag")));

            while ((node_tag = br.readLine()) != null) {
                WpdElement we = new WpdElement();
                WpdTag wt = new WpdTag();
                int tmp1 = 0,tmp2 = 0;
                for(int i = 0;i < wextents.size();i++) {
                    WpdObject wo = (WpdObject)wextents.get(i);

                    if (Integer.parseInt(node_tag.substring(0,SimpleNode.IDLENGTH)) == wo.getID()) {
                        we = (WpdElement)wextents.get(i);tmp1 = i;
                        //                      wextents.removeRange(i,i + 1);
                    } else if (Integer.parseInt(node_tag.substring(SimpleNode.LENGTH,SimpleNode.LENGTH + SimpleNode.IDLENGTH)) == wo.getID()) {
                        wt = (WpdTag)wextents.get(i);tmp2 = i;
                    }
                }

                    //          WpdNode wn=(WpdNode)wextents.get(Integer.toString(Integer.parseInt(node_tag.substring(0,4))));
                    //          WpdTag wt=(WpdTag)wextents.get(Integer.toString(Integer.parseInt(node_tag.substring(12,16))));
                if (we.getID() != -1&&wt.getID() != -1) {
                we.addTag(wt);
		wt.setParentElement(we);
                wextents.set(tmp1,we);
                wextents.set(tmp2,wt);
                }
                //              wextents.put(new String(Integer.toString(wn.getId())),wn);
            }
        } catch(Exception e) {System.out.println("q" + e.getMessage());}

    }




    void loadNodeWithoutComment(String sdbdir) {
        try {
            String Node;
            BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(sdbdir + "/Node")));
            while ((Node = br.readLine()) != null) {
                WpdNode wn = new WpdElement();;
                    
                switch(Integer.parseInt(Node.substring(SimpleNode.LENGTH,SimpleNode.LENGTH + 1))) {
                case SimpleNode.ELEMENT:
                    wn = new WpdElement(Node);
                    wn.setClassName("Element");break;
                    //              wn.setSort(Wnode.ELEMENT);break;
                case SimpleNode.TEXT:
                    wn = new WpdText(Node);
                    wn.setClassName("Text");
                    //              wn.setSort(Wnode.TEXT);
                    String s = Node.substring(SimpleNode.LENGTH + 1);
                    int length = Integer.parseInt(Node.substring(SimpleNode.IDLENGTH + SimpleNode.COFFSETLENGTH,SimpleNode.IDLENGTH + SimpleNode.COFFSETLENGTH + SimpleNode.CLENGTHLENGTH));
                    while (length > s.length()) {
                        Node = br.readLine();
                        s = s.concat("\n");
                        s = s.concat(Node);
                    }
                    String Node2;

                    boolean flag = true;//äĤ줿
                    while (flag) {
                        BufferedReader br2 = new BufferedReader(new InputStreamReader(new FileInputStream(sdbdir + "/Node")));
                        while ((Node2 = br2.readLine()) != null) {         //ȤƤäĤ롣
                            String tmp = Node2;
                            String s3 = Node2.substring(SimpleNode.LENGTH + 1);
                            int length3 = Integer.parseInt(Node2.substring(SimpleNode.IDLENGTH + SimpleNode.COFFSETLENGTH,SimpleNode.IDLENGTH + SimpleNode.COFFSETLENGTH + SimpleNode.CLENGTHLENGTH));            //ԤΤȤϤȤФ
                            while (length3 > s3.length()) {
                                Node2 = br2.readLine();
                                s3 = s3.concat("\n");
                                s3 = s3.concat(Node2);
                            }
                            Node2 = tmp;


                            if (Integer.parseInt(Node2.substring(SimpleNode.IDLENGTH,SimpleNode.IDLENGTH + SimpleNode.COFFSETLENGTH))
                                == wn.getOffset() + wn.getLength()  ) {
                                if (Integer.parseInt(Node2.substring(SimpleNode.LENGTH,SimpleNode.LENGTH + 1)) == SimpleNode.COMMENT) {
                                    wn.setLength(wn.getLength() + Integer.parseInt(Node2.substring(SimpleNode.IDLENGTH + SimpleNode.COFFSETLENGTH,
                                                                                                 SimpleNode.IDLENGTH + SimpleNode.COFFSETLENGTH + SimpleNode.CLENGTHLENGTH)));

                                    flag = true;break;
                                }
                                if (Integer.parseInt(Node2.substring(SimpleNode.LENGTH,SimpleNode.LENGTH + 1)) == SimpleNode.TEXT) {
                                    wn.setLength(wn.getLength() + Integer.parseInt(Node2.substring(SimpleNode.IDLENGTH + SimpleNode.COFFSETLENGTH,SimpleNode.IDLENGTH + SimpleNode.COFFSETLENGTH + SimpleNode.CLENGTHLENGTH)));

                                    String s2 = Node2.substring(SimpleNode.LENGTH + 1);
                                    int length2 = Integer.parseInt(Node2.substring(SimpleNode.IDLENGTH + SimpleNode.COFFSETLENGTH,SimpleNode.IDLENGTH + SimpleNode.COFFSETLENGTH + SimpleNode.CLENGTHLENGTH));
                                    while (length2 > s2.length()) {
                                        Node2 = br2.readLine();
                                        s2 = s2.concat("\n");
                                        s2 = s2.concat(Node2);
                                    }                           
                                    s = s.concat(s2);
                                    flag = true;break;
                                }
                            }
                        }
                        flag = false;
                    }
                            
                                        

                    wn.addText(s);

                    break;
                case SimpleNode.SCRIPT:
                    wn = new WpdScript(Node);
                    wn.setClassName("Script");
                    //              wn.setSort(Wnode.SCRIPTLET);
                    s = Node.substring(SimpleNode.LENGTH + 1);
                    length = Integer.parseInt(Node.substring(SimpleNode.IDLENGTH + SimpleNode.COFFSETLENGTH,SimpleNode.IDLENGTH + SimpleNode.COFFSETLENGTH + SimpleNode.CLENGTHLENGTH));
                    while (length > s.length()) {
                        Node = br.readLine();
                        s = s.concat("\n");
                        s = s.concat(Node);
                    }
                    wn.setScript(s);break;
                case SimpleNode.XMLDECL:
                    wn = new WpdXMLDecl(Node);
                    wn.setClassName("Xmldecl");break;
                    //              wn.setSort(Wnode.XMLDECL);break;
                case SimpleNode.DOCTYPEDECL:
                    wn = new WpdDoctypeDecl(Node);
                    wn.setClassName("Doctypedecl");
                    //              wn.setSort(Wnode.DOCTYPEDECL);
                    wn.setDoctypeVal(Node.substring(SimpleNode.LENGTH + 1));break;
                }
                wextents.add(wn);
            }
        } catch(Exception e) {
            StringWriter sw = null;
            PrintWriter pw = null;
            sw = new StringWriter();
            pw = new PrintWriter(sw);
            e.printStackTrace(pw);
            System.out.println(e.getMessage() + sw.toString());
        }
    }






    public Iterator getObjects(String classname) {
        //      Hashtable hash = new Hashtable();
        ArrayList list = new ArrayList();
        String s;

        for(Iterator i = wextents.iterator();i.hasNext();) {
            WpdObject wo = (WpdObject)i.next();
            if (classname.equals(wo.getClassName())) {
                list.add(wo);
            }
        }
        return list.iterator();
    }

    public Iterator getAllObjects() {
        return wextents.iterator();
    }
}

