package wapid.xhtml;

import java.util.*;
public class WpdNode extends WpdObject {
    ArrayList attri;
    ArrayList cnode = new ArrayList();
    WpdObject pnode;

    public WpdNode(int a,int b,int c) {
        super(a,b,c);
        attri = new ArrayList();


    }

    public WpdNode() {
        super();
    }

    public WpdNode(String s) {
        super(s);
        attri = new ArrayList();

    }

    void addAttribute(WpdAttribute wa) {
        attri.add(wa);
    }
    public Iterator getAttributes() {
        return attri.iterator();
    }
    public Iterator getAttributesOffsetOrder() {
        ArrayList list = new ArrayList(attri);
        Collections.sort(list);
        /*
        WpdAttribute[] wa=(WpdAttribute[])attri.toArray(new WpdAttribute[0]);
        Arrays.sort(wa);
        ArrayList list=new ArrayList();
        for(int i=0;i<wa.length;i++) {
            list.add(wa[i]);
            }*/
        return list.iterator();
    }

    
    void setParentObject(WpdObject wo) {
        pnode = wo;
    }
    public WpdObject getParentObject() {
        return pnode;
    }

    void addChildNode(WpdNode wn) {
        cnode.add(wn);
    }


    public Iterator getChildNodes() {
        return cnode.iterator();
    }
    public Iterator getChildNodesOffsetOrder() {
        ArrayList list = new ArrayList(cnode);
        Collections.sort(list);
        /*
        WpdNode[] wn=(WpdNode[])cnode.toArray(new WpdNode[0]);
        Arrays.sort(wn);
        ArrayList list=new ArrayList();
        for(int i=0;i<wn.length;i++) {
            list.add(wn[i]);
            }*/
        return list.iterator();
    }
    public Iterator getChildNodesWithoutComment() {
        LinkedList cnodewithoutcomm = new LinkedList(cnode);
        boolean flag = true;
        while(flag) {
            for(int i = 0;i < cnodewithoutcomm.size();i++) {
                WpdNode wn1 = (WpdNode)cnodewithoutcomm.get(i);
                if (wn1.getClassName().equals("Comment") ||
                   wn1.getClassName().equals("Text")) {
                    for(int j = 0;j < cnodewithoutcomm.size();j++) {
                        WpdNode wn2 = (WpdNode)cnodewithoutcomm.get(j);
                        if (wn2.getOffset() + wn2.getLength() == wn1.getOffset()&&
                           wn2.getClassName().equals("Text")) {
                            if (wn1.getClassName().equals("Text")) {
                                wn2.addText(wn1.getText());
                                wn2.setLength(wn2.getLength() + wn1.getLength());
                                cnodewithoutcomm.remove(i);
                                cnodewithoutcomm.set(j,wn2);
                                flag = true;break;
                            } else if (wn1.getClassName().equals("Comment")) {
                                wn2.setLength(wn2.getLength() + wn1.getLength());
                                cnodewithoutcomm.remove(i);
                                cnodewithoutcomm.set(j,wn2);
                                flag = true;break;
                            }
                        }
                    }                   
                }
            }
            flag = false;
        }
        return cnodewithoutcomm.iterator();
    }
    public Iterator getChildNodesOffsetOrderWithoutComment() {
        LinkedList cnodewithoutcomm = new LinkedList(cnode);
        boolean flag = true;
        while(flag) {
            for(int i = 0;i < cnodewithoutcomm.size();i++) {
                WpdNode wn1 = (WpdNode)cnodewithoutcomm.get(i);
                if (wn1.getClassName().equals("Comment") ||
                   wn1.getClassName().equals("Text")) {
                    for(int j = 0;j < cnodewithoutcomm.size();j++) {
                        WpdNode wn2 = (WpdNode)cnodewithoutcomm.get(j);
                        if (wn2.getOffset() + wn2.getLength() == wn1.getOffset()&&
                           wn2.getClassName().equals("Text")) {
                            if (wn1.getClassName().equals("Text")) {
                                wn2.addText(wn1.getText());
                                wn2.setLength(wn2.getLength() + wn1.getLength());
                                cnodewithoutcomm.remove(i);
                                cnodewithoutcomm.set(j,wn2);
                                flag = true;break;
                            } else if(wn1.getClassName().equals("Comment")) {
                                wn2.setLength(wn2.getLength() + wn1.getLength());
                                cnodewithoutcomm.remove(i);
                                cnodewithoutcomm.set(j,wn2);
                                flag = true;break;
                            }
                        }
                    }                   
                }
            }
            flag = false;
        }
        ArrayList l = new ArrayList(cnodewithoutcomm);
        Collections.sort(l);
        return l.iterator();
    }






    void setComment(String text){}
    public String getComment(){return null;}
    void addTag(WpdTag wt){}
    public Iterator getTags(){return null;}
    void addText(String text){}
    public String getText(){return null;}
    //    public String getTextWithComment(){return null;}
    void setScript(String script){}
    public String getScript(){return null;}
    void setDoctypeVal(String val){}
    public Iterator getDoctypeVal(){return null;}
    public String getRootName() {return null;}
    public String getPublicOrSystem() {return null;}
	public String getPublicIdent() {return null;}
    public String getSystemIdent() {return null;}
    public String getInnerDtd() {return null;}
}

        
