package wapid.xhtml;

import wapid.parser.xhtml.*;
public class WpdObject extends Object implements Comparable {
    int id  = -1;;
    int coffset;
    int clength;
    String classname = new String();

    public WpdObject() {}
    public WpdObject(int id,int offset,int length) {
        this.id = id;
        coffset = offset;
        clength = length;
    }
    public WpdObject(String s) {
        id = Integer.parseInt(s.substring(0,SimpleNode.IDLENGTH));
        coffset = Integer.parseInt(s.substring(SimpleNode.IDLENGTH,SimpleNode.IDLENGTH + SimpleNode.COFFSETLENGTH));
        clength = Integer.parseInt(s.substring(SimpleNode.IDLENGTH + SimpleNode.COFFSETLENGTH,SimpleNode.LENGTH));
    }


    void setID(int id) {
        this.id = id;
    }
    public int getID() {
        return id;
    }

    void setClassName(String s) {
        classname = s;
    }
    public String getClassName() {
        return classname;
    }

    void setOffset(int offset) {
        coffset = offset;
    }
    public int getOffset() {
        return coffset;
    }

    void setLength(int length) {
        clength = length;
    }
    public int getLength() {
        return clength;
    }

    public int compareTo(Object o) {
        WpdObject wo = (WpdObject)o;
        if (coffset < wo.getOffset()) {
            return -1;
        }else if (coffset>wo.getOffset()) {
            return 1;
        }else {
            return 0;
        }
    }


    String getStringId() {
        String s,t;
        s = Integer.toString(id);
        while(s.length() < 4) {
            s = "0" + s;
        }
        t = Integer.toString(coffset);
        while(t.length() < 5) {
            t = "0" + t;
      }
        s = s + t;
        t = Integer.toString(clength);
        while(t.length() < 3) {
            t = "0" + t;
        }
        s = s + t;
        return s;
    }
}

        
