/* 
 * Program:             $RCSfile: Util.c,v $  $Revision: 40.8 $
 * 
 * Purpose:
 *
 * Author:              Y.Hachisu  1998/06/18
 *                      S.Yamamoto  1998/06/18
 *
 * (C) Copyright:       Y.Hachisu and S.Yamamoto  1998 - 2002
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: Util.c,v 40.8 2002/12/16 12:10:26 yamamoto Exp yamamoto $";
#endif

#include <stdarg.h>
#include <stdio.h>
#include <Sapid/Sapid.h>

#if YYDEBUG

void _jpdDebugMessage(int debugFlag, const char *format, ...)
{
    va_list     args;
    char        line[SPD_LINE_LEN + 1];
    static int  newline = 1;

    if (debugFlag) {
        fflush(stdout);
        fflush(stderr);
        
        if (newline) {
            fputs("Debug: ", stderr);
            newline = 0;
        }
        va_start(args, format);
        vsprintf(line, format, args);
        va_end(args);
        fputs(line, stderr);

        fflush(stderr);
        if (strchr(line, '\n') != NULL) {
            newline = 1;
        }
    }
}

#endif /* YYDEBUG */
