/* 
 * Program:             $RCSfile: FVapi.c,v $  $Revision: 40.4 $
 * 
 * Purpose:
 *
 * Author:              T.Saso  2001/12/11
 *                      S.Yamamoto  2001/12/11
 *
 * (C) Copyright:       T.Saso and S.Yamamoto  2001 - 2002
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: FVapi.c,v 40.4 2002/10/21 07:27:05 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>

/*
 * blkId顤Υ֥åβ۽Ρɤid֤
 */

SpdObjId getFVNode(SpdObjId blkId, SpdId classId)
{
    SpdCursor *cur;
    SpdObjId temp, nodeId = SPD_NON_ID;
  
    cur = spdGetRelObjInit(blkId, "blk_sdanode", "blkId");
    while ((temp = spdGetRelObj(cur)) != SPD_NON_ID) {
        if (spdGetClassId(temp) == classId) {
            nodeId = temp;
            break;
        }
    }
    spdFreeCursor(cur);
    /* fprintf(stderr, "getFVNode %d\n", nodeId); */
    return nodeId;
}
