/* 
 * Program:             $RCSfile: declaration_spec.c,v $  $Revision: 30.2 $
 * 
 * Purpose:
 * 
 * Author:              N.Fukuyasu  1997/10/23
 *                      S.Yamamoto  1997/10/24
 * 
 * (C) Copyright:       N.Fukuyasu and S.Yamamoto  1997
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: declaration_spec.c,v 30.2 2003/06/08 02:42:07 yamamoto Exp yamamoto $";
#endif

/*
 * ˴ؤǡ١롼
 */

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "main.h"
#include "prototype.h"

extern struct Stack_Storage *storage_stack;
extern struct Stack_Decl *decl_decl_stack;

/* Storage Class ˴ؤ Stack */

struct Stack_Storage *push_storage(void)
{
    struct Stack_Storage *new;

    new = (struct Stack_Storage *)spdCalloc(sizeof(struct Stack_Storage), 1);
    new->next = storage_stack;
    new->storage = NON;
    storage_stack = new;

    return storage_stack;
}

struct Stack_Storage *pop_storage(void)
{
    if (storage_stack != NULL) {
        struct Stack_Storage *tmp;

        tmp = storage_stack;
        storage_stack = storage_stack->next;
        spdFree(tmp);
    }

    return storage_stack;
}

/* Ϣ decl_decl ˴ؤ Stack */

struct Stack_Decl *push_decl_decl(void)
{
    struct Stack_Decl *new;

    new = (struct Stack_Decl *)spdCalloc(sizeof(struct Stack_Decl), 1);
    new->next = decl_decl_stack;
    new->decl_decl = NULL;
    decl_decl_stack = new;

    return decl_decl_stack;
}

struct Stack_Decl *pop_decl_decl(void)
{
    if (decl_decl_stack != NULL) {
        struct Stack_Decl *tmp;

        tmp = decl_decl_stack;
        decl_decl_stack = decl_decl_stack->next;
        spdFree(tmp);
    }

    return decl_decl_stack;
}
