/* 
 * Program:             $RCSfile: ext_db_obj.c,v $  $Revision: 40.2 $
 * 
 * Purpose:             
 * 
 * Author:              N.Fukuyasu  2003/04/01
 *                      S.Yamamoto  2003/04/01        
 * 
 * (C) Copyright:       N.Fukuyasu and S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: ext_db_obj.c,v 40.2 2003/04/01 09:03:22 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "linklib.h"
#include "sdblink5.h"

/*
 * ֥ȤȤ˴ϢݻݤΰݤΥǥեȥ
 */

#define CHILD_ALLOCATE_SIZE  4

/*
 * add_child_relation(), add_ext_relation(), free_ext_db_obj():
 *   ExtDBObjѤΥؿ
 */

void add_child_relation(ExtDBObj *parent, SpdDBRel *child_rel)
{
  if (parent->child_num >= parent->child_size) {
    parent->child_size += CHILD_ALLOCATE_SIZE;
    parent->child = spdRealloc(parent->child,
                   sizeof(SpdDBRel *) * parent->child_size);
  }
  parent->child[parent->child_num++] = child_rel;
}

void add_ext_relation(ExtDBObj *obj, SpdDBRel *rel)
{
  if (obj->rel_num >= obj->rel_size) {
    obj->rel_size += CHILD_ALLOCATE_SIZE;
    obj->rel = spdRealloc(obj->rel, sizeof(SpdDBRel *) * obj->rel_size);
  }
  obj->rel[obj->rel_num++] = rel;
}

void free_ext_db_obj(ExtDBObj ext_obj)
{
  if (ext_obj.child_size > 0) {
    spdFree(ext_obj.child);
    ext_obj.child = NULL;
    ext_obj.child_size = 0;
    ext_obj.child_num = 0;
  }
  if (ext_obj.rel_size > 0) {
    spdFree(ext_obj.rel);
    ext_obj.rel = NULL;
    ext_obj.rel_size = 0;
    ext_obj.rel_num = 0;
  }
}
