/* 
 * Program:             $RCSfile: spdDeclarativeAPI.h,v $  $Revision: 41.4 $
 * 
 * Purpose:
 * 
 * Author:              N.Kaneko  2002/05/05
 *                      S.Yamamoto  2002/05/05
 * 
 * (C) Copyright:       N.Kaneko and S.Yamamoto  2002
 *                      This file is a product of the project Sapid.
 */

typedef struct {
    SpdObjId    *TargetObjIds;
    int         TargetObjNum;
    SpdString   UsedRelNames;
} SpdTargetObjSet;

/* Ǥĥ֥Ȥ롥 */
SpdTargetObjSet spdGetAncestralObjs(SpdObjId input_id, SpdString ClassName);

/* Ǥλ¹֥Ȥ롥 */
SpdTargetObjSet spdGetDescendedObjs(SpdObjId input_id, SpdString ClassName);

/* input_id饯饹typeפΥ֥Ȥ롥 */
SpdTargetObjSet spdGetToTypeObjs(SpdObjId input_id, SpdString ClassName);

/* 饹typeפClassNameΥ֥Ȥ*/
SpdTargetObjSet spdGetFromTypeObjs(SpdObjId input_id, SpdString ClassName);

/* input_id饯饹expressionפΥ֥Ȥ롥 */
SpdTargetObjSet spdGetToExprObjs(SpdObjId input_id, SpdString ClassName);

/* 饹expressionפClassNameΥ֥Ȥ롥 */
SpdTargetObjSet spdGetFromExprObjs(SpdObjId input_id, SpdString ClassName);

/* SpdDeclarativeAPIǳƤΰ롥 */
void spdFreeSpdTargetObjSet(SpdTargetObjSet targetSet);








