/* 
 * Program:             $RCSfile: spdSDBformat.c,v $  $Revision: 30.2 $
 * 
 * Purpose:
 * 
 * Author:              R.Miura  1998/12/05
 *                      S.Yamamoto  1998/12/05
 * 
 * (C) Copyright:       R.Miura and S.Yamamoto  1998
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: spdSDBformat.c,v 30.2 1998/12/05 10:23:32 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>

/* SDB format. */

static int read_sdb_format = SAPID_TEXT_FORMAT_SDB;
static int write_sdb_format = SAPID_TEXT_FORMAT_SDB;

/* 
 * Set/Get SDB format.
 */

void spdSetReadSDBformat(int format)
{
    if (format == SAPID_TEXT_FORMAT_SDB || format == SAPID_BINARY_FORMAT_SDB) {
        read_sdb_format = format;
    } else {
        spdErrorExit("Invalid read format.\n");
    }
}

int spdGetReadSDBformat(void)
{
    return (read_sdb_format);
}

void spdSetWriteSDBformat(int format)
{
    if (format == SAPID_TEXT_FORMAT_SDB || format == SAPID_BINARY_FORMAT_SDB) {
        write_sdb_format = format;
    } else {
        spdErrorExit("Invalid write format.\n");
    }
}

int spdGetWriteSDBformat(void)
{
    return (write_sdb_format);
}
