/* 
 * Program:             $RCSfile: docident.h,v $  $Revision: 30.6 $
 * 
 * Purpose:             
 * 
 * Author:              N.Koyama  2000/03/16
 *                      S.Yamamoto  2000/03/16
 * 
 * (C) Copyright:       N.Koyama and S.Yamamoto  2000 - 2001
 *                      This file is a product of the project Sapid.
 */

/* 
 * "$Id: docident.h,v 30.6 2003/06/04 17:00:59 yamamoto Exp yamamoto $";
 */

#ifndef _DOCIDENT_H
#define _DOCIDENT_H

DocIdentInfo *searchDocIdent(char * name);

void initDocIdentSet(void);
void freeDocIdentSet(void);

DocIdentInfo *addDocIdentInfo(const int sort, const char *name);
void freeDocIdentInfoList(void);

DocIdentObj *addDocIdentObj(DocIdentInfo *obj, int offset);
void freeDocIdentObjList(void);

char *removeParentheses(char *text);

#ifdef DOC_DEBUG
void printDocIdentList(void);
#endif

#endif /* not _DOCIDENT_H */
