/* 
 * Program:             $RCSfile: dsdb.h,v $  $Revision: 30.4 $
 * 
 * Purpose:             
 * 
 * Author:              N.Koyama  2000/03/16
 *                      S.Yamamoto  2000/03/16
 * 
 * (C) Copyright:       N.Koyama and S.Yamamoto  2000 - 2001
 *                      This file is a product of the project Sapid.
 */

/* 
 * "$Id: dsdb.h,v 30.4 2002/01/30 12:34:52 yamamoto Exp yamamoto $";
 */

#ifndef _SPD_DSDB_H
#define _SPD_DSDB_H

typedef struct {
    SpdId       new_id;
    SpdId       old_id;
} ModifyField;

void push_modification_table(SpdSet set, SpdId old_id, SpdId new_id);
SpdObjId get_modified_id(SpdSet set, SpdId old_id);

SpdObjId spdLoadDSDB(char *filename, SpdDBId dbId,
                     SpdObjId (*classfunc)(const char *dfilename,
                                           SpdObjId obj_id,
                                           SpdObjId old_id),
                     void (*relfunc)(const char *dfilename,
                                     SpdClassId class_id,
                                     SpdObjId old_p_id, SpdObjId old_c_id,
                                     SpdObjId new_p_id, SpdObjId new_c_id));

SpdObjId spdLoadISDB(char *filename, SpdDBId dbId,
                     SpdObjId (*classfunc)(const char *dfilename,
                                           SpdObjId obj_id,
                                           SpdObjId old_id),
                     void (*relfunc)(const char *dfilename,
                                     SpdClassId class_id,
                                     SpdObjId old_p_id, SpdObjId old_c_id,
                                     SpdObjId new_p_id, SpdObjId new_c_id));

#endif /* not _SPD_DSDB_H */
