/* 
 * Program:             $RCSfile: SrcElem.c,v $  $Revision: 41.6 $
 * 
 * Purpose:             
 * 
 * Author:              N.Koyama  2000/03/16
 *                      S.Yamamoto  2000/03/16
 * 
 * (C) Copyright:       N.Koyama and S.Yamamoto  2000
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: SrcElem.c,v 41.6 2003/07/13 09:17:28 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "chkDoc.h"

/*
 * id(docfrag)˴ޤޤdocfrag֥ȤΤ
 * ˹פΤ֤.docelem_docfragé롥
 */

SpdObjIdArray spdGetIncludedFragObjId(SpdObjId id, SpdCondObjIdFunc cond)
{
    SpdObjIdArray array = SPD_EMPTY_ARRAY;

    SpdCursor *csr;

    csr = spdGetRelObjInit(id, "docelem_docfrag","docelem_id");
    while ((id = spdGetRelObj(csr)) != SPD_NON_ID) {
        SpdObjIdArray temp_array;
        temp_array = spdGetIncludedFragObjId(id, cond);
        if(temp_array.size>0){
            array.id = spdRealloc(array.id, 
                                  sizeof(SpdObjId) * (array.size + temp_array.size));
            memcpy(&array.id[array.size],temp_array.id,
                   temp_array.size*sizeof(SpdObjId));
            spdFreeObjIdArray(temp_array);
        }
        if ((*cond)(id)) {
            array.id =
                spdRealloc(array.id, sizeof(SpdObjId) * (array.size + 1));
            array.id[array.size] = id;
            array.size++;
        }
    }
    spdFreeCursor(csr);
    return array;
}

SpdBoolean isSrcElem(SpdObjId id)
{
    return (spdGetAttrValInt(id, "sort") == DOCFRAG_SRCELEM);
}

/* Ǥéä,ץҤõ */

SpdObjId getSrcElemId(SpdObjId id)
{
    SpdObjIdArray array;

    array = spdGetIncludedFragObjId(id, isSrcElem);
    if(array.size > 0) {
        /* ʣĤäƤ1Ĥ֤ʤɡ */
        SpdObjId id = array.id[0];

        spdFreeObjIdArray(array);
        return id;
    } else {
        spdFreeObjIdArray(array);
        return SPD_NON_ID;
    }
}
