/* 
 * Program:             $RCSfile: getInfo.h,v $  $Revision: 40.4 $
 * 
 * Purpose:             
 * 
 * Author:              K.Toita  2001/12/01
 *                      S.Yamamoto  2001/12/01
 * 
 * (C) Copyright:       K.Toita and S.Yamamoto  2001 - 2002
 *                      This file is a product of the project Sapid.
 */

/* 
 * "$Id: getInfo.h,v 40.4 2002/01/26 06:46:17 yamamoto Exp yamamoto $";
 */

#ifndef _SPD_GETINFO_H
#define _SPD_GETINFO_H

#define MAX_ATTR_STR_LEN    128
#define MAX_VAL_STR_LEN     128
#define NOT_EXIST           (-1)

typedef struct {
    char    attr[MAX_ATTR_STR_LEN];
    char    val[MAX_VAL_STR_LEN];
} SpdInfoElem;

typedef struct _SpdInfoData {
    size_t      size;
    SpdInfoElem *elem;
} SpdInfoData;

SpdInfo *spdChkDocOpenInfo(SpdString checkFile);
void setCheckFlag(SpdInfo *info);
void setModifyFlag(SpdInfo *info);
#endif /* _SPD_GETINFO_H */
