/* 
 * Program:             $RCSfile: debug.c,v $  $Revision: 30.2 $
 * 
 * Purpose:             "Imakefile" of Sapid/tool/SIP/sip.
 *
 * Author:              N.Kurauchi  1997/02/08
 *                      S.Yamamoto  1996/02/08
 *
 * (C) Copyright:       N.Kurauchi and S.Yamamoto  1997
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: debug.c,v 30.2 2003/06/08 02:43:42 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "SaQuLa.h"

extern CondAttrTable condattrtable;

void print_symtable(arg1)
SymTable *arg1;
{
    int i;
    
    printf("\nname is %s\n", arg1->name);
    printf("value.objid_table is ");
    if(arg1->value.objid_table.oiv != NULL){
        for(i=0; i < arg1->value.objid_table.size; i++){
            printf("%d ",arg1->value.objid_table.oiv[i].id);
        }
        printf("\n"); 
    }
    else printf("NULL\n");
}

void print_int_attribute(arg1)
SymTable *arg1;
{
    int i;
    
    printf("\nname is %s\n", arg1->name);
    printf("value.int_table is ");
    for(i=0; i < arg1->value.int_table.size; i++){
        printf("%d ",arg1->value.int_table.iv[i].value);
    }
    printf("\n");
}

void print_string_attribute(arg1)
SymTable *arg1;
{
    int i;
    
    printf("\nname is %s\n", arg1->name);
    printf("value.string_table is ");
    for(i=0; i < arg1->value.string_table.size; i++){
        printf("%s ",arg1->value.string_table.sv[i].value);
    }
    printf("\n");
}    

void print_condattrtableint(void)
{
    int i;

    i = condattrtable.size - 1;
    printf("\ncondattrtable.size = %d\n", condattrtable.size);
    printf("attr_name is %s\n", condattrtable.attr_name[i]);
    printf("attrvalue is %d\n", condattrtable.attrvalue[i].integer);
}

void print_condattrtablestr(void)
{
    int i;

    i = condattrtable.size - 1;
    printf("\ncondattrtable.size = %d\n", condattrtable.size);
    printf("attr_name is %s\n", condattrtable.attr_name[i]);
    printf("attrvalue is %s\n", condattrtable.attrvalue[i].string);
}
