/* 
 * Program:             $RCSfile: tclAR.h,v $  $Revision: 30.12 $
 * 
 * Purpose:
 *
 * Author:              T.Hidaka  1997/06/27
 * Modified:            S.Yamamoto  1997/09/05
 *
 * (C) Copyright:       T.Hidaka and S.Yamamoto  1997 - 2001
 *                      This file is a product of the project Sapid.
 */

#include <tcl.h>

/* libTclAR4ν(TclޥɤϿ) */
void Sapidtclar_Init(Tcl_Interp *interp);

/* libTclAR4νλ */
void Sapidtclar_Cleanup(void);

/* AR4ޥɷ */

int tcl_spdTarget(ClientData, Tcl_Interp *, int, char *[]);

int tcl_spdGetClassNameById(ClientData, Tcl_Interp *, int, char *[]);
int tcl_spdGetClassIdByName(ClientData, Tcl_Interp *, int, char *[]);
int tcl_spdGetAttrIdByName(ClientData, Tcl_Interp *, int, char *[]);
int tcl_spdGetName(ClientData, Tcl_Interp *, int, char *[]);
int tcl_spdGetLength(ClientData, Tcl_Interp *, int, char *[]);
int tcl_spdGetOffset(ClientData, Tcl_Interp *, int, char *[]);
int tcl_spdGetAttrVal(ClientData, Tcl_Interp *, int, char *[]);
int tcl_spdGetClassId(ClientData, Tcl_Interp *, int, char *[]);
int tcl_spdGetClassName(ClientData, Tcl_Interp *, int, char *[]);
int tcl_spdGetObjId(ClientData, Tcl_Interp *, int, char *[]);
int tcl_spdGetRel(ClientData, Tcl_Interp *, int, char *[]);
int tcl_spdGetRelObj(ClientData, Tcl_Interp *, int, char *[]);
int tcl_spdGetRelId(ClientData, Tcl_Interp *, int, char *[]);
int tcl_spdGetObjText(ClientData, Tcl_Interp *, int, char *[]);
int tcl_spdGetOffsetOfObj(ClientData, Tcl_Interp *, int, char *[]);
int tcl_spdGetLengthOfObj(ClientData, Tcl_Interp *, int, char *[]);
int tcl_spdGetIncludedOcc(ClientData, Tcl_Interp *, int, char *[]);

int tcl_spdGetABlockId(ClientData, Tcl_Interp *, int, char *[]);

int tcl_spdUseModel(ClientData, Tcl_Interp *, int, char *[]);
int tcl_spdOpenSDB(ClientData, Tcl_Interp *, int, char *[]);
int tcl_spdReadDB(ClientData, Tcl_Interp *, int, char *[]);

int tcl_spdGetModelNameById(ClientData, Tcl_Interp *, int, char *[]);
int tcl_spdGetModelIdByName(ClientData, Tcl_Interp *, int, char *[]);
int tcl_spdGetModelId(ClientData, Tcl_Interp *, int, char *[]);

#if defined(SAPID_TCLAR4)

int tcl_spdGetTableOfOffset(ClientData, Tcl_Interp *, int, char *[]);
int tcl_spdConvOffsetItoC(ClientData, Tcl_Interp *, int, char *[]);
int tcl_spdConvOffsetCtoI(ClientData, Tcl_Interp *, int, char *[]);
int tcl_spdConvRegionItoC(ClientData, Tcl_Interp *, int, char *[]);
int tcl_spdConvRegionCtoI(ClientData, Tcl_Interp *, int, char *[]);
int tcl_spdConvOccToRegion(ClientData, Tcl_Interp *, int, char *[]);
int tcl_spdConvRegionToOcc(ClientData, Tcl_Interp *, int, char *[]);

#endif /* defined(SAPID_TCLAR4) */

/* ¾ */
int tcl_spdSetSearchFlag(ClientData, Tcl_Interp *, int, char *[]);
int tcl_smuGetAProgramName(ClientData, Tcl_Interp *, int, char *[]);
int tcl_smuGetObjAttr(ClientData, Tcl_Interp *, int, char *[]);
int tcl_smuGetClassAttr(ClientData, Tcl_Interp *, int, char *[]);
int tcl_smuMakeXrefTables(ClientData, Tcl_Interp *, int, char *[]);
int tcl_spdConvIdPfileToFile(ClientData, Tcl_Interp *, int, char *[]);
int tcl_smuIsSystemFile(ClientData, Tcl_Interp *, int, char *[]);
int tcl_smuIsSystemObject(ClientData, Tcl_Interp *, int, char *[]);

/* ĥ */
int tcl_spdGetAllClasses(ClientData, Tcl_Interp *, int, char *[]);
int tcl_spdGetAllRelations(ClientData, Tcl_Interp *, int, char *[]);
int tcl_spdGetAllAttrs(ClientData, Tcl_Interp *, int, char *[]);

/* SpdUtil *//* Added by H.Ohhashi 1999/04/10. */
/* Added by H.Ohhashi 1999/10/22. */
int tcl_spdSetSDBdir(ClientData, Tcl_Interp *, int, char *[]);
int tcl_spdGetSDBdir(ClientData, Tcl_Interp *, int, char *[]);

/* SpdStrޥɡ */
int tcl_spdStr(ClientData, Tcl_Interp *, int, char *[]);

/* 祳ޥɡ */
/* TclǼ */

/* Cޥɡ */
/* TclǼ */

#if defined(SAPID_TCLAR4)

int tcl_spdGetRegionText(ClientData, Tcl_Interp *, int, char *[]);
/* եåȥޥå״Ϣ */
int tcl_spdConvRegionTclToSpd(ClientData, Tcl_Interp *, int, char *[]);
int tcl_spdConvRegionSpdToTcl(ClientData, Tcl_Interp *, int, char *[]);

#endif /* defined(SAPID_TCLAR4) */

int tcl_getMid(ClientData, Tcl_Interp *, int, char *[]);
