/* 
 * Program:             $RCSfile: TypeCheck.c,v $  $Revision: 40.3 $
 * 
 * Purpose:             typeϢƥѴؿ
 * 
 * Author:              N.Kaneko  2002/11/24
 *                      S.Yamamoto  2002/11/24
 * 
 * (C) Copyright:       N.Kaneko and S.Yamamoto  2002
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: TypeCheck.c,v 40.3 2002/11/24 09:12:34 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "DeclTest.h"

int testTypeRel(int Test)
{
    /*
    饹typeȤδϢΥƥȤԤ
    ƥȤˤȤơ饹typeȴϢĥ饹Υ֥Ȥ
    ֥ȤƤӥ饹type롥
    ΤȤ줿typetypeƱǤ뤫Ĵ٤롥
    */
    
    SpdObjIdArray TypeIdArray;
    int i;
    
    TypeIdArray = spdGetObjIdArray("type", NULL, NULL);
    
    /*
    type->type->type
    */
    if(Test == 0){
        for(i = 0; i < TypeIdArray.size; i++){
            Test = checkType(TypeIdArray.id[i], "type", Test);
            if(Test != 0){
                break;
            }
        }
    }
    
    /*
    type->declaration->type
    */
    if(Test == 0){
        for(i = 0; i < TypeIdArray.size; i++){
            Test = checkType(TypeIdArray.id[i], "declaration", Test);
            if(Test != 0){
                break;
            }
        }
    }
    /*
    type->declarator->type
    */
    if(Test == 0){
        for(i = 0; i < TypeIdArray.size; i++){
            Test = checkType(TypeIdArray.id[i], "declarator", Test);
            if(Test != 0){
                break;
            }
        }
    }
    /*
    type->identifier->type
    */
    if(Test == 0){
        for(i = 0; i < TypeIdArray.size; i++){
            Test = checkType(TypeIdArray.id[i], "ident_type", Test);
            if(Test != 0){
                break;
            }
        }
    }
    if(Test == 0){
        for(i = 0; i < TypeIdArray.size; i++){
            Test = checkType(TypeIdArray.id[i], "type_is", Test);
            if(Test != 0){
                break;
            }
        }
    }
    /*
    type->expression->type
    */
    if(Test == 0){
        for(i = 0; i < TypeIdArray.size; i++){
            Test = checkType(TypeIdArray.id[i], "expression", Test);
            if(Test != 0){
                break;
            }
        }
    }
    /*
    type->operator->type
    */
    if(Test == 0){
        for(i = 0; i < TypeIdArray.size; i++){
            Test = checkType(TypeIdArray.id[i], "operator", Test);
            if(Test != 0){
                break;
            }
        }
    }
    
    spdFreeObjIdArray(TypeIdArray);
    return Test;
}

int checkType(SpdObjId check_id, SpdString check_class, int TestFlag)
{
    SpdTargetObjSet other_objs, type_objs;
    int i, j;
    TestFlag = 0;/*ƥѤΥե饰 0:ƥȰ۾ʤ, 1:ƥȰ۾濫*/
    
    
    /*type->check_class->type*/
    other_objs = spdGetFromTypeObjs(check_id, check_class);
    for (i = 0; i < other_objs.TargetObjNum; i++) {
        if (TestFlag == 0) {
            if (SPD_STREQ(check_class, "type_is")) {
                type_objs = spdGetToTypeObjs(other_objs.TargetObjIds[i], "type_is");
            }else if (SPD_STREQ(check_class, "ident_type")) {
                type_objs = spdGetToTypeObjs(other_objs.TargetObjIds[i], "ident_type");
            }else {
                type_objs = spdGetToTypeObjs(other_objs.TargetObjIds[i], "type");
            }
            TestFlag = 1;
            for(j = 0; j < type_objs.TargetObjNum; j++){
                if(type_objs.TargetObjIds[j] == check_id){
                    TestFlag = 0;
                }
            }
            if(TestFlag == 1){
                spdWarning("type->%s->type not matched.\n", check_class);
                break;
            }
        }
        spdFreeSpdTargetObjSet(type_objs);
    }
    spdFreeSpdTargetObjSet(other_objs);
    
    
    return TestFlag;
}
