/* 
 * Program:		$RCSfile: quick_jump.js,v $  $Revision: 50.5 $
 * 
 * Purpose:		
 *
 * Author:		N.Atsumi  2003/07/28
 *			S.Yamamoto  2003/07/28
 *
 * (C) Copyright:	N.Atsumi and S.Yamamoto	 2003
 *			This file is a product of the project Sapid.
 */

/*
 * $Id: quick_jump.js,v 50.5 2003/10/02 09:26:13 yamamoto Exp yamamoto $
 */
 
var max_checker_number=5
var checker_color = new Array(max_checker_number);
checker_color[0]="#EE82EE"
checker_color[1]="#00FFFF"
checker_color[2]="#FFD700"
checker_color[3]="#00FF00"
checker_color[4]="#C0C0C0"
var checker_number = 0;
var defaultbgcolor = "#FFF8DC";
var checker_address = new Array(max_checker_number);

for(i=0;i<max_checker_number;i++) checker_address[i]="FALSE";
var checker_line = new Array(max_checker_number);
for(i=0;i<max_checker_number;i++) checker_line[i]=0;
var checker_pos_name = new Array(max_checker_number);
for(i=0;i<max_checker_number;i++) checker_pos_name[i]="NOT USED";

function select_checker(select_number)
    {

        if(checker_line[select_number - 1] != 0){
            var jpad= checker_address[select_number - 1] + "#s" + checker_line[select_number - 1];

            disp_history("CHECKER" + select_number + " : " +
                         checker_pos_name[select_number - 1] + " : Line " +
                         checker_line[select_number - 1]);
            top.righttop.location.href=jpad;
            if(checker_number != 0){
                var name = "checker" + checker_number;
                if (document.layers) this.document.layers[name].bgColor  = defaultbgcolor;
                if (document.all)    this.document.all(name).style.backgroundColor = defaultbgcolor;
                checker_number = 0;
            }
            return;
        }

        if(checker_number==0){
            var name = "checker" + select_number;
            if (document.layers) this.document.layers[name].bgColor  = checker_color[select_number - 1];
            if (document.all)    this.document.all(name).style.backgroundColor = checker_color[select_number - 1];
            checker_number = select_number;
        }else if(checker_number==select_number){
            var name = "checker" + select_number;
            if (document.layers) this.document.layers[name].bgColor  = defaultbgcolor;
            if (document.all)    this.document.all(name).style.backgroundColor = defaultbgcolor;
            checker_number = 0;
        }else{
            var name = "checker" + checker_number;
            if (document.layers) this.document.layers[name].bgColor  = defaultbgcolor;
            if (document.all)    this.document.all(name).style.backgroundColor = defaultbgcolor;
            name = "checker" + select_number;
            if (document.layers) this.document.layers[name].bgColor  = checker_color[select_number - 1];
            if (document.all)    this.document.all(name).style.backgroundColor = checker_color[select_number - 1];
            checker_number = select_number;
        }
    }

function checker_over(select_number)
    {
        var name = "checker" + select_number;
        if (document.layers) this.document.layers[name].bgColor  = checker_color[select_number - 1];
        if (document.all)    this.document.all(name).style.backgroundColor = checker_color[select_number - 1];
        if(checker_line[select_number - 1] == 0){
            window.status = "NOT USED";
        }else{
            window.status = checker_pos_name[select_number - 1] + " : Line " + checker_line[select_number - 1];
        }
        return true;
    }

function checker_out(select_number)
    {
        if(checker_number == select_number) return;
        var name = "checker" + select_number;
        if (document.layers) this.document.layers[name].bgColor  = defaultbgcolor;
        if (document.all)    this.document.all(name).style.backgroundColor = defaultbgcolor;
        window.status = "";
        return true;
    }

function set_addr()
    {
        var addr;
        var pro;
        var host;
        var path;
        pro = top.righttop.location.protocol;
        host = top.righttop.location.host;
        path = top.righttop.location.pathname;
        return pro + "\/\/" + host + path;
    }

function check_line(line_number, pos_name)
    {
        if(checker_number == 0)  return;
        if(checker_line[checker_number - 1] != 0) return;

        id_name = "line" + line_number;
        if (document.layers) {
            top.righttop.document.layers[id_name].bgColor  = checker_color[checker_number - 1];
        }
        if (document.all) {
            top.righttop.document.all(id_name).style.backgroundColor = checker_color[checker_number - 1];
        }
        checker_address[checker_number - 1] = set_addr();
        checker_line[checker_number - 1] = line_number;
        checker_pos_name[checker_number - 1] = pos_name;

        var img = "chimg" + checker_number;
        document.images[img].src = "ch-red.gif";

        var name = "checker" + checker_number;
        if (document.layers) this.document.layers[name].bgColor  = defaultbgcolor;
        if (document.all)    this.document.all(name).style.backgroundColor = defaultbgcolor;
        checker_number = 0;

    }

function load_checker()
    {
        var temp_address = set_addr();

        for(i=0;i<max_checker_number;i++){
            if(temp_address == checker_address[i]){
                var id_name = "line" + checker_line[i];
                if (document.layers) {
                    top.righttop.document.layers[id_name].bgColor  = checker_color[i];
                }
                if (document.all){
                    top.righttop.document.all(id_name).style.backgroundColor = checker_color[i];
                }
            }
        }
    }

function reset_checker(num)
    {
        if (checker_line[num - 1] == 0) return false;

        var current_address = set_addr();
        var add = 0;

        if (current_address == checker_address[num - 1]) add = 1;

        checker_address[num - 1] = "FALSE";
        checker_line[num - 1] = 0;
        checker_pos_name[num - 1] = "NOT USED";
        var img = "chimg" + num;
        document.images[img].src = "ch-gray.gif";

        if (add == 1){
            top.righttop.location.reload();
        }

        return false;
    }

/*
 * History.
 */

var history_current = 0;
var history_max = 0;
var save_history = new Array();
save_history[0]  = new Array(3);
save_history[0][0] = "NULL";  /* leftbottom frame history */
save_history[0][1] = "NULL";  /* righttop frame history */
save_history[0][2] = "TOP PAGE"; /* disp strings */

function set_href()
    {
        save_history[history_current][1] = top.righttop.window.location.href;
    }

function disp_history(str)
    {
        if(history_current == history_max){
            save_history[history_current][0] = top.leftbottom.window.location.href;
            save_history[history_current][1] = top.righttop.window.location.href;
        }
        history_current++;
        history_max = history_current;
        save_history[history_current] = new Array(3);

        save_history[history_current][2] = history_current + "::" + str;

        document.HISTORY_LIST.history_list.length = history_current + 1;
        for(i=0;i<=history_current;i++){
            document.HISTORY_LIST.history_list.options[i].value = save_history[history_current - i][2];
            document.HISTORY_LIST.history_list.options[i].text = save_history[history_current - i][2];
        }
        document.HISTORY_LIST.history_list.selectedIndex = 0;
        return true;
    }

function jump_history()
    {
        var num = history_max - document.HISTORY_LIST.history_list.selectedIndex;

        if(history_current == history_max){
            save_history[history_current][0] = top.leftbottom.window.location.href;
            save_history[history_current][1] = top.righttop.window.location.href;
        }

        top.leftbottom.window.location.href = save_history[num][0];
        top.righttop.window.location.href = save_history[num][1];
        history_current = num;
    }

function back_history()
    {
        if(history_current==0)  return;
        if(history_current == history_max){
            save_history[history_current][0] = top.leftbottom.window.location.href;
            save_history[history_current][1] = top.righttop.window.location.href;
        }
        top.leftbottom.window.location.href = save_history[history_current - 1][0];
        top.righttop.window.location.href = save_history[history_current - 1][1];
        history_current--;
        /* document.HISTORY_LIST.history_list.selectedIndex++; */
        document.HISTORY_LIST.history_list.selectedIndex = history_max - history_current;
    }

function forward_history()
    {
        if(history_current == history_max) return;
        top.leftbottom.window.location.href = save_history[history_current + 1][0];
        top.righttop.window.location.href = save_history[history_current + 1][1];
        history_current++;
        /* document.HISTORY_LIST.history_list.selectedIndex--; */
        document.HISTORY_LIST.history_list.selectedIndex = history_max - history_current;
    }

function f_reload()
    {
        top.location.reload();
    }
