#! SapidBinDir/tkAR4sh
# 
# Program:              $RCSfile: spec.tcl,v $  $Revision: 30.5 $
# 
# Purpose:
#
# Author:               K.Yasuhara  1998/07/01
#                       S.Yamamoto  1999/10/28
#
# (C) Copyright:        K.Yasuhara and S.Yamamoto  1998 - 1999
#                       This file is a product of the project Sapid.
# 

# 
# "$Id: spec.tcl,v 30.5 1999/12/27 09:18:22 yamamoto Exp yamamoto $";
# 

################################################################################
# Treeǡɤ߹ǻͽΤϤäե
#     argv[0] : ǡǥ쥯ȥ   (default:DATA/)
#           argv[1] : Treeǡե̾ (default:DATA/tree.dat)
#           argv[2] : ͽܥֹ̾
#           argv[3] : SDB ǥ쥯ȥ
# ե̾ͽ       -> DATA/ܥֹ.spec
#             ͽΥ -> DATA/ܥֹ.spec.tag
# ̾SPEC[ֹ]: expressionѥ
#         T[ܥֹ] : ե
#         TT[ܥֹ]: ̵
################################################################################

# TclAR «
source "$env(SAPID_TCLAR_LIBDIR)/tclAR.tcl"
spdSetSDBdir [lindex $argv 3]
set target [smuGetAProgramName]
spdTarget P-model $target

# ɤ߹
set DATADIR  [lindex $argv 0]
set TREEDAT  [lindex $argv 1]
set NUM      [lindex $argv 2]
################################################################################
# ĥ꡼ɤ߹
set id [ open $TREEDAT r ]
seek $id 0 start
set count 0 ; # ĥ꡼ǿ
while { [eof $id]==0 } {
    gets $id line
    scan $line "%d %s %d %d" code name SpId mode
    set attr($count) "$count $code $name $SpId $mode"
##
#    puts $attr($count)
##
    if {$code == 0} { break }
    incr count
}
close $id

################################################################################
# ܥֹ(NUM) Τե̾񤭽Ф
#     Ԥդ
proc PutMyFileName { NUM } {
    global attr
    for {set i $NUM} {$i > 0} {incr i -1} {
	if {[lindex $attr($i) 1] == 2} {
	    WRITE_JP "ե           :" 0 16
	    WRITE3 "[lindex $attr($i) 2]" 1 $i
	    break
	}
    }
}
# ܥֹ(NUM) Τؿ̾񤭽Ф
#     <> ѿѿФƤΤͭ
proc PutMyFuncName { NUM } {
    global attr
    for {set i $NUM} {$i > 0} {incr i -1} {
	if {[lindex $attr($i) 1] == 3} {
	    WRITE_JP "ؿ               :" 0 18
	    WRITE3 "[lindex $attr($i) 2]" 1 $i
	    break
	}
    }
}
################################################################################
# ܥֹ(NUM)ΥץबäƤեե˽񤭽Ф
#     <> NUMϥץΥܥֹǤʤФʤʤ
proc PutHaveFileName { NUM } {
    global attr count
    set flag 0
    WRITE_JP "ե           :" 0 16
    for {set i [expr $NUM + 1]} {$i < $count} {incr i} {
	if {[lindex $attr($i) 1] == 2} {
	    if {$flag == 0} {
		set flag 1
	    } else {
		WRITE "                    " 0
	    }
	    WRITE1 "[lindex $attr($i) 2]" 1 $i
	}
    }
    WRITE "" 1
}
################################################################################
# ܥֹ(NUM)Υե뤬äƤѿե˽񤭽Ф
#     <> NUMϥեΥܥֹǤʤФʤʤ
proc PutHaveGVName { NUM } {
    global attr count
    set flag 0
    WRITE_JP "ѿ           :" 0 16
    for {set i [expr $NUM + 1]} {$i < $count} {incr i} {
	if {[lindex $attr($i) 4] != 0} {
	    if {$flag == 0} {
		set flag 1
	    } else {
		WRITE "                    " 0
	    }
	    WRITE1 "[lindex $attr($i) 2]" 1 $i
	} else {
	    WRITE "" 1
	    return
	}
    }
    WRITE "" 1
}
# ܥֹ(NUM)Υե뤬äƤؿե˽񤭽Ф
#     <> NUMϥեΥܥֹǤʤФʤʤ
proc PutHaveFuncName { NUM } {
    global attr count
    set flag 0
    WRITE_JP "ؿ               :" 0 18
    for {set i [expr $NUM + 1]} {$i < $count} {incr i} {
	switch [lindex $attr($i) 1] {
	    3 {
		if {[lindex $attr($i) 4] == 0} {
		    if {$flag == 0} {
			set flag 1
		    } else {
			WRITE "                    " 0
		    }
		    WRITE1 "[lindex $attr($i) 2]" 1 $i
		}
	    }
	    2 { 
		WRITE "" 1
		return
	    }
	}
    }
    WRITE "" 1
}
################################################################################
# ܥֹ(NUM)δؿäƤѿե˽񤭽Ф
#     <> NUMϴؿΥܥֹǤʤФʤʤ
proc PutHaveILVName { NUM } {
    global attr count
    set flag 0
    WRITE_JP "ѿ           :" 0 16
    for {set i [expr $NUM + 1]} {$i < $count} {incr i} {
	if {[lindex $attr($i) 4] == 1} {
	    if {$flag == 0} {
		set flag 1
	    } else {
		WRITE "                    " 0
	    }
	    WRITE1 "[lindex $attr($i) 2]" 1 $i
	} else {
	    WRITE "" 1
	    return
	}
    }
    WRITE "" 1
}
# ܥֹ(NUM)δؿäƤѿե˽񤭽Ф
#     <> NUMϴؿΥܥֹǤʤФʤʤ
proc PutHaveLVName { NUM } {
    global attr count
    set flag 0
    WRITE_JP "ѿ       :" 0 14
    for {set i [expr $NUM + 1]} {$i < $count} {incr i} {
	if {[lindex $attr($i) 1] == 4} {
	    if {[lindex $attr($i) 4] == 0} {
		if {$flag == 0} {
		    set flag 1
		} else {
		    WRITE "                    " 0
		}
		WRITE1 "[lindex $attr($i) 2]" 1 $i
	    }
	} else {
	    WRITE "" 1
	    return
	}
    }
    WRITE "" 1
}
################################################################################
# ܥֹ(NUM)δؿȤäƤѿե˽񤭽Ф
#     <> NUMϴؿΥܥֹǤʤФʤʤ
proc PutUseGVName { NUM } {
    global attr count
    set NAME [lindex $attr($NUM) 2]
    set flag 0
    WRITE_JP "ѿ           :" 0 16
    for {set i $NUM} {1} {incr i -1} { ;# iեΥܥֹˤ
	if {[lindex $attr($i) 1] == 2} { break }
    }
    for {incr i} {$i < $count} {incr i} {
	if {[lindex $attr($i) 4] != 0} {
	    set decr_id [lindex $attr($i) 3]
	    set ident_id [spdGetRelObj $decr_id decl_ident declarator_id]
	    set expr_id  [spdGetRelObj $ident_id ident_ref identifier_id]
	    # expr_idäƤʤѿ̾񤭽Ф
	    foreach ex $expr_id {
		if { $NAME == [expr2func $ex] } {
		    if {$flag == 0} {
			set flag 1
		    } else {
			WRITE "                    " 0
		    }
		    WRITE1 "[lindex $attr($i) 2]" 1 $i
		    break ;# ȤäƤإ󥯤ĥʤbreakʤ
		}
	    }
	} else {
	    break
	}
    }
    WRITE "" 1
}
# ܥֹ(NUM)δؿƤӽФƤؿե˽񤭽Ф (Caller)
#     <> NUMϴؿΥܥֹǤʤФʤʤ
proc PutUsedFuncName { NUM } {
    global attr
    set flag 0
    WRITE_JP "ƤӽФ줿ؿ   :" 0 12
    set decr_id  [lindex $attr($NUM) 3]
    set ident_id [spdGetRelObj $decr_id decl_ident declarator_id]
    set expr_id  [spdGetRelObj $ident_id ident_ref identifier_id]
    # expr_idΤؿ̾񤭽ФƤ
    foreach ex $expr_id {
	set NAME [expr2func $ex]
	if {$flag == 0} {
	    set flag 1
	} else {
	    WRITE "                    " 0
	}
	WRITE3 "$NAME" 0 [name2num $NAME]
	WRITE ">" 0
	WRITE2 [id2offset $ex] 1 [name2num $NAME] $ex
    }
    WRITE "" 1
}
# ܥֹ(NUM)δؿȤäƤؿե˽񤭽Ф (Callee)
#     <> NUMϴؿΥܥֹǤʤФʤʤ
proc PutUseFuncName { NUM } {
    global attr count
    set NAME [lindex $attr($NUM) 2]
    set flag 0
    WRITE_JP "ƤӽФؿ       :" 0 14
    for {set i 0} {$i < $count} {incr i} {
	if {[lindex $attr($i) 1] != 3} { continue }
	if {[lindex $attr($i) 4] == 0} {
	    set decr_id [lindex $attr($i) 3]
	    set ident_id [spdGetRelObj $decr_id decl_ident declarator_id]
	    set expr_id  [spdGetRelObj $ident_id ident_ref identifier_id]
	    # expr_idäƤʤѿ̾񤭽Ф
	    foreach ex $expr_id {
		if { $NAME == [expr2func $ex] } {
		    if {$flag == 0} {
			set flag 1
		    } else {
			WRITE "                    " 0
		    }
		    # ƤӽФؿƬؤΥ
		    WRITE1 "[lindex $attr($i) 2]" 0 $i
		    WRITE " " 0
		    # ƤӽФƤإ
		    WRITE3 "$NAME" 0 $NUM
		    WRITE ">" 0
		    WRITE2 [id2offset $ex] 1 $NUM $ex
		}
	    }
	}
    }
    WRITE "" 1
}
################################################################################
proc PutSameGvFile { NUM } {
    global attr
    # static¨λ
    if {[lindex $attr($NUM) 4] == 3} { return }
    set LIST [SameGv $NUM]
    WRITE_JP "Ʊѿĥե:" 1 14
    foreach num $LIST {
	WRITE "                    " 0
	set FileNum [num2file $num]
	if {[lindex $attr($num) 4] == 2} {
	    WRITE3 "[lindex $attr($FileNum) 2]" 0 $FileNum
	    WRITE  " (extern)" 1
	} else {
	    WRITE3 "[lindex $attr($FileNum) 2]" 1 $FileNum
	}
    }
}
# ѿΥܥֹ椫ƱפѿΥꥹȤ֤(ʬϴޤޤʤ)
#     num : Ĵ٤ѿΥܥֹ
# Ȥʤѿ static ǤäƤϤʤʤ
proc SameGv {num} {
    global attr count
    set LIST {}
    set NAME [lindex $attr($num) 2]
    set ID   [lindex $attr($num) 3]
    for {set i 0} {$i < $count} {incr i} {
	if {[lindex $attr($i) 1] != 3} {continue}
	if {$i == $num} {continue}
	if {[lindex $attr($i) 3] == $ID} {
	    lappend LIST $i
	    continue
	}
	if {[lindex $attr($i) 2] == $NAME} {
	    if {([lindex $attr($num) 4]==1)||([lindex $attr($num) 4]==2)} {
		lappend LIST $i
		continue
	    }
	}
    }
    return $LIST
}
# ܥֹ¸ߤեΥܥֹ֤
proc num2file { NUM } {
    global attr
    for {set i $NUM} {$i > 0} {incr i -1} {
	if {[lindex $attr($i) 1] == 2} {
	    return $i
	}
    }
}
################################################################################
# expr_idäƤؿ֤̾
#   expr_idϥꥹȤǤäƤϤʤʤ
proc expr2func { expr_id } {
    set tmp_id $expr_id
    for {} {1} {} {
	set tmp2_id [spdGetRelObj $tmp_id expr_expr inner_expression_id]
	if { $tmp2_id == "" } { break }
	set tmp_id $tmp2_id
    }
    set tmp_id [spdGetRelObj $tmp_id blk_expr children_expression_id]
    for {} {1} {} {
	set tmp2_id [spdGetRelObj $tmp_id blk_blk children_block_id]
	if { $tmp2_id == "" } { break }
	set tmp_id $tmp2_id
    }
    set tmp_id [spdGetRelObj $tmp_id func_body block_id]
    set tmp_id [spdGetRelObj $tmp_id decl_opt  optionaldecl_id]
    set tmp_id [spdGetRelObj $tmp_id decl_ident declarator_id]
    return [spdGetName $tmp_id]
}
# ܥ̾ܥֹ֤
#     ˤøǤ뤿ᡢؿʳˤϻȤʤ
proc name2num { NAME } {
    global attr count
    for {set i 0} {$i < $count} {incr i} {
	if {([lindex $attr($i) 2]==$NAME)&&\
		([lindex $attr($i) 1]==3)&&([lindex $attr($i) 4]==0)} {
	    return $i
	}
    }
    return -1
}
# ID饪եåȤѴ
proc id2offset {id} {
    set offset [spdGetOffsetOfObj $id]
    set offset [spdConvOccToRegion [lindex $offset 0]]
    set offset [spdConvRegionItoC $offset]
    set offset [spdConvRegionSpdToTcl $offset]
    return [lindex $offset 1]
}
################################################################################
# ѿʤСͽ˽­
proc CheckCTRL { NUM } {
    global LET TAGNUM DATADIR id id2
    if {[file exists $DATADIR$NUM.CTRL] != 0} {
	puts -nonewline $id "                    "
	set old [incr LET 20]
	incr LET 5
	incr TAGNUM
	puts $id "ѿ"
	puts $id2 ".text.out tag add SPEC$TAGNUM \"1.0 + $old chars\" \
		                                 \"1.0 + $LET chars\";\
		   .text.out tag configure SPEC$TAGNUM -foreground red -underline yes;\
		   .text.out tag bind SPEC$TAGNUM <Button-1> { VarWin $NUM CTRL }"
    }
}
# ǡѿʤСͽ˽­
proc CheckDATA { NUM } {
    global LET TAGNUM DATADIR id id2
    if {[file exists $DATADIR$NUM.DATA] != 0} {
	puts -nonewline $id "                    "
	set old [incr LET 20]
	incr LET 6
	incr TAGNUM
	puts $id "ǡѿ"
	puts $id2 ".text.out tag add SPEC$TAGNUM \"1.0 + $old chars\" \
		                                 \"1.0 + $LET chars\";\
		   .text.out tag configure SPEC$TAGNUM -foreground red -underline yes;\
		   .text.out tag bind SPEC$TAGNUM <Button-1> { VarWin $NUM DATA }"
    }
}
# ѿʤСͽ˽­
proc CheckIO { NUM } {
    global LET TAGNUM DATADIR id id2
    if {[file exists $DATADIR$NUM.IN-OUT] != 0} {
	puts -nonewline $id "                    "
	set old [incr LET 20]
	incr LET 6
	incr TAGNUM
	puts $id "ѿ"
	puts $id2 ".text.out tag add SPEC$TAGNUM \"1.0 + $old chars\" \
		                                 \"1.0 + $LET chars\";\
		   .text.out tag configure SPEC$TAGNUM -foreground red -underline yes;\
		   .text.out tag bind SPEC$TAGNUM <Button-1> { VarWin $NUM IN-OUT }"
    }
}
# ѿʤСͽ˽­
proc CheckENUM { NUM } {
    global LET TAGNUM DATADIR id id2
    if {[file exists $DATADIR$NUM.ENUM] != 0} {
	puts -nonewline $id "                    "
	set old [incr LET 20]
	incr LET 6
	incr TAGNUM
	puts $id "ѿ"
	puts $id2 ".text.out tag add SPEC$TAGNUM \"1.0 + $old chars\" \
		                                 \"1.0 + $LET chars\";\
		   .text.out tag configure SPEC$TAGNUM -foreground red -underline yes;\
		   .text.out tag bind SPEC$TAGNUM <Button-1> { VarWin $NUM ENUM }"
    }
}
################################################################################
# ե񤭹
set id  [ open [format %s%s.spec $DATADIR $NUM] w ]
set id2 [ open [format %s%s.spec.tag $DATADIR $NUM] w ]
set LET  0   ;# 񤭹ʸ
set TAGNUM 0 ;# ֹ
# ե񤭹
#     WORD:񤭹ʸ
#           line:Ԥ̵ͭ(1:ͭ / 0:̵)
proc WRITE {WORD line} {
    global LET id
    incr LET [string length $WORD]
    # ʸ񤭤
    if {$line == 1} {
	puts $id $WORD
	incr LET ;# ʬ
    } else {
	puts -nonewline $id $WORD
    }
}
# ե񤭹 (ܥؤΥ)
#     WORD:񤭹ʸ
#           line:Ԥ̵ͭ(1:ͭ / 0:̵)
#           goto:Υܥֹ
proc WRITE1 {WORD line goto} {
    global attr
    global LET id
    global TAGNUM id2
    set old $LET
    incr LET [string length $WORD]
    # ʸ񤭤
    if {$line == 1} {
	puts $id $WORD
	puts $id2 ".text.out tag add T$goto \"1.0 + $old chars\" \
	                                    \"1.0 + $LET chars\" "
	incr LET ;# ʬ
    } else {
	puts -nonewline $id $WORD
	puts $id2 ".text.out tag add T$goto \"1.0 + $old chars\" \
	                                    \"1.0 + $LET chars\" "
    }
    # 󥯽񤭤
    if {[lindex $attr($goto) 1] > 2} {
	puts $id2 ".text.out tag configure T$goto -foreground red -underline yes;\
	           .text.out tag bind T$goto <Button-1> {;\
	                  set MODE 0;\
			  ViewBotton $goto;\
			  Select .f1.tree.$goto;\
			  .text.out yview TO$goto.first; };\
	           .text.out tag bind T$goto <Button-2> {;\
			  ViewBotton $goto;\
			  Select .f1.tree.$goto; } "
    } else {
	puts $id2 ".text.out tag configure T$goto -foreground red -underline yes;\
	           .text.out tag bind T$goto <Button-1> {;\
	                  set MODE 0;\
			  ViewBotton $goto;\
			  Select .f1.tree.$goto; };\
	           .text.out tag bind T$goto <Button-2> {;\
			  ViewBotton $goto;\
			  Select .f1.tree.$goto; } "
    }
    incr TAGNUM
}
# ե񤭹 (expressionؤΥ)
#     WORD:񤭹ʸ
#           line:Ԥ̵ͭ(1:ͭ / 0:̵)
#           func:򤹤ܥֹ
#           id  :expression_id
#    աidfunc򤷤ɽʤФʤʤ
proc WRITE2 {WORD line func ex_id} {
    global LET id
    global TAGNUM id2
    set old $LET
    incr LET [string length $WORD]
    # ʸ񤭤
    if {$line == 1} {
	puts $id $WORD
	incr LET ;# ʬ
    } else {
	puts -nonewline $id $WORD
    }
    # 󥯽񤭤
    set offset [id2offset $ex_id]
    puts $id2 ".text.out tag add SPEC$TAGNUM \"1.0 + $old chars\" \
	                                     \"1.0 + $LET chars\";\
	       .text.out tag configure SPEC$TAGNUM -foreground red -underline yes;\
	       .text.out tag bind SPEC$TAGNUM <Button-1> {;\
	         set MODE 0;\
		 ViewBotton $func;\
		 Select .f1.tree.$func;\
                 .text.out yview \"1.0 + $offset chars\"; } "
    incr TAGNUM
}
# ե񤭹 (Τ)
#     WORD:񤭹ʸ
#           line:Ԥ̵ͭ(1:ͭ / 0:̵)
#           NUM :ܥֹ
proc WRITE3 {WORD line NUM} {
    global LET id
    global TAGNUM id2
    set old $LET
    incr LET [string length $WORD]
    # ʸ񤭤
    if {$line == 1} {
	puts $id $WORD
	puts $id2 ".text.out tag add TT$NUM \"1.0 + $old chars\" \
	                                    \"1.0 + $LET chars\" "
	incr LET ;# ʬ
    } else {
	puts -nonewline $id $WORD
	puts $id2 ".text.out tag add TT$NUM \"1.0 + $old chars\" \
	                                    \"1.0 + $LET chars\" "
    }
}
# եܸ񤭹
#     WORD  :񤭹ʸ
#           line  :Ԥ̵ͭ(1:ͭ / 0:̵)
#           Length:WORDʸ
proc WRITE_JP {WORD line Length} {
    global LET id
    incr LET $Length
    # ʸ񤭤
    if {$line == 1} {
	puts $id $WORD
	incr LET ;# ʬ
    } else {
	puts -nonewline $id $WORD
    }
}
################################################################################
# 
################################################################################
# ̾ 
WRITE_JP "̾               :" 0 18
WRITE3 "[lindex $attr($NUM) 2]" 1 $NUM

switch [lindex $attr($NUM) 1] {
    1 {
	WRITE_JP "               :ץ" 1 23
	WRITE "----------------------------------------" 1
	PutHaveFileName $NUM             ;# äƤե
    }
    2 {
	WRITE_JP "               :ե" 1 22
	WRITE "----------------------------------------" 1
	PutHaveGVName $NUM               ;# äƤѿ
	PutHaveFuncName $NUM             ;# äƤؿ
    }
    3 {
	if {[lindex $attr($NUM) 4] == 0} {
	    WRITE_JP "               :ؿ" 1 20
	    WRITE "----------------------------------------" 1
	    PutMyFileName $NUM           ;# ¸ߤե̾
	    WRITE "----------------------------------------" 1
	    PutUseGVName $NUM            ;# ȤäƤѿ
	    PutHaveILVName $NUM          ;# äƤѿ
	    PutHaveLVName $NUM           ;# äƤѿ
	    PutUsedFuncName $NUM         ;# ƤӽФؿ(Caller)
	    PutUseFuncName $NUM          ;# ƤӽФؿ(Callee)
        } else {
	    if {[lindex $attr($NUM) 4] == 1} {
		WRITE_JP "               :ѿ" 1 22
	    } elseif {[lindex $attr($NUM) 4] == 2} {
		WRITE_JP "               :ѿ (extern)" 1 31
	    } else {
		WRITE_JP "               :ѿ (static)" 1 31
	    }
	    WRITE "----------------------------------------" 1
	    PutMyFileName $NUM           ;# ¸ߤե̾
	    PutSameGvFile $NUM           ;# Ʊѿ¸ߤե̾
	    WRITE "----------------------------------------" 1
	    WRITE_JP "ѿħ         :" 1 15
	    # 餬
	    CheckCTRL $NUM               ;# ѿå
	    CheckDATA $NUM               ;# ǡѿå
	    CheckENUM $NUM               ;# ѿå
	}
    }
    4 { if {[lindex $attr($NUM) 4] == 0} {
	    WRITE_JP "               :ѿ" 1 24
	    WRITE "----------------------------------------" 1
	    PutMyFileName $NUM           ;# ¸ߤե̾
	    PutMyFuncName $NUM           ;# ¸ߤؿ̾
	    WRITE "----------------------------------------" 1
	    WRITE_JP "ѿħ         :" 1 15
	    # 餬
	    CheckCTRL $NUM               ;# ѿå
	    CheckDATA $NUM               ;# ǡѿå
	    CheckENUM $NUM               ;# ѿå
        } else {
	    WRITE_JP "               :ѿ" 1 22
	    WRITE "----------------------------------------" 1
	    PutMyFileName $NUM           ;# ¸ߤե̾
	    PutMyFuncName $NUM           ;# ¸ߤؿ̾
	    WRITE "----------------------------------------" 1
	    WRITE_JP "ѿħ         :" 1 15
	    # 餬
	    CheckCTRL $NUM               ;# ѿå
	    CheckDATA $NUM               ;# ǡѿå
	    CheckIO $NUM                 ;# ѿå
	    CheckENUM $NUM               ;# ѿå
	}
    }
}

close $id
close $id2

exit
###############################################################################
# End
###############################################################################
