#! SapidBinDir/tkAR4sh
# 
# Program:              $RCSfile: tag.tcl,v $  $Revision: 30.5 $
# 
# Purpose:
#
# Author:               K.Yasuhara  1998/07/01
#                       S.Yamamoto  1999/10/28
#
# (C) Copyright:        K.Yasuhara and S.Yamamoto  1998 - 1999
#                       This file is a product of the project Sapid.
# 

# 
# "$Id: tag.tcl,v 30.5 1999/12/27 09:18:22 yamamoto Exp yamamoto $";
# 

###########################################################################
# Treeǡɤ߹ǥΤϤäե
#     argv[0] : ǡǥ쥯ȥ   (default:DATA/)
#           argv[1] : Treeǡե̾ (default:DATA/tree.dat)
#           argv[2] : 륽ե̾Υܥֹ
#           argv[3] : SDB ǥ쥯ȥ
# ե̾DATA/ե̾.tag
# ()Υ̾:TO[ܥֹ]
# ()Υ̾  :TAG[ܥֹ]
###########################################################################

# TclAR «
source "$env(SAPID_TCLAR_LIBDIR)/tclAR.tcl"
spdSetSDBdir [lindex $argv 3]
set target [smuGetAProgramName]
spdTarget P-model $target

# ɤ߹
set DATADIR  [lindex $argv 0]
set TREEDAT  [lindex $argv 1]
set WFileN   [lindex $argv 2]

###########################################################################
# ĥ꡼ɤ߹
set id [ open $TREEDAT r ]
seek $id 0 start
set count 0 ; # ĥ꡼ǿ
while { [eof $id]==0 } {
    gets $id line
    scan $line "%d %s %d %d" code name SpId mode
    set attr($count) "$count $code $name $SpId $mode"
    if {$code == 0} { break }
    incr count
}
close $id

###########################################################################
# եåȤȤ
proc Get_Offset {file_id obj_id} {
    set temp [spdGetIncludedOcc $obj_id "identifier" $file_id]
    if {[lindex [lindex $temp 0] 2] == -1 } { return {-1 -1 -1} }
    set temp [spdConvOccToRegion [lindex $temp 0]]
    set temp [spdConvRegionItoC $temp]
    set temp [spdConvRegionSpdToTcl $temp]
    return $temp
}
###########################################################################
# 
#     եΥܥֹ椫饳ʬΥ
# SAPID_AR4_BLOCK_COMMENT: 1
proc CommentTag {num} {
    global id attr
    set count 0
    set temp [spdGetRelObj [lindex $attr($num) 3] cfile_ifile file_id]
    set temp [spdGetRelObj $temp file_block pfile_id]
    foreach block_id $temp {
	if {[spdGetAttrVal $block_id sort] == 1} {
	    incr count
	    set REGION [spdGetOffsetOfObj $block_id]
	    set REGION [spdConvOccToRegion [lindex $REGION 0]]
	    set REGION [spdConvRegionItoC $REGION]
	    set REGION [spdConvRegionSpdToTcl $REGION]
	    set TAGNAME [format %sCM%s $num $count]
	    puts -nonewline $id ".text.out tag add $TAGNAME "
	    puts -nonewline $id "1.0+[lindex $REGION 1]chars "
	    puts -nonewline $id "1.0+[expr [lindex $REGION 1]+[lindex $REGION 2]]chars;"
	    puts $id ".text.out tag configure $TAGNAME -foreground purple"
	}
    }
    return
}
###########################################################################
# κᥤ
set id [ open [format %s%s.tag $DATADIR [lindex $attr($WFileN) 2]] w ]
for {set i 0} {$i < $count} {incr i} {
    # Program FileФ󥯤Ϥʤ
    if {[lindex $attr($i) 1] == 1} {
	continue
    } elseif {[lindex $attr($i) 1] == 2} {
        set FileN $i
	if {$WFileN == $FileN} {
	    CommentTag $WFileN
	}
        continue
    }

    # ؿʳΤեȽ񤭹ե뤬Ʊ
    if {([lindex $attr($i) 1]==4) || ([lindex $attr($i) 4]!=0)} {
	if {$WFileN != $FileN} { continue }
    }

    # ()κ
    #     ̾TO[NUM]
    if {$WFileN == $FileN} {
	set REGION [Get_Offset [lindex $attr($WFileN) 3] [lindex $attr($i) 3]]
	if {[lindex $REGION 1] != -1} {
	    puts -nonewline $id ".text.out tag add TO$i "
	    puts -nonewline $id "1.0+[lindex $REGION 1]chars "
	    puts -nonewline $id "1.0+[expr [lindex $REGION 1]+[lindex $REGION 2]]chars;"
	    puts            $id ".text.out tag configure TO$i -foreground blue"
	}
    }

    # ()Υ
    #     ̾TAG[NUM]
    set FLAG 0
    set decr_id  [lindex $attr($i) 3]
    set ident_id [spdGetRelObj $decr_id decl_ident declarator_id]
    set expr_id  [spdGetRelObj $ident_id ident_ref identifier_id]
    for {set j 0} {$j < [llength $expr_id]} {incr j} {
	set REGION [Get_Offset [lindex $attr($WFileN) 3] [lindex $expr_id $j]]
	if {[lindex $REGION 1] == -1} { continue }
	if {$FLAG == 0} {
	    set FLAG 1
	    puts -nonewline $id ".text.out tag add TAG$i "
	}
	puts -nonewline $id "1.0+[lindex $REGION 1]chars "
	puts -nonewline $id "1.0+[expr [lindex $REGION 1]+[lindex $REGION 2]]chars "
    }
    if {$FLAG == 1} {
	puts -nonewline $id ";.text.out tag configure TAG$i -underline yes -foreground red;"
	puts -nonewline $id ".text.out tag bind TAG$i <Button-1> {;\
		ViewBotton $i;\
		Select .f1.tree.$i;\
		.text.out yview TO$i.first };"
	puts $id ".text.out tag bind TAG$i <Button-2> {;\
		set MODE 1;\
		ViewBotton $i;\
		Select .f1.tree.$i };"
    }
}
close $id

exit
###########################################################################
# End
###########################################################################
