/* 
 * Program:         $RCSfile: parts.c,v $  $Revision: 30.6 $
 * 
 * Purpose:         ѡĳ
 *
 * Author:          K.Yasuhara  2000/07/01
 *                  S.Yamamoto  2000/07/01
 *
 * (C) Copyright:   K.Yasuhara and S.Yamamoto  2000
 *                  This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: parts.c,v 30.6 2003/06/15 04:47:59 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "my.h"

/* ץȥ(ΥեǤΤ) */
/* åط */
void DrawEdgeFrom(int num, double dz);           /* ؿΥåи֤򼨤 */
void DrawGvToFunc(int num);                      /* ѿ/ؿ֤Υå */
void DrawGvToGv(int num);                        /* ѿ֤Υå */
/* ¾γؿ */
void DrawText (POS pos, GLbyte *name, double dz);/* ƥȤ */

/****************************************************************************/
/*******************************   ؿ   ***********************************/

void DrawFunc(void)
{
    int i;
    GLUquadricObj* qobj = gluNewQuadric();
    /* ޥƥꥢ */
    GLfloat materialAmbient1[] = {0.0f, 0.5f, 0.0f, 0.7f}; /**/
    GLfloat materialAmbient2[] = {0.7f, 0.0f, 0.7f, 0.5f}; /**/
    GLfloat materialDiffuse[]  = {0.0f, 0.0f, 0.0f, 1.0f}; /* ȾƩ */

    /*** ʪʳ ***/
    for(i=0; i<func_num; i++){
        if(!func[i].view)    continue;      /* ɽ */
        if(select_func == i) continue;      /* ʪȾƩΤǸ˳ */

        /* ؿο */
        glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, materialAmbient1);
        /* Τ̾ ID Ȥ */
        glLoadName(func[i].id);
        /* ؿ */
        if(drawmode != DETAIL) {
            /* ʪΤ */
            glTranslatef(func[i].pos.x,
                         func[i].pos.y,
                         func[i].pos.z - func[i].r*scale/2);
            /* Ψ */
            glScalef(scale,scale,scale);
            /* ʰɽ */
            glutSolidCube(func[i].r);
        }else{
            /* ʪΤ */
            glTranslatef(func[i].pos.x,
                         func[i].pos.y,
                         func[i].pos.z);
            /* Ψ */
            glScalef(scale,scale,scale);
            /* ܺɽ() */
            glRotatef(180.0, 1.0, 0.0, 0.0); /* ˿Ф */
            gluCylinder(qobj, func[i].r, func[i].r, func[i].h, SLICES, 1);
            gluDisk(qobj, 0, func[i].r, SLICES, 1); /*  */
            glTranslatef(0, 0, func[i].h);
            gluDisk(qobj, 0, func[i].r, SLICES, 1); /*  */
        }
        glLoadName(-1);

        /* ѥ᡼򸵤᤹ */
        glMaterialfv(GL_FRONT, GL_DIFFUSE, materialDiffuse);
        glLoadIdentity();

        /* ؿ̾ɽ */
        if(func[i].label)
            DrawText(func[i].pos, func[i].name, 0.05);
    }


    /*** ʪ ***/
    if(func[select_func].view && select_func != -1){
        /*  */
        materialAmbient2[3] = MakeAlpha(func[select_func]); /* Ʃ٤η */
        glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, materialAmbient2);
        /* Τ̾ ID Ȥ */
        glLoadName(func[select_func].id);
        /* ؿ */
        if(drawmode == TINY) {
            /* ʪΤ */
            glTranslatef(func[select_func].pos.x,
                         func[select_func].pos.y,
                         func[select_func].pos.z - func[select_func].r*scale/2);
            /* Ψ */
            glScalef(scale,scale,scale);
            /* ʰץ֥Ȥ */
            glutSolidCube(func[select_func].r);
        }else{
            /* ʪΤ */
            glTranslatef(func[select_func].pos.x,
                         func[select_func].pos.y,
                         func[select_func].pos.z);
            /* Ψ */
            glScalef(scale,scale,scale);
            /*  */
            glRotatef(180.0, 1.0, 0.0, 0.0); /* ˿Ф */
            gluCylinder(qobj, func[select_func].r, func[select_func].r,
                        func[select_func].h, SLICES, 1);
            gluDisk(qobj, 0, func[select_func].r, SLICES, 1);
            glTranslatef(0, 0, func[select_func].h);
            gluDisk(qobj, 0, func[select_func].r, SLICES, 1);
        }
        glLoadName(-1);

        /* ѥ᡼򸵤᤹ */
        glLoadIdentity();
        glMaterialfv(GL_FRONT, GL_DIFFUSE, materialDiffuse);

        /* ؿ̾ɽ */
        DrawText(func[select_func].pos, func[select_func].name, 0.05);
    }

    gluDeleteQuadric(qobj);
}

/* Top Mode  */

void DrawFuncTOP(void)
{
    int i;
    GLUquadricObj* qobj = gluNewQuadric();
    /* ޥƥꥢ */
    GLfloat materialAmbient1[] = {0.0f, 0.6f, 0.0f, 1.0f};
    GLfloat materialAmbient2[] = {0.7f, 0.0f, 0.7f, 1.0f};

    for(i=0; i<func_num; i++){
        if(!func[i].view) continue;
        /* ޥƥꥢ */
        if(i == select_func)
            glMaterialfv(GL_FRONT, GL_AMBIENT, materialAmbient2);
        else
            glMaterialfv(GL_FRONT, GL_AMBIENT, materialAmbient1);

        glLoadName(func[i].id);             /* Τ̾ ID Ȥ */
        /* ʪΤ */
        glTranslatef(func[i].pos.x, func[i].pos.y, func[i].pos.z);
        /* Ψ */
        glScalef(scale,scale,scale);
        /* ؿ */
        glRotatef(180.0, 1.0, 0.0, 0.0);    /* Τžʤȱ */
        gluDisk(qobj, 0, func[i].r, SLICES, 1);
        glLoadName(-1);

        /* ѥ᡼򸵤᤹ */
        glLoadIdentity();

        /* ؿ̾ɽ */
        if(func[i].label)
            DrawText(func[i].pos, func[i].name, 0.05);
    }

    gluDeleteQuadric(qobj);
}

/*****************************   ѿ   *********************************/

void DrawGv(void)
{
    int i;
    GLUquadricObj* qobj = gluNewQuadric();
    /* ޥƥꥢ */
    GLfloat materialAmbient[]  = {0.6f, 0.0f, 0.0f, 0.8f};
    GLfloat materialDiffuse[]  = {0.0f, 0.0f, 0.0f, 1.0f}; /* ȾƩ */

    /* ̾ȥå */
    for(i=0; i<gv_num; i++){
        if(!gv[i].view) continue;
        /* ѿ̾ɽ */
        DrawText(gv[i].pos, gv[i].name, 0.025*scale);
        /* å */
        DrawGvToFunc(i);
        DrawGvToGv(i);
    }

    glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, materialAmbient);
    for(i=0; i<gv_num; i++){
        if(!gv[i].view) continue;
        /* Τ̾ ID Ȥ */
        glLoadName(gv[i].id);
        /* ʪΤ */
        glTranslatef(gv[i].pos.x, gv[i].pos.y, gv[i].pos.z);
        /* Ψ */
        glScalef(scale,scale,scale);
        /* ѿ */
        glutSolidCube(0.05f);
        glLoadName(-1);

        glLoadIdentity();
    }
    glMaterialfv(GL_FRONT, GL_DIFFUSE, materialDiffuse);

    gluDeleteQuadric(qobj);
}

/* ѿ/ؿ֤Υå */
/*     ѿ˸Ƥ֤      */

void DrawGvToFunc(int num)
{
    int i;
    /* ޥƥꥢ */
    GLfloat materialAmbient[] = {0.4f, 0.4f, 0.4f, 1.0f};
    glMaterialfv(GL_FRONT, GL_AMBIENT, materialAmbient);

    glBegin(GL_LINES);
    for(i=0; i<gv[num].f_num; i++) {
        if(!func[gv[num].f[i]].view) continue;
        glVertex3f(gv[num].pos.x, gv[num].pos.y, gv[num].pos.z);
        glVertex3f(func[gv[num].f[i]].pos.x,
                   func[gv[num].f[i]].pos.y,
                   func[gv[num].f[i]].pos.z);
    }
    glEnd();
}

/* ѿ֤Υå */
/*     ѿ˸Ƥ֤ */

void DrawGvToGv(int num)
{
    int i;
    /* ޥƥꥢ */
    GLfloat materialAmbient[] = {0.4f, 0.4f, 0.4f, 1.0f};
    glMaterialfv(GL_FRONT, GL_AMBIENT, materialAmbient);

    glEnable(GL_LINE_STIPPLE);              /* Ȥ */
    glBegin(GL_LINES);
    for(i=0; i<gv[num].g_num; i++) {
        if(!gv[gv[num].g[i]].view) continue;
        glVertex3f(gv[num].pos.x, gv[num].pos.y, gv[num].pos.z);
        glVertex3f(gv[gv[num].g[i]].pos.x,
                   gv[gv[num].g[i]].pos.y,
                   gv[gv[num].g[i]].pos.z);
    }
    glEnd();
    glDisable(GL_LINE_STIPPLE);
}

/**************************   å   ***************************/

void DrawEdge(void)
{
    int i;
    double dx=0,dy=0,dz=0,l=0;              /* åΥȤĴ */

    /* ޥƥꥢ */
    GLfloat materialAmbient1[] = {0.3f, 0.3f, 0.0f, 1.0f}; /* ɸ */
    GLfloat materialAmbient2[] = {0.7f, 0.0f, 0.0f, 1.0f}; /* Ƥ */
    GLfloat materialAmbient3[] = {0.0f, 0.7f, 0.7f, 1.0f}; /* ƤФ */

    for(i=0; i<edge_num; i++) {
        if(!func[edge[i].from].view || !func[edge[i].to].view) continue;

        if(edge[i].from == select_func){
            glMaterialfv(GL_FRONT, GL_AMBIENT, materialAmbient2);
        }else if(edge[i].to == select_func){
            glMaterialfv(GL_FRONT, GL_AMBIENT, materialAmbient3);
        }else{
            glMaterialfv(GL_FRONT, GL_AMBIENT, materialAmbient1);
        }

        if(viewmode == NORMAL && drawmode != TINY && 
           (drawmode == DETAIL || edge[i].from == select_func) ){
            /* åνȯ׾ */
            l  = PosDiff_XY(func[edge[i].from].pos,func[edge[i].to].pos);
            dx = scale*(func[edge[i].to].pos.x-func[edge[i].from].pos.x)
                *func[edge[i].from].r/l;
            dy = scale*(func[edge[i].to].pos.y-func[edge[i].from].pos.y)
                *func[edge[i].from].r/l;
            dz = scale*edge[i].offset/func_scale;
            glBegin(GL_LINES);
            glVertex3f(func[edge[i].from].pos.x+dx,
                       func[edge[i].from].pos.y+dy,
                       func[edge[i].from].pos.z-dz);
            glVertex3f(func[edge[i].to].pos.x,
                       func[edge[i].to].pos.y,
                       func[edge[i].to].pos.z);
            glEnd();
            /* åνФ */
            DrawEdgeFrom(edge[i].from,dz);
        } else {
            glBegin(GL_LINES);
            glVertex3f(func[edge[i].from].pos.x,
                       func[edge[i].from].pos.y,
                       func[edge[i].from].pos.z);
            glVertex3f(func[edge[i].to].pos.x,
                       func[edge[i].to].pos.y,
                       func[edge[i].to].pos.z);
            glEnd();
        }
    }
}

/* åȰ֤˱ߤ */

void DrawEdgeFrom(int num, double dz)
{
    GLUquadricObj* qobj = gluNewQuadric();
    GLfloat materialAmbient1[] = {0.0f, 0.7f, 0.7f, 0.5f};
    GLfloat materialAmbient2[] = {0.7f, 0.0f, 0.0f, 0.5f};
    GLfloat materialDiffuse[]  = {0.0f, 0.0f, 0.0f, 1.0f}; /* ȾƩ */

    if(num == select_func){
        glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, materialAmbient1);
    }else{
        glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, materialAmbient2);
    }

    /* ʪΤ */
    glTranslatef(func[num].pos.x, func[num].pos.y, func[num].pos.z-dz);
    /* Ψ */
    glScalef(scale,scale,scale);
    gluDisk(qobj, 0, func[num].r+0.03, SLICES, 1);

    /* ѥ᡼򸵤᤹ */
    glLoadIdentity();
    glMaterialfv(GL_FRONT, GL_DIFFUSE, materialDiffuse);

    gluDeleteQuadric(qobj);
}

/****************************   ƥȤ   *****************************/
/* 񤯰֡ */

void DrawText (POS pos, GLbyte *name, double dz)
{
    int i;
    /* ޥƥꥢ */
    GLfloat materialAmbient[] = {1.0f, 1.0f, 1.0f, 1.0f};
    glMaterialfv(GL_FRONT, GL_AMBIENT, materialAmbient);

    glRasterPos3f(pos.x, pos.y, pos.z+dz);
    /* եȤ /usr/include/GL/glut.h ͭ */
    switch(fontsize) {
      case SMALL :
        for(i=0; name[i]!='\0'; i++)
            glutBitmapCharacter(GLUT_BITMAP_HELVETICA_10, name[i]);
        break;
      case MIDIUM :
        for(i=0; name[i]!='\0'; i++)
            glutBitmapCharacter(GLUT_BITMAP_HELVETICA_12, name[i]);
        break;
      case LARGE :
        for(i=0; name[i]!='\0'; i++)
            glutBitmapCharacter(GLUT_BITMAP_HELVETICA_18, name[i]);
        break;
    }

    glLoadIdentity();
}

/****************************   ե   *****************************/
/* ե̾ */

void DrawFileName(void)
{
    int i,j;
    GLUquadricObj* qobj = gluNewQuadric();
    GLfloat materialAmbient1[] = {0.0f, 0.8f, 0.8f, 1.0f}; /* ե̾ */
    GLfloat materialAmbient2[] = {0.0f, 0.4f, 0.6f, 0.3f}; /*  */
    GLfloat materialDiffuse[]  = {0.0f, 0.0f, 0.0f, 1.0f}; /* ȾƩ */

    /* ե̾ */
    glMaterialfv(GL_FRONT, GL_AMBIENT, materialAmbient1);
    for(i=0; i<file_num; i++){
        if(f_info[i].view){
            glRasterPos3f(0, 0, f_info[i].z);
            for(j=0; f_info[i].name[j]!='\0'; j++)
                glutBitmapCharacter(GLUT_BITMAP_HELVETICA_10, f_info[i].name[j]);
            glLoadIdentity();
        }
    }

    /*  */
    glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, materialAmbient2);
    for(i=0; i<file_num; i++){
        if(f_info[i].view){
            glTranslatef(0, 0, f_info[i].z);
            if(func[select_func].file_id == i)
                gluDisk(qobj, 0, f_info[i].r, 20, 1);
            else
                gluDisk(qobj, f_info[i].r-0.05, f_info[i].r+0.05, 20, 1);
            glLoadIdentity();
        }
    }
    glMaterialfv(GL_FRONT, GL_DIFFUSE, materialDiffuse);

    gluDeleteQuadric(qobj);
}

/****************************      *****************************/

void DrawXYZ(void)
{
    /* ޥƥꥢ */
    GLfloat materialAmbient[] = {0.3f, 0.3f, 0.5f, 1.0f};
    glMaterialfv(GL_FRONT, GL_AMBIENT, materialAmbient);

    /*  */
    glLineWidth(1.0f);
    glBegin(GL_LINES);
    glVertex3f(-20.0f, 0.0f, 0.0f);
    glVertex3f(20.0f, 0.0f, 0.0f);

    glVertex3f(0.0f, -20.0f, 0.0f);
    glVertex3f(0.0f, 20.0f, 0.0f);

    glVertex3f(0.0f, 0.0f, -20.0f);
    glVertex3f(0.0f, 0.0f, 20.0f);
    glEnd();
}

/****************************      *****************************/
/* ֡礭 */

void DrawPoint (POS pos, GLdouble r)
{
    /* ޥƥꥢ */
    GLfloat materialAmbient[] = {1.0f, 0.5f, 0.5f, 1.0f};
    glMaterialfv(GL_FRONT, GL_AMBIENT, materialAmbient);

    /*  */
    glPointSize(r);
    glBegin(GL_POINTS);
    glVertex3f(pos.x, pos.y, pos.z);
    glEnd();
}

/****************************************************************************
  ȥ
  ****************************************************************************/

void DrawTitle(void)
{
    char title[64];
    sprintf(title,"(%.2f,%.2f,%.2f):%.0f -> (%.2f,%.2f,%.2f)",
            eye.x, eye.y, eye.z, zoom, dst.x, dst.y, dst.z);
    glutSetWindowTitle(title);
}
