/* 
 * Program:         $RCSfile: view.c,v $  $Revision: 30.6 $
 * 
 * Purpose:         ɽʪؤץࡥ
 *
 * Author:          K.Yasuhara  2000/07/01
 *                  S.Yamamoto  2000/07/01
 *
 * (C) Copyright:   K.Yasuhara and S.Yamamoto  2000 - 2003
 *                  This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: view.c,v 30.6 2003/06/15 04:48:00 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <stdlib.h>     /* For atof(). */
#include <Sapid/Sapid.h>
#include "my.h"

/*
 * ɽ륪֥Ȥ׻ؿ
 */

/* ѿ(ѿ򤵤줿Ȥ,θChangeDrawFuncƤ֤) */

void ChangeDrawGv(void)
{
    int i,j;

    /*  */
    for(i=0; i<gv_num; i++){
        gv[i].view = FALSE;
    }
    /* ѿ򤵤Ƥ */
    if(select_gv != -1){
        if(drawgv != NOTHING){
            /* ѿΤɽ */
            for(i=0; i<gv[select_gv].g_num; i++){
                gv[gv[select_gv].g[i]].view = TRUE;
            }
        }
        return;
    }
    /* ؿ򤵤Ƥ */
    if(drawgv != NOTHING){
        /* 򤵤줿ؿȤäƤΤΤɽ */
        for(i=0; i<gv_num; i++){
            for(j=0; j<gv[i].f_num; j++){
                if(select_func == gv[i].f[j]){
                    gv[i].view = TRUE;
                    break;
                }
            }
        }
    }
    return;
}

/* ؿ(ؿ򤵤줿Ȥ,θChangeDrawGvƤ֤) */

void ChangeDrawFunc(void)
{
    int i,j;
    int f_id;

    /* ܴطκƹ */
    SerchNear();

    if(select_gv != -1){
        /* ѿ򤵤Ƥ */
        for(i=0; i<func_num; i++){
            func[i].view = FALSE;           /*  */
        }
        for(i=0; i<gv_num; i++){
            if(gv[i].view)
                for(j=0; j<gv[i].f_num; j++){
                    func[gv[i].f[j]].view = TRUE;
                }
        }
    }else if(drawfunc == NEAR) {
        /* ܤΤɽ */
        for(i=0;i<func_num;i++){
            if(func[i].near) func[i].view = TRUE;
            else             func[i].view = FALSE;
        }
    }else if(drawfunc == ALL){
        /* ɽ */
        for(i=0;i<func_num;i++){
            func[i].view = TRUE;
        }
    }else{
        /* ƱեΤɽ */
        f_id = func[select_func].file_id;
        for(i=0;i<func_num;i++){
            if(func[i].file_id == f_id) func[i].view = TRUE;
            /*else if(func[i].near)       func[i].view = TRUE;*/
            else                        func[i].view = FALSE;
        }
    }
}

/* ܴطĴ */

void SerchNear(void) 
{
    int i;
    for(i=0;i<func_num;i++){
        func[i].near = FALSE;
    }

    if(select_func == -1) return;

    for(i=0;i<edge_num;i++){
        if(edge[i].from==select_func){
            func[edge[i].to].near = TRUE;
        }else if(edge[i].to==select_func){
            func[edge[i].from].near = TRUE;
        }
    }
    func[select_func].near = TRUE;
}

/* ե롥 */

void ChangeDrawFile(void)
{
    int i;
    for(i=0; i<file_num; i++){
        f_info[i].view = FALSE;
    }
    for(i=0; i<func_num; i++){
        if(func[i].view) f_info[func[i].file_id].view = TRUE;
    }
}

/* ̾ɽء */

void ChangeDrawName(void)
{
    int i;
    int f_id;
  
    if(select_gv != -1){
        /* ѿ򤵤Ƥʤɽ */
        for(i=0;i<func_num;i++){
            func[i].label = TRUE;
        }
        return;
    }

    f_id = func[select_func].file_id;

    if(drawname == NEAR) {
        /* ܤΤɽ */
        for(i=0;i<func_num;i++){
            if(func[i].near) func[i].label = TRUE;
            else             func[i].label = FALSE;
        }
    }else if(drawname == ALL){
        /* ɽ */
        for(i=0;i<func_num;i++){
            func[i].label = TRUE;
        }
    }else{
        /* ƱեΤɽ */
        for(i=0;i<func_num;i++){
            if(func[i].file_id == f_id) func[i].label = TRUE;
            /*else if(func[i].near)       func[i].label = TRUE;*/
            else                        func[i].label = FALSE;
        }
    }
}

/*
 * ɽإ󥿥ե
 */

/* ֥Ȥξܺ٤Ѥ */

int ChangeMode(struct Togl *togl, int argc, char *argv[])
{
    /* Top⡼ɤȤʤɲä뤳 */
    switch(atoi(argv[2])) {
      case 0:
        drawmode = DETAIL; break;
      case 1:
        drawmode = FIRST; break;
      case 2:
        drawmode = TINY; break;
      default :
        return TCL_OK;
    }
    Togl_PostRedisplay(togl);
    return TCL_OK;
}

/* եȤѤ */

int ChangeFont(struct Togl *togl, int argc, char *argv[])
{
    switch(atoi(argv[2])) {
      case 0:
        fontsize = LARGE;  break;
      case 1:
        fontsize = MIDIUM; break;
      case 2:
        fontsize = SMALL;  break;
    }
    Togl_PostRedisplay(togl);
    return TCL_OK;
}

/* ɽ륪֥Ȥ */

int ChangeViewObj(struct Togl *togl, int argc, char *argv[])
{
    switch(atoi(argv[2])) {
      case 0:
        drawfunc = ALL; break;
      case 1:
        drawfunc = NEAR; break;
      case 2:
        drawfunc = SAMEFILE; break;
    }
    ChangeDrawGv();
    ChangeDrawFunc();
    ChangeDrawFile();
    Togl_PostRedisplay(togl);
    return TCL_OK;
}

/* ̾ɽ륪֥Ȥ */

int ChangeViewName(struct Togl *togl, int argc, char *argv[])
{
    switch(atoi(argv[2])) {
      case 0:
        drawname = ALL; break;
      case 1:
        drawname = NEAR; break;
      case 2:
        drawname = SAMEFILE; break;
    }
    ChangeDrawName();
    Togl_PostRedisplay(togl);
    return TCL_OK;
}

/* ֥Ȥγ/̾ */

int ChangeScale(struct Togl *togl, int argc, char *argv[])
{
    scale = atof(argv[2]);
    Togl_PostRedisplay(togl);
    return TCL_OK;
}

/* ѿɽ/ɽ */

int ChangeViewGv(struct Togl *togl, int argc, char *argv[])
{
    /* ѿɽ/ɽ */
    if(drawgv == NOTHING) drawgv=USEING;
    else                  drawgv=NOTHING;
    ChangeDrawGv();
    Togl_PostRedisplay(togl);
    return TCL_OK;
}
