/* 
 * Program:             $RCSfile: detectEncoding.c,v $  $Revision: 40.4 $
 * 
 * Purpose:
 * 
 * Author:              S.Yamamoto  2003/01/09
 * 
 * (C) Copyright:       S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: detectEncoding.c,v 40.4 2003/03/21 06:39:39 yamamoto Exp yamamoto $";
#endif

#include <ctype.h>
#include <stdio.h>
#include <Sapid/Sapid.h>

int main(int argc, char *argv[])
{
    SpdEncode   en;
    int         c;
    FILE        *in;

    if (argc == 2) {
        in = spdFopen(argv[1], SPD_FOPEN_RB_MODE);

        /* Just for test. */
        while ((c = fgetc(in)) != EOF) {
            /* Nothing. */
        }

        en = spdDetectEncoding(in);
        spdFclose(in);
        spdMessage("Detected input code: \"%s\".\n", spdEncodeToStr(en));
    }
    return (EXIT_SUCCESS);
}
