# 
# Program:              $RCSfile: Out.pm,v $  $Revision: 30.7 $
# 
# Purpose:
# 
# Author:               T.Suzuki  1997/08/01
#                       S.Yamamoto  1997/08/01
# 
# Copyright:            T.Suzuki and S.Yamamoto  1997 - 2002
#                       This file is a product of the project Sapid.
#

# 
# $Id: Out.pm,v 30.7 2003/06/08 12:29:48 yamamoto Exp yamamoto $
# 

package Out;

$openflag   = 0;      # OUTPUT openƤ뤫
$secLblflag = 1;      # ߤsection٥Ť줿
$cur_fname  = '';     # ߤΥե̾ ѥꡤ$prefix, -$secꡥ
$cur_fname2 = '';     # ߤΥե̾ ѥꡤ$prefixʤ, -$secꡥ

$localOutDir  = '';
$globalOutDir = '';
$logDir       = '';
$fname        = '';   # ǥ쥯ȥꡤ'.tex'ʤ
$sec          = '';
$prefix       = '';
$pgcnt        = ''; # page-counter

sub setOutFile {
    ($fname, $localOutDir, $globalOutDir, $logDir, $prefix) = @_;
    $log1 = "${logDir}${prefix}ignored.log";
    $log2 = "${logDir}${prefix}error.log";
}

sub openSecPage {
    ($sec, $pgcnt) = @_;

    if ($openflag==1){
	closeTitlePage();
    }

    $cur_fname  = "$localOutDir$prefix$fname-$pgcnt";
    $cur_fname2 = "$localOutDir$fname-$pgcnt";
    open(OUTPUT, ">$cur_fname.tmp")
	|| &main::perror("Can't open $cur_fname.tmp");

    &putC('<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"', "\n");
    &putC('    "http://www.w3.org/TR/html4/loose.dtd">', "\n");
    &putC("<HTML>\n");
    &putC("<HEAD>\n");
    &putC('<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=EUC-JP">', "\n");
    &putC("<TITLE>\n");
    &Out::putC($Macro::TITLE);
    &putC(" Section $sec");
    &putC("\n</TITLE>\n");
    &putC('<!-- Generator ver. : $Id: Out.pm,v 30.7 2003/06/08 12:29:48 yamamoto Exp yamamoto $ -->', "\n");
    &putC("<!-- TeX source file : $Parser::fname -->\n");
    &putC("</HEAD>\n");
    &putC("<BODY>\n");
    &putC("\@\@LINKS\@\@<HR>\n");

    $openflag=1;
}

sub closeSecPage {
    &Out::secLabel();
    &Out::putFootnote();
    &putC("<HR>\n\@\@LINKS\@\@\n");
    &putC("</BODY>\n");
    &putC("</HTML>\n");
    close(OUTPUT);
    $openflag = 0;
}

sub openTitlePage {
    $cur_fname = "$localOutDir$prefix$fname-0";
    $cur_fname2 = "$localOutDir$fname-0";
    open(OUTPUT, ">$cur_fname.tmp")
	|| &main::perror("Can't open $cur_fname.tmp");
    open (LLBL, ">$localOutDir$prefix$fname.llbl")
	|| &main::perror("Local label ($main::fname.llbl): Can't open.");
    
    &putC('<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"', "\n");
    &putC('    "http://www.w3.org/TR/html4/loose.dtd">', "\n");
    &putC("<HTML>\n");
    &putC("<HEAD>\n");
    &putC('<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=EUC-JP">', "\n");
    &putC("<TITLE>\n");
    $Out::outbuf = '';
    &Parser::ungett($Macro::TITLE);    &main::innerLoopPut('{', '}');
    $Macro::TITLE = $Out::outbuf;
    &putC("\n</TITLE>\n");
    &putC("</HEAD>\n");
    &putC('<!-- Generator ver. : $Id: Out.pm,v 30.7 2003/06/08 12:29:48 yamamoto Exp yamamoto $ -->', "\n");
    &putC("<!-- TeX source file : $Parser::fname -->\n");
    &putC("<BODY>\n");
    &putC("\n\@\@LINKS\@\@\n<HR>");
    
    $openflag = 1;
}

sub closeTitlePage {
    &closeSecPage();
#     &print("</HTML>\n");
#     close(OUTPUT);
#     $openflag = 0;
}

sub closeLabel {
    close (LLBL);
}

@FOOTNOTE = ();
$footnCou = 0;

sub putFootnote {
    my $cou;
    &putC("<hr>\n") if ($#FOOTNOTE >= 0 );
    for (@FOOTNOTE) {
	$footnCou++;
	&putC("<P>");
	&putC("<A NAME=\"footnote$footnCou\"> $footnCou: </A>");
	&Parser::ungett($_);
	&main::innerLoopPut('{', '}');
	&putC("</P>");
    }

    @FOOTNOTE = ();
}

sub print {
    print OUTPUT @_;
#    print @_;
}

##
## եؤν
##

# HTMLʸ(&,<,>)ΥԤʤ
# Input  1.Ѵʸ
# Output Ѵʸ
sub trans {           
    local $_ = $_[0];

    s/\&/&amp;/g;     # ʸ
    s/\</&lt;/g;
    s/\>/&gt;/g;

    s/\\(.)/$1/g;     # ʸ(\)ä
    s/\-\-/\-/g;      # åϥե 

    return $_;
}

$outbuf = '';         # ϤʸΥХåե

# ʸν
sub putS {
    foreach (@_) {
	my $p = &Out::trans($_);
	print OUTPUT $p;
	$outbuf .= $p;
    }
}

# ޥν
sub putC {
    my $p = join('', @_);
    print OUTPUT $p;
#    print @_;
}

# section  labelŤƤʤʤ section label 
# Input  None
# Refer  secLblflag
# Output None
sub secLabel {
    if (!$Out::secLblflag){
	my $tmp = $TEnv::LblEnv[0]; 
	$TEnv::LblEnv[0] = 'document'; # ߤδĶ 'document'ˡ
	&Parser::ungett("{section" . &Counter::getcount2('document') . "}");
	&Macro::label;
	$TEnv::LblEnv[0] = $tmp;
    }
}


# ٥ν (obsolate)
# Input  ʸ
# Output None
#   ٥ؽ
sub label {
    $secLblflag = 1 if ($_[0] eq 'document');
    my $lbl = join('}{', @_);
    print LLBL "{$lbl}\n";
}


# Local Label ν
# Input  1., 2.TeX٥, 3.ȥ٥, 4., 5.Ф
# Output
#   local-label-file˽
sub llabel {
    $secLblflag = 1 if ($_[0] eq 'document');
    my ($type, $texLabel, $ref, $count, $caption) = @_;
    print LLBL "{$type}{$texLabel}{$fname-$pgcnt.html}",
	       "{$ref}{$count}{$caption}\n";
}

# Global Label ν
# Input  1., 2.٥̾
# Output None
#   ٥륿Ƭ(<a>), global-label-file˽
sub printGLabel {
    my ($type, $name) = @_;

    my $ref = $name;
    $ref =~ s/\\//g;

    &Out::putC("<A NAME=\"$ref\">");

    $ref =~ tr/\=\;\/\#\?\:\ /\_\_\_\_\_\_/;

#    print GLBL "{$type}{$name}{$main::relPath$fname-$sec.html}{$ref}{}{}\n";

    &GLabel::outGLbl($name, 
	"{$type}{$name}{$main::relPath$fname-$pgcnt.html}{$ref}{}{}");
}

#  brace  global labelȤ(ɤߤ)Ϥ롥
# Input
#   1. global label η
#   2. global label ηб prefix
# Output None
#   '[',']'⤷ϼ'{','}'٥̾Ȥ global labelꡤ
#   ٥ global-label-file˽Ϥ롥
#   '[]'Ͼ񤵤뤬 '{}'ϽϤ
sub makeBraceGLabel {
    my ($type, $head) = @_; # $head is obsolate
    my ($lbl) = (&Parser::forwRead('[', ']') =~ /\[(.*)\]/);

    if ($lbl eq '*NOREF*'){
	&main::innerLoopPut('{', '}');
	return;
    };

    if ($lbl eq '') {
	my $str = &Parser::forwReadBrace;
	($lbl) = $str =~ /\{(.*)\}/;	
	&Parser::ungett($str);
    }

    &printGLabel($type, "Spd_$lbl");
    &main::innerLoopPut('{', '}');

    &Out::putC( "</A>");

}

# Global LabelΤ褬section/fig/faqˤʤΤν
# Input  1., 2.٥̾
# Output None
#   global-label-file˥٥
sub gLabelSec {
    my ($type, $name, $str) = @_;
    if ($TEnv::LblEnv[0] eq 'document'){
	if ($str = &Counter::getcount2('document')){
	    $str = "LABEL_S_$str";
	} else {
	    $str = "LABEL_INDEX";
	}
    }
#    print GLBL "{$type}{Spd_$name}{$main::relPath$cur_fname2.html}",
#               "{$str}{}{$name}\n";


    &GLabel::outGLbl("Spd_$name", 
	"{$type}{Spd_$name}{$main::relPath$cur_fname2.html}{$str}{}{$name}");
}


##  ################################

# եΥץ
# Input  None
# Output None
sub openLog {
    open(LOG1, ">$log1") || &main::perror("File $log1 Can't open.");
    open(LOG2, ">$log2") || &main::perror("File $log2 Can't open.");
    print LOG2 `date`;
    print LOG1 `date`;
    print LOG2 "Version $ver\n";
}

# եΥ
sub closeLog {
    close (LOG1);
    close (LOG2);
}

# ̵뤵줿ޥɤξ
$log1 = 'ignored.log';
sub ignored { print LOG1 "$Parser::fname ($.):", @_, "\n"; }

# STDERRؤν
$log2 = 'error.log';
sub errLog {
    if ($main::VERBOSE_MODE) {
	print STDERR @_;
    }
    print LOG2 join('', @_);
}

sub errPut {
    print LOG2 @_;
}

sub warnPut {
   errLog("Warning:", @_, "\n");
}


package GLabel;

%gl = ();
$ptrn = '{\s*(\S+)\s*}' . '{\s*(\S*)\s*}'x4 . '{\s*(.*)\s*}';
# ǤꤵƤͤɤ߹
sub preSet {

    open (GLBL, "$Out::globalOutDir"."labels.glbl")
	|| &Out::warnPut("File for Global Label($main::texroot"
		  ."labels.glbl)  Can't Read");
    $chengedF = 0;

    while(<GLBL>) {
	next if (/^\#/);
	chop;
	my ($sort, $ref) = /$ptrn/o;

	$gl{$ref} = $_;
    }

    close (GLBL);
    return;
}


sub outGLbl {
    my ($name, $str) = @_;
    if ($gl{$name} ne '' && $gl{$name} ne $str) {
	&Out::warnPut("Global Label $name is over loaded.");
    }
    $chengedF++;
    $gl{$name} = $str;
}

sub output {

    return if ($chengedF == 0);

    open (GLBL, ">$Out::globalOutDir"."labels.glbl")
	|| &Out::warnPut("File for Global Label($main::texroot"
		  ."labels.glbl)  Can't Write");

    for (values %gl) {
	print GLBL "$_\n";
    }
    
    close GLBL;
}

1
