# 
# Program:              $RCSfile: TEX.pm,v $  $Revision: 30.3 $
# 
# Purpose:
# 
# Author:               T.Suzuki  1997/08/01
#                       S.Yamamoto  1997/08/01
# 
# Copyright:            T.Suzuki and S.Yamamoto  1997 - 2002
#                       This file is a product of the project Sapid.
# 

# 
# $Id: TEX.pm,v 30.3 2002/11/26 10:32:24 yamamoto Exp yamamoto $
# 

package TEX;

# Ȥꤢ֤Τ
# Ÿ
#  Ϣ۵ ޥ̾ ¹ʸ򵭲
# ޥɤѤ줿Ÿ

# \def\<command-name>#args#...{}

%com = ();    # ޥ̾Τε
%arg = ();    # 򵭲

sub def {
    # \defβ
    # %com˼Τ%arg ˰ο
    # Input 
    #   ʤ
    # Output
    #    :: ޥɤ֤̾
    #    :: 0֤

    # ޥ̾
    my $comname = &Parser::parse();
    $comname =~ s/^\\//;
    $comname =~ tr/\*\@/\_\_/;

    if ($Parser::type != 'CtrlSeq') {
	&main::perror("$comname must be Macro ($Parser::type)");
	return 0;
    }

    if (eval "defined(&Macro::$comname)"){
        # print "$comname Already Defined.\n";
	# Already Defined.
	&Parser::read('{'); &Parser::ungett('{');
	&Parser::forwReadBrace;
	return -1;
    }
    
    # ѥ᡼ο
    # '{' ޤǤʬȽ
    my $args = &Parser::read('{');
    chop $args;
    $arg{$comname} = $args; # start from 1

    &Parser::ungett('{');

    # ΤǼ
    ($com{$comname}) = (&Parser::forwReadBrace() =~ /\{(.*)\}/s);
    
    return $comname;
}

sub newcom {
    # ޥ̾
    my $comname = &Parser::forwReadBrace();
    $comname =~ s/^\{\\//;
    chop $comname;

    if ($Parser::type != 'CtrlSeq') {
	&main::perror("$comname must be Macro ($Parser::type)");
	return 0;
    }

    if (eval "defined(&Macro::$comname)"){
	# Already Defined.
        # print "&Macro::$comname Already Defined.\n";
	&Parser::forwRead('[',']');
	&Parser::forwReadBrace();
	return -1;
    }

    # ѥ᡼ο
    my ($s) = &Parser::forwRead('[',']') =~ /\[(\d)\]/;
    $s = join('#', 1..$s );
    $s = "#$s" if ($s);

    $arg{$comname} = $s; 

    # ΤǼ
    ($com{$comname}) = (&Parser::forwReadBrace() =~ /\{(.*)\}/s);
    
    return $comname;
}

sub TeXMacro {
    # ޥŸ
    # Input
    #   1. ޥ̾
    # Output
    #   0:  (Ϥ줿ޥɤdefƤʤ)
    #  !0: ɤ߹Ÿ줿ʸƤ
    my ($com) = @_;
    my ($i);

    #print STDERR "(InnerMacro of $com)\n";
    # ؿȤ¸ߤʤʤ 0֤ƽλ
    return 0 if ($com{$com} eq '');


    ### ꡤޥɤŸ
    my $comm = $com{$com}; # ¥ޥ
    local $_  = reverse $arg{$com}; # 

    #print STDERR "$comm : $Parser::STR(<$_>";

    my $tk;
    my $stoken = '';

    while($tk = chop) {
	if ($tk eq '#'){
	    my $str;
	    my $num = chop;
	    if ($stoken eq  ''){
		$str = &Parser::forwReadBraceInner();
	    } else {
		my $endtoken = chop;
		$str = &Parser::read($endtoken);
		chop $str;
	    }
	    $str =~ tr/\n//d;
	    $comm =~ s/#$num/$str/g;
	    $stoken = '';
	} else {
	    my $p;
	    $stoken = $tk;
	    &main::perror("Argument Unmatch : $tk<>$p")
		if ($tk ne ($p=&Parser::getchar()));
	}
    }
    # Ÿޥɤɤ߹᤹
    #print STDERR "$.) --> $comm\n";
    &Parser::ungett($comm);
}

#ޥɤФ
sub ignoreMacro {
    my ($name, $arg) = @_; # 1.ޥ̾,
                           # 2.ɤФ ('{','['ʤʸ)
    my @s = $arg =~/(.)/g;

    for (@s) {
	if ($_ eq '{') {
	    &Parser::forwReadBrace();
	} elsif ($_ eq '[') {
	    &Parser::forwRead('[', ']');
	}
    }
    
    &Out::ignored($name);
    return 1;
}


sub makeIgnoreMacro {   # 줷ƤǤΤϺ
    
    for (@ignoreMacroList) {
	my ($name, $ptr) = /(\S+)\s*(.*)/;
	if (!eval "defined(&Macro::$name)"){
	    eval "sub Macro::$name { &TEX::ignoreMacro('$name', '$ptr'); 1}";
	}
    }
}


@ignoreMacroList =
    (
     "noindent",
     "centering",  # ?ɤɬס
     "long",
     "makeatletter",
     "makeatother",
     "medskip",
     "protect",
     "tableofcontents",
     "newcounter               {",
     "newenvironment           {[{{",
     "setlength                {{",
     "documentstyle            [{",
     "undefined",
     "gtfam",
     "newpage",
     "vspace                   {",
     "pageref                  {",   # You should use \ref.
     "clearpage",
     "break",
     "allowbreak",
     "hfil",
     "hfill",
     "thebibliography 		[{",
     "bibitem	  		[{",
     "cite                      [{",
#     "endthebibligraphy	       [{",
#     "baselineskip"
     );
