#! PerlCmd
# 
# Program:              $RCSfile: getMacro.pl,v $  $Revision: 30.4 $
# 
# Purpose:
# 
# Author:               T.Suzuki  1997/08/01
#                       S.Yamamoto  1997/08/01
# 
# Copyright:            T.Suzuki and S.Yamamoto  1997 - 2002
#                       This file is a product of the project Sapid.
# 

# 
# $Id: getMacro.pl,v 30.4 2002/11/26 10:32:25 yamamoto Exp yamamoto $
# 

#
# TeXѤƤޥȤΰФ
#
# ץ
# -l : line number ν
# -u : uniqɽϤ
# -U : иԤĤuniq
# -t : Ĥ
% 

use lib $ENV{"SAPID_MKHTML_LIBDIR"};

use Getopt::Std;
&getopts(luUt);

use Parser;

package Out;

sub errLog {
    print STDERR "errLog::", @_, "\n";
}
package main;

%uniq = ();

sub perror {
    print STDERR "ERROR", @_, "\n";
}


sub getArgs {
    my ($name) = @_;
    my @str = ();
    my $line = $.;
    my $num = 0;

    while(1){
	my $s;
	$k = &Parser::getchar;
	&Parser::ungett($k);
	$num++;
	if ($k eq '[') {
	    $s = &Parser::forwRead('[', ']');
	    $ke = ']';
	} elsif ($k eq '{') {
	    $s = &Parser::forwReadBrace;
	    $ke = '}';
	} else {
	    last;
	}

	push @str, $s;
	&Parser::ungett($s);  # Ƶõ
	&subget($k, $ke);
    }

    $output = " $name\t". join("\t", @str);
    $output =~ tr/\n//;
    
    if (!$UNIQ_SORT_FLAG){
	printf("%04d:", $line) if ($LINE_NUM_FLAG);
	print "$Parser::fname:$line:" if ($TAG_FLAG);
	print $output, "\n";
    }

    $uniq{$output} .= "$Parser::fname:$.\x0" if ($UNIQ_SORT_FLAG);
}



sub subget {
    my ($startC, $endC) = @_;
#    print ":: $startC : $endC ::\n";

    
    my $str;

    if ($startC ne '') {
	$str = &Parser::gett();
	return 
	    if ($str ne $startC && &Parser::ungett($str));
    }

    while(!$Parser::EOF) {
	my $str = &Parser::gett();
	if ($Parser::TYPE eq 'MACRO') {
	    next if ($str eq "\\\\");
	    getArgs($str);
	} elsif ($str eq $startC && $startC ne '') {
	    subget($startC, $endC);
	} elsif ($str eq $endC) {
	    last;
	}
    }
}


&Parser::setInputdir($ENV{'TEXINPUTS'});

$LINE_NUM_FLAG = 0;
$LINE_NUM_FLAG = 1 if ($opt_l);

$UNIQ_SORT_FLAG = 0;
$UNIQ_SORT_FLAG = 1 if ($opt_u);

$UNIQ_SORT_FLAG2 = 0;
$UNIQ_SORT_FLAG2 = $UNIQ_SORT_FLAG = 1 if ($opt_U);

$TAG_FLAG = 1;
$TAG_FLAG = 0 if ($opt_t);

for (@ARGV) {
    if ($_){
	$Parser::EOF = 0;
        &Parser::openFile($_);
    }else{
        perror("Usage: $0 filename");
        exit;
    }

    subget('', '');
}

if ($UNIQ_SORT_FLAG){

    @uniq = keys(%uniq);
    @uniq = sort @uniq;

    foreach (@uniq) {
	print "$_";
        my $s = $uniq{$_};
	chop $s;
#	print "  ", join(" ", split("\x0",$s)) if ($UNIQ_SORT_FLAG2);
	print "\n";

	if ($TAG_FLAG){
	    foreach $l (split ("\0", $s)){
		print "$l:\n" if ($_ ne '');
	    }
	    print "\n";
	}
    }
}
